
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_AddHeader)
{
/* call: AddHeader( fname, [lineNo] ) (default - 1st) */

    dXSARGS;
    STRLEN n_a;	
    char *tpl_name=NULL, *clineno=NULL;
    char full_tpl_name[256];
    char *err="perl_AddHeader()";
    int lineNo = 0;
    TEXT *tpl_text = NULL;
	
    if (items < 1 && items > 2) {
	fprintf(stderr, "%s argument count (need 1 or 2, exist %d)\n", err, (int)items);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }

    sp_s = FromSP(0);
    tpl_name = XCAL;
    strcpy(tpl_name, sp_s);
    expand_str(tpl_name);
	
    if (items > 1) {
	sp_s = FromSP(1);
	clineno = XCAL;
	strcpy(clineno, sp_s);
	if ( !__isnumber(clineno) ) {
	    fprintf(stderr, "\7%s incorrect lineNo: `%s'\n", err, clineno);
	    abort();
	}
	lineNo = atoi(clineno);
    }
	
    if (lineNo == 0)
	lineNo = 1;

    if ( !strchr(tpl_name, '.') )
    	strcat(tpl_name, ".tpl");
	
    sprintf(full_tpl_name, "%s%s%s", ItraxPath, TemplatePath, tpl_name);
    
    if (access(full_tpl_name, 0)) {
		
	sprintf(full_tpl_name, "%s%s", TemplatePath, tpl_name);
		
	if (access(full_tpl_name, 0)) {
	    strcpy(full_tpl_name, tpl_name);

	    if (access(full_tpl_name, 0)) {
		writeToLog(0, "template file not found: `%s'\n", full_tpl_name);
		free(tpl_name);
		free(clineno);
		XSRETURN_UNDEF;
	    }
			
	}
    }
    
    tpl_text = read_tpl(full_tpl_name);
	
    (void) add_text(&TextFirst, tpl_text, lineNo, Mode_Text);
	
    free_text(tpl_text);
	
    ftn.stat |= i_Changed;
    free(tpl_name);
    free(clineno);

    XSRETURN_UNDEF;
}
/*************************************************************************/
TEXT *read_tpl( char *fname )
{
	FILE *h;
	char buf[256], *s = NULL;
	TEXT *text = NULL, *t;
	
	if ( (h = fopen(fname, "r") ) == NULL ) {
		fprintf(stderr, "read_tpl: can`t open template file: `%s'\n", fname );
		perror(fname);
		abort();
	}
	
	while (fgets(buf, 128, h))
	{
		
		expand_str(buf);

		if (!strlen(buf))
			continue;

		if (s == NULL) {
			s = (char *) malloc (strlen(buf)+1);
			strcpy (s, buf);
		}
		else {
			s = (char *) realloc (s, strlen(s) + strlen(buf) + 1);
			strcat (s, buf);
		}

		if (s[strlen(s)-1] == '\n') {

			char *tok = NULL, *cr, *cl, var[128], *head, *tail, *ss = NULL;
			
			strip_CRLF(s);
			
			if ( (cl = strchr(s, '%')) && (cr = strrchr(s, '%')) && (cr - cl > 1))
			{
				tok = cl+1;
				if (*tok == '%') {
					++tok;
					--cr;
					if (*cr != '%')
						tok = NULL;
				}
				if (tok) {
					ss = (char *)malloc(strlen(s)+1);
					strcpy(ss, s);
					ss[cr-s] = '\0';
					strncpy(var, &ss[tok-s], 127);
					var[127] = '\0';
					ss[cl-s] = '\0';
					head = ss;
					tail = &ss[cr-s+1];
					if (*tail == '%')
						++tail;
					if (var[strlen(var)-1] != '.') {
						free (ss);
						ss = NULL;
						tok = NULL;
					}
				}
			}
			if (tok) {
				TEXT* tmp;
				
				t = line_to_txt (head);

				for (tmp = t; tmp && tmp->next; tmp = tmp->next)
					;
				if (tmp)
					strip_CRLF (tmp->str);

				
				(void) add_text(&text, t, -1, Mode_Text);
				free_text (t);

				t = get_array_string (var);

				for (tmp = t; tmp && tmp->next; tmp = tmp->next)
					;
				
				if (tmp)
					strip_CRLF (tmp->str);

				(void) add_text(&text, t, -1, Mode_Text);
				free_text (t);

				t = line_to_txt (tail);
				(void) add_text(&text, t, -1, Mode_Text);
				free_text (t);

				if (ss) {
					free (ss);
					ss = NULL;
				}
				tok = NULL;
			}
			else {
				t = line_to_txt (s);
				(void) add_text(&text, t, -1, Mode_Text);
				free_text (t);
			}
			free (s);
			s = NULL;
		}
		
	}
	
	fclose(h);
	
	return text;
	
}  

