
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_ChangeFrom)
{
    dXSARGS;
    STRLEN n_a;
    char *tmp, *err="perl_ChangeFrom()";
    
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }
	
	
    sp_s = FromSP(0);
    tmp = XCAL;
    strcpy(tmp, sp_s);
    strip( tmp );
    expand_str(tmp);
	/*/////////////*/
    ChangeAddr(tmp, &ftn.from, err);
	/*/////////////*/
    if (is_echoarea(CurMsg.type, CurMsg.areaname)) {
	writeToLog(4, "ChangeTo: changing echomail address kludges");
/*		strset(ftn.intl, 0); */
	(void)change_echo_kludges(ftn, TextFirst);
    } else {
	writeToLog(4, "ChangeTo: changing netmail address kludges");
	(void)change_address_kludges(&ftn, &TextFirst);
    }
		
    ftn.stat |= i_Changed;

    free(tmp);	

    XSRETURN_UNDEF;	
}

static XS(perl_ChangeTo)
{
    dXSARGS;
    STRLEN n_a;
    char *tmp, *err="perl_ChangeTo";
    
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }
	
    sp_s = FromSP(0);
    tmp = XCAL;
    strcpy(tmp, sp_s);
    strip( tmp );
    expand_str(tmp);
	/*/////////////*/
    ChangeAddr(tmp, &ftn.to, err);
	/*/////////////*/
    if (!is_echoarea(CurMsg.type, CurMsg.areaname))
	(void)change_address_kludges(&ftn, &TextFirst);
	
    ftn.stat |= i_Changed;
    free(tmp);

    XSRETURN_UNDEF;	
}


/*****************************************************/
static void ChangeAddr(char *pptmp, ADDR *addr, char *err)
{
	char tmp[128];
	char token[32] = {0}, caddr1[128], caddr2[128], tag[20]={0};
	ADDR addr1, addr2;
	BOOL direct = No, positive = Yes, relaxed = No;
	struct AddrTags *AddrTag = NULL;
	struct ReAddrTags *ReAddrTag = NULL;
	char *ptmpp, *ptmp;
	
	ptmpp = NULL;
	
	if (*pptmp) {
	    ptmpp= (char*)xcalloc(strlen(pptmp)+1, sizeof(char));
	    strcpy(ptmpp, pptmp);
	}
	
	ptmp = ptmpp;
	
	strcpy(tmp, ptmp);
	
	while( *ptmp && (*ptmp=='!' || *ptmp=='~' || *ptmp=='@') )
	{
		if (*ptmp == '!') { /* positive data */
			++ptmp;
			strip(ptmp);
			if (positive == No) {
			    fprintf(stderr, "%s syntax: `%s'\n", err, tmp);
			    free(ptmpp);
			    abort();
			}
			positive = No;
		}
		if (*ptmp == '~') {
			++ptmp;
			strip(ptmp);
			if (relaxed) {
			    fprintf(stderr, "%s syntax: `%s'\n",  err, tmp);
			    free(ptmpp);
			    abort();
			}
			relaxed = Yes;
		}
		
		if (*ptmp == '@') { /* direct data */
			++ptmp;
			strip(ptmp);
			if (direct) {
			    fprintf(stderr, "%s syntax: `%s'\n", err, tmp);
			    free(ptmpp);
			    abort();
			}
			direct = Yes;
		}
	} /* while !~@ */

	if (!strlen(ptmp)) {
	    fprintf(stderr, "%s empty data argument: `%s'\n", err, tmp);
	    free(ptmpp);
	    abort();
	}
		
	if (direct) {
		get_next_word(ptmp, token);
		if (!stricmp(token, "ADDRESS")) {
			get_next_word(ptmp, caddr1);
			if ( !str_to_Waddr(caddr1, &addr1) ) {
			    fprintf(stderr, "%s incorrect address: `%s' in `%s'\n",
				    err, caddr1, tmp);
			    free(ptmpp);
			    abort();
			}
			
			if (relaxed)
				addr1.point = Wild_1;
			
			set_Waddr(addr1, addr);
			
		} /* Change ADDRESS */
		
		else if (!stricmp(token, "READDRESSLIST")) {
			get_next_word(ptmp, caddr1);
			get_next_word(ptmp, caddr2);
			if ( !str_to_Waddr(caddr1, &addr1) ||
					!str_to_Waddr(caddr2, &addr2) )
			{
			    fprintf(stderr, "%s readdress syntax error: `%s'\n",
								err, token);
			    free(ptmpp);
			    abort();
			}
			
			if (relaxed)
				addr2.point = Wild_1;
			
			if (comp_addrs(*addr, addr1) == positive) {
				set_Waddr(addr2, addr);
			}
		}
		/* incorrect data type after @ */
		else {
		    fprintf(stderr, "%s incorrect data type: `%s' in `%s'\n",
							err, token, tmp);
		    free(ptmpp);
		    abort();
		}
	} /* direct mode */
	/* block mode */
	else { 
		
		strncpy(tag, ptmp, 19); tag[19] = 0;
		strip(tag);
		/*////////////////////////////////////////////////////////////*/
		for( AddrTag = AddrTagFirst; AddrTag; AddrTag = AddrTag->next )
		{
			if (!stricmp(tag, AddrTag->tag)) {
				addr1 = AddrTag->recfirst->addr;
				if (relaxed)
					addr1.point = Wild_1;
				set_Waddr(addr1, addr);
				break;
			}
		}
		if (NULL == AddrTag) {
			for( ReAddrTag = ReAddrTagFirst; ReAddrTag; ReAddrTag = ReAddrTag->next )
			{
				if (!stricmp(tag, ReAddrTag->tag)) {
					ReAddrTag->rec = ReAddrTag->recfirst;
					for(; ReAddrTag->rec; ReAddrTag->rec = ReAddrTag->rec->next )
					{
						addr1 = ReAddrTag->rec->addr1;
						addr2 = ReAddrTag->rec->addr2;
						
						if (relaxed)
							addr2.point = Wild_1;
			
						if (comp_addrs(*addr, addr1) == positive) {
							set_Waddr(addr2, addr);
							break;
						}
					}
					break;
				}
			}
			if (NULL == ReAddrTag) {
			    fprintf(stderr, "%s data block not defined: `%s' \n", err, tag);
			    free(ptmpp);
			    abort();
			}
		}
		
	} /* block mode */

    free(ptmpp);		

	return;
}
/***********************************************/
void change_address_kludges(FTN *ftn, TEXT **Text)
{
	char intl[128], full_intl[128];
	char system[20];
/*	char caddr[128]; */
	TEXT *t = *Text;
	int i, l = 1;
	int toptLine = 0, fmptLine = 0;
	ADDR aka;
	int j, found;
	char *p = NULL, kludge[128];
	char topt[64]={0}, fmpt[64]={0};
	
	areaname_to_system(CurMsg.areaname, system);
	get_def_addr(system, ftn->to ,&aka);
	
	if (ftn->to.point)
		sprintf(topt, "\1TOPT %d\r", ftn->to.point );
	if (ftn->from.point)
		sprintf(fmpt, "\1FMPT %d\r", ftn->from.point );
	
	for( i = 1; t; t = t->next, ++i )
	{
		/* kludge found */
		if (is_kludge(t->str)) {
			strncpy(kludge, t->str, 127); kludge[127] = 0;
			p = kludge;

			strip_CRLF(p);

			++p;

			for(j = 0 , found = -1; strlen( Kludges[j].s ); ++j)
			{
				if (!strnicmp(p, Kludges[j].s, strlen(Kludges[j].s))) {
					p += strlen( Kludges[j].s );
					if (*p == ':')
						++p;
					++p;
					found = Kludges[j].n;
					break;
				}
			}

			switch (found)  {

			case k_Domain:
/*				strset(t->str, 0); */
				++l;
				break;
			case k_Intl:
				sprintf(intl, "%d:%d/%d %d:%d/%d\r",
								ftn->to.zone, ftn->to.net, ftn->to.node,
								ftn->from.zone, ftn->from.net, ftn->from.node );
				sprintf(full_intl, "\1INTL %s", intl);
				strcpy(ftn->intl, intl);
				strcpy(t->str, full_intl);
				++l;
				break;
#if 0
			case k_Msgid:
				addr_to_str(ftn->from, caddr);
				if (strlen(ftn->from.domain)) {
					strcat(caddr, "@");
					strcat(caddr, ftn->from.domain);
				}
				sprintf(t->str, "\1MSGID: %s %08x\r", caddr, get_MsgId() );
				break;
#endif
			case k_Topt:
				if (strlen(topt)) {
					strcpy(t->str, topt);
					memset(topt, '\0', 64);
				}
				else
					toptLine = i;
				break;
			case k_Fmpt:
				if (strlen(fmpt)) {
					strcpy(t->str, fmpt);
					memset(fmpt, '\0', 64);
				}
				else
					fmptLine = i;
				break;
			case k_Via:
				/* we are sure that the last string in text is our via */
				if (t->next == NULL)
					(void) make_via_string(aka, t->str);
				break;
			default:
				break;
			}
		} /* kludge found */
		else if (is_Origin(t->str)) {
			replace_origin_addr(t->str, ftn->from);
		}
		
	} /* txt loop */
	
	/* kill old FMPT line */
	if (fmptLine) {
		kill_text(Text, fmptLine, Mode_Bin);
		if (toptLine > fmptLine)
			--toptLine;
	}
	
	/* kill old TOPT line */
	if (toptLine)
		kill_text(Text, toptLine, Mode_Bin);
	
	t = (TEXT *) calloc(1, sizeof(TEXT) );
	t->next = NULL;

	/*  FMPT was absent but exists in the new message */
	if (strlen(fmpt)) {
		strcpy(t->str, fmpt);
		(void) add_text(Text, t, l, Mode_Bin);
	}
	
	/*  TOPT was absent but exists in the new message */
	if (strlen(topt)) {
		strcpy(t->str, topt);
		(void) add_text(Text, t, l, Mode_Bin);
	}
	
		
	free_text(t);
	
	return;
	
}

/*****************************************/
void set_Waddr(ADDR new_addr, ADDR *old_addr)
{
	if (!isW(new_addr.zone))
		old_addr->zone = new_addr.zone;
	if (!isW(new_addr.net))
		old_addr->net = new_addr.net;
	if (!isW(new_addr.node))
		old_addr->node = new_addr.node;
	if (!isW(new_addr.point))
		old_addr->point = new_addr.point;
	
	strcpy(old_addr->domain, new_addr.domain);
	
	return;
}

/*****************************************/
void change_echo_kludges(FTN ftn, TEXT *t)
{
	char caddr[128];
	
	for( ; t ; t = t->next)
	{
		if (!strnicmp("\1MSGID", t->str, 6)) {
			addr_to_str(ftn.from, caddr);
			if (strlen(ftn.from.domain)) {
				strcat(caddr, "@");
				strcat(caddr, ftn.from.domain);
			}
			sprintf(t->str, "\1MSGID: %s %08x\r", caddr, (unsigned)get_MsgId() );
		}
		else if (is_Origin(t->str)) {
			replace_origin_addr(t->str, ftn.from);
		}
	}
	return;
}
/******************************************/
static void replace_origin_addr(char *o, ADDR new_addr)
{
	char *p, *pL, *pR, buf[256];
	char cold_addr[128]={0}, cnew_addr[128]={0};
	char head[256]={0}, tail[256];
	ADDR old_addr;
	
	if (NULL == (pL = strrchr(o, '(')) || 
			NULL == (pR = strrchr(o, ')')) ||
			pL > pR )
		return;
	
	
	
	/* Scan till the first digit in the origin address specification */

	for (p = pL + 1; !isdigit(*p); p++)
	{
		if (*p == ')')
			return;
	}

	strncpy(head, o, p-o);
	strncpy(cold_addr, p, pR-p);
	strcpy(tail, pR);

	if (Fail == str_to_addr(cold_addr, &old_addr)) {
		sprintf(buf, "replace_origin: error parsing origin address:`%s'\n", o);
		writeToLog(4, buf);
		return;
	}

	addr_to_str(new_addr, cnew_addr);
	sprintf(o, "%s%s%s", head, cnew_addr, tail);
	
	return;
}
