
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_CheckPath)
{
    dXSARGS;
    STRLEN n_a;
    char tag[64], path[64], subj[72];
    char *s, save_str[256], *err = "perl_CheckPath()";
    struct PathTags *PathTag = NULL;
    struct Path *paths = NULL, *pathFirst = NULL, *pathLast = NULL;
    char *new_subj[10];
    int i, nsubj = 0;
    BOOL direct = No, rc = Fail;
	
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }
	
    if (!CurMsg.n) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_IV(rc);
    }
	
    if (!(ftn.attr & a_File)) {
	writeToLog(4, "%s msg is not a fileattach, ignored\n", err);
	XSRETURN_IV(rc);
    }
	
    if (Yes == is_echoarea(CurMsg.type, CurMsg.areaname)) {
	writeToLog(3, "%s no CheckPath possible for echomail area\n", err);
	XSRETURN_IV(rc);
    }
	
    sp_s = FromSP(0);
    s = XCAL;
    strcpy(s, sp_s);
    strip(s);
    expand_str(s);
	
    strcpy(save_str, s);
    get_next_word(s, tag);
	
	/* direct data definition */
    if (!strnicmp( "@path" , tag , strlen(tag))) {
		
	direct = Yes;
		
	while (get_next_word(s, path)) {
			
	    if (strlen(path) > 58) path[58] = '\0';
			
	    writeToLog(4, "checkpath, got path directly: `%s'\n", path);
			
	    if (setpath(path)) {
		
		paths = (struct Path *)calloc(1, sizeof(struct Path));
		paths->next = NULL;
		/*//////////////////////*/
		strcpy(paths->path, path);
		/*//////////////////////*/
		if (pathLast) pathLast->next = paths;
		else pathFirst = paths;
		pathLast = paths;
				
	    } else {
		writeToLog(4, "checkpath, path not found: `%s'\n", path);
	    }

	} /* words loop */
		
    } /* end of direct data */
	
    /* block data */
    else {
	for( PathTag = PathTagFirst; PathTag; PathTag = PathTag->next ) {
	    if (!stricmp(save_str, PathTag->tag)) {
		pathFirst = PathTag->recfirst;
		break;
	    }
	}
		
	if (NULL == PathTag) {
	    fprintf(stderr, "\7%s block undefined : `%s'\n", err, save_str);
	    abort();
	}
    }
	
    strcpy(subj, ftn.subject);
    if (!strlen(subj)) XSRETURN_IV(rc);
		
    rc = adjust_subj(subj, pathFirst, new_subj, &nsubj);

    if (0 != stricmp(ftn.subject, new_subj[0]) || nsubj > 1) {
    	log_msg_hdr();
	writeToLog(1, "   CheckPath: subject changed");
	writeToLog(1, "   Old : `%s'\n", ftn.subject);
	writeToLog(1, "   New : `%s'\n", new_subj[0]);
	strcpy(ftn.subject, new_subj[0]);
	ftn.stat |= i_Checkedpath;
	ftn.stat |= i_Changed;
    }

    /* generate extra mails */
    if (nsubj > 1) {
	gen_more_mails(ftn, nsubj, new_subj);
    }

    for(i = 0; i < nsubj; ++i)
	free(new_subj[i]);

    if (direct) {
	while(pathFirst) {
	    paths = pathFirst;
	    pathFirst = pathFirst->next;
	    free(paths);
	}
    }
    free(s);
    
    XSRETURN_IV(rc);

}	
/*****************************************************************/
static BOOL adjust_subj(char *old_subj, struct Path *pathFirst,
				char *New_subj[], int *nsubj)
{
    char buf[256], fname[256], *pfname = NULL;
    char full_fname[256], new_subj[72]={0};
/*    struct find_t ffblk; */
    struct Path *path = NULL;
    int MaxSubjLen = 71;
    BOOL rc = Ok, found;
	
    *nsubj = 0;
	
/*	strset(new_subj, 0); */
	
    while (get_next_word(old_subj, fname)) {

	/* chop off old path, if any */
	if (NULL != (pfname = strrchr(fname, DELIM)))
	    ++pfname;
	else
	    pfname = fname;

	found = No;
		
	for(path = pathFirst ; path; path = path->next) {
	    /* add our path */
	    strcpy(full_fname, path->path);
	    strcat(full_fname, pfname);

	    sprintf(buf, "adjust_subj: looking for `%s'... ", full_fname);
	    /* file found ok and name is less then 72 chars */
	    if (!access(full_fname, 0)) {
		sprintf(buf, " ok\n");
		writeToLog(4, buf);
		if (strlen(full_fname) <= MaxSubjLen)
		    strcpy(fname, full_fname);
		found = Yes;
		break;
	    } else {
		memmove(fname, pfname, strlen(pfname)+1);
		sprintf(buf, "not found\n");
		writeToLog(4, buf);
	    }
	} /* paths loop */
		
	if (strlen(new_subj)) {
			
	    /* subj too long, split it */
	    if ((strlen(new_subj) + strlen(fname) + 1) > MaxSubjLen) {
		New_subj[*nsubj] = (char *)malloc(MaxSubjLen);
		strcpy(New_subj[(*nsubj)++], new_subj);
		memset(&new_subj, '\0', 72);
	    } else
		strcat(new_subj, " ");
	}
		
	strcat(new_subj, fname);

	if (!found)
	    rc = Fail;
		
    } /* fname loop */
	
	
    New_subj[*nsubj] = (char *)malloc(MaxSubjLen);
    strcpy(New_subj[(*nsubj)++], new_subj);
	
    return rc;
}
