
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_DefDataBlock)
{
    dXSARGS;
    STRLEN n_a;
    AV *array;
    SV **scalar;
    char **parray = NULL;
    int i, array_len;
    char *err = "perl_DefDataBlock()";
    char *blocktype, *blockname;



    if (items != 3) {
	fprintf(stderr, "%s argument count (need 3, exist %d)\n", err, (int)items);
	abort();
    }


    sp_s = FromSP(0);
    blocktype = XCAL;
    strncpy(blocktype, sp_s, n_a);

    sp_s = FromSP(1);
    blockname = XCAL;
    strncpy(blockname, sp_s, n_a);

    
    array = (AV*)SvRV(ST(2));
    
    array_len = (int)av_len(array) + 1;
    
    for (i = 0; i < array_len ; i++) {
	scalar = av_fetch(array, i, 0);
	if (i) {
	    parray = (char**)xrealloc(parray, (i+1)*sizeof(char*));
	} else {
	    parray = (char**)xmalloc(sizeof(char*));
	}
	sp_s = (char*)SvPV(*scalar, n_a);
	parray[i] = XCAL;
	strncpy(parray[i], sp_s, n_a);
    }

    define_block(blocktype, blockname, parray, array_len, err);
    
    for (i = 0; i < array_len; i++) {
	free(parray[i]);
    }
    free(parray);
    free(blocktype);
    free(blockname);
    
    XSRETURN_UNDEF;
}
/*************************************/
void define_block(char *blocktype, char *blockname, char **parray,
					int array_len, char *err)
{
    char *tag;
    char *data;
    int i;
    void (*f) (char *, char *, char *) = NULL;
    struct Tags *Tag = NULL;
    
    for(i = 0; strlen(TagDesc[i].s); ++i)
	if (!stricmp(TagDesc[i].s, blocktype)) {
	    f = (void (*)(char *, char *, char *))TagDesc[i].deffunc;
	    break;
	}

    if (f == NULL) {
	fprintf(stderr, "%s unknown data type: `%s'\n", err, blocktype);
	abort();
    }

	
    tag = (char*)xcalloc(strlen(blockname)+1, sizeof(char));
    strcpy(tag, blockname);

    for(Tag = TagFirst; Tag; Tag = Tag->next) if (!stricmp(Tag->tag, tag)) {
	memset(Tag->tag, '\0', 20);
	writeToLog(4, "%s tag %s has already been defined, reset\n", err, tag);
	break;
    }


    for (i = 0; i < array_len; i++) {
	data = (char*)xcalloc(strlen(parray[i])+1, sizeof(char));
	strcpy(data, parray[i]);
	f(tag, data, err);
	free(data);
    }
    
    free(tag);
    
    return;
}
