
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


BOOL relaxed = No, direct = No, ALL = No;

static XS(perl_DeleteLine)
{
/* call: ( "[-s] string" ) or ("[-n] lineno") */

    dXSARGS;
    STRLEN n_a;	
    char *parg, *arg, save_arg[256], buf[256];
    char *err="perl_DeleteLine()";
    int l = -1;
    BOOL rc = Fail;
	
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d\n", err, (int)items);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(2, "%s no active message in memory\n", err);
	XSRETURN_IV(rc);
    }
/*///////////////////////////////////////////////////////////////////////*/

	/* parse arguments */

    sp_s = FromSP(0);
    arg = XCAL;
    strcpy(arg, sp_s);
    strip(arg);
    expand_str(arg);

    strcpy(save_arg, arg);

    parg = arg;

	/* maybe -s or -n */
    if (parg[0] == '-') {

		/* lineNo */
	if (parg[1] == 'n') {      
			
	    parg += 2;
	    strip(parg);
			
	    if (!__isnumber(parg)) {
		fprintf(stderr, "%s syntax : `%s'\n", err, save_arg );
		abort();
	    }
			
	    parg[5] = '\0'; /* restrict lineno length */
	    l = atoi(parg);
			
	}

	/* string */
	else if (parg[1] == 's') {
	    parg += 2;
	    strip(parg);
	    if (!strlen(parg)) {
		fprintf(stderr, "%s syntax : `%s'\n", err, save_arg );
		abort();
	    }
	    strcpy(arg, parg);
	}
    }

	/* no keys */
    else if (__isnumber(arg) ) l = atoi(arg);
	
	

	/* kill by lineno */
    if (l != -1)  { 
	l = l ? l : 1;
	rc = kill_text( &TextFirst , l , Mode_Text );
	ftn.stat |= i_Changed;
    } else { 
    /* kill by context */

	TEXT *t = TextFirst, *t_prev = NULL, *t_next = NULL, *tmp;
		
	parg = arg;
		
	while( *parg && (*parg=='~' || *parg=='@' || *parg=='+' || *parg==' ') ) {
	    if (*parg == '~')       relaxed = Yes;
	    else if (*parg == '@')  direct = Yes;
	    else if (*parg == '+')  ALL = Yes;
	    ++parg;
	}

	remove_quotes(parg);
		
	if (!strlen(parg)) {
	    fprintf(stderr, "%s string to kill empty: `%s'\n", err, save_arg);
	    abort();
	}

	while(t) {
	    strcpy (buf, t->str); /* buf will be modified */
			
	    if (find_string(parg, buf, err)) {
		while (t && t->next) {
		    if (t->str[strlen(t->str)-1] == '\r') {
			break;
		    }
		    tmp = t;
		    t = t->next;
		    free (tmp);
		}

		t_next = t->next;

		free(t);

		if (t_prev) {
		    t = t_prev;
		    t->next = t_next;
		} else {
		    t = t_next;
		    TextFirst = t;
		}

		ftn.stat |= i_Changed;
		rc = Ok;
		if (!ALL)
		    break;

	    } /* line found */
	    else {

		while (t && t->next) {
		    if (t->str[strlen(t->str)-1] == '\r') {
	    		break;
		    }
		    t = t->next;
		}

	    }

	    t_prev = t;
	    t = t->next;
	}
	
    } /* kill by context */

    free(arg);
/*///////////////////////////////////////////////////////////////////////*/
    XSRETURN_IV(rc);
}

/************************************************************/
static BOOL find_string( char *tag, char *string, char *err)
{
	struct TextStrTags *TextStrTag = NULL;

	strip_CRLF(string);

	if (direct)
		return comp_strings(string, tag, relaxed);

	
	/*////////////////////////////////////////////////////////////*/
	for( TextStrTag = TextStrTagFirst; TextStrTag; TextStrTag = TextStrTag->next )
		if (!stricmp(tag, TextStrTag->tag))
			break;

	if (!TextStrTag) {
		
	    fprintf(stderr, "%s no such <Data TextString> : `%s'\n", err, tag);
	    abort();
		
	}
		
	TextStrTag->rec = TextStrTag->recfirst;
	for( ; TextStrTag->rec ; TextStrTag->rec = TextStrTag->rec->next )
	{
		if (TextStrTag->rec->preg) {
			if (0 == regexec (TextStrTag->rec->preg, string, 0, NULL, 0)) {
				return Ok;
			}
		}
		else {
			if (comp_strings(string, TextStrTag->rec->str, relaxed))
				return Ok;
		}
		
	}
	
	return Fail;
	
}
