
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_DoOutbound)
{
    dXSARGS;
    STRLEN n_a;
    int Type;
    char *areaname, *err = "perl_DoOutbound()";
    char outname[8];
    

    if (items != 1) {
	fprintf(stderr, "%s argument count(need 1, exist %d)\n", err, (int)items);
	abort();
    }
    sp_s = FromSP(0);
    areaname = XCAL;
    strcpy(areaname, sp_s);
    
    Type = areaname_to_binktype(areaname);
    
    switch (Type) {
    
	case tBINK:
	    sprintf(outname, "Binkley");
	    break;
	case tBRAKE:
	    sprintf(outname, "Brake");
	    break;
	case tAMIGA4D:
	    sprintf(outname, "Amiga4D");
	    break;
	default:
	    sprintf(outname, "Unknown");
	    break;
    
    }
    
    writeToLog(1, "Making %s Outbound\n", outname);
    if (Chat_On) {
	printf("\nMaking %s Outbound\n", outname);
    }

    dobinkout(areaname, Type, err);
	
    if (Chat_On) {
	printf("\n");
    }

    free(areaname);
    XSRETURN_UNDEF;
}

static XS(perl_DoBinkOutbound)
{
    dXSARGS;
    STRLEN n_a;
    char *areaname, *err = "perl_DoBinkOutbound()";
    

    if (items != 1) {
	fprintf(stderr, "%s argument count(need 1, exist %d)\n", err, (int)items);
	abort();
    }
    sp_s = FromSP(0);
    areaname = XCAL;
    strcpy(areaname, sp_s);
    writeToLog(1, "Making Binkley Outbound\n");
    if (Chat_On) {
	printf("\nMaking Binkley Outbound\n");
    }

    dobinkout(areaname, tBINK, err);
	
    if (Chat_On) {
	printf("\n");
    }

    free(areaname);
    XSRETURN_UNDEF;
}

static XS(perl_DoBrakeOutbound)
{
    dXSARGS;
    STRLEN n_a;
    char *areaname, *err = "perl_DoBrakeOutbound";
    
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)", err, (int)items);
	abort();
    }
    
    sp_s = FromSP(0);
    areaname = XCAL;
    strcpy(areaname, sp_s);

    writeToLog(1, "Making Brake Outbound\n");
    
    if (Chat_On) {
	printf("\nMaking Brake Outbound\n");
    }
	
    dobinkout(areaname, tBRAKE, err);
    if (Chat_On) {
	printf("\n");
    }

    free(areaname);

    XSRETURN_UNDEF;
}

static XS(perl_DoAmiga4DOutbound)
{
    dXSARGS;
    STRLEN n_a;
    char *areaname, *err = "perl_DoAmiga4DOutbound";
    
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)", err, (int)items);
	abort();
    }
    
    sp_s = FromSP(0);
    areaname = XCAL;
    strcpy(areaname, sp_s);

    writeToLog(1, "Making Amiga4D Outbound\n");
    
    if (Chat_On) {
	printf("\nMaking Amiga4D Outbound\n");
    }
	
    dobinkout(areaname, tAMIGA4D, err);
    if (Chat_On) {
	printf("\n");
    }

    free(areaname);

    XSRETURN_UNDEF;
}

/******************************************/
static void dobinkout(char *areaname, int outtype, char *err)
{
	char buf[256], OIP_name[256], FIF_name[256];
	char OUT_name[256], FLO_name[256], itxDir[128], areapath[128], bsy[256];
	char IR_name[256], REQ_name[256];
	char caddrFrom[64], caddrTo[64], *pathBase;
	char cflav, c, *p, *q;
	struct BinkAreas *BinkArea = NULL;
	BOOL found = No;
	int done;
	struct find_t ffblk;
/*	FFIND *ff; */
	PKT_HDR *phdr = NULL;
	ADDR from_addr, to_addr;
	struct ATT Att;

	memset(&Att, 0, sizeof(struct ATT));
	
	for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea ->next )
	{
		if (!stricmp(areaname, BinkArea->name)) {
			strcpy( areapath , BinkArea->path );
			outtype = BinkArea->type;
			found = Yes;
			break;
		}
	}
	
	if (found == No) {
	    fprintf(stderr, "%s binkarea undefined: `%s'\n", err, areaname);
	    abort();
	}
	
	
	if ( areapath[strlen(areapath)-1] == DELIM) {
		areapath[strlen(areapath)-1] = '\0';
	}
	
	sprintf( itxDir , "%s.itx" , areapath);
							
							
	/* process tmp mail files  ( OIP->OUT ) */
	sprintf( OIP_name , "%s%c*.?ip" , itxDir, DELIM);
	
	done = _dos_findfirst(OIP_name, 0, &ffblk);
		
	while (!done) {
		
		sprintf( OIP_name , "%s%c%s" , itxDir , DELIM, ffblk.name );
		sprintf( buf , "Outbound handling: %s\n", OIP_name );
		writeToLog(1, buf);
		
		phdr = do_read_pkt(OIP_name);
		
		if ( phdr ) {
			
			from_addr.zone  = phdr->fromZone;
			from_addr.net   = phdr->fromNet;
			from_addr.node  = phdr->fromNode;
			from_addr.point = phdr->fromPoint;
			addr_to_str( from_addr , caddrFrom );
			
			to_addr.zone  = phdr->toZone;
			to_addr.net   = phdr->toNet;
			to_addr.node  = phdr->toNode;
			to_addr.point = phdr->toPoint;
			addr_to_str( to_addr , caddrTo );

			cflav = get_flavor_letter( ffblk.name );
			
			if (outtype == tBINK) {
				pathBase = addr_to_binkoutbase(to_addr, BinkArea);
				sprintf( OUT_name , "%s.%cut" , pathBase , cflav );
				sprintf( bsy , "%s.bsy" , pathBase );
			}
			else if (outtype == tAMIGA4D) {
				pathBase = addr_to_amiga4doutbase(to_addr, BinkArea);
				sprintf( OUT_name , "%s.%cut" , pathBase , cflav );
				sprintf( bsy , "%s.bsy" , pathBase );
			} else {
				char *brflav = brflavor(cflav);
				pathBase = addr_to_brakeoutbase(to_addr, BinkArea);
				
				sprintf( OUT_name , "%s.%s.Mail" , pathBase , brflav );
				sprintf( bsy , "%s.Busy" , pathBase );
			}

			if ( set_bsy(bsy) ) {
				if (do_binkOUT( OIP_name, OUT_name )) {
					sprintf( buf , " Packet from %s to %s  added to %s\n" ,
									caddrFrom, caddrTo , OUT_name );
					writeToLog(1, buf);
					if (Chat_On) {
						printf(".");
					}
				}
				kill_bsy(bsy);
			}
			else {
				sprintf( buf , "Skipping busy system: %s\n", caddrTo );
				writeToLog(1, buf);
			}
			
			++nRead;
			
			free(phdr);
		} /* pkt read ok */
		done = _dos_findnext(&ffblk);
	}
	_dos_findclose(&ffblk);
	/* process tmp attach files  ( FIF->FLO ) */
	sprintf( FIF_name , "%s%c*.?if" , itxDir ,DELIM);
	done = _dos_findfirst(FIF_name, 0, &ffblk);
	
	while (!done) {
		
		sprintf( FIF_name , "%s%c%s", itxDir, DELIM, ffblk.name );
		sprintf( buf , "Outbound handling %s\n", FIF_name);
		writeToLog(1, buf);

		if (Ok == get_attach_info(FIF_name, &Att)) {
		
			addr_to_str( Att.addr , caddrTo );

			cflav = get_flavor_letter( ffblk.name );

			if (outtype == tBINK) {
				pathBase = addr_to_binkoutbase( Att.addr, BinkArea );
				sprintf( FLO_name , "%s.%clo" , pathBase , cflav );
				sprintf( bsy , "%s.bsy" , pathBase );
			}
			else if (outtype == tAMIGA4D) {
				pathBase = addr_to_amiga4doutbase(Att.addr, BinkArea);
				sprintf( FLO_name , "%s.%clo" , pathBase , cflav );
				sprintf( bsy , "%s.bsy" , pathBase );
			} else {
				char *brflav = brflavor(cflav);
				pathBase = addr_to_brakeoutbase(Att.addr, BinkArea);
				
				sprintf( FLO_name , "%s.%s.List" , pathBase , brflav );
				sprintf( bsy , "%s.Busy" , pathBase );
			}

			if ( set_bsy(bsy) ) {
				if (do_binkFLO(Att.fif_body, FLO_name )) {
					sprintf( buf , " attach to : %s,   added to: %s\n" ,  caddrTo , FLO_name );
					writeToLog(1, buf);
					if (Chat_On) {
						c = *Att.fif_body;
						if (c!='#' && c!='^')
							c = 'A';
						printf("%c", c);
					}
					
					if (0 != remove(FIF_name)) {
						sprintf(buf, "dobinkout: error deleting *.?IF file: `%s'\n",
										FIF_name);
						writeToLog(0, buf);
					}
				}
				kill_bsy(bsy);
			}
			else {
				sprintf( buf , "skipping busy system: %s\n", caddrTo );
				writeToLog(1, buf);
			}

			++nRead;

			free(Att.fif_body);
			Att.fif_body = NULL;
			
		} /* FIF read OK */
		done = _dos_findnext(&ffblk);
	}
	_dos_findclose(&ffblk);
	
	/* process tmp FREQ files  ( IR->REQ ) */
	sprintf( IR_name , "%s%c*.ir" , itxDir , DELIM);
	
	done = _dos_findfirst(IR_name, 0, &ffblk);
	
	while (!done) {
		
		sprintf( IR_name , "%s%c%s" , itxDir , DELIM, ffblk.name );
		sprintf( buf , "Outbound handling %s\n", IR_name);
		writeToLog(1, buf);

		if (Ok == get_attach_info(IR_name, &Att)) {
		
			addr_to_str( Att.addr , caddrTo );

			if (outtype == tBINK) {
				pathBase = addr_to_binkoutbase( Att.addr, BinkArea );
				sprintf( REQ_name , "%s.req" , pathBase );
				sprintf( bsy , "%s.bsy" , pathBase );
			}
			else if (outtype == tAMIGA4D) {
				pathBase = addr_to_amiga4doutbase( Att.addr, BinkArea );
				sprintf( REQ_name , "%s.req" , pathBase );
				sprintf( bsy , "%s.bsy" , pathBase );
			} else {
				pathBase = addr_to_brakeoutbase(Att.addr, BinkArea);
				
				sprintf( REQ_name , "%s.Request" , pathBase);
				sprintf( bsy , "%s.Busy" , pathBase );
			}

			if ( set_bsy(bsy) ) {
				if (do_binkFLO(Att.fif_body, REQ_name )) {
					sprintf( buf , " FREQ to : %s,   added to: %s\n" ,
									caddrTo , REQ_name );
					writeToLog(1, buf);
					if (Chat_On) {
						p = Att.fif_body;
						while (p) {
							if ((q = strchr(p, '\r')))
								printf("R");
							else
								break;
							p = q + 1;
						}
					}
					
					if (0 != remove(IR_name)) {
						sprintf(buf, "dobinkout: error deleting *.IR file: `%s'\n",
										IR_name);
						writeToLog(0, buf);
					}
				}
				kill_bsy(bsy);
			}
			else {
				sprintf( buf , "skipping busy system: %s\n", caddrTo );
				writeToLog(1, buf);
			}

			++nRead;

			free(Att.fif_body);
			Att.fif_body = NULL;
			
		} /* IR read OK */
		done = _dos_findnext(&ffblk);
	}
	_dos_findclose(&ffblk);
	return;
}

/****************************************************************************/
static PKT_HDR *do_read_pkt( char *OIP_name )
{
	int h; /* *.?IP */
/*	ULONG len; */
	PKT_HDR *phdr;
	
	if( (h = open(OIP_name, O_RDONLY|O_BINARY)) == -1 ) {
		writeToLog(0, "do_read_pkt: error opening *.?IP file: `%s'\n", OIP_name);
		return  NULL;
	}
	
	phdr = (PKT_HDR *)xcalloc(1, PKT_HDR_SIZE);
/*	len = sizeof( PKT_HDR ); */
	if ( PKT_HDR_SIZE != ReadPktHdr( h, phdr) ){
		writeToLog(0, "do_read_pkt: error reading *.?IP file: `%s'\n", OIP_name);
		close(h);
		free(phdr);
		return NULL;
	}
	
	close(h);

	if (phdr->pktType != 0x0002) {
		writeToLog(0, "do_read_pkt: error: `%s' is no type 2 pkt file\n", OIP_name);
		free(phdr);
		return NULL;
	}
	
	return phdr;
}
/****************************************************************************/
static char get_flavor_letter( char *name )
{
	while( *name && *name++!='.' )
	{};
	
	return *name;

}
/****************************************************************************/
static BOOL do_binkOUT(char *fromName, char *toName)
{
	int hFrom, hTo;
	PKT_HDR hdrFrom, tmpHdr;  /* pkt hdr */
	char *fromText = NULL;  /* pkt message hdr + text */
	char z[2] = {0};
	char *backup;
/*	struct find_t ffblk; */
	ULONG len, tlen;
	BOOL No_OUT = No;
	word two_zeroes;
	
	if( (hFrom = sopen(fromName, O_RDONLY|O_BINARY, SH_DENYNO, ACCFILE)) == -1 ) {
		writeToLog(0, "dobinkout: error opening *.?IP file: `%s'\n", fromName);
		return Fail;
	}
	
	lseek( hFrom , 0 , SEEK_SET );
	len = PKT_HDR_SIZE;
	if ( len != ReadPktHdr( hFrom, &hdrFrom) ) {
		writeToLog(0, "dobinkout: error reading *.?IP file: `%s'\n", fromName);
		close(hFrom);
		return Fail;
	}
	
	tlen = filelength(hFrom) - len;
	fromText = (char *)calloc( tlen + 1 , sizeof(char));
	
	if ( tlen != read( hFrom, fromText, tlen ) ){
		writeToLog(0, "dobinkout: error reading *.?IP file: `%s'\n", fromName);
		close(hFrom);
		free(fromText);
		return Fail;
	}
	
	close(hFrom);
	
	if ( !access(toName, 0) ) { /* search for *.OUT */
		/* Exist */
		No_OUT = No;
		while (1) /* never looped! */
		{
			/* open existing *.OUT */
			if( (hTo = sopen(toName, O_RDWR|O_BINARY, SH_DENYNO, ACCFILE)) == -1 ) {
				writeToLog(0, "dobinkout: error opening *.OUT file: `%s'\n", toName);
				No_OUT = Yes;
				break;
			}
			
			/* read pkt header of *.OUT */
			lseek( hTo , 0 , SEEK_SET );
			len = PKT_HDR_SIZE;
			if ( len != ReadPktHdr( hTo, &tmpHdr) ){
				writeToLog(0, "dobinkout: error reading *.OUT file: `%s'\n", toName);
				close(hTo);
				No_OUT = Yes;
				break;
			}

			/* check pkt type */
			if (tmpHdr.pktType != 0x0002) {
				writeToLog(0, "dobinkout: error: `%s' is no type 2 pkt file\n", toName);
				close(hTo);
				No_OUT = Yes;
				break;
			}
			
			/* skip back two trailing zeroes */
			if ( -1 == (lseek(hTo , -2L , SEEK_END)) ) { 
				writeToLog(0, "dobinkout: lseek error in `%s'\n", toName);
				close(hTo);
				No_OUT = Yes;
				break;
			}
			/* check for two trailing zeroes */
			len = sizeof(word);
			if ( len != read( hTo, &two_zeroes, len ) ){
				writeToLog(0, "dobinkout: error reading *.OUT file: `%s'\n", toName);
				close(hTo);
				No_OUT = Yes;
				break;
			}
			if (two_zeroes != 0L) {
				writeToLog(0, "dobinkout: error in `%s':  packet grunged\n", toName);
				close(hTo);
				No_OUT = Yes;
				break;
			}
			/* skip back two trailing zeroes */
			if ( -1 == (lseek(hTo , -2L , SEEK_END)) ) { 
				writeToLog(0, "dobinkout: lseek error in `%s'\n", toName);
				close(hTo);
				No_OUT = Yes;
				break;
			}
		
			No_OUT = No;
			break; /* *.OUT found and OK to add to */
			
		} /* while(1) */

		if (No_OUT) { /* file grunged */

			backup = (char*)xcalloc(strlen(toName)+1, sizeof(char));
			strncpy(backup, toName, strlen(toName)-3);
			strcat(backup, "bad");
			writeToLog(0, "dobinkout: pkt file `%s' grunged, renaming to `%s'\n",
							toName, backup);
			
			if ( rename(toName, backup) ) {
				writeToLog(0, "dobinkout: error renaming grunged pkt file `%s' to `%s'\n",
								toName, backup);
			}
			free(backup);
		} /* No_OUT set */
	}
	else {
		No_OUT = Yes; /* need to create new OUT file */
	}
				
	/**    *.OUT not found or file grunged, creating new **/
	if (No_OUT) {
		if (-1 == (hTo = open(toName, O_RDWR|O_BINARY|O_CREAT|O_EXCL, ACCFILE))) {
			writeToLog(0, "dobinkout: can`t create new *.OUT file: `%s'\n", toName);
			perror(toName);
			free(fromText);
			return Fail;
		}
	
		lseek( hTo, 0L, SEEK_SET);
		
		/* write pkt header */
		len = PKT_HDR_SIZE;
		if ( len != WritePktHdr( hTo, &hdrFrom) ){
			writeToLog(0, "dobinkout: error writing *.OUT file: `%s'\n", toName);
			close(hTo);
			free(fromText);
			return Fail;
		}
	} /* No_OUT */

	/* write pkt text */
	if ( tlen != write( hTo, fromText, tlen ) ){
		writeToLog(0, "dobinkout: error writing *.OUT file: `%s'\n", toName);
		close(hTo);
		free(fromText);
		return Fail;
	}

	write(hTo, z, 2);

	close(hTo);
	
	free(fromText);

	if ( remove(fromName) ) {
		writeToLog(0, "dobinkout: error deleting *.?IP file: `%s'\n", fromName);
	}
	
	++nWritten;

	return Ok;
}
/****************************************************************************/
static BOOL do_binkFLO(char *fif_body, char *toName)
{
	int hTo;
	char buf[256];
	dword len;
	
	if( (hTo = open(toName, O_RDWR|O_BINARY|O_CREAT|O_APPEND, ACCFILE)) == -1 ) {
		sprintf(buf, "dobinkFLO: error opening *.?LO file: `%s'\n", toName);
		writeToLog(0, buf);
		return Fail;
	}
	
	len = strlen(fif_body);
	if (len != write(hTo, fif_body, len ) ){
		sprintf(buf, "dobinkFLO: error writing *.?LO file: `%s'\n", toName);
		writeToLog(0, buf);
		close(hTo);
		return Fail;
	} 
	
	++nWritten;

	close(hTo);

	return Ok;
}
/**************************************************************************/
BOOL set_bsy( char *bsy)
{
	int hTo;
	
	if (IgnoreBSY == Yes)
		return Ok;
	hTo = sopen (bsy, O_CREAT | O_EXCL | O_TRUNC | O_RDWR, SH_DENYNO, ACCFILE);

	if (hTo == -1) {
		return Fail;
	}
	close(hTo);
	return Ok;
}
/**************************************************************************/
void kill_bsy( char *bsy)
{
	if (IgnoreBSY == Yes)
		return;
	
	if ( remove(bsy) ) {
		writeToLog(0, "dobinkout: error deleting *.bsy file: `%s'\n", bsy);
	}

	return;
}
/************************************************************************/
char * addr_to_binkoutbase(ADDR addr, struct BinkAreas *Bink)
{
	char basepath[256], nodepath[256], path[128];
	char system[20]={0}, domain[64]={0}, ext[6]={0};
	ADDR aka;
	static char fname[256];
	
	strcpy(path, Bink->path);
	
	if (path[strlen(path)-1] == DELIM) {
		path[strlen(path)-1] = '\0';
	}
	
	if (Bink->multi_domain) {
		
		areaname_to_system(Bink->name, system);
		if (strlen(system)) {
			get_def_addr(system, addr, &aka);
			strcpy(domain, aka.domain);
		}
		
		if (!strlen(domain))
			strcpy(domain, MainAddress.domain);
	}
	
	if (Bink->no_main_zone || (addr.zone != MainAddress.zone))
		sprintf(ext, ".%03x", addr.zone );

	strcpy(basepath, path);
	if (strlen(domain)) {
		strcat(basepath, SEP);
		strcat(basepath, domain);
	}
	
	if (strlen(ext))
		strcat(basepath, ext);
	
	fix_path(basepath);  /* fix root outbound directory */
	
	if (addr.point == 0) {
		sprintf( fname , "%.240s%c%04x%04x", basepath, DELIM, addr.net, addr.node );
	}
	else {
		sprintf( nodepath , "%.240s%c%04x%04x.pnt", basepath, DELIM, addr.net, addr.node );
		fix_path(nodepath);  /* fix 'outbound\node' directory */
		sprintf( fname , "%.240s%c%08x", nodepath, DELIM, addr.point );
	}
	
	return fname;
	
}
/************************************************************************/
char * addr_to_amiga4doutbase(ADDR to, struct BinkAreas *Bink)
{
	static char p[256];
	char system[20];
	ADDR aka;
	areaname_to_system(Bink->name, system);
	get_def_addr(system, to, &aka);
	sprintf(p, "%s%hu.%hu.%hu.%hu",
					Bink->path, to.zone, to.net, to.node, to.point);
	return p;
}
/************************************************************************/
char * addr_to_brakeoutbase(ADDR to, struct BinkAreas *Bink)
{
	static char p[256];
	char system[20];
	ADDR aka;
	areaname_to_system(Bink->name, system);
	get_def_addr(system, to, &aka);
	sprintf(p, "%s%s.%hu.%hu.%hu.%hu",
					Bink->path, aka.domain, to.zone, to.net, to.node, to.point);
	return p;
}

static char * brflavor(char cflav)
{
	static char *p;

	if (cflav == 'H' || cflav == 'h')
		p = "Hold";
	else if (cflav == 'I' || cflav == 'i')
		p = "Immediate";
	else if (cflav == 'C' || cflav == 'c')
		p = "Crash";
	else if (cflav == 'D' || cflav == 'd')
		p = "Direct";
	else
		p = "Normal";
	
	return p;
	
}

/*********************************************/
static BOOL get_attach_info(char *FIF_name, struct ATT *att)
{
	int h;
	sADDR addr;
	dword len;
	char buf[256];
	
	if( (h = open(FIF_name, O_RDONLY|O_BINARY)) == -1 ) {
		sprintf(buf, "get_attach_info: error opening *.?IF file: `%s'\n", FIF_name);
		writeToLog(0, buf);
		return  Fail;
	}
	
	len = sizeof(sADDR);
	if ( len != read( h, &addr, len ) ){
		sprintf(buf, "get_attach_info: error reading *.?IF file: `%s'\n", FIF_name);
		writeToLog(0, buf);
		close(h);
		return Fail;
	}
	
	len = filelength(h) - tell(h);
	att->fif_body = (char *)malloc(len+1);
	if ( len != read( h, att->fif_body, len ) ){
		sprintf(buf, "get_attach_info: error reading (fspec) *.FIF file: `%s'\n", FIF_name);
		writeToLog(0, buf);
		close(h);
		return Fail;
	}
	att->fif_body [len] = '\0';
	
	close(h);

	att->addr.zone  = addr.zone;
	att->addr.net   = addr.net;
	att->addr.node  = addr.node;
	att->addr.point = addr.point;
	
	return Ok;
	
}

int areaname_to_binktype(char *areaname) {

    struct BinkAreas *BinkArea = NULL;

    for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea ->next ) {
	if (!stricmp(areaname, BinkArea->name)) {
	    return BinkArea->type;
	}
    }
	
    return -1;
}
