
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_GetAreaList)
{

    static TEXT *list = NULL;

    dXSARGS;
    char *err = "perl_GetAreaList()";
    char **prealist = NULL;
    int count, alist;
    TEXT *tmp;
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
	
/*///////////////////////////////////////////////////////////////////////*/
																			/* Initialize data area       */
    for(count = 0, getalist(&list); list; list = tmp ) {
	if (count == 0) prealist = (char**)xmalloc((count+1)*sizeof(char*));
	else prealist = (char**)xrealloc(prealist, (count+1)*sizeof(char*));

	prealist[count] = (char*)calloc(strlen(list->str)+1, sizeof(char));
	strcpy(prealist[count], list->str);
	tmp = list->next;
	free(list);
	count++;
		
    } /* text loop */

    if (count) {
	EXTEND(SP, count);
    
        for (alist = 0; alist < count; alist++) {
	    ST(alist) = sv_newmortal();
	    sv_setpv((SV*)ST(alist), prealist[alist]);
	    free(prealist[alist]);
	}
	
	free(prealist);
	XSRETURN(alist);
    }
																		/* set stem.0 to lines read   */
    XSRETURN_UNDEF;
}

/**********************************/
static void getalist(TEXT **list)
{
	struct FidoAreas *FidoArea;
	struct BinkAreas *BinkArea;
	struct SquishAreas *SquishArea;
	struct JamAreas *JamArea;
	struct PktAreas  *PktArea;
	
	for( FidoArea = FidoAreaFirst; FidoArea; FidoArea = FidoArea->next )
		add_list(FidoArea->name, list);
	
	for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea->next )
		add_list(BinkArea->name, list);
	
	for( PktArea = PktAreaFirst; PktArea; PktArea = PktArea->next )
		add_list(PktArea->name, list);
	
	for( SquishArea = SquishAreaFirst; SquishArea; SquishArea = SquishArea->next )
		add_list(SquishArea->name, list);
	
	for( JamArea = JamAreaFirst; JamArea; JamArea = JamArea->next )
		add_list(JamArea->name, list);

			
	return;
}

/******************************/
static void add_list(char *s, TEXT **list)
{
	static TEXT *tmp;

	tmp = (TEXT *) calloc(1, sizeof(TEXT) );
	strcpy(tmp->str, s);
	tmp->next = *list;

	*list = tmp;

	return;
}
