
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_SetGlobalVar)
{
    dXSARGS;
    STRLEN n_a;
    char *err="SetGlobalVar()";
    struct _gv *gv;
	
    if (items != 2) {
	fprintf(stderr, "%s argument count (need 2, exist %d)\n", err, (int)items);
	abort();
    }

    sp_s = FromSP(0);
    
    for (gv = GlobalVarList; gv; gv = gv->next) {
	if ( gv->var && !stricmp(gv->var, sp_s) ) {
	    sp_s = FromSP(1);
	    free (gv->val);
	    gv->val = xstrcpy (sp_s);
	    break;
	}
    }

    if (!gv) {
	gv = (struct _gv *)xmalloc(sizeof(struct _gv));
	gv->next = GlobalVarList;
	gv->var = xstrcpy (sp_s);
	sp_s = FromSP(1);
	gv->val = xstrcpy (sp_s);
	GlobalVarList = gv;
    }

    XSRETURN_UNDEF;	
}

static XS(perl_GetGlobalVar)
{
    dXSARGS;
    STRLEN n_a;
    char *pgv, *err="GetGlobalVar()";

    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }

    sp_s = FromSP(0);	
    pgv = get_global_var(sp_s);

    if (pgv) {
	XSRETURN_PV(pgv);
    }
    XSRETURN_UNDEF;
}

static XS(perl_UnSetGlobalVar)
{
    dXSARGS;
    STRLEN n_a;
    char *err="UnSetGlobalVar()";
    struct _gv *gv;
	
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d\n", err, (int)items);
	abort();
    }
	

    sp_s = FromSP(0);
    
    for (gv = GlobalVarList; gv; gv = gv->next) {
	if ( gv->var && !stricmp(gv->var, sp_s) ) {
	    free(gv->var);
	    free(gv->val);
	    gv->var = gv->val = NULL;
	}
    }

    XSRETURN_UNDEF;
	
}
/***************************************/
char* get_global_var(char *var)
{
	struct _gv *gv;

	for (gv = GlobalVarList; gv; gv = gv->next)
		if (gv->var && !stricmp(gv->var, var))
			return gv->val;
	
	return NULL;
}
/***************************************/
BOOL get_global_var_old(char *in, char* out)
{
	struct _gv *gv;

	for (gv = GlobalVarList; gv; gv = gv->next)
		if (gv->var && !stricmp(gv->var, in)) {
			strncpy (out, gv->val, 255);
			out[255] = '\0';
			return Ok;
		}
	
	return Fail;
}

