
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_KillKludge)
{
    dXSARGS;
    STRLEN n_a;
    char *s = NULL, save_str[256], arg1[256];
    char *err="perl_KillKludge()";
    char ckl[128], *p, str[256], save_kl[256], real_kl[128], tag[128];
    struct KludgeTags *KludgeTag = NULL;
    TEXT *Text, *T_prev = NULL, *T_next = NULL;
    BOOL relaxed = No, direct = No, set = Yes, found, kill_all = No;
    BOOL RegEx = No;

	
    if ( items > 1 ) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }

    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
	

    if (items) {

	sp_s = FromSP(0);		
	s = XCAL;
	strcpy(s, sp_s);
	strip(s);
	expand_str( s );

	strcpy(save_str, s);


	p = s;

	while( *p && (*p=='!' || *p=='~' || *p=='@')) {
    	    if (*p == '!') { /* negate data */
		++p;
		strip(p);
		if (set == No) {
		    fprintf(stderr, "%s syntax: `%s'\n",  err, save_str);
		    abort();
		}
		set = No;
	    }
	    if (*p == '~') {
		++p;
		strip(p);
		if (relaxed) {
		    fprintf(stderr, "%s syntax: `%s'\n",  err, save_str);
		    abort();
		}
		relaxed = Yes;
	    }
	    if (*p == '@') { /* direct data */
		++p;
		strip(p);
		if (direct) {
		    fprintf(stderr, "%s syntax: `%s'\n",  err, save_str);
		    abort();
		}
		direct = Yes;
	    }
	} /* while !~@ */

	get_next_word(p, tag);

	/* direct data definition */
	if (direct) {


	    writeToLog(4, "kill_kludge: direct kludge: `%s'\n", p);

	    if (!strlen(p)) {
		fprintf(stderr, "%s syntax: `%s'\n", err , save_str );
		abort();
	    }

	    strcpy(save_kl, p);

	} /* direct data */

	else {
			
	    memset(&save_kl, '\0', 256);

	    for( KludgeTag = KludgeTagFirst; KludgeTag; KludgeTag = KludgeTag->next )
		if (!stricmp(tag, KludgeTag->tag))
		    break;

		if (!KludgeTag) {
		    fprintf(stderr, "%s kill_kludge error:  no such <Data Kludge> : `%s'\n", err, tag);
		    abort();
		}

		KludgeTag->rec = KludgeTag->recfirst;
			
		if (KludgeTag->rec->klfirst->preg)
		    RegEx = Yes;
		else {
		    for(; KludgeTag->rec; KludgeTag->rec = KludgeTag->rec->next ) {
			KludgeTag->rec->kl = KludgeTag->rec->klfirst;
			for( ; KludgeTag->rec->kl; KludgeTag->rec->kl = KludgeTag->rec->kl->next ) {
			    if (strlen(save_kl))
				strcat(save_kl, " ");
			    strcat(save_kl, KludgeTag->rec->kl->kl);
			}
		    }
		}

	    } /* block data */
		
	} /* argc > 0 */
	else
	    kill_all = Yes;
		
	Text = TextFirst;
	while(Text) {
/*    if (is_kludge(Text->str) && !is_reserved_kludge(Text->str)) { */
    	    if (is_kludge(Text->str)) {

	    strcpy( str, Text->str);
	    get_next_word(str, arg1);
			
	    if (kill_all)
		found = set = Ok;
	    else {
				
		found = No;

		/* block data and regex supported */
		if (RegEx) {
		    KludgeTag->rec = KludgeTag->recfirst;
		    for(; KludgeTag->rec; KludgeTag->rec = KludgeTag->rec->next ) {
			KludgeTag->rec->kl = KludgeTag->rec->klfirst;
			for( ; KludgeTag->rec->kl; KludgeTag->rec->kl = KludgeTag->rec->kl->next ) {
			    if (!KludgeTag->rec->kl->set)
				continue;
			    if (0 == regexec (KludgeTag->rec->kl->preg, arg1, 0, NULL, 0)) {
				found = Yes;
				break;
			    }

			}
		    }
		}
		/* no regex - strings only */
		else {
		    strcpy(s, save_kl);

		    while(get_next_word(s, ckl)) {
			if (*ckl == '!')
			continue;

			if (direct) sprintf(real_kl, "\1%s", ckl);
			else strcpy(real_kl, ckl);

			if (comp_strings(arg1, real_kl, relaxed )) {
			    found = Yes;
			    break;
			}

		    } /* substr walk */
		}   /* !RegEx */
	    }     /* !kill_all */
			
	    if (found == set) {
				
		writeToLog(4, "kill_kludge: kill this kludge: `%s'\n", arg1);
		ftn.stat |= i_Changed;

		T_next = Text->next;
				
		free(Text);
				
		if (T_prev) {
		    Text = T_prev;
		    Text->next = T_next;
		} else {
		    Text = T_next;
		    TextFirst = Text;
		    continue;
		}
				
	    }

	} /* safe kludge found */

	T_prev = Text;
	Text = Text->next;

    } /* text walk */
    
    free(s);

    XSRETURN_UNDEF;
}
