
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/
 
static XS(perl_InvalideTearOrig)
{
    dXSARGS;
    char *err="perl_InvalideTearOrig";
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
    
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
    
    if (TextFirst) {
	inv_tear_orig(TextFirst);
    }
    XSRETURN_UNDEF;
}


static XS(perl_Kill)
{
    dXSARGS;

    char *err="perl_Kill";
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
	
    log_msg_hdr();

    if (kill_msg()) writeToLog(1, "   Killed");
    else writeToLog(0, "error: Kill failed");

    /* Resetting globals */
	
    free_text(TextFirst);  
    TextFirst = NULL;    
    free_text(ViaTextFirst);
    ViaTextFirst = NULL;
    ftn.stat = 0L;
    ftn.flag = 0; 
    CurMsg.n = 0;
    sq_errno = 0;
    jam_errno = 0;

    XSRETURN_UNDEF;
}

static XS(perl_Move)
{
/* call: Move(areaname, [-t nameTo], [-f nameFrom],  [-s subj],
			    [-a attr], [-h header], [-l line] ) */
			
    dXSARGS;
    STRLEN n_a;				
    char *arg[10], *err="perl_Move()";
    char *areatag, cflag[128];
    NewMsgArg nma;
    int i, n, areatype;
    TEXT *newtext = NULL;
    FTN new_ftn;
    BOOL isEcho, rc = Ok;
	
    if (items < 1) {
	fprintf(stderr, "%s argument count (need 1 or more, exist %d)\n", err, (int)items);
	abort();
    }

    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
	
    items = (items<10) ? items : 10;
    sp_s = FromSP(0);
    areatag = XCAL;
    strcpy(areatag, sp_s);
    strip(areatag);
    remove_quotes(areatag);
    expand_str(areatag);
	
	/* set defaults */
    memset(&nma, 0, sizeof(NewMsgArg));
    strcpy(nma.fromName, ftn.fromName );
    strcpy(nma.toName, ftn.toName );
    strcpy(nma.subj, ftn.subject );
    nma.hText = nma.lText = NULL;
    nma.to = ftn.to;
    nma.from = ftn.from;
    nma.tlineNo = 0; /* no template */
    nma.llineNo = 0; /* no string */
    nma.aa.attr = ftn.attr;
    nma.aa.flag = ftn.flag;
    nma.aa.stat = ftn.stat;
    memset(&new_ftn, 0, sizeof(FTN));
    /*//////////////////////////////////////*/
    for(i = 0; i < items-1; i++) {
		
	sp_s = FromSP(i+1);
	arg[i] = XCAL;
	strcpy(arg[i], sp_s);
	strip (arg[i]);
	remove_quotes (arg[i]);
	expand_str_200 (&arg[i]);
    }
	
    if (-1 == (areatype = areaname_to_type(areatag))) {
	fprintf(stderr, "%s unknown area `%s'\n", err, strUpper(areatag));
	for (i = 0; i < items-1; i++) {
	    free(arg[i]);
	}	
	free(areatag);
	abort();
    }
	
    isEcho = is_echoarea(areatype, areatag);
	
    if (isEcho) {
	nma.aa.attr = 0;
	nma.aa.flag = 0;
    }
	
    if (items-1) get_new_msg_arg( items-1, arg, err, &nma );


    /* log original msg before changing */
    log_msg_hdr();
	
    new_ftn = change_hdr(ftn, nma);
    newtext = change_text(TextFirst, nma, new_ftn.from);
	
    if (isEcho) {
		
	(void) kill_netmail_kludges(&newtext);
		
	if (!addr_cmp(ftn.from, new_ftn.from)) {
	    writeToLog(4, "move: changing echomail kludges\n");
	    (void)change_echo_kludges(new_ftn, newtext);
	}
		
    }  /* echomail */
	
    else {
		
	/* set routing if defined */
	if (strlen (nma.route)) {
	    if (!str_to_addr (nma.route, &new_ftn.routeTo)) {
		writeToLog(4, "set_route: `%s' is not valid ADDR, try block route",
							 nma.route);
		set_route (nma.route, &new_ftn);
	    }
	}
		
	if (!addr_cmp(ftn.to, new_ftn.to) || !addr_cmp(ftn.from, new_ftn.from)) {
	    writeToLog(4, "move: changing netmail kludges");
	    (void)change_address_kludges(&new_ftn, &newtext);
	}
    }  /* netmail */
	
    /* adjust FLAGS kludge if needed */
    if (isEcho || nma.aa.flag != ftn.flag) {
	flag_to_str( nma.aa.flag, cflag );
	(void) set_flag_kludge(&newtext, cflag );
    }
	
	
    if (new_ftn.stat & i_Invalidvias) {
	writeToLog(2, "move: invalidate vias\n");
	inv_vias(newtext);
    }
    if (new_ftn.stat & i_Invkludges) {
	writeToLog(2, "move: invalidate kludges\n");

	if (areatype == TXT) {
			/* invalidate all kludges */
	    inv_kludges(newtext, 1);
	} else {
	    /* leave off addressing kludges */
	    inv_kludges(newtext, 0);
	}
    }

    *OutFileName = '\0';
    if (Fail != (n = add_msg(areatype, areatag, &new_ftn, newtext, nma.pkt_hdr))) {

	if (CurMsg.type == FIDO || CurMsg.type == SQUISH || areatype == JAM) {
	    writeToLog(1, "   %d created in %s\n", n, strUpper(areatag) );
        }
	writeToLog(1, "   Moved to area %s\n", areatag );
	++nWritten;
		
	if (Fail == kill_msg()) {
	    rc = Fail;
	}
    } else {
	rc = Fail;
    }

    if (rc == Fail) {
	writeToLog(0, "%s move failed\n", err);
	if (CurMsg.type == BINK || CurMsg.type == PKT) {
	    fprintf(stderr, "%s move failed\n", err);
	    for (i = 0; i < items-1; i++) {
		free(arg[i]);
	    }	
	    free(areatag);
	    abort();
	}
    }
	
    free_text(newtext);
    free (nma.pkt_hdr);

    /* Resetting globals */
	
    free_text(TextFirst);  
    TextFirst = NULL;    
    free_text(ViaTextFirst);
    ViaTextFirst = NULL;
    ftn.stat = 0L;
    ftn.flag = 0; 
    CurMsg.n = 0;
    sq_errno = 0; 
    
    for (i = 0; i < items-1; i++) {
	free(arg[i]);
    }
    free(areatag);
    
    XSRETURN_PV(OutFileName);
}

static XS(perl_CopyArea)
{
/* call: CopyArea(areaname, [-t nameTo], [-f nameFrom],  [-s subj],  
			[-a attr], [-h header], [-l line] ) */

    dXSARGS;
    STRLEN n_a;				
    char *arg[10], *err="perl_CopyArea()";
    char *areatag, cflag[128];
    NewMsgArg nma;
    int i, n, areatype;
    TEXT *newtext = NULL;
    FTN new_ftn;
    BOOL isEcho;

    if (items < 1) {
	fprintf(stderr, "%s argument count (need 1 or more, exist %d\n", err, (int)items);
	abort();
    }

    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
	
    items = (items<10) ? items : 10;
	
    sp_s = FromSP(0);
    areatag = XCAL;
    strcpy(areatag, sp_s);
    strip(areatag);
    remove_quotes(areatag);
    expand_str(areatag);
	
	/* set defaults */
    memset(&nma, 0, sizeof(NewMsgArg));
    strcpy(nma.fromName, ftn.fromName );
    strcpy(nma.toName, ftn.toName );
    strcpy(nma.subj, ftn.subject );
    nma.hText = nma.lText = NULL;
    nma.to = ftn.to;
    nma.from = ftn.from;
    nma.tlineNo = 0; /* no template */
    nma.llineNo = 0; /* no string */
    nma.aa.attr = ftn.attr;
    nma.aa.flag = ftn.flag;
    nma.aa.stat = ftn.stat;
    memset(&new_ftn, 0, sizeof(FTN));
    /****************************************/
	

    for(i = 0; i < items-1; ++i) {
	sp_s = FromSP(i+1);
	arg[i] = XCAL;
	strcpy(arg[i], sp_s);
	strip (arg[i]);
	remove_quotes (arg[i]);
	expand_str_200 (&arg[i]);
    }
	
	
    if (-1 == (areatype = areaname_to_type(areatag))) {
	fprintf(stderr, "%s unknown area `%s'\n", err, strUpper(areatag));
	for (i = 0; i < items-1; i++) {
	    free(arg[i]);
        }	
	free(areatag);
	abort();
    }
	
    isEcho = is_echoarea(areatype, areatag);
	
    if (isEcho) {
	nma.aa.attr = 0;
	nma.aa.flag = 0;
    }

    if (items-1)
	get_new_msg_arg( items-1, arg, err, &nma );
	
	
    /* log original msg before changing */
    log_msg_hdr();

    new_ftn = change_hdr(ftn, nma);
    newtext = change_text(TextFirst, nma, new_ftn.from);
	
    if (isEcho) {
		
	(void) kill_netmail_kludges(&newtext);
	
	if (!addr_cmp(ftn.from, new_ftn.from)) {
	    writeToLog(4, "copyarea: changing echomail kludges");
	    (void)change_echo_kludges(new_ftn, newtext);
	}
		
    }  /* echomail */
	
    else {

	/* set routing if defined */
	if (strlen (nma.route)) {
	    if (!str_to_addr (nma.route, &new_ftn.routeTo)) {
		writeToLog(4, "set_route: `%s' is not valid ADDR, try block route\n",
						 nma.route);
		set_route (nma.route, &new_ftn);
	    }
	}
		
	if (!addr_cmp(ftn.to, new_ftn.to) || !addr_cmp(ftn.from, new_ftn.from)) {
	    writeToLog(4, "copyarea: changing netmail kludges");
	    (void)change_address_kludges(&new_ftn, &newtext);
	}
    }  /* netmail */

	
    /* adjust FLAGS kludge if needed */
    if (isEcho || nma.aa.flag != ftn.flag) {
	writeToLog(4, "copyarea: adjust FLAGS kludge");
	flag_to_str( nma.aa.flag, cflag );
	(void) set_flag_kludge(&newtext, cflag );
    }
	
    if (new_ftn.stat & i_Invalidvias) {
	writeToLog(2, "copyarea: invalidate vias");
	(void) inv_vias(newtext);
    }
    if (new_ftn.stat & i_Invkludges) {
	writeToLog(2, "copyarea: invalidate kludges");

	if (areatype == TXT) {
	    /* invalidate all kludges */
	    inv_kludges(newtext, 1);
	} else {
	    /* leave off addressing kludges */
	    inv_kludges(newtext, 0);
	}
    }

    *OutFileName = '\0';
	
    if (Fail != (n = add_msg(areatype, areatag, &new_ftn, newtext, nma.pkt_hdr))) {
	if (areatype == FIDO || areatype == SQUISH || areatype == JAM) {
	    writeToLog(1, "   %d created in %s", n, strUpper(areatag) );
	}
	writeToLog(1, "   Copied to area %s", areatag );
	++nWritten;
    } else
	writeToLog(0, "error: CopyArea failed");

    free_text(newtext);
    free (nma.pkt_hdr);
    free(areatag);
    for (i = 0; i < items-1; i++) {
	free(arg[i]);
    }

    XSRETURN_PV(OutFileName);
}

static XS(perl_Bounce)
{
/* call: Bounce( [-t nameTo], [-f nameFrom], [-s subj],  [-a attr], 
                 [-h header] [-l line] )
*/
    dXSARGS;
    STRLEN n_a;				
    char *arg[10], *err="perl_Bounce()";
    char msgtime[20], system[20]={0};
    NewMsgArg nma;
    ADDR fromAddr, toAddr;
    int i;
    TEXT *newtext = NULL, *upper_text = NULL, *old_text = NULL;
    FTN new_ftn;
    BOOL isEcho;
    int ret;
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory", err);
	XSRETURN_UNDEF;
    }
	
    items = (items<10) ? items : 10;
	
    isEcho = is_echoarea(CurMsg.type, CurMsg.areaname);
	
    /* set defaults */
    memset(&nma, 0, sizeof(NewMsgArg));
    sprintf(nma.fromName, "%s %s", ProdName, VER );
    strcpy(nma.toName, ftn.fromName );
    strcpy(nma.subj, ftn.subject );
    nma.hText = nma.lText = NULL;
    nma.tlineNo = 0; /* no template */
    nma.llineNo = 0; /* no string */
    clear_all_attr(&nma.aa);
	
    if (No == isEcho)
	nma.aa.attr = a_Private;
	
    nma.aa.attr |= a_Local;
    nma.aa.flag = 0;

    memset(&new_ftn, 0, sizeof(FTN));
    /****************************************/
	
    for(i = 0; i < items; ++i) {
	sp_s = FromSP(i);
	arg[i] = XCAL;
	strcpy(arg[i], sp_s);
	strip (arg[i]);
    	remove_quotes (arg[i]);
	expand_str_200 (&arg[i]);
    }
	
    if (items) ret = get_new_msg_arg(items, arg, err, &nma );
	
    /* log original msg before changing */
    log_msg_hdr();
	
    /* select our aka */
    toAddr = ftn.from;
    (void)areaname_to_system(CurMsg.areaname, system);
    get_def_addr( system, toAddr , &fromAddr );
	
    new_ftn.routeTo = toAddr;
    new_ftn.to = toAddr;
    new_ftn.from = fromAddr;
	
    make_DateTime( msgtime );
    strcpy(new_ftn.DateTime, msgtime);
	
    new_ftn = change_hdr(new_ftn, nma);
    new_ftn.to = toAddr;
    new_ftn.from = fromAddr;
	
    /* make msg header text (upper kludges) */
    upper_text = make_msgtext_hdr(&new_ftn, isEcho);

    /* get original text without kludges (only vias included) */
    old_text = get_old_text(TextFirst);
    /* invalidate all previous vias */
    inv_vias(old_text);
	
    /* paste old text w/o kludges below upper kludges */
    (void) add_text(&upper_text, old_text, -1, Mode_Text);
    free_text(old_text);
	
    /* add template and/or string of text held in nma */
    newtext = change_text(upper_text, nma, new_ftn.from);
    free_text(upper_text);
	
    /*  inv_tear_orig(newtext); */
	
    /* add our via */
    (void) add_via(&newtext, fromAddr);

    if (isEcho) (void) kill_netmail_kludges(&newtext);
    else {
		
	/* set routing if defined */
	if (strlen (nma.route)) {
	    if (!str_to_addr (nma.route, &new_ftn.routeTo)) {
		writeToLog(4, "set_route: `%s' is not valid ADDR, try block route\n",
							 nma.route);
		set_route (nma.route, &new_ftn);
	    }
	}
		
    }

    if (new_ftn.stat & i_Invalidvias) {
	writeToLog(2, "Bounce: invalidate vias");
	(void) inv_vias(newtext);
    }
    if (new_ftn.stat & i_Invkludges) {
	writeToLog(2, "Bounce: invalidate kludges");
	inv_kludges(newtext, 0);
    }

    free_text(TextFirst);
    free (nma.pkt_hdr);
    TextFirst = newtext;
    ftn = new_ftn;
	
    ftn.stat |= i_Changed;
	
    writeToLog(1, "   Bounced");
    ++nWritten;

    for (i = 0; i < items; i++) {
	free(arg[i]);
    }

    XSRETURN_UNDEF;
}


static XS(perl_CreateMail)
{
/* call: createmail( areaname, address, [-t nameTo], [-f nameFrom],
                     [-s subj],  [-a attr], [-h header] [-l line] )
*/	
    dXSARGS;
    STRLEN n_a;			
    char *arg[10], *err="perl_CreateMail()";
    char *areatag, system[20]={0};
    char msgtime[20];
    NewMsgArg nma;
    int i, n, save_msgno, areatype;
    TEXT *newtext = NULL, *upper_text = NULL;
    FTN new_ftn, save_ftn;
    ADDR aka;
    BOOL isEcho;
	
    if (items < 2) {
	fprintf(stderr, "%s argument count (need 2 or more, exist %d)\n", err, (int)items);
	abort();
    }
	
    items = (items < 10) ? items : 10;
	
    sp_s = FromSP(0);
    areatag = XCAL;
    strcpy(areatag, sp_s);
    strip(areatag);
    remove_quotes(areatag);
    expand_str(areatag);
	
    if (!strlen(areatag)) {
	strcpy(areatag, CurMsg.areaname);
    }
	
    if (-1 == (areatype = areaname_to_type(areatag))) {
	fprintf(stderr, "%s unknown area `%s'\n", err, strUpper(areatag));
	free(areatag);
	abort();
    }
	
	
    /* set defaults */
    memset(&nma, 0, sizeof(NewMsgArg));
    strcpy(nma.fromName, ProdName );
    strcpy(nma.toName, "Sysop" );
    strcpy(nma.subj, "Automatically created mail" );
    nma.hText = nma.lText = NULL;
    nma.tlineNo = 0; /* no template */
    nma.llineNo = 0; /* no string */
    clear_all_attr(&nma.aa);
	
	
    nma.aa.attr |= a_Local;
    nma.aa.flag = 0;
    nma.to.zone = (word)-1;
    nma.from.zone = (word)-1;

    memset(&new_ftn, 0, sizeof(FTN));
	
    for(i = 0; i < items-1; ++i) {
    
	if (i == 0) {
	    sp_s = FromSP(i+1);
	    arg[i]=(char*)xcalloc(n_a+5, sizeof(char));
	    sprintf(arg[i], "-t %s", sp_s);
	    continue;
	} else {
	    sp_s = FromSP(i+1);
	    arg[i] = XCAL;
	    strncpy(arg[i], sp_s, n_a);
	}
		
		
	strip (arg[i]);
	remove_quotes (arg[i]);
	expand_str_200 (&arg[i]);
    }
	
	
    get_new_msg_arg(items-1, arg, err, &nma );
	
	
    /* set our aka */
    (void)areaname_to_system(areatag, system);
    get_def_addr(system, nma.to , &aka);
	
    /* toAddr ( -t ) not defined, error! */
    if (nma.to.zone == (word)-1) {
	fprintf(stderr, "%s To addr not defined: `%s'\n", err, arg[0]);
	for (i = 0; i < items-1; i++) {
	    free(arg[i]);
	}	
	free(areatag);
	abort();
    }

	/* fromAddr ( -f ) not defined */
    if (nma.from.zone == (word)-1) 
	nma.from = aka;

    isEcho = is_echoarea(areatype, areatag) || nma.e;
	
    if (No == isEcho)
	nma.aa.attr |= a_Private;

	
    /* make msg hdr */
    make_DateTime( msgtime );
    strcpy(new_ftn.DateTime, msgtime);
    new_ftn.utime = time(NULL);
	
    /* form new message */
    new_ftn = change_hdr(new_ftn, nma);

    /* applies to createmail only */
    new_ftn.flavor = set_msg_flavor(new_ftn.attr, new_ftn.flag);
	

    new_ftn.routeTo = new_ftn.to;
		
	
    /* make msg header text (upper kludges) */
    if (!strlen(new_ftn.from.domain))
    	strcpy(new_ftn.from.domain, aka.domain);

    upper_text = make_msgtext_hdr(&new_ftn, isEcho);

    /* change text - add template and/or string from `nma' struct */
    newtext = change_text(upper_text, nma, new_ftn.from);
    free_text(upper_text);
	
    save_msgno = CurMsg.n;   /* msg is logged via global `CurMsg' */
													/* so we have to bypass this by disabling */
													/* msgno of a real msg in memory */
												
    CurMsg.n = 0;
	
    save_ftn = ftn;          /* this we need to log original msg header (from/to) */
    ftn = new_ftn;           /* not the already modified one */
    ftn.stat &= ~MsgLogged;
	
    /* log newly created msg */
    log_msg_hdr();

    if (!isEcho) {

	/* set routing if defined */
	if (strlen (nma.route)) {
	    if (!str_to_addr (nma.route, &new_ftn.routeTo)) {
		writeToLog(4, "set_route: `%s' is not valid ADDR, try block route\n",
							 nma.route);
		set_route (nma.route, &new_ftn);
    	    }
	}
		
	/* timestamp the new netmail */
	(void) add_via(&newtext, aka);
		
	if (new_ftn.stat & i_Invalidvias) {
	    writeToLog(2, "CreateMail: invalidate vias");
	    inv_vias(newtext);
	}
		
    }   /* netmail specific stuff */
	
    if (new_ftn.stat & i_Invkludges) {
	writeToLog(2, "CreateMail: invalidate kludges");

	if (areatype == TXT) {
	    /* invalidate all kludges */
	    inv_kludges(newtext, 1);
	} else {
	    /* leave off addressing kludges */
	    inv_kludges(newtext, 0);
	}
    }

    *OutFileName = '\0';
    if (Fail != (n = add_msg(areatype, areatag, &new_ftn, newtext, nma.pkt_hdr))) {
	if (CurMsg.type == FIDO || CurMsg.type == SQUISH || areatype == JAM) {
	    writeToLog(1, "   %d created in %s\n", n, strUpper(areatag) );
	}
	writeToLog(1, "   Mail created in area %s\n", areatag );
	++nWritten;
    } else {
	writeToLog(0, "error: CreateMail failed");
	abort();
    }
	
    free_text(newtext);
    free (nma.pkt_hdr);
	
    /* restore real data of the current msg in memory */
    CurMsg.n = save_msgno;
    ftn = save_ftn;

    for (i = 0; i < items-1; i++) {
	free(arg[i]);
    }	
    free(areatag);

    XSRETURN_PV(OutFileName);
}

static XS(perl_ChangeMail)
{
/* call: ChangeMail([-t addrTo | nameTo], [-f addrFrom | nameFrom],  [-s subj],
								[-a attr], [-h header], [-l line] ) */
    dXSARGS;
    STRLEN n_a;				
    char *arg[10], *err="perl_ChangeMail()";
    char cflag[128];
    NewMsgArg nma;
    int i;
    TEXT *newtext = NULL;
    FTN new_ftn;
    BOOL isEcho;

    if (items < 1) {
	fprintf(stderr, "%s argument count (need 1 or more, exist %d)\n", err, (int)items);
	abort();
    }

    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory", err);
	XSRETURN_UNDEF;
    }
	
    items = (items<10) ? items : 10;
	
    /* set defaults */
    memset(&nma, 0, sizeof(NewMsgArg));
    strcpy(nma.fromName, ftn.fromName );
    strcpy(nma.toName, ftn.toName );
    strcpy(nma.subj, ftn.subject );
    nma.hText = nma.lText = NULL;
    nma.to = ftn.to;
    nma.from = ftn.from;
    nma.tlineNo = 0; /* no template */
    nma.llineNo = 0; /* no string */
    nma.aa.attr = ftn.attr;
    nma.aa.flag = ftn.flag;
    nma.aa.stat = ftn.stat;
    memset(&new_ftn, 0, sizeof(FTN));
    /*//////////////////////////////////////*/
	
    for(i = 0; i < items; ++i) {
	sp_s = FromSP(i);
	arg[i] = XCAL;
	strcpy(arg[i], sp_s);
	strip (arg[i]);
	remove_quotes (arg[i]);
	expand_str_200 (&arg[i]);
    }

    get_new_msg_arg(items, arg, err, &nma);
	
    new_ftn = change_hdr(ftn, nma);
    newtext = change_text(TextFirst, nma, new_ftn.from);
	
	
    isEcho = is_echoarea(CurMsg.type, CurMsg.areaname);
	
    if (isEcho) {
		
	(void) kill_netmail_kludges(&newtext);
		
	if (!addr_cmp(ftn.from, new_ftn.from))
	    (void)change_echo_kludges(new_ftn, newtext);
		
    }  /* echomail */
	
    else {
		
	/* set routing if defined */
	if (strlen (nma.route)) {
	    if (!str_to_addr (nma.route, &new_ftn.routeTo)) {
		writeToLog(4, "set_route: `%s' is not valid ADDR, try block route\n",
						 nma.route);
		set_route (nma.route, &new_ftn);
    	    }
	}
	if (!addr_cmp(ftn.to, new_ftn.to) || !addr_cmp(ftn.from, new_ftn.from))
	    (void)change_address_kludges(&new_ftn, &newtext);
		
    }  /* netmail */
	
    /* adjust FLAGS kludge if needed */
    if (isEcho || nma.aa.flag != ftn.flag) {
	flag_to_str( nma.aa.flag, cflag );
	(void) set_flag_kludge(&newtext, cflag );
    }
	
	
    if (new_ftn.stat & i_Invalidvias) {
	writeToLog(2, "ChangeMail: invalidate vias");
	(void) inv_vias(newtext);
    }
    if (new_ftn.stat & i_Invkludges) {
	writeToLog(2, "ChangeMail: invalidate kludges");
    	inv_kludges(newtext, 0);
    }

    free_text(TextFirst);
    free (nma.pkt_hdr);
    TextFirst = newtext;
    ftn = new_ftn;
	
    ftn.stat |= i_Changed;
	
    writeToLog(1, "   Message Changed");
    ++nWritten;
    
    for (i = 0; i < items; i++) {
	free(arg[i]);
    }

    XSRETURN_UNDEF;
}

/*************************************************************************/
/******************************************************/
int add_msg(int areatype, char *areatag, FTN *new_ftn, TEXT *newtext,
						PKT_HDR* pkt_hdr)
{
	BOOL rc = Fail;
	char buf[256];
	
	switch (areatype)
	{
		
	/*//////*/
	case FIDO:
	{
		FIDO_MSG new_msghdr;
		
		memset(&new_msghdr, 0, sizeof(FIDO_MSG));
		ftn_to_msghdr(*new_ftn, &new_msghdr);

		if (Fail == (rc = create_fido_msg(areatag, new_msghdr, newtext)))
			writeToLog(0, "add_msg error: failed to add mail to fido area\n");

		break;
	}
	/*//////*/
	case BINK:
		
		if (Fail == (rc = write_binkout_OIP(areatag, *new_ftn, newtext)))
			writeToLog(0, "add_msg error: failed to add mail to bink area\n");
		
		break;
		
	/*////////*/
	case SQUISH:

	{
		int sqd = -1, sqi = -1;
		BOOL need_close = No;
		XMSG new_xmsg;
		char *cbuf = NULL, *tbuf = NULL;

		memset(&new_xmsg, 0, XMSG_SIZE);

		/* same area, no need to open */
		if (0 == stricmp(CurMsg.areaname, areatag)) {
			sqd = CurMsg.squish.sqd;
			sqi = CurMsg.squish.sqi;
			strcpy (OutFileName, CurMsg.areapath);
		}

		if (sqd == -1) {
			if (!open_squish_bases(areatag, &sqd, &sqi))
				return Fail;
			if (sqd == -1) {
				return Fail;
			}
			need_close = Yes;
		}

		(void)ftn_to_xmsg(*new_ftn, &new_xmsg);
		(void)text_to_sqbase(newtext, &cbuf, &tbuf);

		if (Fail == (rc = add_squish_msg(sqd, sqi, new_xmsg, cbuf, tbuf))) {

			sprintf(buf, "add_msg error: failed to add mail to squish area, errno %d\n",
							sq_errno);
			writeToLog(0, buf);
			*OutFileName = '\n';
		}

		free(cbuf);
		free(tbuf);

		if (need_close) {
			close(sqd);
			close(sqi);
		}

		break;

	} /* case close */

	/*///////*/
	case JAM:

	{
				
		BOOL need_close = No;
		JAM_AREA jam;

		memset(&jam, 0, sizeof(JAM_AREA));

		jam.Idx.UserCRC = (dword) -1L;
		jam.Hdr.MsgIdCRC = (dword) -1L;
		jam.Hdr.ReplyCRC = (dword) -1L;
		jam.Hdr.PasswordCRC = (dword) -1L;
		strcpy(jam.Hdr.Signature, HEADERSIGNATURE);
		jam.Hdr.Revision = CURRENTREVLEV;

		jam.HdrHandle = -1;

		if (CurMsg.type == JAM) {

			/* same area, no need to open */
			if (0 == stricmp(CurMsg.areaname, areatag)) {
				jam.HdrHandle = CurMsg.jam.HdrHandle;
				jam.TxtHandle = CurMsg.jam.TxtHandle;
				jam.IdxHandle = CurMsg.jam.IdxHandle;
				strcpy (OutFileName, CurMsg.areapath);
			}

		}

		if (jam.HdrHandle == -1) {
			if (!open_jam_bases(areatag, &jam))
				return Fail;
			need_close = Yes;
		}

		(void)ftn_to_jam(new_ftn, &jam);


		if (is_echoarea(areatype, areatag)) {
			jam.Hdr.Attribute &= ~MSG_TYPENET;
			jam.Hdr.Attribute |= MSG_TYPEECHO;
		}
		else {
			jam.Hdr.Attribute &= ~MSG_TYPEECHO;
			jam.Hdr.Attribute |= MSG_TYPENET;
		}


		if (Fail == (rc = add_jam_msg(&jam, newtext))) {
			sprintf(buf, "add_msg error: failed to add mail to JAM area, errno %d\n",
							jam_errno);
			writeToLog(0, buf);
		}

		if (need_close) {
			close(jam.HdrHandle);
			close(jam.TxtHandle);
			close(jam.IdxHandle);
		}

		break;

	} /* case close */

	/*/////*/
	case PKT:
			
	{
		struct pktarea pkt;
		ADDR aka;
		char caddrTo[128], caddrFrom[128];
		char system[20]={0};

		memset(&pkt, 0, sizeof(struct pktarea));
			
			
		(void) areaname_to_system(areatag, system);
		(void) get_def_addr(system, new_ftn->routeTo , &aka);
		
		pkt.pkt_hdr = make_pkt_header(*new_ftn, aka, areatag);
		if (pkt_hdr) {
			memcpy (&pkt.pkt_hdr, pkt_hdr, sizeof (PKT_HDR));
			pkt.pkt_hdr.baud = (word) 0;
			pkt.pkt_hdr.pktType = (word) 0x2;
			pkt.pkt_hdr.CapWord   =  0x0001; /* CW */
			pkt.pkt_hdr.CapWordS  =  0x0100; /* CW swapped */
		}

		addr_to_str(aka, caddrFrom);
		addr_to_str(new_ftn->routeTo, caddrTo);

		pkt.to.zone = pkt.pkt_hdr.toZone;
		pkt.to.net = pkt.pkt_hdr.toNet;
		pkt.to.node = pkt.pkt_hdr.toNode;
		pkt.to.point = pkt.pkt_hdr.toPoint;

		pkt.from.zone = pkt.pkt_hdr.fromZone;
		pkt.from.net = pkt.pkt_hdr.fromNet;
		pkt.from.node = pkt.pkt_hdr.fromNode;
		pkt.from.point = pkt.pkt_hdr.fromPoint;
		if (pkt.from.net == Wild_1)
			pkt.from.net = pkt.pkt_hdr.AuxNet;

		/* current message specific info */
		(void) ftn_to_pktarea(*new_ftn, &pkt);

		rc = write_pkt_msg(areatag, &pkt, newtext, new_ftn->flavor);
		if (!rc)
			writeToLog(0, "add_msg error: failed to add mail to pkt area\n");

		break;
	} /* case close */

	/*/////*/
	case TXT:

		if (Fail == (rc = add_text_msg (areatag, new_ftn, newtext)))
			writeToLog(0, "add_msg error: failed to add mail to text area\n");

		break;
		
	default:
		fprintf(stderr, "add_msg error: areatag of unknown type: `%s'\n", areatag );
		abort();
	}
	
	return rc;
	
}
/**********************************************************/
static BOOL kill_msg(void)
{
	BOOL rc = Fail;
	char buf[256];
	
	if (CurMsg.type == FIDO)
		rc = (BOOL)kill_fido_msg();
	
	else if (CurMsg.type == SQUISH) {
		
		if (CurMsg.squish.cur_frame) {
			
			rc = (BOOL)kill_squish_msg(&CurMsg.squish);
		
			if (rc == Fail)
				(void)sq_failure_reason();
		}

	}
	else if (CurMsg.type == JAM) {
		
		rc = (BOOL)kill_jam_msg(&CurMsg.jam);
		
	} else if (CurMsg.type == PKT) {

		if (CurMsg.pkt.off == CurMsg.pkt.len) {
			sprintf(buf, "kill_msg: eof, saving file: `%s'\n", CurMsg.pkt.fname);
			writeToLog(4, buf);
			update_old_pkt(CurMsg.pkt.fname, CurMsg.pkt);
			CurMsg.pkt.off = 0L;
		}
		
		rc = Ok;
		
	}
	else if (CurMsg.type == BINK) {
		
		if (CurMsg.bink.off == CurMsg.bink.len) {

			char bsy[256];

			sprintf(buf, "kill_msg: eof, saving file: `%s'\n", CurMsg.bink.fname);
			writeToLog(4, buf);
			
			update_old_pkt(CurMsg.bink.fname, CurMsg.bink);
			CurMsg.bink.off = 0L;

			bnk_to_bsy(CurMsg.bink.fname, bsy);
			sprintf(buf, "kill_msg: killing bsy: `%s'\n", bsy);
			writeToLog(3, buf);
			kill_bsy(bsy);

		}

		rc = Ok;
		
	}
	
	return rc;
}
/********************************************/
static FTN change_hdr (FTN ftn, NewMsgArg nma)
{
	FTN new_ftn;
	new_ftn = ftn;
	strcpy( new_ftn.toName , nma.toName );
	strcpy( new_ftn.fromName , nma.fromName );
	strcpy( new_ftn.subject , nma.subj );
	if (nma.d) {
		unix_to_ftscdate(nma.d, new_ftn.DateTime);
		new_ftn.utime = nma.d;
	}
	new_ftn.to = nma.to;
	new_ftn.from = nma.from;
	new_ftn.attr = nma.aa.attr;
	new_ftn.flag = nma.aa.flag;
	new_ftn.stat = nma.aa.stat;
	
/*  new_ftn.flavor = set_msg_flavor(new_ftn.attr, new_ftn.flag); */
	
	return new_ftn;
}
/********************************************/
static TEXT * change_text(TEXT *text, NewMsgArg nma, ADDR from)
/* add template and/or string, if any */
{
	TEXT *newtext = NULL, *new_first = NULL, *new_last = NULL;
	TEXT *tmp = NULL;

	/* copy old text -> newtext */
	for( ; text ; text = text->next )
	{
		newtext = (TEXT *)calloc(1, sizeof(TEXT));
		newtext->next = NULL;
		strcpy(newtext->str, text->str);
		if (new_last)
			new_last->next = newtext;
		else
			new_first = newtext;

		new_last = newtext;
		
	} /* text loop */
					
	newtext = new_first;
	
	/* add header (if any) */
	if (nma.hText) {
		(void) add_text(&newtext, nma.hText, nma.tlineNo, Mode_Text);
		free_text(nma.hText);
	}
	
	/* add string (if any) */
	if (nma.lText) {
		(void) add_text(&newtext, nma.lText, nma.llineNo, Mode_Text);
		free_text(nma.lText);
	}
	

	if (nma.e && strlen(nma.e)) {
		tmp = (TEXT *)calloc(1, sizeof(TEXT));
		tmp->next = NULL;
		sprintf(tmp->str, "AREA:%s\r", strUpper(nma.e));
		(void) add_text(&newtext, tmp, 1, Mode_Bin);
		free(tmp);
		free(nma.e);
	}
	
	if (nma.r) {

		tmp = (TEXT *)calloc(1, sizeof(TEXT));
		tmp->next = NULL;
		sprintf(tmp->str, "--- %s\r", nma.r);
		(void) add_text(&newtext, tmp, -1, Mode_Text);
		free(tmp);
		free(nma.r);
	}
	
	if (nma.o) {
		char caddr[64];
		ADDR f = from;

		f.domain[0] = 0;
		addr_to_str(f, caddr);
		tmp = (TEXT *)calloc(1, sizeof(TEXT));
		tmp->next = NULL;
		sprintf(tmp->str, " * Origin: %s (%s)\r", nma.o, caddr);
		(void) add_text(&newtext, tmp, -1, Mode_Text);
		free(tmp);
		free(nma.o);
	}
	
	return newtext;
	
}
/*****************************/
static TEXT *get_old_text(TEXT *text)
{
	/* gets text only. kludges excluded except vias */
	/* tearline/origin will be invalidated */
	
	TEXT *textbuf=NULL, *first=NULL, *last=NULL;
	BOOL add = No;
	char buf[256];

	for( ; text ; text = text->next )
	{
		strcpy( buf , text->str );
		if (is_kludge(buf)) {
			if ( is_Via(buf) ) {
				add = Yes;
			} /* via */
			else {
				add = No;
			}
		} /* kludge found */
		else {
			add = Yes;
		}
		
		if (add) {
			textbuf = (TEXT *) calloc(1, sizeof(TEXT) );
			textbuf->next = NULL;
			
			if (is_Origin(buf))
				buf[1] = '+';
			else  if (is_TearLine(buf))
				buf[1] = '+';

			strcpy( textbuf->str, buf);
			if (last) {
				last->next = textbuf;
			}
			else {
				first = textbuf;
			}
			last = textbuf;
		}
	} /* text loop */
	
	return first;
}

/********************************************************************************/
TEXT *make_msgtext_hdr(FTN *f, BOOL isEcho)
{
	TEXT *textbuf = NULL, *newtext = NULL;
	ADDR tmpAddr;
	char buf[256];
	char fmpt[64]={0}, topt[64]={0};
	char caddrFrom[64], caddrTo[64], cflag[128];
	
	if (f->from.point)
		sprintf(fmpt, "%u", f->from.point);
/*		itoa( f->from.point , fmpt , 10 ); */
	
	if (f->to.point)
		sprintf(topt, "%u", f->to.point);
/*		itoa( f->to.point , topt , 10 ); */
	
	tmpAddr = f->from;
	tmpAddr.point = 0;
	addr_to_str( tmpAddr, caddrFrom);
	tmpAddr = f->to;
	tmpAddr.point = 0;
	addr_to_str( tmpAddr, caddrTo);
	
	textbuf = (TEXT *) calloc(1, sizeof(TEXT) );
	textbuf->next = NULL;
	
	if (isEcho == No) {
	
		sprintf(buf, "\1INTL %s %s\r", caddrTo, caddrFrom);

		strcpy(textbuf->str, buf);
		(void) add_text(&newtext, textbuf, -1, Mode_Text);

		if (strlen(fmpt)) {
			sprintf(textbuf->str, "\1FMPT %s\r", fmpt);
			(void) add_text(&newtext, textbuf, -1, Mode_Text);
		}
	
		if (strlen(topt)) {
			sprintf(textbuf->str, "\1TOPT %s\r", topt);
			(void) add_text(&newtext, textbuf, -1, Mode_Text);
		}
		
	} /* netmail kludges */
		
	addr_to_str( f->from, caddrFrom);
	if (strlen(f->from.domain)) {
		strcat(caddrFrom, "@");
		strcat(caddrFrom, f->from.domain);
	}
	
	sprintf(textbuf->str, "\1MSGID: %s %08x\r", caddrFrom, (unsigned)get_MsgId() );
	(void) add_text(&newtext, textbuf, -1, Mode_Text);
	
	sprintf(textbuf->str, "\1PID: %s %s\r",
					ProdName, VER);
	(void) add_text(&newtext, textbuf, -1, Mode_Text );
	
	free_text(textbuf);
	
	if (f->flag) { /* set FLAGS kludge if needed */
		flag_to_str(f->flag , cflag );
		(void) set_flag_kludge(&newtext, cflag);
	}
	
	return newtext;
}

/****************************************************************************/
BOOL update_msg(int type)
{
	char fname[256], backup[256], buf[256];
	char *cbuf = NULL, *tbuf = NULL;
	TEXT *Text = TextFirst;
	BOOL rc;
	struct pktarea pkt;
	char system[20];
	ADDR aka;
	
	
	if (type == FIDO) {
		
		ftn_to_msghdr(ftn, &CurMsg.fido.msgHdr);
		
		sprintf(fname , "%s%s" , CurMsg.areapath ,
						CurMsg.fido.fnames[CurMsg.fido.n-1].fname);
		sprintf(backup, "%s%d.\043", CurMsg.areapath, CurMsg.n);
		
		if (!write_fido_msg(backup, CurMsg.fido.msgHdr, Text)) {
			sprintf(buf, "update_msg: error writing tmp file `%s'\n", backup);
			writeToLog(0, buf);
			return Fail;
		}
		
		if ( remove(fname) ) {
			sprintf(buf, "update_msg: error deleting old msg file: `%s'\n", fname);
			writeToLog(0, buf);
			return Fail;
		}

		if ( rename(backup, fname) ) {
			sprintf(buf, "update_msg: error renaming tmp file `%s' to '%s'\n", backup, fname);
			writeToLog(0, buf);
			return Fail;
		}
		
	}
	else if (type == SQUISH) {
		
		ftn_to_xmsg(ftn, &CurMsg.squish.xmsg);
		(void)text_to_sqbase(Text, &cbuf, &tbuf);
		
		rc = update_squish_msg(cbuf, tbuf);
		
		free(cbuf);
		free(tbuf);
		
		if (Fail == rc) {
			writeToLog(0, "update_msg: failed to update squish message\n");
			return Fail;
		}
	}
	else if (type == JAM) {
		
		(void)ftn_to_jam(&ftn, &CurMsg.jam);
		
		rc = update_jam_msg(&CurMsg.jam, Text);
		
		if (Fail == rc) {
			writeToLog(0, "update_msg: failed to update JAM message\n");
			return Fail;
		}
	}
	
	else if (type == PKT) {


		if (ftn.stat & i_Changed) {
		
		    if (ftn.stat & i_NoMyVia) {
			areaname_to_system(CurMsg.areaname, system);
			get_def_addr(system, CurMsg.pkt.to, &aka);
			del_my_via(&TextFirst, aka);
		    }		
		    
			ftn_to_pktarea(ftn, &CurMsg.pkt);
			pkt = CurMsg.pkt;
			pkt.to = ftn.routeTo;
			pkt.pkt_hdr.toZone  = pkt.to.zone;
			pkt.pkt_hdr.toNet   = pkt.to.net;
			pkt.pkt_hdr.toNode  = pkt.to.node;
			pkt.pkt_hdr.toPoint = pkt.to.point;
			
			if (!write_pkt_msg(CurMsg.areaname, &pkt, TextFirst, ftn.flavor)) {
				writeToLog(0, "update_msg: failed to update mail in pkt area\n");
				return Fail;
			}
			
		}   /* really changed */
		
		else { /* unchanged pkt mail */

			dword l, len = CurMsg.pkt.off - CurMsg.pkt.off0;

			l = CurMsg.pkt.new_off + len;
			
			if (CurMsg.pkt.new_buf == NULL)
				CurMsg.pkt.new_buf = (char *)malloc(l+1);
			else
				CurMsg.pkt.new_buf = (char *)realloc(CurMsg.pkt.new_buf, l+1);

			if (CurMsg.pkt.new_buf == NULL) {
				writeToLog(0, "update_msg error: low memo (pkt.new_buf)\n");
				return Fail;
			}
			
			memcpy(&CurMsg.pkt.new_buf[CurMsg.pkt.new_off],
						&CurMsg.pkt.text[CurMsg.pkt.off0], len);

			CurMsg.pkt.new_off = l;
			
		}   /* unchanged pkt mail */

		if (CurMsg.pkt.off == CurMsg.pkt.len) {

			sprintf(buf, "update_msg: eof, saving file: `%s'\n", CurMsg.pkt.fname);
			writeToLog(4, buf);
			update_old_pkt(CurMsg.pkt.fname, CurMsg.pkt);
			CurMsg.pkt.off = 0L;
			
		}
		
	} else if (type == BINK) {

		if (ftn.stat & i_Changed) {
			
		    if (ftn.stat & i_NoMyVia) {
			areaname_to_system(CurMsg.areaname, system);
			get_def_addr(system, CurMsg.pkt.to, &aka);
			del_my_via(&TextFirst, aka);
		    }		
		    
		    rc = write_binkout_OIP(CurMsg.areaname, ftn, TextFirst);
		    if (!rc)
		    	writeToLog(0, "update_msg error: failed to write mail to bink area\n");
			
		}   /* really changed */
		else {

			dword l, len = CurMsg.bink.off - CurMsg.bink.off0;

			l = CurMsg.bink.new_off + len;
			
			if (CurMsg.bink.new_buf == NULL)
				CurMsg.bink.new_buf = (char *)malloc(l+1);
			else
				CurMsg.bink.new_buf = (char *)realloc(CurMsg.bink.new_buf, l+1);

			if (CurMsg.bink.new_buf == NULL) {
				writeToLog(0, "update_msg error: low memo (new_buf)\n");
				return Fail;
			}
			
			memcpy(&CurMsg.bink.new_buf[CurMsg.bink.new_off],
						&CurMsg.bink.text[CurMsg.bink.off0], len);

			CurMsg.bink.new_off = l;
			
		}   /* unchanged bink mail */

		if (CurMsg.bink.off == CurMsg.bink.len) {

			char bsy[256];

			sprintf(buf, "update_msg: eof, saving file: `%s'\n", CurMsg.bink.fname);
			writeToLog(4, buf);
			update_old_pkt(CurMsg.bink.fname, CurMsg.bink);
			CurMsg.bink.off = 0L;
			
			bnk_to_bsy(CurMsg.bink.fname, bsy);
			sprintf(buf, "update_msg: killing bsy: `%s'\n", bsy);
			writeToLog(3, buf);
			kill_bsy(bsy);
			
		}
		
	}

	
	if (ftn.stat & i_Changed) {

		log_msg_hdr();
		sprintf(buf, "   %d updated in %s\n", CurMsg.n , strUpper(CurMsg.areaname) );
		writeToLog(1, buf);
		++nWritten;

		CurMsg.maxts = time(NULL) + TZOFF;
		
	}

	
	ftn.stat &= ~i_Changed;
	
	return Ok;
	
}
/**********************************************************/
static int get_new_msg_arg( int argc, char **argv, char *err, NewMsgArg *nma)
{
    char key[128], *p, *arg, *parg;
    char *keys[] = {
		"-t" ,
		"-f" ,
		"-s" ,
		"-a" ,
		"-h" ,
		"-l" ,
		"-e" ,
		"-d" ,
		"-o" ,
		"-r" ,
		"-u" ,
		"-p"
    };
    enum { T = 0, F, S, A, H, L, E, D, O, R, U, P };
    int ret;
    /* ret
       0x0000 - no key
       0x0001 - To addr
       0x0002 - To name
       0x0004 - From addr
       0x0008 - From name
       0x0010 - subj
       0x0011 - attribute
       0x0012 - header
       0x0014 - line
       0x0018 - echoarea
       0x0020 - date
       0x0021 - origin
       0x0022 - tearline
       0x0024 - route
       0x0028 - pkthdr */
	/*  To   *   From   *   Subject   *   Attribute   *   Header   *   Line */
	/*  EchoArea * Date * Origin * Tearline * Route * PktHdr */
	/* (to/from may include address and name) */
	
    char subj[72], cattr[128];
    char buf[256], w1[256], save[256];
    int i, j, kfound = 0, tno = 1, lno = 1;
    BOOL direct = 0;
    ADDR tmp_addr;
	
    arg = NULL;
    ret = 0;
	
    for( j = 0; j < argc ; ++j ) {
	arg = (char*)xcalloc(strlen(argv[j])+1, sizeof(char));
	strcpy(arg, argv[j]);
		
	p = key;
	parg = arg;
	while( *parg && *parg != ' ' && *parg != '\t' ) {
	    *p++ = *parg++;
	}
	*p = '\0';
	
	strip(parg);
	
	if (*parg == '@') {
	    direct = 1;
	    ++parg;
	    strip(parg);
	    writeToLog(6, "direct data");
	} else {
	    direct = 0;
	    writeToLog(6, "block search");
	}
	
	kfound = -1;
	for(i = 0; i < sizeof(keys)/sizeof(keys[0]); ++i) {
	    if ( !stricmp(key, keys[i]) ) {
		kfound = i;
		break;
	    } else { /* maybe lineno defined */
		if ( !strnicmp(key, keys[i], strlen(keys[i])) && i > 3 ) {
		    p = key + 2;
		    writeToLog(6, "get_new_msgarg: got lineno for -t or -l : `%s'\n", p );
		    if (strlen(p) && __isnumber(p)) {
			if ( i == 4 ) {
			    tno = atoi(p);
			    writeToLog(6, "get_new_msgarg: got tno : %d\n", tno );
			} else {
			    lno = atoi(p);
			    writeToLog(6, "get_new_msgarg: got lno : %d\n", lno );
			}
			kfound = i;
			break;
		    } /* lineno found and correct */
		} /* -t or -l found with lineno attached */
	    }
	} /* arg loop */

	remove_quotes (parg);
		
	switch (kfound) {

	    case U: /* route to */
			
		if (strlen(parg)) {
		    writeToLog(4, "try to set route `%s'\n", parg);
		    strncpy (nma->route, parg, 63);
		    nma->route[63] = '\0';
		    ret |= 0x24;
		}
		break;
			
	    case T: /* to name/addr */

		if (!strlen(parg))
		    break;

		if (strlen (parg) > 255) parg[255] = '\0';
			
		if (direct) {
		    strcpy(save, parg);
		    get_next_word(parg, w1);
		    if (str_to_Waddr(w1, &tmp_addr)) {
			set_Waddr(tmp_addr, &nma->to);
			ret |= 0x01;
		    } else parg = save;
		    if (strlen(parg)) { 
			strncpy(nma->toName, parg, 35);
			nma->toName[35] = 0;
			ret |= 0x02;
		    }
		} else {
		    if (get_block_name(parg, w1)) {
			strcpy(nma->toName, w1);
			ret |= 0x02;
		    } else if (get_block_addr(parg, &tmp_addr)) {
			set_Waddr(tmp_addr, &nma->to);
			ret |= 0x01;	
		    } else if (get_block_addrname(parg, &tmp_addr, w1)) {
			strcpy(nma->toName, w1);
			set_Waddr(tmp_addr, &nma->to);
			ret |= 0x03;
		    } else if (get_def_addr(parg, nma->to, &tmp_addr)) {
			set_Waddr(tmp_addr, &nma->to);
			ret |= 0x01;
		    } else {
			fprintf(stderr, "%s block undefinded : `%s'\n", err, parg);
			free(arg);
			abort();
		    }
		} /* block */
			
		break;
			
	    case F: /* from name/addr */
			
		if (!strlen(parg))
		    break;
			
		if (strlen (parg) > 255)
		    parg[255] = '\0';
			
		if (direct) {
		    strcpy(save, parg);
		    get_next_word(parg, w1);
		    if (str_to_Waddr(w1, &tmp_addr)) {
			set_Waddr(tmp_addr, &nma->from);
			ret |= 0x04;
		    } else
			parg = save;
		    if (strlen(parg)) {
			strncpy(nma->fromName, parg, 35);
			nma->fromName[35] = 0;
			ret |= 0x08;
		    }
		} else {
		    if (get_block_name(parg, w1)) {
			strcpy(nma->fromName, w1);
			ret |= 0x08;
		    } else if (get_block_addr(parg, &tmp_addr)) {
			set_Waddr(tmp_addr, &nma->from);
			ret |= 0x04;
		    } else if (get_block_addrname(parg, &tmp_addr, w1)) {
			strcpy(nma->fromName, w1);
			nma->from = tmp_addr;
			set_Waddr(tmp_addr, &nma->from);
			ret |= 0x04|0x08;
		    } else if (get_def_addr(parg, nma->to, &tmp_addr)) {
			set_Waddr(tmp_addr, &nma->from);
			ret |= 0x04;
		    } else {
			fprintf(stderr, "%s block undefinded : `%s'\n", err, parg);
			free(arg);
			abort();
		    }
		} /* block */
			
		break;
			
	    case S: /* subject */

		/*	if (!strlen(parg))
				break;
		*/		
		strncpy(subj, parg, 71); subj[71] = 0;
		writeToLog(6, "get_new_msgarg: subj: `%s'\n", subj);
		if (!direct) {
		    get_block_subj( subj , err );
		    sprintf(buf, "get_new_msgarg: subj from block: `%s'\n", subj);
		    writeToLog(6, buf);
		}
			
		strcpy( nma->subj, subj);
		
		ret |= 0x010;
			
		break;
			
	    case A: /* attribute */
			
		if (!strlen(parg))
		    break;

		strncpy(cattr, parg, 127); cattr[127] = 0;
		sprintf(buf, "get_new_msgarg: attr: `%s'\n", cattr);
		writeToLog(6, buf);
		set_hdr_attr( cattr , &nma->aa, direct, err );
		
		ret |= 0x11;
				
		break; 
			
	    case L: /* add string */

/*			if (!strlen(parg))
					break;
*/				
				
		if (nma->lText == NULL) {
				
		    if (!direct) {
						
						/* get_block_string(parg, err); */
						
		    } else if (parg[strlen(parg)-1] == '.') {

			if (strlen (parg) > 127)
			    parg[127] = '\0';
			nma->lText = get_array_string(parg);  /* stem */
						
		    } else {
						
		        nma->lText = line_to_txt (parg);
						
		    }
		    nma->llineNo = lno;
		    
		    ret |= 0x14;
		}

		break;
			
	    case H: /* add template */

		if (nma->hText == NULL) {
		    get_tpl(parg, &nma->hText);
		    nma->tlineNo = tno;
		    ret |= 0x12;
		}

		break;

	    case E: /* echomail kludge, AREA: */

		if (!strlen(parg))
				break;

		nma->e = malloc(sizeof(char)*64);
		strncpy(nma->e, parg, 63); nma->e[63] = 0;
		ret |= 0x18;
		break;

	    case R: /* tearline */

		nma->r = malloc(sizeof(char)*64);
		strncpy(nma->r, parg, 63); nma->r[63] = 0;
		ret |= 0x22;
		break;

	    case O:

		nma->o = malloc(sizeof(char)*64);
		strncpy(nma->o, parg, 63); nma->o[63] = 0;
		ret |= 0x21;
		break;
				
	    case D:

		if (strlen(parg)) {
		    if (Fail == (nma->d = ftscdate_to_unix(parg)) &&
			Fail == (nma->d = seadog_to_unix(parg)) ) {
			writeToLog(0, "incorrect date format `%s', ignored\n", parg);
		    }
		} else  { 
		    nma->d = time(NULL);
		    ret |= 0x20;
		}

		break;

	    case P:

		{
		    STRLEN len;
		    AV *array;
		    SV **pscalar;
		    char *name_array, *scalar;
		    char *data, **array_arg = NULL;
		    int i, n;
		    PKT_HDR hdr;
		    
		    name_array = (char*)xcalloc(strlen(parg)+8, sizeof(char));
		    if ((data = strchr(parg, ':')) != NULL && *(data+1) == ':') {
			strcpy(name_array, parg);
		    } else {
			sprintf(name_array, "main::%s", parg);
		    }
    
		    i = strlen(name_array);
    
		    if (name_array[i-1] == '.') {
			name_array[i-1] = '\0';
			i--;
		    }
    
		    array = perl_get_av(name_array, FALSE);
    
		    if (array) {
			n = av_len(array)+1;

			for( i = 0; i < n; ++i) {
			    if (i) {
				array_arg = (char**)xrealloc(array_arg, (i+1)*sizeof(char*));
			    } else {
				array_arg = (char**)xmalloc(sizeof(char*));
			    }
			    pscalar = av_fetch(array, i, 0);
			    scalar = (char*)SvPV(*pscalar, len);
			    array_arg[i] = (char*)xcalloc(len+1, sizeof(char));
			    strncpy(array_arg[i], scalar, len);
			}

		    
		    
			if (setpkthdr (array_arg, len, "", &hdr)) {
			    nma->pkt_hdr = (PKT_HDR*) xmalloc (sizeof (PKT_HDR));
			    memcpy (nma->pkt_hdr, &hdr, sizeof (PKT_HDR));
			}
			
			for (i = 0; i < n; i++) {
			    free(array_arg[i]);
			}
			free(array_arg);

			ret |= 0x28;
		    }				
		}

		break;

	    default:
		{
		    fprintf(stderr, "%s incorrect argument : `%s'\n", err, argv[j]);
		    free(arg);
		    abort();
		}
	}
	free(arg);
    } /* argv loop */
	
    return ret;
	
}

/**********************************************************************/
static void set_hdr_attr( char *cattr, AllAttr *aa, BOOL direct, char *err)
{
	struct AttrTags *AttrTag = NULL;
	char *result[20], buf[256], *p;
	int i, kw;
	BOOL setClear = attrSet, found = 0;
	
	if (direct)  { /* direct attr definition */

		for( i = 0; i < 20; ++i )
		{
			result[i] = (char *)calloc(256, sizeof(char));
		}

		kw = splitf( cattr , result );
		kw = (kw > 20) ? 20 : kw ;

		for( i = 0; i < kw; ++i )
		{
			strcpy( buf , result[i] );
			
			if (!stricmp( buf,  "clear" )) { /* clear all attr */
				clear_all_attr( aa );
			}
			else {
				set_all_attrs( buf , aa );
			}
		} /* attr queue (main loop) */

		for( i = 0; i < 20; ++i )
		{
			free( result[i] );
		}
	}
	else { /* block definition */

		if (*cattr == '!') {
			++cattr;
			setClear = attrClear;
		}
		
		for( AttrTag = AttrTagFirst; AttrTag; AttrTag = AttrTag->next )
		{
			if (!stricmp(cattr, AttrTag->tag)) {
				found = 1;
				break;
			}
		}

		if (!found) {
			fprintf(stderr, "%s block undefined : `%s'\n", err, cattr);
			abort();
		}

		AttrTag->rec = AttrTag->recfirst;
		for( ; AttrTag->rec; AttrTag->rec = AttrTag->rec->next )
		{
			AttrTag->rec->attr = AttrTag->rec->attrfirst;
			for( ; AttrTag->rec->attr; AttrTag->rec->attr = AttrTag->rec->attr->next )
			{
				strcpy( buf , AttrTag->rec->attr->cattr );
				p = buf;
				if (setClear == attrClear) { /* reverse attr */
					if (*p == '!') {
						++p;
					}
					else {
						sprintf( buf , "!%s", p);
						p = buf;
					}
				} /* reverse attr */
				set_all_attrs( p , aa );
			}
		}
	} /* end of block definition */
	
	return;
	
}
/************************************************************/
static BOOL get_block_name( char *str, char *name)
{
	struct NameTags *NameTag = NULL;
	
	/*////////////////////////////////////////////////////////////*/
	for( NameTag = NameTagFirst; NameTag; NameTag = NameTag->next )
	{
		if (!stricmp(str, NameTag->tag)) {
			break;
		}
	}

	if (NULL == NameTag)
		return Fail;
		
	NameTag->rec = NameTag->recfirst;
	strcpy(name, NameTag->rec->name );
	
	return Ok;
}
/************************************************************/
static BOOL get_block_addr( char *str, ADDR *addr)
{
	struct AddrTags *AddrTag = NULL;
	
	/*////////////////////////////////////////////////////////////*/
	for( AddrTag = AddrTagFirst; AddrTag; AddrTag = AddrTag->next )
	{
		if (!stricmp(str, AddrTag->tag)) {
			break;
		}
	}

	if (NULL == AddrTag)
		return Fail;
		
	AddrTag->rec = AddrTag->recfirst;
	*addr = AddrTag->rec->addr;
	
	return Ok;
}
/************************************************************/
static BOOL get_block_addrname( char *str, ADDR *addr, char *name)
{
	struct AddrNameTags *AddrNameTag = NULL;
	
	/*////////////////////////////////////////////////////////////*/
	AddrNameTag = AddrNameTagFirst;
	for( ; AddrNameTag; AddrNameTag = AddrNameTag->next )
	{
		if (!stricmp(str, AddrNameTag->tag)) {
			break;
		}
	}

	if (NULL == AddrNameTag)
		return Fail;
		
	AddrNameTag->rec = AddrNameTag->recfirst;
	*addr = AddrNameTag->rec->addr;
	strcpy(name, AddrNameTag->rec->name);
	
	return Ok;
}
/************************************************************/
static char *get_block_subj( char *subj, char *err)
{
	struct SubjectTags *SubjectTag = NULL;
	BOOL found = 0;
	
	/*////////////////////////////////////////////////////////////*/
	for( SubjectTag = SubjectTagFirst; SubjectTag; SubjectTag = SubjectTag->next )
	{
		if (!stricmp(subj, SubjectTag->tag)) {
			found = 1;
			break;
		}
	}

	if (!found) { 
		
		fprintf(stderr, "%s no such <Data Subject> : `%s'\n", err, subj);
		abort();
		
	}
		
	SubjectTag->rec = SubjectTag->recfirst;
	strcpy( subj , SubjectTag->rec->subject);
	
	return subj;
}
/************************************************************/
/*
static char *get_block_string( char *string, char *err)
{
	struct TextStrTags *TextStrTag = NULL;
	static char buf[256];
	BOOL found = 0;
	
	////////////////////////////////////////////////////////////////
	for( TextStrTag = TextStrTagFirst; TextStrTag; TextStrTag = TextStrTag->next )
	{
		if (!stricmp(string, TextStrTag->tag)) {
			found = 1;
			break;
		}
	}

	if (!found) { 
		
		fprintf(stderr, "%s no such <Data TextString> : `%s'\n", err, string);
		abort();
		
	}
		
	TextStrTag->rec = TextStrTag->recfirst;
	strcpy(buf, TextStrTag->rec->str );
	
	return buf;
}
*/
/**************************************************/
BOOL is_echoarea(int areatype, char *areatag)
{
	struct FidoAreas *FidoArea;
	struct SquishAreas *SquishArea;
	struct JamAreas *JamArea;
	struct PktAreas  *PktArea;
	
	switch (areatype)
	{
	case FIDO:
		for( FidoArea = FidoAreaFirst; FidoArea; FidoArea = FidoArea->next )
		{
			if (!stricmp(FidoArea->name, areatag)) {
				if ( FidoArea->EchoMail == Yes )
					return Ok;
				else
					return Fail;
			}
		}
		break;
	case SQUISH:
		SquishArea = SquishAreaFirst;
		for( ; SquishArea; SquishArea = SquishArea->next )
		{
			if (!stricmp(SquishArea->name, areatag)) {
				if ( SquishArea->EchoMail == Yes )
					return Ok;
				else
					return Fail;
			}
		}
	case JAM:
		JamArea = JamAreaFirst;
		for( ; JamArea; JamArea = JamArea->next )
		{
			if (!stricmp(JamArea->name, areatag)) {
				if ( JamArea->EchoMail == Yes )
					return Ok;
				else
					return Fail;
			}
		}
	case PKT:
		for( PktArea = PktAreaFirst; PktArea; PktArea = PktArea->next )
		{
			if (!stricmp(PktArea->name, areatag)) {
				if ( PktArea->EchoMail == Yes )
					return Ok;
				else
					return Fail;
			}
		}
		break;

	default:
		break;
	}
	
	return Fail;
}
/***************************************/
static void kill_netmail_kludges(TEXT **text)
{
	int j, found;
	char *p = NULL, kludge[128];
	TEXT *t = *text, *t_prev = NULL, *t_next = NULL;
	
	while(t)
	{
		/* kludge found */
		if (is_kludge(t->str)) {
			
			strncpy(kludge, t->str, 127); kludge[127] = 0;
			p = kludge;

			strip_CRLF(p);

			++p;

			for(j = 0 , found = -1; strlen( Kludges[j].s ); ++j)
			{
				if (!strnicmp(p, Kludges[j].s, strlen(Kludges[j].s))) {
					p += strlen( Kludges[j].s );
					if (*p == ':')
						++p;
					++p;
					found = Kludges[j].n;
					break;
				}
			}

			switch (found)  {

			case k_Domain:
			case k_Intl:
			case k_Topt:
			case k_Fmpt:
			case k_Via:
			case k_Recv:
					
					t_next = t->next;
				
					free(t);
				
					if (t_prev) {
						t = t_prev;
						t->next = t_next;
					}
					else {
						t = t_next;
						*text = t;
						continue;
					}

					break;

			case k_Flags:
					(void) kill_flag_attr(t->str);
					break;

			default:
					break;
			}
			
		} /* kludge found */

		t_prev = t;
		t = t->next;

	} /* txt loop */
	
	return;
}

/*********************************/
static void inv_tear_orig(TEXT *t)
{
	for ( ; t ; t = t->next)
	{
		if (is_Origin(t->str))
			t->str[1] = '+';

		if (is_TearLine(t->str))
			t->str[1] = '+';
	}

	return;
}


/********************************/
static void clear_all_attr( AllAttr *aa)
{
	aa->attr = (word)0;
/*	aa->attr |= a_Private; */
/*	aa->attr |= a_Local; */
	aa->flag = (word)0;
	aa->stat = (dword)0L;

	return;
}

/****************************************/
#if 0
static void change_via(TEXT *t, ADDR aka)
{
	for( ; t ; t = t->next)
		if ( is_Via(t->str) && t->next == NULL )
			(void) make_via_string(aka, t->str);
	
	return;
}
#endif
/*****************************************/
static void kill_flag_attr(char *s)
{
	char buf[256], arg[256], res[256] = {0};
	
	strcpy(buf, s);
	
	memset(s, '\0', strlen(buf));
	
	strip_CRLF(buf);
	
	/* skip the `FLAGS ' tag itself */
	get_next_word(buf, arg);
	
	while(get_next_word(buf, arg))
	{
		if (minus_one == str_to_flag(arg)) {
			if (strlen(res))
				strcat(res, " ");
			strcat(res, arg);
		}
	}
	
	if (strlen(res))
		sprintf(s, "\1FLAGS %s\r", res );
	
					
	return;
}

/*******************************************************************/
void gen_more_mails(FTN new_ftn, int nsubj, char *new_subj[])
{
	int n, i;
	TEXT *newtext = NULL;
	ADDR aka;
	char system[20], buf[256];
	
	/* set our aka */
	(void)areaname_to_system(CurMsg.areaname, system);
	get_def_addr(system, new_ftn.to , &aka);
	
	for( i = 0; i < nsubj-1; ++i)
	{
		strcpy(new_ftn.subject, new_subj[i+1]);
		newtext = make_msgtext_hdr(&new_ftn, 0);
		(void) add_via(&newtext, aka);
		if (Fail !=
				(n = add_msg(CurMsg.type, CurMsg.areaname, &new_ftn, newtext, NULL)))
		{
			if (CurMsg.type == FIDO || CurMsg.type == SQUISH) {
				sprintf(buf, "   %d created in %s\n", n, strUpper(CurMsg.areaname) );
				writeToLog(1, buf);
			}
			sprintf(buf, "   Extra mail created by CheckPath in area %s\n", 
							CurMsg.areaname);
			writeToLog(1, buf);
			++nWritten;
		}
		else
			writeToLog(0, "CheckPath error: failed to create extra mail(s)\n");
	
		free_text(newtext);
				
	}
	
	return;
	
}
/****************************************/

int get_i_tpl(char *fullname, char *tpl_name, char *tpl)
{
    int rc = Ok;
    
    sprintf(fullname, "%s%s", TemplatePath, tpl_name);
    
    if (tpl) strcat(fullname, tpl );
    
    writeToLog(2, "change_text: searching tpl: `%s'\n", fullname);

    if (access(fullname, 0)) {
	strcpy(fullname, tpl_name);
	writeToLog(2, "change_text: searching tpl: `%s'\n", fullname);
	if (access(fullname, 0)) {
		writeToLog(1, "change_text: template file not found: `%s'\n", tpl_name);
		rc =  Fail;
	}
    }
    return rc;
}

static void get_tpl(char *tpl_name, TEXT **t)
{
    char fullname[256];
    int addtpl = 0;
	
    if ( !strchr(tpl_name, '.') ) addtpl = 1;

    if (!get_i_tpl(fullname, tpl_name, addtpl ? ".tpl" : NULL)) {
        get_i_tpl(fullname, tpl_name, addtpl ? ".TPL" : NULL);
    }

    *t = read_tpl(fullname);

    return;
}


/***********************************************/
TEXT * get_array_string (char *str)
{
/*    dXSARGS; */
    STRLEN len;
    AV *array;
    SV **pscalar;
    char *name_array, *scalar;
    char *data;
    int i, n;
    TEXT *t = NULL, *tfirst = NULL;

    name_array = (char*)xcalloc(strlen(str)+8, sizeof(char));
    if ((data = strchr(str, ':')) != NULL && *(data+1) == ':') {
	strcpy(name_array, str);
    } else {
	sprintf(name_array, "main::%s", str);
    }
    
    i = strlen(name_array);
    
    if (name_array[i-1] == '.') {
	name_array[i-1] = '\0';
	i--;
    }
    
    array = perl_get_av(name_array, FALSE);
    
    if (!array) {
	free(name_array);
	return line_to_txt (str);
    }

    n = av_len(array)+1;

    for( i = 0; i < n; ++i) {
	pscalar = av_fetch(array, i, 0);
	scalar = (char*)SvPV(*pscalar, len);
	data = (char*)xcalloc(len+1, sizeof(char));
	strncpy(data, scalar, len);
	expand_str_200 (&data);
	t = line_to_txt (data);
	(void) add_text (&tfirst, t, -1, Mode_Text);
	free_text (t);
	free (data);
    }

    return tfirst;
}

#if 0
TEXT * get_stem_string (char *str)
{
	char *data;
	int i, n;
	TEXT *t = NULL, *tfirst = NULL;

	data = get_shvar (str, 0);
	
	if (!data)
		return line_to_txt (str);
	
	n = atoi(data);
	free (data);


	for( i = 0; i < n; ++i)
	{
		data = get_shvar (str, i+1);
		if (!data) {
			free_text (tfirst);
			return line_to_txt (str);
		}
		expand_str_200 (&data);
		if (data) {
			t = line_to_txt (data);
			(void) add_text (&tfirst, t, -1, Mode_Text);
			free_text (t);
			free (data);
		}
	}

	return tfirst;
}

#endif
