
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_NdlReBuild)
{
    dXSARGS;
    STRLEN n_a;
    
    char *s, *err = "perl_NdlReBuild()";
    struct Tags *t = NULL;
	
    if (items > 1) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }
    
    s = (char*)xcalloc(1, sizeof(char));

    if (items) {
	
	sp_s = FromSP(0);
	s = (char*)xrealloc(s, n_a+1);
	strncpy(s, sp_s, n_a);
	s[n_a] = '\0';
    }
		

    for(t = TagFirst; t; t = t->next) {
	if ((t->i==NODELIST || t->i==VERSION9) && (!stricmp(t->tag, s) || !items)) {
	    char *ss="rebuilding nodelist indexes";
	    writeToLog(1, ss);
	    if (Chat_On)
		printf("%s\n", ss);
	    rebndl(t);
	}
    }
    
    free(s);

    XSRETURN_UNDEF;
	
}

/********************************/
static void rebndl(struct Tags *t)
{
	char buf[256], *ndlnames[10], allnames[256];
	int i, nndl;
	struct ndlTags *ndlTag = NULL;
	BOOL rc;

	if (t->i==NODELIST)
		ndlTag = ndlTagFirst;
	else
		ndlTag = v9_ndlTagFirst;
		
	for(; ndlTag; ndlTag = ndlTag->next )
	{
		if (!stricmp(t->tag, ndlTag->tag)) {
			sprintf(buf, "rebndl: rebuilding nodelist block `%s'\n", t->tag);
			writeToLog(4, buf);
			ndlTag->rec = ndlTag->recfirst;
			for(; ndlTag->rec; ndlTag->rec = ndlTag->rec->next)
			{

				/* expand templates in ndl block */
				strcpy(allnames, ndlTag->rec->allnames);
				nndl = getndlnames(ndlTag->rec->path, allnames, ndlnames);
				
				if (!nndl) {
					fprintf(stderr, "NdlReBuild error: nodelist file template not found: `%s'\n",
									ndlTag->rec->allnames);
					abort();
				}
				
				if (t->i==NODELIST)
					rc = ndl_build(nndl, ndlnames, ndlTag->rec->path, ndlTag->rec->ext);
				else
					rc = v9_ndl_build(nndl, ndlnames,
														ndlTag->rec->path,
														ndlTag->rec->ext,
														ndlTag->rec->zone,
														ndlTag->rec->reg);

				if ( rc == Fail ) {
					fprintf(stderr, "rebndl error: nodelist rebuild failed\n");
					abort();
				}

				for(i = 0; i < nndl; ++i)
					free(ndlnames[i]);

			} /* rec loop */
		}   /* tag found */
	} /* ndlTag */
}
