
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static long MAXLEN, RATIO = 32L;
static char ADD[256];
static char ArchName[20];

static XS(perl_PackPkt)
{
/* <PKTAREANAME>  <AREANAME> [<ADDRESSPACKER BLOCKNAME>] [NOMOVE] */
    dXSARGS;
    STRLEN n_a;	
    char *err="perl_PackPkt()";
    char *pkt_areaname, pkt_path[128], buf[256];
    char *targ_areaname, targ_path[128]={0};
    char *aptag = NULL;
    int i;
    struct PktAreas  *PktArea = NULL;
    struct BinkAreas *BinkArea = NULL;
    struct AddrPackerTags *AddrPackerTag = NULL;
    PKT_AREA pkt;
    BOOL NoMove = No;
    int fbox = 0;
	
    if (items < 2 || items > 4) {
	fprintf(stderr, "%s argument count (need 2 ... 4, exist %d)\n", err, (int)items);
	abort();
    }
	
    items = (items<10) ? items : 10;


    sp_s = FromSP(0);
    pkt_areaname = XCAL;
    strncpy(pkt_areaname, sp_s, n_a);
	
    for( PktArea = PktAreaFirst; PktArea; PktArea = PktArea->next ) {
	if ( !stricmp( PktArea->name, pkt_areaname ) ) {
	    strcpy(pkt_path, PktArea->path);
	    break;
	}
    }

    if (!PktArea) {
	fprintf(stderr, "%s PKT area undefined: `%s'\n", err, pkt_areaname);
	abort();
    }

    sp_s = FromSP(1);
    targ_areaname = XCAL;
    strncpy(targ_areaname, sp_s, n_a);

    for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea->next )
	if (!stricmp(targ_areaname, BinkArea->name))
	    break;

    if (!BinkArea) {
	writeToLog(4, "packpkt: binkarea not found, try pkt fbox");
	for( PktArea = PktAreaFirst; PktArea; PktArea = PktArea->next ) {
	    if ( !stricmp( PktArea->name, targ_areaname ) ) {
		fbox = PktArea->fbox;
		strcpy(targ_path, PktArea->path);
		if (!fbox) {
		    fprintf(stderr, "%s PKT area is not a filebox: `%s'\n", err, targ_areaname);
		    abort();
		}
	  	break;
	    }
	}
    }
	
    if (!BinkArea && !fbox) {
	fprintf(stderr, "%s area not found: `%s'\n", err, targ_areaname);
	abort();
    }

	/* get AddressPacker block */
    if (items >= 3) {

	int next_arg = 2;
	
	sp_s = FromSP(2);
	aptag = XCAL;
	strncpy(aptag, sp_s, n_a);
	AddrPackerTag = AddrPackerTagFirst;
	for( ; AddrPackerTag; AddrPackerTag = AddrPackerTag->next )
	    if (!stricmp(aptag, AddrPackerTag->tag))
		break;

	if (!AddrPackerTag) {
	    if (items == 4) {
		fprintf(stderr, "%s no such Data AddressPacker block: `%s'\n", err, aptag);
		abort();
	    }
	} else next_arg = 3;

	if (next_arg < items) {
	    sp_s = FromSP(next_arg);
	    if (!stricmp(sp_s, "nomove"))
		NoMove = Yes;
        }
			
		
		
    } /* get AddressPacker block */
	
	
    select_pkt_area(pkt_path, &pkt);

    for(i = 0; i < pkt.total; ++i) {
	BOOL set_bsy(char *bsy);
	void kill_bsy(char *bsy);
	ADDR to;
	word kill_flv;
	char bsy[256]={0}, caddrTo[128], flags[128], *basename=NULL;
	char full_pktname[256], arcmail[128], full_arcmail[256], FLOname[256]={0};
	char exe[128], arg[512], buf2[256], cflv, kill_flavor[2]={0}, caddr[128];
	char arcpath[128];
		
	strcpy (full_pktname, pkt.fnames[i].fname);
		
	if (!get_pkt_to(full_pktname, &to)) {
	    writeToLog(0, "PackPkt: error reading pkt header, file `%s'\n",
						full_pktname);
	    continue;
	}

	addr_to_str(to, caddr);
		
	memset(ArchName, '\0', 20);
	memset(flags, '\0', 128);
	MAXLEN = 0L;
	RATIO = 32L;
		
	if (AddrPackerTag)
	    read_aptag(AddrPackerTag, to, flags);

	cflv = get_FLO_flavor(flags);

	if (fbox) {
	    char* p;
	    word flv = flv_Normal;
	    if (cflv == 'h')
    		flv = flv_Hold;
	    else if (cflv == 'i')
		flv = flv_Imm;
	    else if (cflv == 'c')
		flv = flv_Crash;
	    else if (cflv == 'd')
		flv = flv_Dir;
	    strcpy (arcpath, targ_path);
	    if (NULL != (p = get_fbox_path (fbox, targ_areaname, to, flv))) {
		strcat (arcpath, p);
		fix_path(arcpath);
		strcat(arcpath, SEP);
	    }
	} else {
	    if (BinkArea->type == tBINK) {
		basename = addr_to_binkoutbase(to, BinkArea);
		sprintf(bsy , "%s.bsy" , basename);
		sprintf(FLOname, "%s.%clo", basename, cflv);
	    } else if (BinkArea->type == tAMIGA4D) {
		basename = addr_to_amiga4doutbase(to, BinkArea);
		sprintf(bsy , "%s.bsy" , basename);
		sprintf(FLOname, "%s.%clo", basename, cflv);
	    } else {
		char *p;
		basename = addr_to_brakeoutbase(to, BinkArea);
			
		if (cflv == 'h')
		    p = "Hold";
		else if (cflv == 'i')
		    p = "Immediate";
		else if (cflv == 'c')
		    p = "Crash";
		else if (cflv == 'd')
		    p = "Direct";
		else
		    p = "Normal";
			
		sprintf(FLOname, "%s.%s.List", basename, p);
		sprintf(bsy, "%s.Busy", basename);
	    }
		
	    if ( !set_bsy(bsy) ) {
		addr_to_str( to , caddrTo );
		writeToLog(1, "Skipping busy system: %s\n", caddrTo );
		continue;
	    }
	}   /* not a fbox */

	/* add arcmail */
	if (strlen(ArchName)&&strcmp(ArchName, "-")) {


	    BOOL rc;

	    read_compress_block();


	    if (!fbox) {
		if (NoMove || !basename)
		    strcpy(arcpath, pkt_path);
		else {
		    chop_fname(basename);
		    strcpy(arcpath, basename);
		}
	    }
				
	    rc = get_arcmail_name(arcpath, full_pktname, FLOname, to, arcmail, fbox);

	    if (!strlen(arcmail)) {
		writeToLog(0, "PackPkt error: extention list full, skipping `%s'\n",
						full_pktname);
		if (!fbox)
		    kill_bsy(bsy);
		continue;
	    }

	    sprintf(full_arcmail, "%s%s", arcpath, arcmail);
/*	    strupr(full_arcmail); */
			
	    /* create attach */
	    if (!fbox && !rc) {
		sprintf(buf, "   Create arcmail attach for %s\n", caddr);
		writeToLog(1, buf);
		if (Chat_On) printf(buf);
		kill_flv = set_kill_flavor(flags, f_Tfs);
		if ( kill_flv & f_Kfs )
			strcpy(kill_flavor, "^");
		else if ( kill_flv & f_Tfs )
			strcpy(kill_flavor, "#");

		sprintf(buf, "%s%s\r\n", kill_flavor, full_arcmail);
/*		strupr(buf); */
		pupdate_FLO(FLOname, buf);
	    }
				
	    get_callstr(full_arcmail, full_pktname, exe, arg);
	    writeToLog(4, "PackPkt: executing: `%s %s'\n", exe, arg);
			
    	    sprintf(buf, "PackPkt: adding to archive: %s", full_arcmail);
/*	    if (Chat_On)
	    printf("%s", buf);
*/			
	    if (0 == (rc = shell(exe, arg))) {
		strcat(buf, " - ok\n");
		writeToLog(2, buf);

		if (0 != remove(full_pktname))
		    perror(full_pktname);

	    } else {
		sprintf(buf2, " - error: packer reported %d\n", rc);
/*        if (Chat_On)
          printf("%s", buf2);
*/		strcat(buf, buf2);
		writeToLog(0, buf);
	    }

	}      /* arcmail */
		
	else if (!fbox) { /* uncompressed pkt */
			
	    kill_flv = set_kill_flavor(flags, f_Kfs);
			
	    if ( kill_flv & f_Kfs )
		strcpy(kill_flavor, "^");
	    else if ( kill_flv & f_Tfs )
		strcpy(kill_flavor, "#");
			
	    sprintf(full_pktname, "%s%s\r\n", kill_flavor, 
					pkt.fnames[i].fname);
/*	    strupr(full_pktname); */
			
			
	    if (pupdate_FLO(FLOname, full_pktname)) {
		sprintf(buf, "   Created pkt attach for %s\n", caddr);
		writeToLog(1, buf);
		if (Chat_On)
		    printf(buf);
	    }
			
	} /* add uncompressed pkt */

	if (!fbox)
	    kill_bsy(bsy);
		
    } /* pktnames loop */

    free(pkt.fnames);
    free(aptag);
    free(targ_areaname);
    free(pkt_areaname);

    XSRETURN_UNDEF;
}

/**********************************/
static char get_FLO_flavor(char *p)
{
	char cattr[128], s[256];

	strcpy(s, p);
	
	while(get_next_word(s, cattr)) {
		if (str_to_attr(cattr) == a_Hold)
			return 'h';
		else if (str_to_flag(cattr) == f_Imm)
			return 'i';
		else if (str_to_attr(cattr) == a_Crash)
			return 'c';
		else if (str_to_flag(cattr) == f_Dir)
			return 'd';
	}
	
	return 'f';
}
/**********************************/
static word set_kill_flavor(char *p, word flag)
{
	AllAttr aa;
	char cattr[128], s[256];

	aa.flag = flag;

	strcpy(s, p);
	
	while(get_next_word(s, cattr))
		set_all_attrs( cattr , &aa );
	
	return aa.flag;
}

/*******************************************/
static BOOL get_pkt_to(char *fname, ADDR *to)
{
	int h;
	char buf[256];
	dword len;
	PKT_HDR pkt_hdr;

	if( (h = open(fname, O_RDONLY|O_BINARY)) == -1 ) {
		sprintf(buf, "get_pkt_to: error opening  file: `%s'\n", fname);
		writeToLog(3, buf);
		return Fail;
	}

	len = sizeof(PKT_HDR);
	
	if ( len != read( h, &pkt_hdr, len ) ){
		sprintf(buf, "get_pkt_to: error reading pkt file: `%s'\n", fname);
		writeToLog(3, buf);
	}

	to->zone    = pkt_hdr.toZone;
	to->net     = pkt_hdr.toNet;
	to->node    = pkt_hdr.toNode;
	to->point   = pkt_hdr.toPoint;

	close(h);
	return Ok;
}

/**************************************************/
static void read_aptag(struct AddrPackerTags *tag, ADDR to, char *flags)
{
	char buf[256];
	tag->rec = tag->recfirst;
	for( ; tag->rec; tag->rec = tag->rec->next)
	{
		if (comp_addrs(to, tag->rec->addr)) {
			strcpy(ArchName, tag->rec->archname);
			strcpy(flags, tag->rec->attrs);
			MAXLEN = tag->rec->len;
			sprintf(buf, "read_aptag: arcname: `%s' flags: `%s' maxlen=%lu\n",
							ArchName, flags, MAXLEN);
			writeToLog(4, buf);
			break;
		}
	}
	
	return;
}

/************************************/
static BOOL pupdate_FLO(char *fname, char *s)
{
	FILE *h;
	char buf[256], j[256], *pj, *ps = s;

	if( (h = fopen(fname, "a+b")) == NULL ) {
		sprintf(buf, "pupdate_FLO: error opening `%s'\n", fname);
		writeToLog(0, buf);
		return Fail;
	}

	if (*ps == '^' || *ps == '#')
		++ps;


	if (is_pkt(s)) {
		
		fseek(h, 0L, SEEK_SET);

		while(fgets(j, 255, h))
		{
			pj = j;
			if (*pj == '^' || *pj == '#')
				++pj;
			if (!stricmp(pj, ps)) {
				strip_CRLF(pj);
				sprintf(buf, "pupdate_FLO: entry already exists: `%s'\n", pj);
				writeToLog(4, buf);
				fclose(h);
				return Fail;
			}

		}
		
	}
	
	fputs(s, h);
	fclose(h);
	
	return Ok;
}
/******************************/
static BOOL is_pkt(char *fname)
{
	char *p = strrchr(fname, '.');
	
	if (p && !strnicmp(&p[1], "PKT", 3))
		return Ok;
	else
		return Fail;
}

/****************************************************************/
static BOOL get_arcmail_name
(char *arcpath, char *pkt,	char *flo, ADDR to, char *fname, int fbox)
{
	struct pktcache *cache = ArcCache;
	char buf[256], s[256];
	

	for( ; cache; cache = cache->next )
	{
		if (addr_cmp(cache->to, to) && !stricmp(cache->areapath, arcpath) )
		{
			
			sprintf(s, "%s%s", cache->areapath, cache->fname);
			if (!is_size_ok(s, pkt))
				break;

			strcpy(fname, cache->fname);
			sprintf(buf, "get_arcname: get name from cache `%s'\n", fname);
			writeToLog(4, buf);
			
			return Ok;
			
		} /* cache record found */
		
	}   /* cache walk */


	writeToLog(4, "get_arcname: assign new archive name\n");

	if (!cache && get_last_arc_entry(fbox, flo, pkt, arcpath, fname)) {
		sprintf(buf, "get_arcname: assign last found name:  `%s'\n", fname);
		writeToLog(4, buf);
		add_to_arccache(to, arcpath, fname);
		sprintf(buf, "get_arcname: add new name to cache: `%s'\n", fname);
		writeToLog(4, buf);
		return Ok;
	}
	else {
		
		if (make_new_arcname(to, arcpath, fname)) {
			sprintf(buf, "get_arcname: made new name`%s'\n", fname);
			writeToLog(4, buf);
			if (cache) {
				strcpy(cache->fname, fname);
				sprintf(buf, "get_arcname: replace current cache entry for `%s'\n", fname);
				writeToLog(4, buf);
			}
			else {
				add_to_arccache(to, arcpath, fname);
				sprintf(buf, "get_arcname: add new name to cache: `%s'\n", fname);
				writeToLog(4, buf);
			}
		}
		else {
			if (!cache)
/*				strset(fname, 0); */
				*fname = '\0';
			else {
				strcpy(fname, cache->fname); /* theoretically this may fail if:
				                             - too many bundles have been created
     				                         - all of them have been sent and truncated
				                             */
				return Ok;
			}
		}   /* make_new_arcname failed */
	
		return Fail;  /* attach needed */
	}

}

/*****************************************************/
static BOOL get_last_arc_entry
(int fbox, char *flo, char *pkt, char *arcpath, char *fname)
{
	char buf[256], last_arc[256]={0}, plast[256]={0};
	struct stat st;
	time_t t;
	struct tm *tm;
	int today_d, today_m, today_y;
	
	t = time(NULL);
	tm = localtime(&t);
	today_d = tm->tm_mday;
	today_m = tm->tm_mon;
	today_y = tm->tm_year;

	if (!fbox) {
		
		if (0 != stat(flo, &st)) {
			sprintf(buf, "get_last_arc_entry: %s not found\n", flo);
			writeToLog(4, buf);
			return Fail;
		}
		else {

			int file_d, file_m, file_y;

			tm = localtime(&st.st_mtime);
			file_d = tm->tm_mday;
			file_m = tm->tm_mon;
			file_y = tm->tm_year;


			if ((today_d != file_d) ||
					(today_m != file_m) ||
					(today_y != file_y))
			{
				sprintf(buf, "get_last_arc_entry: %s is old\n", flo);
				writeToLog(4, buf);
				return Fail;
			}
			else {

				FILE *h;
				char j[256], *p, *q;
				char *pfull;

				if ( (h = fopen(flo, "r") ) == NULL ) {
					sprintf(buf, "get_last_arc_entry: error opening `%s'\n", flo );
					writeToLog(0, buf);
					return Fail;
				}

				sprintf(buf, "get_last_arc_entry: scanning %s\n", flo);
				writeToLog(4, buf);
			
				while (fgets(j, 255, h))
				{
					strip_CRLF(j);
					pfull = j;
				
					if (*pfull == '^' || *pfull == '#')
						++pfull;

					if (0 != strnicmp(arcpath, pfull, strlen(arcpath))) {
						sprintf(buf, "get_last_arc_entry: path `%s' not found in entry `%s'\n",
										arcpath, j);
						writeToLog(4, buf);
						continue;
					}

					if (NULL != (p = strrchr(pfull, DELIM)))
						q = ++p;
					else
						q = pfull;

					/* entry OK */
					if (is_arcmail(q) && is_curdate(q)) {

						strcpy(last_arc, q);
						strcpy (plast, pfull);
						sprintf(buf, "get_last_arc_entry: got entry `%s'\n", plast);
						writeToLog(4, buf);
					}         /* entry is arcmail and up-to-date */
					else {
						sprintf(buf, "get_last_arc_entry: not arcmail or old `%s'\n", q);
						writeToLog(4, buf);
					}

				} /* fgets */

				fclose(h);
			
			}  /* FLO is fresh */

		}    /* FLO found */

	}
	else {

		char fullname[256];
		struct dirent *d;
		int file_d, file_m, file_y;
		char last_char = ' ', c0;
		DIR *dir;

#ifdef __MINGW32__
		dirNameLen = strlen(arcpath)-1;
		arcpath[dirNameLen] = 0;
#endif

		dir = opendir(arcpath);

#ifdef __MINGW32__
		arcpath[dirNameLen] = '\\';
#endif

		while (dir && (NULL != (d = readdir(dir))))
		{
			if (!strcmp(d->d_name, ".") || !strcmp(d->d_name, ".."))
				continue;
			if (!is_arcmail(d->d_name)) {
				sprintf (buf, "get_last_arc_entry: %s is not arcmail", d->d_name);
				writeToLog(5, buf);
				continue;
			}

			sprintf(fullname, "%s%s", arcpath, d->d_name);
			if ((stat(fullname, &st) != 0) ) {
				sprintf (buf, "get_last_arc_entry: %s not found", fullname);
				writeToLog(5, buf);
				continue;
			}
			
			tm = localtime(&st.st_mtime);
			file_d = tm->tm_mday;
			file_m = tm->tm_mon;
			file_y = tm->tm_year;

			
			if ((today_d != file_d) ||
					(today_m != file_m) ||
					(today_y != file_y))
			{
				sprintf(buf, "get_last_arc_entry: %s is old\n", fullname);
				writeToLog(5, buf);
				
				if (st.st_size == 0) {
					sprintf (buf, "removing old empty arcmail: %s\n", fullname);
					writeToLog(5, buf);
					unlink (fullname);
				}
				
				continue;
				
			}

			c0 = d->d_name[strlen(d->d_name)-1];
			if (c0 > last_char) {
				last_char = c0;
				strcpy(last_arc, d->d_name);
				strcpy (plast, fullname);
				sprintf(buf, "get_last_arc_entry: found `%s'\n", fullname);
				writeToLog(5, buf);
			}
			
		} /* while dir */
		
	} /* fbox */

	
	/* check last entry */
	if (strlen(last_arc) && strlen(plast)) {
		
		extern struct Compress * detect_arctype(char *a);
		struct Compress *Compress = NULL;
		
		while(1) {

			if (0 != stat(plast, &st) || !st.st_size) {
				sprintf(buf, "get_last_arc_entry: empty or non-existant entry `%s'\n",
								plast);
				writeToLog(4, buf);
/*				strset(last_arc, 0); */
				break;
			}
			
			if (MAXLEN && !is_size_ok(plast, pkt)) {
				writeToLog(4, "get_last_arc_entry: maxsize exceeded\n");
/*				strset(last_arc, 0); */
				break;
			}
			
			Compress = detect_arctype(plast);
			if (Compress == NULL) {
				sprintf (buf, "get_last_arc_entry: error detecting archive type for %s\n",
								 last_arc);
				writeToLog(4, buf);
/*				strset(last_arc, 0); */
				break;
			}
			else if (0 != stricmp(ArchName, Compress->archname)) {
				writeToLog(4, "get_last_arc_entry: different archive types\n");
/*				strset(last_arc, 0); */
				break;
			}

			break;
			
		}  /* while(1) (NEVER REACHED) */
		
	}    /* check last entry */

	if (strlen(last_arc)) {
		strcpy(fname, last_arc);
		sprintf(buf, "get_last_arc_entry: last arcmail entry (w/o path) in %s is %s\n",
						flo, fname);
		writeToLog(4, buf);
		
		return Ok;
	}
	else {
		sprintf(buf, "get_last_arc_entry: no valid entry found in %s\n", flo);
		writeToLog(4, buf);
		return Fail;
	}
	
}

/***********************************/
static BOOL is_curdate(char *fname)
{
	char *ext = strrchr(fname, '.');
#ifdef DOS
	struct dosdate_t d;
#else
	time_t t;
	struct tm *ttm;
#endif
	char buf[256];
	
	if (!ext)
		return Fail;

	++ext;

	sprintf(buf, "is_curdate: current entry's extention is `%s'\n", ext);
	writeToLog(6, buf);

#ifdef DOS
	_dos_getdate(&d);

	sprintf(buf, "is_curdate:  day of week: %d\n",	d.dayofweek);
	writeToLog(6, buf);

	return  (0 == strnicmp(Dow[d.dayofweek].dow, ext, 2)) ? Ok : Fail;
#else
	t = time(NULL);
	ttm = gmtime(&t);
	
	sprintf(buf, "is_curdate:  day of week: %d\n",	ttm->tm_wday);
	writeToLog(6, buf);

	return  (0 == strnicmp(Dow[ttm->tm_wday].dow, ext, 2)) ? Ok : Fail;
#endif
}
/****************************************************************/
static BOOL make_new_arcname(ADDR to, char *arcpath, char *fname)
{
	char s[128],  dow[3], buf[256], base[9]={0};
	char c;

	addr_to_str(to, s);
	sprintf(base, "%08lX", crc_str(-1L, s, strlen(s)));
	get_todays_dow(dow);
	sprintf(fname, "%s.%.2s?", base, dow);
	
	if (Fail == (c = get_last_char(arcpath, fname))) {
		sprintf(buf, "make_new_arcname error: extention set exhausted for node %s\n", s);
		writeToLog(0, buf);
		return Fail;
	}
	else
		fname[strlen(fname)-1] = c;
	
	return Ok;
}
/***********************************/
static void get_todays_dow(char *dow)
{
#ifdef DOS
	struct dosdate_t d;

	_dos_getdate(&d);

	strcpy(dow, Dow[d.dayofweek].dow);
#else
    time_t t;
    struct tm *ttm;
    
    t = time(NULL);
    
    ttm = gmtime(&t);
    
    strcpy(dow, Dow[ttm->tm_wday].dow);
#endif	
	return;
}
/***************************************************/
static char get_last_char(char *arcpath, char *fname)
{
	struct find_t ffblk;
	char buf[256], s[256];
	BOOL done;
	char c = 0, maxc = 0;

	sprintf(s, "%s%s", arcpath, fname);
	
	sprintf(buf, "get_last_char (arcmail naming): search for pattern: `%s'\n", s);
	writeToLog(4, buf);
	done = _dos_findfirst(s, 0, &ffblk);
	while (!done) {
		if (is_arcmail(ffblk.name)) {
			c = (char)tolower(ffblk.name[strlen(ffblk.name)-1]);
			if (c > maxc)
				maxc = c;
			sprintf(buf, "get_last_char (arcmail naming): found file `%s', lchar: `%c', maxlchar: `%c'\n",
							ffblk.name, c, maxc);
			writeToLog(4, buf);
		}
		done = _dos_findnext(&ffblk);
	}
	_dos_findclose(&ffblk);
	
	if (c)
		c = maxc+1;
	else
		c = '0';

	if (c>'9' && c<'a')
		c = 'a';

	sprintf(buf, "get_last_char (arcmail naming): max char is : `%c'\n", c);
	writeToLog(4, buf);
	
	if (c <= 'z') {
		
		return c;
		
	}
	else {
		
		writeToLog(4, "get_last_char (arcmail naming): all chars used, try to find a hole\n");
		c = '0';
		while(c != 'z')
		{
			s[strlen(s)-1] = c;
			if (_dos_findfirst(s, 0, &ffblk)) {
				sprintf(buf, "get_last_char (arcmail naming): file not exist (%s), use it\n",
						s);
				writeToLog(4, buf);
				return c;
			}
			else {
				if (!ffblk.size) {
					sprintf(buf, "get_last_char (arcmail naming): file empty (%s), kill&use it\n",
							s);
					writeToLog(4, buf);
					remove(s);
					return c;
				}
				_dos_findclose(&ffblk);
			}
			
			++c;
			c = (char)tolower(c);
			if (c>'9' && c<'a')
				c = 'a';
			
		}
		
		return 0;   /* snafu */
		
	} /* all letters used */


}
/********************************************************/
static void read_compress_block(void)
{
	struct Compress *Compress = NULL;
	char buf[256];
	
	for(Compress = CompressFirst; Compress; Compress = Compress->next)
		if (!stricmp(Compress->archname, ArchName))
				break;
				
	if (Compress) {
		if (Compress->arc.ratio)
			RATIO = Compress->arc.ratio;
		strcpy(ADD, Compress->arc.add);
		sprintf(buf, "read_compress_block: got ratio:%ld, addstr:`%s'\n", RATIO, ADD);
		writeToLog(4, buf);
	}
	else {
		fprintf(stderr, "read_compress_block error: packer undefined : `%s'\n", ArchName);
		abort();
	}
	
	return;
}


/**************************************************************/
static void get_callstr(char *a, char *f, char *exe, char *arg)
{
	char buf[512], *p, *q;

	q = ADD;
						
	p = strstr(q, "%f");
	strncpy(buf, q, p-q);
	buf[p-q] = '\0';
	strcat(buf, f);
	strcat(buf, &q[p-q+2]);

	q = buf;
	p = strstr(q, "%a");
	strncpy(arg, q, p-q);
	arg[p-q] = '\0';
	strcat(arg, a);
	strcat(arg, &q[p-q+2]);
				
	get_next_word(arg, exe);
		
	return;
}

/****************************************************************/
void add_to_arccache(ADDR to, char *areapath, char *fname)
{
	struct pktcache *cache;
	
	cache = (struct pktcache *)calloc(1, sizeof(struct pktcache));
	if (cache) {
		cache->next = NULL;
		/*/////////////////*/

		cache->to.zone = to.zone;
		cache->to.net = to.net;
		cache->to.node = to.node;
		cache->to.point = to.point;

/*    cache->to = *to; */
		strcpy(cache->areapath, areapath);
		strcpy(cache->fname, fname);
		/*/////////////////*/
		if (ArcCacheLast) {
			ArcCacheLast->next = cache;
		}
		else {
			ArcCache = cache;
		}
		ArcCacheLast = cache;
	}
	
	return;
}

/****************************************/
static BOOL is_size_ok(char *s, char *pkt)
{

	struct stat st;
	char buf[256];
	dword len;

	sprintf(buf, "is_size_ok: check length of `%s'\n", s);
	writeToLog(5, buf);

	/* archive not found */
	if (0 != stat(s, &st)) {
		sprintf(buf, "is_size_ok: archive not found: `%s'\n", s);
		writeToLog(0, buf);
		return Fail;
	}

	len = st.st_size;

	/* don't care about size,  just check if the bundle
	   has already been sent and truncated by mailer */
	if (MAXLEN == 0)
	{
		return len ? Ok : Fail;
	}

	/* pkt not found */
	if (0 != stat(pkt, &st)) {
		sprintf(buf, "is_size_ok: pkt not found: `%s'\n",
						pkt);
		writeToLog(0, buf);
		return Fail;
	}

	sprintf(buf, "is_size_ok: current arclen=%ld, pktlen=%d, ratio=%ld, est. newlen=%ld maxlen=%ld\n",
					len, (int)st.st_size, RATIO, (long)(len + st.st_size*10L/RATIO), MAXLEN);
	writeToLog(5, buf);

	if (len + st.st_size*10L/RATIO > MAXLEN)
		return Fail;
	
	return Ok;
}
