
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

int loop;

static XS(perl_ReadMsg)
{
    dXSARGS;
/*  STRLEN n_a; */
    BOOL rc;
/*  char res[256]; */
    char err[128];
/*  char buf[256]; */
	
    sprintf(err, "perl_readMsg()");
	
    if (items) {
	fprintf(stderr, "%s argument count\n", err);
	abort();
    }

    if ( !strlen(CurMsg.areaname) ) {
	fprintf(stderr, "%s no area selected\n", err);
	abort();
    }

    rc = readmsg(err);

    XSRETURN_IV(rc);
}


BOOL readmsg(char *err)  
{
	BOOL  rc = Fail;
	char buf[256], filename[256], system[20];
	FIDO_MSG msgHdr;
	BOOL need_parse = Yes;

	
	/* first log the previous msg, if it was actually read and changed */

	if (CurMsg.n && ( (ftn.stat & i_Changed) ||
			CurMsg.type == PKT || CurMsg.type == BINK) )
		update_msg(CurMsg.type);

	if (CurMsg.n)
		CurMsg.lrno = CurMsg.realNo;

	/* Resetting globals */
	
	free_text(TextFirst);  
	TextFirst = NULL;    
	free_text(ViaTextFirst);
	ViaTextFirst = NULL;
	memset(&ftn, 0, sizeof(FTN));
	CurMsg.n = 0;
	sq_errno = 0;
	jam_errno = 0;
	
	
	if (CurMsg.type == FIDO) {
		while(!rc) {
		
			if (CurMsg.fido.n < CurMsg.fido.total) {

				dword ts = CurMsg.fido.fnames[CurMsg.fido.n].ts;
				char* basename = CurMsg.fido.fnames[CurMsg.fido.n++].fname;

				sprintf(filename, "%s%s", CurMsg.areapath, basename);
				sprintf(buf, "read_msg (fido): about to read fido msg file: `%s'\n",
								filename);
				writeToLog(4, buf);
				
				rc = read_fido_msg(filename, &msgHdr, &TextFirst);
				/* rc = 1 on success or 0 on failure */


				if (rc) {
					CurMsg.n = CurMsg.fido.n;
					sprintf(buf, "read_msg (fido): fido msg %d read ok\n", CurMsg.n);
					writeToLog(4, buf);
					CurMsg.fido.msgHdr = msgHdr;
					CurMsg.realNo = atoi (basename);
					msghdr_to_ftn(msgHdr, &ftn);
					if (ts > CurMsg.maxts)
						CurMsg.maxts = ts;
				}
				else {
					sprintf(buf, "%s error reading fido msg file : `%s'\n",
									err, filename );
					writeToLog(0, buf);
				}
				
			} /* n < total */
			else {
				sprintf(buf, "%s end of fido area found\n", err);
				writeToLog(3, buf);
				break;
			}
		} 

		
	/* SQUISH base */
	} else  if (CurMsg.type == SQUISH) {

		/* returns 1 on success, 0 on failure */
		rc = read_squish_msg(&CurMsg.squish, &TextFirst);

		if (rc) {
			xmsg_to_ftn(CurMsg.squish.xmsg, &ftn);
			CurMsg.n = CurMsg.squish.n;
			CurMsg.realNo = CurMsg.squish.n;
		}
		else {
			if (sq_errno == SQ_NOMOREMSGS) {
				sprintf(buf, "%s end of squish area found\n", err);
				writeToLog(3, buf);
			}
			else {
				sprintf(buf, "read_msg error: squish area read failed with errno: %d\n", sq_errno);
				writeToLog(0, buf);
/*				fprintf(stderr, "\7%s", buf); */
				sq_failure_reason();
				abort();
			}
		}
		
	/* JAM area     */
	} else  if (CurMsg.type == JAM)  {

		rc = read_jam_msg(&CurMsg.jam, &TextFirst);
		
		if (rc) {
			jam_to_ftn(&CurMsg.jam, &ftn);
			CurMsg.n = CurMsg.jam.nMsgRead;
			CurMsg.realNo = CurMsg.jam.curMsgRead;
		}
		else {
			if (jam_errno == JAMAPIMSG_NOMOREMSGS) {
				sprintf(buf, "%s end of JAM area found\n", err);
				writeToLog(3, buf);
			}
			else {
				sprintf(buf, "read_msg error: JAM area read failed with errno: %d\n", jam_errno);
				writeToLog(0, buf);
/*				fprintf(stderr, "\7%s", buf); */
				abort();
			}
		}

		
	/*   PKT area   */
	} else if (CurMsg.type == PKT) {

		rc = readpkt_wrapper(err);	
		
	}                                    /* PKT AREA end         */
	/*   BINK area   */
	else if (CurMsg.type == BINK) {

		char bsy[256];

		while (CurMsg.bink.icur < CurMsg.bink.total)
		{
			
			strcpy(filename, CurMsg.bink.fnames[CurMsg.bink.icur].fname);
			
			/* read next file */
			if (0L == CurMsg.bink.off) {

				strcpy(CurMsg.bink.fname, filename);
				bnk_to_bsy(filename, bsy);
				sprintf(buf, "read_msg (bink): setting bsy: `%s'\n", bsy);
				writeToLog(3, buf);
				if (!set_bsy(bsy)) {
					sprintf(buf, "Skipping busy ?ut/?lo: `%s'\n", filename);
					writeToLog(1, buf);
					++CurMsg.bink.icur;
					continue;
				}

				if (isFLO(filename))
					rc = read_FLO(CurMsg.areaname, filename, &CurMsg.bink);
				else
					rc = read_pkt(filename, &CurMsg.bink);
						
				if (Fail == rc) {
					sprintf(buf, "%s error reading file `%s'\n", err, filename);
					writeToLog(3, buf);
					CurMsg.bink.off = 0L;
					CurMsg.n = 0;
					(void)rename_bad_pkt(filename);
					sprintf(buf, "read_msg (bink): killing bsy: `%s'\n", bsy);
					writeToLog(3, buf);
					kill_bsy(bsy);
					++CurMsg.bink.icur;
					continue;
				}
				
			} /* read next file */
			
			if (isFLO(filename))
				rc = read_FLO_msg(&CurMsg.bink, &TextFirst, &ftn);
			else
				rc = read_pkt_msg(&CurMsg.bink, &TextFirst);
					
			if ( Ok == rc )
			{
				/* end of current file */
				if (CurMsg.bink.off == CurMsg.bink.len)
					++CurMsg.bink.icur;
				
				if (isFLO(filename))
					need_parse = No;
				else
					pktarea_to_ftn(CurMsg.bink, &ftn);
				
				writeToLog(4, "read_msg (bink): next ?lo/?ut msg read OK\n");
				CurMsg.n = ++CurMsg.bink.n;
				rc = Ok;
				break; /* from BinkNames loop */
				
			} /* msg read OK */
			
			else {
				
				sprintf(buf, "%s error reading next msg in `%s'\n", err, filename);
				writeToLog(3, buf);
				(void)rename_bad_pkt(filename);
				CurMsg.bink.off = 0L;
				CurMsg.n = 0;
				
				bnk_to_bsy(CurMsg.bink.fname, bsy);
				sprintf(buf, "killing bsy: `%s'\n", bsy);
				writeToLog(3, buf);
				kill_bsy(bsy);
				
			}  /* bad msg */
			
			++CurMsg.bink.icur;
			
		} /* BinkNames loop */
		
		if (rc == Fail) {
			sprintf(buf, "%s end of bink area found\n", err);
			writeToLog(3, buf);
		}
		
		
	}                                    /* BINK AREA end         */
				

	if (rc == Ok) {

		if( Chat_On )
			do_chat();    

		if (need_parse) {
			areaname_to_system(CurMsg.areaname, system);
			parse_msg(&ftn , &TextFirst, &ViaTextFirst, system);

			if (CurMsg.type == PKT)
				ftn.routeTo = CurMsg.pkt.to;
			else if (CurMsg.type == BINK) {
				word bname_to_flv(char *fname);
				ftn.routeTo = CurMsg.bink.to;
/*        ftn.flavor |= bname_to_flv(CurMsg.bink.fname); */
				ftn.flavor = bname_to_flv(CurMsg.bink.fname);
			}

			if (isZaloop(ViaTextFirst, ftn.routeTo, system))
				ftn.stat |= i_ZaLoop;
		}

		old_ftn = ftn;

		/* increment the global counter of the messages read */
		++nRead;
		
	} /* rc = Ok */

	return rc;    
}
/************************************************************/
static void parse_msg(FTN *ftn, TEXT **txt, TEXT **Via, char *system)
{
	int j, lines = 0;
	BOOL found = 0;
	char str[256], kludge[128], *p = NULL, origin[256]={0};
	char caddr_aka[128], caddr_to[128];
	TEXT *tmptxt = NULL, *via = NULL;
	ADDR from, to, aka, origin_from;
	word flag = 0;
	dword stat = ftn->stat, len = 0L;
	struct kl_str kl;
	
	via = (TEXT *)calloc(1, sizeof(TEXT));
	via->next = NULL;
	

	memset(kl.INTL, 0, 128);
	memset(kl.FMPT, 0, 128);
	memset(kl.TOPT, 0, 128);
	memset(kl.MSGID, 0, 128);
	memset(kl.REPLY, 0, 128);
	
	for(tmptxt = *txt; tmptxt; tmptxt = tmptxt->next)
	{
		strcpy(str, tmptxt->str);
		
/*    len += strlen(str); */
		
		/* kludge found */
		if (is_kludge(str)) {
			
			strncpy(kludge, str, 127); kludge[127] = 0;
			p = kludge;

			strip_CRLF(p);

			
			++p;
			
			for(j = 0 , found = -1; strlen( Kludges[j].s ); ++j)
			{
				if (!strnicmp(p, Kludges[j].s, (int)strlen(Kludges[j].s))) {
					p += strlen( Kludges[j].s );
					if (*p == ':')
						++p;
					++p;
					found = Kludges[j].n;
					break;
				}
			}
			
			switch (found)  {

			case k_Intl:  strcpy(kl.INTL,  p); break;
			case k_Topt:  strcpy(kl.TOPT,  p); break;
			case k_Fmpt:  strcpy(kl.FMPT,  p); break;
			case k_Msgid: strcpy(kl.MSGID, p); break;
			case k_Reply: strcpy(kl.REPLY, p); break;
				
			case k_Area:
				
				/*  if kludge ^aArea found at the 1st line, it's routed echomail   */
				if (lines == 0)
					stat |= i_Routedecho;
				
				break;
				
			case k_Flags:
				if (!flag)
					flag = str_to_flags(p);
				break;
				
			case k_Via:
					if (str[strlen(str)-1] != '\r') {
						writeToLog(0, "no <cr> at end,  fucking BiP here?\n");
						strcat(str, "\r");
					}
				strcpy(via->str, str);
				(void) add_text(Via, via, -1, Mode_Bin);
				break;

			default:    
				break;
			}
		}

		/* not a kludge */
		else { 
			
			/* !NB: empty lines count (in Itrack they don`t !) */
			
			if (!is_TearLine(str) &&          /*   tearlines don't count    */
					!is_Origin(str) )             /*   neither does origin      */
			{
				if (tmptxt == *txt)                      /*   if it's 1st line    */
					if (!strncmp(str ,"AREA:", 5))     /*   then echomail found      */
						stat |= i_Echomail;
				
				/* the number of lines in the message _including_  empty lines */
				
				++lines; 
			}
			
		}                                        /*   not a kludge             */

		/* hack against fucking BiP, which puts Via with no <CR> at the end */
		if ( !tmptxt->next &&
				tmptxt->str[strlen(tmptxt->str)-1] != '\r' &&
				strlen(tmptxt->str) < 255 )
		{
			strcat(tmptxt->str, "\r");
		}
		
		
	}                                          /*   outmost txt loop         */

	free(via);
	
	from.net  = ftn->from.net;
	from.node = ftn->from.node;
	to.net    = ftn->to.net;
	to.node   = ftn->to.node;
	
	from.zone = ftn->from.zone;            
	to.zone   = ftn->to.zone;              

	
	/*    get zone and point info from upper kludges                         */
	/*    if needed, also set `intl' and `interzone' bits as needed          */

	
	stat |= parse_kludges(&kl, &from, &to);
	
	get_def_addr(system, from, &aka);

	
		
	/*    get system address to use in via                                   */
	
	/*    match aka for this area                                            */
	
	get_def_addr(system, to, &aka);
	
	(void)addr_to_str(to, caddr_to);
	(void)addr_to_str(aka, caddr_aka);

	sprintf(str, "parse_msg: aka matching for Data System %s : to=%s   aka=%s\n",
					system, caddr_to, caddr_aka);
	writeToLog(3, str);

	
	/*    settle Via stuff (parse vias to detect loops, lastvia, and seen)  */

	loop = 0;                                           /*    global !!!    */

	stat |= parse_via(*Via, aka); /* returns Lastiva|Seen|Loops */

	if ( !(stat & i_Lastvia) && (!(stat & i_Echomail) || TouchEchomail)) {
	    (void) add_via(txt, aka);
	    stat |= i_Changed;
	}
	
	ftn->to = to;
	ftn->from = from;
	strcpy(ftn->from.domain, aka.domain);
	
	if (CurMsg.type == PKT &&
			(is_echoarea(CurMsg.type, CurMsg.areaname) || (stat & i_Echomail)))
	{
		
		(void)get_origin(TextFirst, origin);
		if (Ok == get_echo_from(origin, &origin_from)) {
			ftn->echo_from = ftn->from;
			ftn->from = origin_from;
		}
		else {
			sprintf(str, "parse_msg error: origin not found or incorrect:`%s'\n", origin);
			writeToLog(4, str);
		}
			
	} /* echo-mail area */

	/* empty mail */
	if (lines == 0) {
		stat |= i_Null;
	}
	
	
	ftn->flag = flag;
	ftn->stat = stat;
	ftn->flavor = set_msg_flavor(ftn->attr, ftn->flag);
	ftn->routeTo = to;
	strcpy(ftn->domain, aka.domain);
	strcpy(ftn->reply, kl.REPLY);
	strcpy(ftn->msgid, kl.MSGID);
	strcpy(ftn->intl, kl.INTL);
	
	ftn->loop = loop;
	ftn->lines = lines;
	ftn->msglen = len;

	
	return;
	
} 

/**********************************************************/
static dword parse_kludges(struct kl_str *kl, ADDR *from, ADDR *to)
{
	char buf[256];
	char caddr_to[128], caddr_from[128], caddr[128];
	ADDR intl_to, intl_from, tmp_addr;
	BOOL zonegate = No;
	dword stat = 0;

	/*     to->zone and from->zone already predefined:                   */
	/*     zeroed for fido, and have true values for squish              */
	/*     so we don't need to clear them here                           */
	
	from->point = (word) atoi(kl->FMPT);
	to->point   = (word) atoi(kl->TOPT);
	zonegate = No;
	
	/*   if INTL found and it's valid, get zone info from it             */
	if (strlen(kl->INTL)) {
		
		strcpy(buf, kl->INTL);
		get_next_word(buf, caddr_to);
		get_next_word(buf, caddr_from);

		if (!str_to_addr(caddr_to, &intl_to) || 
				!str_to_addr(caddr_from, &intl_from)) {
					memset(kl->INTL, 0, 128);
					writeToLog(3, "parse_kludges: INTL not valid, ignored\n");
		}
		else {
			
			stat |= i_Intl;
		
			from->zone = intl_from.zone;

			if (to->net == intl_to.net && to->node == intl_to.node) {
				to->zone = intl_to.zone;
			}
			else {
				zonegate = Yes;
				
				/* zonegate is in our zone  */
				to->zone = from->zone; 

				/*  none of the following is used so far, so let`s comment it out  */
				
				/*      realTo.zone  = intlTo.zone; */
				/*      realTo.net   = intlTo.net;  */
				/*      realTo.node  = intlTo.node; */
				/*      realTo.point = to.point;    */
				/*      ftn->toPoint = 0;          */
			}
		}   /* INTL ok */
	}     /* INTL string found */
	
	/* zone not resolved ? */
	
	if (from->zone == 0) {
		
		writeToLog(3, "parse_kludges: try to fetch zone from MSGID\n");

		
		/*   try to fetch zone from MSGID                                */
		/*   if it is legal and the rest address elements match          */
		
		if (strlen(kl->MSGID)) {
			strcpy(buf, kl->MSGID);
			get_next_word(buf, caddr);

			if (str_to_addr(caddr, &tmp_addr)       &&
					tmp_addr.net   == from->net  &&
					tmp_addr.node  == from->node &&
					tmp_addr.point == from->point)
			{
				from->zone = tmp_addr.zone;
			}
			else {
				writeToLog(3, "parse_kludges: MSGID not valid or doesn't match, ignored\n");
			}
		}
	} /* MSGID */
	
	/* zone still not resolved ? */
	if (from->zone == 0) {
			
		writeToLog(3, "parse_kludges: try to fetch zone from REPLYTO\n");
			
		/*   try to fetch zone from REPLY                                */
		/*   if it is legal and the rest address elements match          */
		
		if (strlen(kl->REPLY)) {
				
			strcpy(buf, kl->REPLY);
			get_next_word(buf, caddr);

			if (str_to_addr(caddr, &tmp_addr)       &&
					tmp_addr.net   == to->net  &&
					tmp_addr.node  == to->node &&
					tmp_addr.point == to->point)
			{
				from->zone = tmp_addr.zone;
			}
			else {
				writeToLog(3, "parse_kludges: REPLYTO not valid or doesn't match, ignored\n");
			}
		}
	}   /* REPLY */

	if (zonegate == Yes)
		writeToLog(3, "parse_kludges: zonegating detected (who cares? ;-)\n");

	
	/* hmmm, zone still not resolved ?! */
	
	if (from->zone == 0) {
		writeToLog(3, "parse_kludges: fetch def zone from MainAddress\n");
		from->zone = MainAddress.zone;
	}

	if (to->zone == 0)
		to->zone = from->zone;
	
	if (to->zone != from->zone)
		stat |= i_Interzone;
	
	
	return stat;
}

/*****************************************/
static dword parse_via(TEXT *via, ADDR aka)
{
	ADDR via_addr, last_via_addr;
	register char *p = NULL;
	dword stat = 0L;

	
	memset(&last_via_addr, 0, sizeof(ADDR));
	
	for( ; via; via = via->next )
	{
		/* chop off `\1Via ' */
		p = &via->str[5];
			
		/*   address extracted from Via line is Ok   */
		if (Ok == get_via_address(p, &via_addr)) {
			
			/* if our aka found in the via addr, mark the current msg as SEEN */
			if (addr_cmp(aka, via_addr))
				stat |= i_Seen;
			else if (addr_cmp(aka, last_via_addr)) {
				++loop;                                      /*   global !!!    */
				if (loop == 1)
					stat |= i_Loop;
				else if (loop == 2)
					stat |= i_Loop2;
				else if (loop == 3)
					stat |= i_Loop2;
			}
				
			last_via_addr = via_addr;
			
		}  /*   get_via_address ok   */

	}                                             /*   outmost Text loop    */
	
	/*  if (addr_cmp(aka, last_via_addr) && is_our_ProdCode(lastvia)) */
	
	if (addr_cmp(aka, last_via_addr)) {
		struct tm tm;
		int year;
		stat |= i_Lastvia;
		tm.tm_isdst = -1;
		if (6 == sscanf(p, "%*s @%4d%2d%2d.%2d%2d%2d.",
					&year, &tm.tm_mon, &tm.tm_mday,
					&tm.tm_hour, &tm.tm_min, &tm.tm_sec))
		{
			tm.tm_year = year - 1900;
			--tm.tm_mon;
			ftn.lvia_utime = mktime (&tm);
		}
	}

	
	return stat;
	
}
/*********************************************************/
static BOOL get_via_address(char *str, ADDR *addr)
{
	char *p = NULL, buf[256];

	strcpy(buf, str);
	
	if (NULL == (p = strtok(buf, " ,")))
		return Fail;
	
	if (str_to_addr(p, addr))
		return Ok;
	
	while ( NULL != (p = strtok(NULL, " ,")))
		if (str_to_addr(p, addr))
			return Ok;

	return Fail;
}


/*******************************************************************/
#if 0
static BOOL is_our_ProdCode(char *str)
{
	int i;
	BOOL rc = 0;
	char *res[20];
	
	for(i = 0; i < 20; ++i)
		if (NULL == (res[i] = (char *)calloc(256, sizeof(char))))
			return Fail;  /* ouch :-( */

	
	splitf(str, res);

	rc = (!strcmp(ProdName, res[2])) ? Yes : No;

	for(i = 0; i < 20; ++i)
		free( res[i] );
	
	return rc;
}
#endif
/***********************************************/
/*       converts attributes to flavor         */
/***********************************************/
word set_msg_flavor(word attr, word flag)
{
	word flavor = 0;
	
	/*    Itrack's flavor priority is like this (from the highest):       */
	/*                                                                    */
	/*                   HOLD IMM CRASH DIR NORMAL                        */
	
	if (attr & a_Hold)  flavor |= flv_Hold;
	if (flag & f_Imm)   flavor |= flv_Imm;
	if (attr & a_Crash) flavor |= flv_Crash;
	if (flag & f_Dir)   flavor |= flv_Dir;
	
	if (flavor == 0)
		flavor = flv_Normal;
	
	return flavor;
	
}

/*********************************************/
TEXT *str_to_text(char *buf)
{
	register int i;
	register char cc;
	char str[256];
	TEXT *Text = NULL, *First = NULL, *Last = NULL;

	i = 0;
	memset(str, 0, 256);
	while (*buf)
	{
		cc = *buf++;
		
/*    if (cc == '\n')
      continue;     // just ignore <LF> (only <CR>s that matter */
		
		str[i++] = cc;
		/* EOL found, line too long, or EOF found */
		if (cc == '\r' || i == 255 || *buf == '\0' ) {
			
			if (*buf == '\n' && i != 255)
				str[i++] = *buf++;
			/*/////////////////////////////////////////////*/
			Text = (TEXT *)calloc(1, sizeof(TEXT));
			if (Text) {
				Text->next = NULL;
				/*/////////////////*/
				strcpy( Text->str, str);
				/*/////////////////*/
				if (Last) {
					Last->next = Text;
				}
				else {
					First = Text;
				}
				Last = Text;
			}
			/*//////////////////////////////////////////////*/
			i = 0;
			memset(str, 0, 256);
		} /* cr found or line too long */
	} /* while (buf) */

	return First;
}

/*****************************************/
static void get_origin(TEXT *t, char *o)
{
	for( ; t ; t = t->next)
		if (is_Origin(t->str))
			strcpy(o, t->str);
	
	/* if multimple found, get the last one */
	return;
}
/***************************************/
static BOOL get_echo_from(char *o, ADDR *addr)
/* extract fromAddr from Origin line */
{
	char *p, *pL, *pR, buf[256];
	
	if (NULL == (pL = strrchr(o, '(')) || 
			NULL == (pR = strrchr(o, ')')) ||
			pL > pR )
		return Fail;
	
	o[pR-o] = '\0';
	
	/* Scan till the first digit in the origin address specification */

	for (p = pL + 1; !isdigit(*p); p++)
	{
		if (*p == ')')
			return Fail;
	}

	if (Fail == str_to_addr(p, addr)) {
		sprintf(buf, "get_echo_from: error parsing origin address:`%s'\n", p);
		writeToLog(4, buf);
		return Fail;
	}
	
	return Ok;
}

/*********************************************************/

void del_my_via(TEXT **text, ADDR addr) {

    TEXT *t = *text;
    char *p;
    ADDR via_addr;
	
    for( ; t ; t = t->next)
	if (t->next && t->next->next == NULL)
/*	if (t->next == NULL) */
	    break;

    if (strncasecmp(t->next->str, "\001Via", 4) == 0) {
	p = t->next->str+5;
	if (Ok == get_via_address(p, &via_addr)) {
	    if (addr_cmp(addr, via_addr)) {
		free(t->next);
		t->next = NULL;
	    }
	}
    }
	
    return;
}

void add_via(TEXT **text, ADDR fromAddr)
{
	char str[256];
	
#if 0
	via_text = (TEXT *)calloc(1, sizeof(TEXT));
	via_text->next = NULL;
	(void) make_via_string(fromAddr, via_text->str);
	
	(void) add_text(text, via_text, -1, Mode_Bin);
	free(via_text);
	
#else

	(void) make_via_string(fromAddr, str);
	(void) add_at_end(text, str);
	
#endif
	
	return;
}
/***************************************/
void make_via_string(ADDR aka, char *str)
{
	char caddr[128], buf[256];
	
	addr_to_str( aka , caddr );
	
	if (strlen(aka.domain)) {
		strcat(caddr, "@");
		strcat(caddr, aka.domain);
	}
	
	fetch_systime(buf);
	sprintf(str, "\1Via %s %s %s %s\r", caddr, buf, ProdName, VER);
	
	return;
}


/**********************************************/
void add_at_end(TEXT **txt, char *str)
{
	TEXT *last = NULL, *t = *txt;
	
	for( ; t ; t = t->next)
		if (t->next == NULL)
			break;

	last = t;
	
	t = (TEXT *)calloc(1, sizeof(TEXT));
	t->next = NULL;
	strcpy(t->str, str);
	if (last)
		last->next = t;
	else
		*txt = t;
	
	return;
}
/****************************************/
BOOL isZaloop(TEXT *v, ADDR to, char *system)
{
	ADDR vaddr, aka;
	BOOL seen_here = No;
	
	get_def_addr(system, to, &aka);
	
	for( ; v ; v = v->next )
	{
		if (Ok == get_via_address(v->str, &vaddr)) {

			if (addr_cmp(aka, vaddr))
				seen_here = Yes;
			else if (seen_here && addr_cmp(vaddr, to))
				return Yes;
			
		} /* via addr ok */
	}
	
	return No;
}

/*****************************/
BOOL   isFLO(char *fname)
{
	char *ext = strrchr (fname, '.');
	char buf[256];

	if (ext == NULL) { /* impossible */
		fprintf (stderr, "isFLO panic: `%s'\n", fname);
		abort ();
	}

 ++ext;

	if (!stricmp (ext, "List") || !stricmp (&ext[1], "LO")) {
		sprintf (buf, "%s is ?lo", fname);
		writeToLog(10, buf);
		return Yes;
	}
	else {
		sprintf (buf, "%s is ?ut", fname);
		writeToLog(10, buf);
		return No;
	}
	
}
/******************************/
#if 0
static BOOL get_replyto(char *reply, ADDR *addr)
{
	char s[64], caddr[64];
	
	strcpy(s, reply);
	get_next_word(s, caddr);

	return str_to_addr(caddr, addr);
	
}
#endif

void do_chat(void)
{
			char buf[256];

			sprintf(buf, "Scanning %s         %d", 
							strUpper(CurMsg.areaname), CurMsg.n);
	
			printf("%s\r", buf);
}
