
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_Renumber)
{
    dXSARGS;
    STRLEN n_a;
    char *areatag = NULL, *err="perl_Renumber()";
    int areatype;
	
    if (items) {
	
	sp_s = FromSP(0);
	areatag = XCAL;	
	strncpy(areatag, sp_s, n_a);
	strip(areatag);
	expand_str(areatag);

	if (-1 == (areatype = areaname_to_type(areatag))) {
		fprintf(stderr, "%s unknown area `%s'\n", err, areatag);
		abort();
	}

	if (!stricmp(areatag, CurMsg.areaname)) {
		writeToLog(1, "%s Can't pack open area `%s'\n", err, areatag);
    	} else {
	    if (areatype == FIDO) fido_pack(areatag);
    	    else if (areatype == JAM) {
		if (!jam_pack(areatag)) {
		    writeToLog(0, "%s error: pack failed for JAM area `%s', errno %d'\n",
				err, areatag, jam_errno);
		}
	    } else if (areatype == SQUISH) {
		if (!sq_pack(areatag)) {
		    writeToLog(0, "%s error: pack failed for squish area `%s', errno %d'\n",
				err, areatag, sq_errno);
		}
	    }
	}
    }   /*argc > 0*/
      else {
		
	struct FidoAreas *FidoArea;
	struct SquishAreas *SquishArea;
	struct JamAreas *JamArea;
	
	for( FidoArea = FidoAreaFirst; FidoArea; FidoArea = FidoArea->next ) {
	    strcpy(areatag, FidoArea->name);
	    if (stricmp(areatag, CurMsg.areaname)) fido_pack(areatag);
	}
	
	for( SquishArea = SquishAreaFirst; SquishArea; SquishArea = SquishArea->next ) {
	    strcpy(areatag, SquishArea->name);
	    if (stricmp(areatag, CurMsg.areaname))
		if (!sq_pack(areatag)) {
		    writeToLog(0, "%s error: pack failed for squish area `%s', errno %d'\n",
				err, areatag, sq_errno);
    		}
	}
	
	for( JamArea = JamAreaFirst; JamArea; JamArea = JamArea->next ) {
	    strcpy(areatag, JamArea->name);
	    if (stricmp(areatag, CurMsg.areaname)) 
		if (!jam_pack(areatag)) {
		    writeToLog(0, "%s error: pack failed for JAM area `%s', errno: %d\n",
									err, areatag, sq_errno);
		}
	}

    } /* pack all */
    
    free(areatag);

    XSRETURN_UNDEF;
}
