
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_Scan)
{
    dXSARGS;
    STRLEN n_a;
    int type = -1, total_msg = 0;
    char *areaname;
    char /*res[256], */ err[128], /*buf[256], areaname[20],*/ areapath[128];
    int rc = Ok;
	
    if (items > 2 || items == 0) {
	fprintf(stderr, "%s argument count(need 1 or 2, exist %d)\n", err, (int)items);
	abort();
    }
    /*   first log the previous msg, if it was actually read and changed    */
    if (CurMsg.n && ( (ftn.stat & i_Changed) ||
	CurMsg.type == PKT || CurMsg.type == BINK) )
		update_msg(CurMsg.type);

    (void)reset_globals(CurMsg.type);
	
    sp_s = FromSP(0);
    areaname = XCAL;
    strcpy(areaname, sp_s);        
    strip(areaname);

	
    if ( -1 == (type = areaname_to_type(areaname))) {
	fprintf(stderr, "%s area not defined: `%s'\n", err, areaname);
	free(areaname);
	abort();
    }

    areaname_to_path(areaname, areapath);

    CurMsg.type = type;
    strcpy(CurMsg.areapath, areapath);
    strcpy(CurMsg.areaname, areaname);
	

    if (items == 2) {
	char s[256], *tsname;

	sp_s = FromSP(1);
	tsname = XCAL;
 	strcpy(tsname, sp_s);        
	strip(tsname);

	if (TsPath)
	    sprintf(s, "%s%s", TsPath, tsname);
	else
	    strcpy(s, tsname);
		
	(void)read_tsfile(s);
	free(tsname);
    }

    /******  FIDO *****/
    if (type == FIDO) {
		
	select_fido_area(areapath, &CurMsg.fido);
	total_msg = CurMsg.fido.total;
		
	/******  SQUISH *****/
		
    } else if (type == SQUISH) {

	rc = select_squish_area(areaname, &CurMsg.squish);
			
	if (rc) {
	    total_msg = CurMsg.squish.num_msg;
	    if (TsHandle != -1)
		CurMsg.squish.ts = fetch_ts(areaname);
	    else
		CurMsg.squish.ts = 0L;
	    CurMsg.maxts = CurMsg.squish.ts;
/*	    sprintf ("select_squish: maxts for area `%s' is %d\n", areaname, CurMsg.maxts); */
	    writeToLog(4, "select_squish: maxts for area `%s' is %d\n", areaname, CurMsg.maxts);
	} else {
	    writeToLog(0, "sqselect error: sqinit failed with errno: %d\n", sq_errno);
	    (void)sq_failure_reason();
	}
		
	/******  JAM *****/
		
    } else if (type == JAM) {

	rc = select_jam_area(areaname, &CurMsg.jam);
		
	if (rc) {
	    total_msg = CurMsg.jam.totalMsg;
	    if (TsHandle != -1)
		CurMsg.jam.ts = fetch_ts(areaname);
	    else
		CurMsg.jam.ts = 0L;
	    CurMsg.maxts = CurMsg.jam.ts;
	} else {
	    writeToLog(0, "JAMselect error: init failed with errno: %d\n", jam_errno);
	    /*      (void)jam_failure_reason(); */
	}
			
	/*********  PKT  **********/
    } else if (type == PKT) {

	select_pkt_area(areapath, &CurMsg.pkt);
		
	CurMsg.pkt.off = 0L;
		
    /*********  BINK  **********/
    } else if (type == BINK) {
		
	select_bink_area(areapath, &CurMsg.bink);
		
	CurMsg.bink.off = 0L;
		
    }
	
    if (rc == Fail) {
	fprintf(stderr, "%s error initializing area : %s\n", err, areaname);
	free(areaname);
	abort();
    }

    writeToLog(0, "Scanning %s", strUpper(areaname) );
	
    if (Chat_On) {
	printf("\nScanning %s\r", areaname);
    }

    free(areaname);
    
    XSRETURN_IV(rc);
}

/********************************/
static void read_tsfile(char *fn)
{
	TS ts;
	if (-1 == (TsHandle = open(fn, O_RDWR|O_CREAT, ACCFILE)))
		return;

	while(sizeof(TS) == read(TsHandle, &ts, sizeof ts))
	{
		char buf[256];
		sprintf (buf, "read_tsfile: set_tlist: area `%s' -> %d\n",
						 ts.areaname, (unsigned)ts.ts);
		writeToLog(4, buf);
		set_ts(ts.areaname, ts.ts);
	}
	
	return;
}
