
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


static XS(perl_SetAttribute)
{
    dXSARGS;
    STRLEN n_a;
    char buf[256], *s, cattr[256], arg1[256], *err="perl_SetAttribute()";
    char cflag[256], cstat[256], *p = NULL, save_str[256];
    struct AttrTags *AttrTag = NULL;
    BOOL setClear = attrSet, clearChanged = No, log_it = No;
    AllAttr aa;
	
    if ( items != 1 ) {
	fprintf(stderr, "%s argument count (need 1, exist %d)\n", err, (int)items);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
	
    sp_s = FromSP(0);
    s = XCAL;
    strcpy(s, sp_s);
    strip(s);
    expand_str( s );
	
    strcpy(save_str, s);
	
    writeToLog(4, "SetAttribute: attrs string after all expansions: `%s'\n" , s );

    aa.flag = ftn.flag;
    aa.attr = ftn.attr;
    aa.stat = ftn.stat;
	
    get_next_word(s, arg1);

    /* direct data definition */
    if ( !strnicmp( "@attribute" , arg1 , strlen(arg1))) {
		
	writeToLog(4, "SetAttribute: set attribute directly: `%s'\n", s);
		
	if (!strlen(s)) {
	    fprintf(stderr, "%s syntax: `%s'\n", err , save_str );
	    abort();
	}
		
	while(get_next_word(s, cattr)) {
	    if ( !stricmp(cattr, "!Changed") ) {
		clearChanged = Yes;
	    }
	    set_all_attrs( cattr , &aa );
	} /* attr queue (main loop) */
		
    }  /* direct data */
	
	/* do block definition */
    else {  
		
	p = save_str;
	if (*p == '!') {
	    ++p;
	    setClear = attrClear;
	    writeToLog(4, "SetAttribute: set inversed block `%s'\n", p);
	}
		
	for( AttrTag = AttrTagFirst; AttrTag; AttrTag = AttrTag->next ) {
	    if (!stricmp(p, AttrTag->tag)) {
		break;
	    }
	}
		
	if (NULL == AttrTag) {
	    fprintf(stderr, "\7%s `block undefined : %s'\n", err, p);
	    abort();
	}

	AttrTag->rec = AttrTag->recfirst;
	for( ; AttrTag->rec; AttrTag->rec = AttrTag->rec->next ) {
	    AttrTag->rec->attr = AttrTag->rec->attrfirst;
	    for( ; AttrTag->rec->attr; AttrTag->rec->attr = AttrTag->rec->attr->next ) {
		strcpy( cattr , AttrTag->rec->attr->cattr );
		p = cattr;
		if (setClear == attrClear) { /* reverse attr */
		    if (*p == '!') {
			++p;
		    } else {
			sprintf(buf, "!%s", p);
			strcpy(cattr, buf);
			p = cattr;
		    }
		} /* reverse attr */
		if ( !stricmp(cattr, "!Changed") ) {
		    clearChanged = Yes;
		}
		set_all_attrs( p , &aa );
	    }
	}
    } /* end of block definition */
	
    if (aa.flag != ftn.flag) {
	flag_to_str( aa.flag , cflag );
	(void) set_flag_kludge(&TextFirst, cflag);
    }
	
    if ( (aa.attr != ftn.attr) ||
	(aa.flag != ftn.flag) ||
	(aa.stat != ftn.stat)) {
	ftn.attr = aa.attr;
	ftn.flag = aa.flag;
	ftn.stat = i_Changed;
	log_it = Yes;
    }
	
	
    ftn.stat |= aa.stat;

	
    if ( (ftn.stat & i_Changed) && clearChanged) {
	if (CurMsg.type == BINK || CurMsg.type == PKT) {
	    ftn.stat |= i_NoMyVia;
	} else {
	    ftn.stat &= ~i_Changed;
	    free_text(TextFirst);
	    TextFirst = NULL;
	    free_text(ViaTextFirst);
	    ViaTextFirst = NULL;
	    ftn.stat = 0L;
	    ftn.flag = 0;
	    CurMsg.n = 0;
	}
    }
	
    if ( (ftn.stat & i_Changed) && log_it ) {
		/*//////////////////////////////*/
	log_msg_hdr();
	attr_to_str( ftn.attr , cattr );
	flag_to_str( ftn.flag, cflag );
	stat_to_str( ftn.stat, cstat );
	if (ftn.stat & i_Invalidvias) {
	    writeToLog(4, "SetAttribute: invalidate vias");
    	    inv_vias(TextFirst);
	}
	if (ftn.stat & i_Invkludges) {
	    writeToLog(4, "SetAttribute: invalidate kludges");
	    /* leave off addressing kludges */
	    inv_kludges(TextFirst, 0);
	}
	/*/////////////////////////////////*/
	writeToLog(1, "   Changed Attributes : %s %s %s", cattr, cflag, cstat);

/*    ftn.flavor |= set_msg_flavor(ftn.attr, ftn.flag); */
		
    }
    free(s);
    /*/////////////////////////////////////////////////////////////////*/
    XSRETURN_UNDEF;
}
/************************************************************************/
void set_all_attrs( char *str , AllAttr *p_aa)
{
/* accepts: one(!) attribute in a string form
   returns: structure with respective attr, flag, or stat set
*/	
	char *p = str;
	BOOL setClear;
	word at;
	dword dat;
	
	if (*p == '!') {
		setClear = attrClear;
		++p;
	}
	else {
		setClear = attrSet;
	}

	at = str_to_attr(p);

	if ( at != minus_one ) {
		if (setClear == attrSet) {
			p_aa->attr |= at;
		}
		else {
			p_aa->attr &= (word) ~at;
		}
		return;
	}

	at = str_to_flag(p);

	if ( at != minus_one ) {
		if (setClear == attrSet) {
			p_aa->flag |= at;
		}
		else {
			p_aa->flag &= (word) ~at;
		}
		return;
	}
	
	dat = str_to_stat(p);

	if ( dat != minus_one_long ) {
		if (setClear == attrSet) {
			p_aa->stat |= dat;
		}
		else {
			if (dat != i_Intl)
				p_aa->stat &= ~dat;
		}
		return;
	}
	
	fprintf(stderr, "SetAttribute error: incorrect `%s'\n", p);
	abort();

	/*NOT REACHED */
	return;
}

/****************************************/
void inv_vias(TEXT *text)
/* invalidate all the vias */
{
	for( ; text; text = text->next )
	{
		if ( is_Via(text->str) ) {
			*text->str = '@';
		}
	} 
	return;
}
/***************************/

void inv_kludges(TEXT *text, BOOL ALL)
{
	char str[256], kludge[128]={0}, *p = NULL;
	int j, found;
	BOOL doInv = No;
	
	for( ; text; text = text->next )
	{
		strcpy(str, text->str);
		
		/* kludge found */
		if (is_kludge(str)) { 
			
			if (ALL == Yes)
				doInv = Yes;
			else {
			
				strncpy(kludge, str, 127); kludge[127] = 0;
				p = kludge;

				strip_CRLF(p);

				++p;

				for(j = 0 , found = -1; strlen( Kludges[j].s ); ++j)
				{
					if (!strnicmp(p, Kludges[j].s, strlen(Kludges[j].s))) {
						p += strlen( Kludges[j].s );
						if (*p == ':')
							++p;
						++p;
						found = Kludges[j].n;
						break;
					}
				}

				switch (found)  {

				case k_Domain:
				case k_Intl:
				case k_Topt:  
				case k_Fmpt:  
				case k_Msgid: 
				case k_Via:   
					doInv = No;
					break;
				default:
					doInv = Yes;
					break;
				}

			} /* check what kludges to invalidate */
			
			if (doInv)
				*text->str = '@';
			
		} /* kludge found */
		
	}  /* end of text loop */

		return;
}
