
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/


BOOL setpkthdr (char **parray, int array_len, char* err, PKT_HDR* hdr)
{
	char buf[256];
	struct tm* tm;
	ADDR to, from;
	dword hval;
	time_t utime;

	if (array_len != 9) {
		sprintf (buf, "%s wrong number of elements in pkt hdr array\n", err);
		writeToLog(0, buf);
		return Fail;
	}

	/* FROM */
	if (!str_to_addr(parray[0], &from)) {
		writeToLog(0, "%s incorrect to address: `%s'\n", err, parray[0]);
		return Fail;
	}
	
	/* TO */
	if (!str_to_addr(parray[1], &to)) {
		writeToLog(0, "%s incorrect from address: `%s'\n", err, parray[1]);
		return Fail;
	}

	/* DATE */
	if (Fail == (utime = ftscdate_to_unix (parray[2]))) {
		writeToLog(0, "%s incorrect ftsc date: `%s'\n", err, parray[2]);
		return Fail;
	}

	tm = localtime (&utime);
	if (!tm) {
		writeToLog(0, "%s localtime failed for %08x\n", err, utime);
		return Fail;
	}


	hdr->toZone  = (word) to.zone;
	hdr->toNet   = (word) to.net;
	hdr->toNode  = (word) to.node;
	hdr->toPoint = (word) to.point;

	hdr->fromZone  = (word) from.zone;

	if (from.point == 0)
		hdr->fromNet   = (word) from.net;
	else {
		hdr->fromNet  = 0xffff;
		hdr->AuxNet   = (word) from.net;
	}

	hdr->fromNode  = from.node;
	hdr->fromPoint = from.point;

	hdr->QtoZone    = hdr->toZone;
	hdr->QfromZone  = hdr->fromZone;


	hdr->second = tm->tm_sec;
	hdr->minute = tm->tm_min;
	hdr->hour   = tm->tm_hour;
	hdr->day    = tm->tm_mday;
	hdr->month  = tm->tm_mon;
	hdr->year   = tm->tm_year + 1900;

	/* PASSWD */
	strncpy (hdr->password, parray[3], 8);

	if (1 == sscanf (parray[4], "%2lx", &hval))
		hdr->prodCodeH = (char) hval;

	if (1 == sscanf (parray[5], "%2lx", &hval))
		hdr->prodCodeL = (char) hval;

	if (1 == sscanf (parray[6], "%2lx", &hval))
		hdr->verMinor = (char) hval;

	if (1 == sscanf (parray[7], "%2lx", &hval))
		hdr->verMajor = (char) hval;

	if (1 == sscanf (parray[8], "%lx", &hval))
		hdr->prodData = hval;
		
	return Ok;

}

static XS(perl_SetPktHdr)
{
    dXSARGS;
    STRLEN n_a;
    AV *array;
    SV **scalar;
    int i, array_len;
    char **parray = NULL, *err="perl_SetPktHdr()";
    BOOL rc = Fail;
    
    if (items != 1) {
	fprintf(stderr, "%s argument count (need 1, exist %d\n", err, (int)items);
	abort();
    }

    array = (AV*)SvRV(ST(0));
    array_len = (int)av_len(array) + 1;
    
    for (i = 0; i < array_len; i++) {
	scalar = av_fetch(array, i, 0);
	if (i) {
	    parray = (char**)xrealloc(parray, (i+1)*sizeof(char*));
	} else {
	    parray = (char**)xmalloc(sizeof(char*));
	}
	sp_s = (char*)SvPV(*scalar, n_a);
	parray[i] = XCAL;
	strncpy(parray[i], sp_s, n_a);
    }
    

    if (CurMsg.type == PKT && CurMsg.pkt.icur != -1) {
	rc = setpkthdr (parray, array_len, err, &CurMsg.pkt.pkt_hdr);
	if (rc) {
	    CurMsg.pkt.to.zone  = CurMsg.pkt.pkt_hdr.toZone;
	    CurMsg.pkt.to.net   = CurMsg.pkt.pkt_hdr.toNet;
	    CurMsg.pkt.to.node  = CurMsg.pkt.pkt_hdr.toNode;
	    CurMsg.pkt.to.point = CurMsg.pkt.pkt_hdr.toPoint;
	    CurMsg.pkt.from.zone  = CurMsg.pkt.pkt_hdr.fromZone;
	    CurMsg.pkt.from.net   = CurMsg.pkt.pkt_hdr.fromNet;
	    CurMsg.pkt.from.node  = CurMsg.pkt.pkt_hdr.fromNode;
	    CurMsg.pkt.from.point = CurMsg.pkt.pkt_hdr.fromPoint;
	}
    }

    for (i = 0; i < array_len; i++) {
	free(parray[i]);
    }
    free(parray);
    
    XSRETURN_UNDEF;
	
}
