
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_SetRouting)
{
    dXSARGS;
    STRLEN n_a;
    char *tag;
    char *err="perl_SetRouting()";
	
    if (items != 1) {
	fprintf(stderr, "\7%s argument count (need 1, exist %d)", err, (int)items);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_UNDEF;
    }
	
/*///////////////////////////////////////////////////////////////////////*/

	/* parse arguments */

    sp_s = FromSP(0);
    tag = XCAL;
    strcpy(tag, sp_s);
    expand_str(tag);
    strip(tag);

    set_route (tag, &ftn);
	
    free(tag);
    /*///////////////////////////////////////////////////////////////////////*/
    XSRETURN_UNDEF;
}

void set_route (char *tag, FTN *ftn)
{
	ADDR addr, dest, targ, route, tmp_addr;
	char buf[256], saddr[128], saddr2[128], system[20];
	int found = 0, i;
	struct RoutingTags *RoutingTag = NULL;
	word flavor = 0;
	word uplink;
	dword stat;
	
	
	/* search block */
	found = 0;
	RoutingTag = RoutingTagFirst;
	while(RoutingTag)
	{
		if ( !stricmp(RoutingTag->tag, tag) ) {
			found = 1;
			break;
		}
		RoutingTag = RoutingTag->next;
	}
	
	if (!found) {
		fprintf(stderr, "block not defined: `%s'\n", tag);
		abort();
	}
/*///////////////////////////////////////////////////////////////////////*/
/* now do the job */
	
	/* destination of the routed message */
	addr = ftn->to;
	
	route = addr; /* set default routing */
	
	found = No;
	RoutingTag->rec = RoutingTag->recfirst;
	while(RoutingTag->rec)
	{
		/*///////////////////////////////////*/
		dest = RoutingTag->rec->dest;
		/*///////////////////////////////////*/
		RoutingTag->rec->targlist = RoutingTag->rec->targfirst;
		
		while(RoutingTag->rec->targlist)
		{
			targ = RoutingTag->rec->targlist->targ;
			
			/* do address matching */
			if ( (addr.zone == targ.zone) || isW(targ.zone) ) {
				
				if ( (targ.node == Wild_2) &&
						 (targ.point == Wild_1 || (targ.point == addr.point)) )
				{
					word uplink, region;
					addr_to_str( addr , saddr );
					writeToLog(4, "setrouting: region match requested\n");
					if  (get_ndl_info(addr, &uplink, &region)) {
						sprintf (buf, "region for %s is %hu\n", saddr, region);
						writeToLog(4, buf);
						if (region == targ.net) {
							writeToLog(4, "region matches ok\n");
							found = 1;
							break;
						}
						else
							writeToLog(4, "region doesn't match\n");
					}
					else {
						sprintf (buf, "region for %s not found\n", saddr);
						writeToLog(4, buf);
					}
						
				} /* region match (example:  2:50/# ) */
				
				else if ( (addr.net == targ.net) || isW(targ.net) ) {
					
					
					if (targ.point == Wild_2) { /* from hub segment? */
						tmp_addr.zone = isW(targ.zone) ? addr.zone : targ.zone;
						tmp_addr.net = isW(targ.net) ? addr.net : targ.net;
						tmp_addr.node = isW(targ.node) ? addr.node : targ.node;
						tmp_addr.point = 0;
						addr_to_str( addr , saddr );
						addr_to_str( tmp_addr , saddr2 );
						sprintf(buf, "setrouting: check if node %s is in hub segment of %s\n",
										saddr, saddr2);
						writeToLog(4, buf);
						if (from_hub(addr, tmp_addr)) {
							writeToLog(4, "setrouting: check ok\n");
							found = 1;
							break;
						}
						else {
							writeToLog(4, "setrouting: check failed\n");
						}
					} /* check hub segment */
					else {
						if ( (addr.node == targ.node) || isW(targ.node) ) {
							if ( (addr.point == targ.point) || targ.point == Wild_1 ) {
								found = 1;
								break;
							}
						}
					}    /* not hub segment */
				}      /* nets match */
			}        /* zones match */
			
			RoutingTag->rec->targlist = RoutingTag->rec->targlist->next;
		} /* while, list of target templates */
		
		if (found == Yes) {
			break;
		}

		RoutingTag->rec = RoutingTag->rec->next;
	} /* while, list of records in the current tag */
		
	if (found == Yes) {
		if (dest.zone == Wild_1)
			route.zone = addr.zone;
		else
			route.zone = dest.zone;
		
		if (dest.net == Wild_1)
			route.net = addr.net;
		else
			route.net = dest.net;

		/*//////////////////////*/
		if (dest.node == Wild_1) {
			route.node = addr.node;
		}
		else {
			if (dest.node == Wild_2) {
				word j;
				writeToLog(4, "setrouting: hubrouting requested by `#'\n");
				if  (get_ndl_info(addr, &uplink, &j)) {
					dest.node = uplink;
					writeToLog(4, "setrouting: uplink found, do hubrouting\n");
				}
				else
					dest.node = addr.node;
			}
			route.node = dest.node;
		}
		/*////////////////////////*/
		
		if (dest.point == Wild_1)
			route.point = addr.point;
		else
			route.point = dest.point;
		
		/* set the final flavor */
		for (i = 0; i < 10; ++i)
		{
			flavor = RoutingTag->rec->flavor[i];
			if (flavor == 0)
				break;
			if (flavor & flv_NEG) {
				flavor &= (word) ~flv_NEG;
				ftn->flavor &= (word) ~(word)flavor; /* global */
			}
			else
				ftn->flavor |= flavor; /* global */
		}
		
		addr_to_str( addr , saddr );
		addr_to_str( route , saddr2 );
		
		sprintf(buf, "setrouting: message to %s routed to %s\n", saddr, saddr2);
		writeToLog(2, buf);
	} /* found */
	else {
		route = addr; /* just in case */
		addr_to_str( route , saddr );
		sprintf(buf, "setrouting: no routing found, do direct routing to %s\n", saddr);
		writeToLog(2, buf);
	}
	
	ftn->routeTo = route; /* global */

	areaname_to_system(CurMsg.areaname, system);
	
	stat = ftn->stat;
	
	if (isZaloop(ViaTextFirst, ftn->routeTo, system))
		ftn->stat |= i_ZaLoop;
	else
		ftn->stat &= ~i_ZaLoop;

	if (stat != ftn->stat)
		ftn->stat |= i_Changed;
	
	return;
}
