
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

static XS(perl_SubstText)
{
    dXSARGS;
    STRLEN n_a;
    char *arg1, *arg2;
    char *parg1, *err="perl_SubstText";
    int i;
    BOOL rc = Fail, relaxed = No, ALL = No;
	
    if (items < 1 && items > 2) {
	fprintf(stderr, "%s argument count (need 1 or 2, exist %d)\n", err, (int)items);
	abort();
    }
	
    if ( !CurMsg.n ) {
	writeToLog(3, "%s no active message in memory\n", err);
	XSRETURN_IV(rc);
    }

    sp_s = FromSP(0);
    arg1 = XCAL;
    strcpy(arg1, sp_s);
    strip(arg1);
    expand_str(arg1);

    parg1 = arg1;
    while( *parg1 && (*parg1=='~' || *parg1=='+') ) {
	if (*parg1 == '~')
	    relaxed = Yes;
	else if (*parg1 == '+')
		ALL = Yes;
		
	    ++parg1;
    }

	/* direct data */
    if (items == 2) {
	
	sp_s = FromSP(1);
	arg2 = XCAL;
	strcpy(arg2, sp_s);
	expand_str(arg2);

	strip(parg1);
	remove_quotes(parg1);
		
	strip(arg2);
	remove_quotes(arg2);
	rc = substr(parg1, arg2, relaxed, ALL);
		
    }
	
	/* block data */
    else {
	struct TextStrTags *TextStr = NULL;
	regex_t *preg = NULL;
	arg2 = NULL;	    		
		
	for( TextStr = TextStrTagFirst; TextStr; TextStr = TextStr->next )
	    if (!stricmp(parg1, TextStr->tag))
		break;

	if (!TextStr) {
	    fprintf(stderr, "%s select, no such <Data TextString> : `%s'\n", err, parg1);
	    abort();
	}
		
	TextStr->rec = TextStr->recfirst;
	for( i = 0; TextStr->rec ; TextStr->rec = TextStr->rec->next, ++i) {
	    if (i%2) {
			
		strcpy(arg2, TextStr->rec->str);
			
		if (preg) {
		    if (rx_substr(preg, arg2, ALL)) rc = Ok;
		} else {
		    if (substr(arg1, arg2, relaxed, ALL))
		    rc = Ok;
		}
				
	    }  /* even record (2nd in pair) */
			
	    else {
				
		strcpy(arg1, TextStr->rec->str);
		preg = TextStr->rec->preg;
		memset(arg2, '\0', n_a);
				
		if (!TextStr->rec->next) {
					
		    if (preg) {
			if (rx_substr(preg, arg2, ALL))
			    rc = Ok;
		    } else {
			if (substr(arg1, arg2, relaxed, ALL))
			    rc = Ok;
		    }
		}   /* last record is odd */
				
	    } /* odd record (first in pair) */
			
	}   /* TextStr loop */

		
    }  /* block data */


    if (rc)
	ftn.stat |= i_Changed;

    free(arg1); free(arg2);

    XSRETURN_IV(rc);		
	
}
/********************************************/
static BOOL substr(char *s1, char *s2, BOOL relaxed, BOOL ALL)
{
	TEXT *Text = NULL;
	char str[256] , *p, tail[256], new_str[256], buf[256];
	BOOL rc = Fail, found;
	
	for(Text = TextFirst ; Text; Text = Text->next)
	{
/*    if (!is_reserved_kludge(Text->str)) { */
			
			strcpy(str, Text->str);
			memset(new_str, '\0', 256);
			memset(tail, '\0', 256);
			found = No;
			
			while(strlen(str))
			{
				strip_CRLF(str);
				
				if (comp_strings(str, s1, relaxed)) {

					sprintf(buf, "SubstText, `%s' found in `%s'\n", s1, str);
					writeToLog(4, buf);
					
					if (NULL != (p = strstr(str, s1))) {
						
						strcpy(tail, &str[p-str+strlen(s1)]);
						str[p-str] = '\0';
						strcat(new_str, str);
						strcat(new_str, s2);
						
						rc = Ok;
						found = Ok;
						
					} /* be paranoic: assure strstr is okay */
				}   /* comp_strings ok */
				
				else
					break; /* no more matches */

				strcpy(str, tail);
				if (found && !ALL)
					break;
				
			}    /* while(str) */

			/* something was changed */
			if (found) {
				
				strcat(new_str, str);

/*	if (!is_re1served_kludge(new_str)) { */
					sprintf(buf, "SubstText, new string:`%s'\n", new_str);
					writeToLog(4, buf);
					strcat(new_str, "\r");
					strcpy(Text->str, new_str);
					if (!ALL)
						return Ok;
/*	} // resereved kludge */
				
			}   /* found */
			
/*	} // not a reserved kludge */
	}
	
	return rc;
}

/********************************************/
static BOOL rx_substr(regex_t *preg, char *s2, BOOL ALL)
{
	TEXT *Text = NULL;
	char str[256] , tail[256], new_str[256];
	BOOL rc = Fail, found = No;
	regmatch_t pmatch[1];
	int s, e;
	
	for(Text = TextFirst ; Text; Text = Text->next)
	{
		strcpy(str, Text->str);
		memset(new_str, '\0', 256);
		memset(tail, '\0', 256);

		found = No;
		while(strlen(str))
		{
			strip_CRLF(str);

			if (regexec(preg, str, 1, pmatch, 0))
				break; /* no more matches */

			found = Yes;

			s = pmatch[0].rm_so;
			e = pmatch[0].rm_eo;

			strcpy(tail, &str[e]);
			str[s] = '\0';
			strcat(new_str, str);
			strcat(new_str, s2);
			strcpy(str, tail);
			
			if (!ALL)
				break;


		}    /* while(str) */

		if (found) {
			strcat(new_str, str);
			strcat(new_str, "\r");
			strcpy(Text->str, new_str);
		
			rc = Ok;
			
			if (!ALL)
				break;
		}
		
	}     /* Text loop */

	return rc;
}
