
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#if defined (__WATCOMC__) || defined (__MINGW32__)
#include <direct.h>
#else
#include <dirent.h>
#endif

#define NMAX 20

char* WorkDir;

static void unpack (char* in_dir, char *wdir, char *err)
{
	char exe[256], fullname[256], buf2[256];
	char curdir[256], buf[256];
	int rc;
	DIR *dir;
	struct dirent *d;
	
	if (Chat_On)
		printf("\n\n");
	
	printf ("scanning %s\n", in_dir);

#ifdef __MINGW32__
	dirNameLen = strlen(in_dir)-1;
	in_dir[dirNameLen] = 0;
#endif
	
	dir = opendir(in_dir);

#ifdef __MINGW32__
	in_dir[dirNameLen] = '\\';
#endif

	if (dir == NULL) {
		fprintf(stderr, "%s can't open dir: `%s'\n", err, in_dir);
		abort();
	}
	
	while (NULL != (d = readdir(dir))) {
			
		if (!strcmp(d->d_name, ".") || !strcmp(d->d_name, ".."))
			continue;
		
		if (is_arcmail(d->d_name)) {
			
			struct stat st;
/*			unsigned attr=0; */
			char*arg;
			BOOL dirset;

			sprintf(fullname, "%s%s", in_dir, d->d_name);
			if ((stat(fullname, &st) != 0) || (st.st_size == 0L)) {
				continue;
			}
/*////////////////*/





#if 0
#if !defined(UNIX)
#if defined(__TURBOC__) || defined(__DJGPP__)
      _dos_getfileattr(dummy, &fattrs);
#elif defined(__MINGW32__)
      fattrs = (GetFileAttributes(dummy) & 0x2) ? _A_HIDDEN : 0;
#else
      fattrs = file->d_attr;
#endif
      if(fattrs & _A_HIDDEN) {
          nfree(dummy);
      } else
#endif


/*///////////////*/			
			_dos_getfileattr (fullname, &attr);
		
			if (attr & ~(_A_ARCH|_A_NORMAL)) {
				continue;
			}

#endif
			if (NULL != (arg = ufetch_arcer(fullname, "*.pkt", exe, wdir, &dirset)))
			{
				sprintf(buf, "Unpack: executing: `%s %s'\n", exe, arg);
				writeToLog(4, buf);
				sprintf(buf, "Unpacking archive: %s into workdir: %s", fullname, wdir);
				if (Chat_On)
					printf("%s\n", buf);

				if (!dirset) {
					getcwd(curdir, 256);
					ch_dir(wdir);
				}
				
				rc = shell(exe, arg);
/*				rc = system(exe) */				
				if (!dirset)
					ch_dir(curdir);
				
				if (rc == 0) {
					strcat(buf, " - ok\n");
					writeToLog(1, buf);
					if (0 != remove(fullname)) {
						perror(fullname);
					}
				}
				else {
					sprintf(buf2, " - error: packer reported %d\n", rc);
/*					if (Chat_On)
						fprintf(stderr, "%s", buf2);
*/					strcat(buf, buf2);
					writeToLog(0, buf);
				}
			}
			else {
				sprintf(buf, "Unpack: error fetching arcer for file `%s'\n", fullname);
				writeToLog(0, buf);
			}
		} /* arcmail found */
		
	} /* scan dir */

	
}

static XS(perl_Unpack)
{
    dXSARGS;
    STRLEN n_a;
    char *err="perl_Unpack";
    char *path, *in_dir[NMAX];
    int i, n=0;
	
    if (items < 1 && items > 2) {
	fprintf(stderr, "%s argument count (need 1 or 2, exist %d)\n", err, (int)items);
	abort();
    }

    if (!CompressFirst) {
	fprintf(stderr, "%s compress configuration not defined\n", err);
	abort();
    }

    sp_s = FromSP(0);
    path = XCAL;
    strncpy(path, sp_s, n_a);
    n = get_path (path, in_dir, NMAX, err);
    
    free(path);

    if (items == 2) {
	sp_s = FromSP(1);
	path = XCAL;
	strncpy(path, sp_s, n_a);
	get_path (path, NULL, 0, err);
	free(path);
    }

    for (i = 0; i < n; i++) {
	unpack (in_dir[i], WorkDir ? WorkDir : in_dir[i], err);
	free (in_dir[i]);
    }

    XSRETURN_UNDEF;
	
}

static int get_path (char *s, char *dir[], int max, char *err)
{
	char save_str[256], arg1[256], buf[256];
	char* tmp;
	
	strip(s);
	expand_str( s );

	strcpy(save_str, s);


	get_next_word(s, arg1);
	remove_quotes(arg1);

	/* direct data definition */
	if ( !strnicmp( "@path" , arg1 , strlen(arg1))) {
		
		sprintf(buf, "Unpack, 1) direct path: `%s'\n", s);
		writeToLog(4, buf);
		
		if (!strlen(s)) {
			fprintf(stderr, "%s syntax: `%s'\n", err , save_str );
			abort();
		}
		
		if (is_full_path(s))
			tmp = (char*)xstrcpy (s);
		else {
			tmp = (char*)xstrcpy (ItraxPath);
			tmp = (char*)xstrcat (tmp, s);
		}
			
		if (!setpath(tmp)) {
			fprintf(stderr, "%s Path not found : `%s'", err, tmp);
			abort();
		}

		if (max == 0) {
			WorkDir = tmp;
		}
		else  {
			dir[0] = tmp;
		}

		return 1;

	}
	else {
		struct PathTags *PathTag = PathTagFirst;
		char* p, *q;
		int n=0;
		
		for(; PathTag; PathTag = PathTag->next)
		{
			if (!stricmp(PathTag->tag, save_str)) {
				struct Path* tmp;
				for (tmp = PathTag->recfirst; tmp; tmp = tmp->next)
				{
					p = tmp->path;
		
					if (is_full_path(p))
						q = (char*)xstrcpy (p);
					else {
						q = (char*)xstrcpy (ItraxPath);
						q = (char*)xstrcat (q, p);
					}

					if (!setpath(q)) {
						sprintf(buf, "%s Path not found : `%s'", err, q);
						writeToLog(0, buf);
						continue;
					}
				
					if (max == 0) {
						WorkDir = q;
						return 0;
					}

					dir[n++] = q;
					if (n == max)
						break;
				}
			}
		}
		
		
		return n;
		
	} /* block */


}
/**************************************/
BOOL is_arcmail(char *fname)
{
	char *p = fname;
	
	while(*p && *p != '.')
		if (!isxdigit(*p++))
			return Fail;

	if (*p != '.')
		return Fail;

	if (p++ - fname != 8)
		return Fail;

	if (strlen(p) != 3)
		return Fail;

	return
		(0 == strnicmp(p, "SU", 2)) ||
		(0 == strnicmp(p, "MO", 2)) ||
		(0 == strnicmp(p, "TU", 2)) ||
		(0 == strnicmp(p, "WE", 2)) ||
		(0 == strnicmp(p, "TH", 2)) ||
		(0 == strnicmp(p, "FR", 2)) ||
		(0 == strnicmp(p, "SA", 2));
}

/************************************/
char* ufetch_arcer(char *a, char *f, char *exe, char* wdir, BOOL* dirset)
{
	struct Compress *Compress = detect_arctype(a);
	char buf[256];
	static char arg[256];

	if (Compress) {
		
		char *p, *q;
				
		sprintf(buf, "ufetch_arcer: `%s' is %s archive\n",
						a, Compress->archname);
		writeToLog(4, buf);
		q = Compress->arc.extract;

		p = strstr(q, "%f");
		strncpy(buf, q, p-q);
		buf[p-q] = '\0';
		strcat(buf, f);
		strcat(buf, &q[p-q+2]);

		q = buf;
		p = strstr(q, "%a");
		strncpy(arg, q, p-q);
		arg[p-q] = '\0';
		strcat(arg, a);
		strcat(arg, &q[p-q+2]);

		get_next_word(arg, exe);


		q = arg;
		if (NULL != (p = strstr(q, "%d"))) {
			char arg2[256];
			strncpy(arg2, q, p-q);
			arg2[p-q] = '\0';
			strcat(arg2, wdir);
			strcat(arg2, &q[p-q+2]);
			strcpy (arg, arg2);
			*dirset = 1;
		}
		else
			*dirset = 0;
		
		return arg;
		
	}

	sprintf(buf, "ufetch_arcer: couldn't detect archive type for `%s'\n", a);
	writeToLog(0, buf);
	return NULL;
}

/***************************************************/
struct Compress * detect_arctype(char *a)
{
	int h;
	struct Compress *Compress = NULL;
	char buf[256];
	byte *ident = NULL;
	
	if( -1 == (h = open(a, O_RDONLY)) ) {
		sprintf(buf, "error opening archive `%s'\n", a);
		writeToLog(0, buf);
		perror(a);
		return NULL;
	}

	for(Compress = CompressFirst; Compress; Compress = Compress->next)
	{
		int i;
		BOOL rc;
		
		if (Compress->arc.ioff < 0)  {
			sprintf(buf, "detect_arctype: seeking %ld bytes backward\n", Compress->arc.ioff);
			writeToLog(4, buf);
			if (-1L == lseek(h, Compress->arc.ioff, SEEK_END)) {
				sprintf(buf, "detect_arctype: seek error\n");
				writeToLog(0, buf);
				Compress = NULL;
				goto end;
			}
		}
		else {
			sprintf(buf, "detect_arctype: seeking %ld bytes forward\n", Compress->arc.ioff);
			writeToLog(4, buf);
			if (-1L == lseek(h, Compress->arc.ioff, SEEK_SET)) {
				sprintf(buf, "detect_arctype: seek error\n");
				writeToLog(0, buf);
				Compress = NULL;
				goto end;
			}
		}

		if (!ident)
			ident = (byte *)malloc(Compress->arc.ilen);
		else
			ident = (byte *)realloc(ident, Compress->arc.ilen);
		if (!ident) {
			sprintf(buf, "detect_arctype error: low_memo (ident)\n");
			writeToLog(0, buf);
			Compress = NULL;
			goto end;
		}

		if (Compress->arc.ilen != read(h, ident, Compress->arc.ilen)) {
			sprintf(buf, "detect_arctype: read error\n");
			writeToLog(0, buf);
			Compress = NULL;
			goto end;
		}

		rc = Ok;
		for( i = 0; i < Compress->arc.ilen; ++i)
		{
			if (Compress->arc.ident[i] != ident[i]) {
				rc = Fail;
				break;
			}
		}

		if (rc)
			goto end;

	}    /* Compress list */

end:
	
	free(ident);
	close(h);
	return Compress;
	
}

/******************************/
static void ch_dir(char *path)
{
	char s[256], *p;

	strcpy(s, path);
	
	p = &s[strlen(s)-1];
	if ( (*p == DELIM) && (strlen(s) > 1) ) {
		*p = '\0';
	}

	p = &s[strlen(s)-1];
	if (*p == ':') {
		strcat(s,"\\");
	}
	
	chdir(s);
	
	if (s[1] == ':') {
		strLower(s);
#if !defined (UNIX)
	    {
		_chdrive(*s-'a'+1);
	    }
#endif
	}

	
	return;
}
