#include "regex.h"
#include "ver9.h"

extern FLock lockFile;

struct Macro {
    struct Macro *next;
    char macrotag[20];
    char macroname[256];
};
extern struct Macro *MacroFirst, *MacroLast;

struct Tags {
  struct Tags *next;
  char tag[20];
  int i;
};
extern struct Tags *TagFirst, *TagLast;

/* MAINADDRESS */
extern ADDR MainAddress;

/* FIDOAREA */
struct FidoAreas {
  struct FidoAreas *next;
  char path[128];
  char name[20];
  char system[20];
	BOOL EchoMail;
	BOOL DefinedEcho;
};
extern struct FidoAreas *FidoAreaFirst, *FidoAreaLast;

/* SQUISHAREA */
struct SquishAreas {
  struct SquishAreas *next;
  char path[128];
  char name[20];
  char system[20];
  BOOL EchoMail;
	BOOL DefinedEcho;
};
extern struct SquishAreas *SquishAreaFirst, *SquishAreaLast;

/* JAMAREA */
struct JamAreas {
  struct JamAreas *next;
  char path[128];
  char name[20];
  char system[20];
  BOOL EchoMail;
	BOOL DefinedEcho;
};
extern struct JamAreas *JamAreaFirst, *JamAreaLast;

/* BINKAREA */
struct BinkAreas {
  struct BinkAreas *next;
  char path[128];
  char name[20];
  char system[20];
  char passw_tag[20];
  BOOL no_main_zone;
  BOOL multi_domain;
  int  type;               /* tBINK / tBRAKE / tAMIGA4D */
};
extern struct BinkAreas *BinkAreaFirst, *BinkAreaLast;

/* PKTAREA */
struct PktAreas {
  struct PktAreas *next;
  char path[128];
  char name[20];
  char system[20];
  char passw_tag[20];
  char pktlentag[20];
  BOOL EchoMail;
  int fbox; /* 0=none, 1=brake, 2=tmail */
};
extern struct PktAreas *PktAreaFirst, *PktAreaLast;

/* TEXTAREA */
struct TextAreas {
  struct TextAreas *next;
  char pathname[256];
  char name[20];
};
extern struct TextAreas *TextAreaFirst, *TextAreaLast;


struct Address {
  struct Address *next;
  ADDR addr;
};

/* ECHOAREA */
struct EchoAreas {
	struct EchoAreas *next;
	char name[20];
	enum { E_JAM = 1, E_SQUISH, E_FIDO, E_PASS } type;
	struct Address *links;
	BOOL BadArea;
};
extern struct EchoAreas *EchoAreas;

/************************************************************************/

/* DATA NODELIST */
struct nodelist {
  struct nodelist *next;
  char ext[128];
  word zone, reg;
  char path[128];
  char allnames[256];
};

struct ndlTags {
  struct ndlTags *next;
  char tag[20];
  BOOL active;
  struct nodelist *rec;
  struct nodelist *recfirst;
  struct nodelist *reclast;
};

extern struct ndlTags *ndlTagFirst, *ndlTagLast;

/* DATA VERSION9 */
extern struct ndlTags *v9_ndlTagFirst, *v9_ndlTagLast;

/* DATA SYSTEM **********************************************************/
struct System {
  struct System *next;
  ADDR addr;
  char domain[64];
  word zones[20];
};

struct SystemTags {
  struct SystemTags *next;
  struct System  *rec;
  struct System  *recfirst;
  struct System  *reclast;
  char   tag[20];
};
extern struct SystemTags *SystemTagFirst, *SystemTagLast;

/* DATA ADDRESS *********************************************************/

struct AddrTags {
  struct AddrTags *next;
  struct Address  *rec;
  struct Address  *recfirst;
  struct Address  *reclast;
  char   tag[20];
};
extern struct AddrTags *AddrTagFirst, *AddrTagLast;

/* DATA NAME ************************************************************/
struct Name {
  struct Name *next;
  char name[36];
  regex_t *preg;
};

struct NameTags {
  struct NameTags *next;
  struct Name  *rec;
  struct Name  *recfirst;
  struct Name  *reclast;
  char   tag[20];
};
extern struct NameTags *NameTagFirst, *NameTagLast;

/* DATA SUBJECT *********************************************************/
struct Subject {
  struct Subject *next;
  char subject[72];
  regex_t *preg;
};

struct SubjectTags {
  struct SubjectTags *next;
  struct Subject  *rec;
  struct Subject  *recfirst;
  struct Subject  *reclast;
  char   tag[20];
};
extern struct SubjectTags *SubjectTagFirst, *SubjectTagLast;

/* DATA TEXTSTRING ******************************************************/
struct TextStr {
  struct TextStr *next;
  char str[256];
  regex_t *preg;
};

struct TextStrTags {
  struct TextStrTags *next;
  struct TextStr  *rec;
  struct TextStr  *recfirst;
  struct TextStr  *reclast;
  char   tag[20];
};
extern struct TextStrTags *TextStrTagFirst, *TextStrTagLast;

/* DATA ECHONAME */
struct Echo {
  struct Echo *next;
  char name[256];
  regex_t *preg;
};

struct EchoNameTags {
  struct EchoNameTags *next;
  struct Echo  *rec;
  struct Echo  *recfirst;
  struct Echo  *reclast;
  char   tag[20];
};
extern struct EchoNameTags *EchoNameTagFirst, *EchoNameTagLast;



/* DATA READDRESSLIST ***************************************************/
struct ReAddressList {
  struct ReAddressList *next;
  ADDR addr1;
  ADDR addr2;
};

struct ReAddrTags {
  struct ReAddrTags *next;
  char tag[20];
  struct ReAddressList  *rec;
  struct ReAddressList  *recfirst;
  struct ReAddressList  *reclast;
};
extern struct ReAddrTags *ReAddrTagFirst, *ReAddrTagLast;

/* DATA RENAME **********************************************************/
struct Rename {
  struct Rename *next;
  ADDR addr1;
  char name1[36];
  ADDR addr2;
  char name2[36];
};

struct RenameTags {
  struct RenameTags *next;
  char tag[20];
  struct Rename  *rec;
  struct Rename  *recfirst;
  struct Rename  *reclast;
  int n;
};
extern struct RenameTags *RenameTagFirst, *RenameTagLast;

/* DATA READDRESSNAME ***************************************************/
struct ReAddressName {
  struct ReAddressName *next;
  ADDR addr1;
  ADDR addr2;
  char name[36];
};

struct ReAdNameTags {
  struct ReAdNameTags *next;
  char tag[20];
  struct ReAddressName  *rec;
  struct ReAddressName  *recfirst;
  struct ReAddressName  *reclast;
};
extern struct ReAdNameTags *ReAdNameTagFirst, *ReAdNameTagLast;



/* DATA ADDRESSNAME */
struct AddrName {
  struct AddrName *next;
  ADDR addr;
  char name[36];
  regex_t *preg;
};

struct AddrNameTags {
  struct AddrNameTags *next;
  char tag[20];
  struct AddrName  *rec;
  struct AddrName  *recfirst;
  struct AddrName  *reclast;
};
extern struct AddrNameTags *AddrNameTagFirst, *AddrNameTagLast;

/* DATA ATTRIBUTE *******************************************************/

struct attrs {
  struct attrs *next;
  char cattr[20];
};
struct recAttr {
  struct recAttr *next;
  struct attrs *attr;
  struct attrs *attrfirst;
  struct attrs *attrlast;
};
struct AttrTags {
  struct AttrTags *next;
  char tag[20];
  struct recAttr *rec;
  struct recAttr *recfirst;
  struct recAttr *reclast;
};
extern struct AttrTags *AttrTagFirst, *AttrTagLast;

/* DATA ROUTING *********************************************************/
struct targets {
  struct targets *next;
  ADDR targ;
};
struct Routing {
  struct Routing *next;
  word   flavor[10];
  ADDR   dest;
  struct targets *targlist;
  struct targets *targfirst;
  struct targets *targlast;
};
struct RoutingTags {
  struct RoutingTags *next;
  char tag[20];
  struct Routing *rec;
  struct Routing *recfirst;
  struct Routing *reclast;
};
extern struct RoutingTags *RoutingTagFirst, *RoutingTagLast;

/* DATA PASSWORDNAME ****************************************************/
struct PassName {
  struct PassName *next;
  char password[9];
  char name[36];
};

struct PassNameTags {
  struct PassNameTags *next;
  char tag[20];
  struct PassName  *rec;
  struct PassName  *recfirst;
  struct PassName  *reclast;
};
extern struct PassNameTags *PassNameTagFirst, *PassNameTagLast;

/* DATA PASSWORADDRESS **************************************************/
struct PassAddr {
  struct PassAddr *next;
  char password[9];
  ADDR addr;
};

struct PassAddrTags {
  struct PassAddrTags *next;
  char tag[20];
  struct PassAddr  *rec;
  struct PassAddr  *recfirst;
  struct PassAddr  *reclast;
};
extern struct PassAddrTags *PassAddrTagFirst, *PassAddrTagLast;

/* DATA FILES ***********************************************************/
struct files {
  struct files *next;
  char fname[256];
  char path[256];
  regex_t *preg;
};
struct recFiles {
  struct recFiles *next;
  struct files *file;
  struct files *filefirst;
  struct files *filelast;
};
struct FilesTags {
  struct FilesTags *next;
  char tag[20];
  struct recFiles *rec;
  struct recFiles *recfirst;
  struct recFiles *reclast;
};
extern struct FilesTags *FilesTagFirst, *FilesTagLast;

/* DATA MESSAGEAGE *******************************************************
   matches older
*/

/* DATA PROCESSAGE *******************************************************
   (matches older in lastvia)
   both data uses the same structure:
*/
struct MsgAge {
  struct MsgAge *next;
  dword secs;
  ADDR addr;
};

struct MsgAgeTags {
  struct MsgAgeTags *next;
  char tag[20];
  struct MsgAge *rec, *recfirst, *reclast;
};
extern struct MsgAgeTags *MsgAgeTagFirst, *MsgAgeTagLast;

struct ProcAgeTags {
  struct ProcAgeTags *next;
  char tag[20];
  struct MsgAge *rec, *recfirst, *reclast;
};
extern struct ProcAgeTags *ProcAgeTagFirst, *ProcAgeTagLast;

/* DATA MESSAGELENGTH ****************************************************
   matches longer
*/
struct MsgLen {
  struct MsgLen *next;
  dword len;
  ADDR addr;
};

struct MsgLenTags {
  struct MsgLenTags *next;
  char tag[20];
  struct MsgLen *rec, *recfirst, *reclast;
};
extern struct MsgLenTags *MsgLenTagFirst, *MsgLenTagLast;


/* DATA FILEAGE **********************************************************
   matcher if any of the files on the same string is older
*/
struct FileAge {
  struct FileAge *next;
  dword secs;
  struct files *file, *filefirst, *filelast;
};

struct FileAgeTags {
  struct FileAgeTags *next;
  char tag[20];
  struct FileAge *rec, *recfirst, *reclast;
};
extern struct FileAgeTags *FileAgeTagFirst, *FileAgeTagLast;

/* DATA LENGTHADDRESS ****************************************************
   length in bytes
*/
struct LengthAddr {
  struct LengthAddr *next;
  dword len;
  ADDR addr;
};

struct LengthAddrTags {
  struct LengthAddrTags *next;
  char tag[20];
  struct LengthAddr *rec, *recfirst, *reclast;
};
extern struct LengthAddrTags *LengthAddrTagFirst, *LengthAddrTagLast;

/* DATA PKTLENGTHADDRESS ************************************************/
extern struct LengthAddrTags *PktLenAddrTagFirst, *PktLenAddrTagLast;


/* DATA DAYOFWEEK ********************************************************
   SUN MON TUE WED THU FRI SAT
   0   1   2   3   4   5   6   (-1 = empty array element - default)
   matches if any
*/
struct Dow {
  struct Dow *next;
  int dow[7];
};

struct DowTags {
  struct DowTags *next;
  char tag[20];
  struct Dow *rec, *recfirst, *reclast;
};
extern struct DowTags *DowTagFirst, *DowTagLast;


/* DATA DATE *************************************************************
   wildcards allowed (all positions should be filled: day.month.year)
   day, month, year all start from 0. -1 = wildcard (default)

   matches if date OR any of dow match
*/
struct Date {
  struct Date *next;
  DD_MM_YY date;
  int dow[7];
};

struct DateTags {
  struct DateTags *next;
  char tag[20];
  struct Date *rec, *recfirst, *reclast;
};
extern struct DateTags *DateTagFirst, *DateTagLast;

/* DATA PATH *************************************************************
*/
struct Path {
  struct Path *next;
  char path[128];
};

struct PathTags {
  struct PathTags *next;
  char tag[20];
  struct Path *rec, *recfirst, *reclast;
};
extern struct PathTags *PathTagFirst, *PathTagLast;

/* DATA ALIAS ************************************************************
*/
struct Alias {
  struct Alias *next;
  char alias[256];
  char fname[256];
};

struct AliasTags {
  struct AliasTags *next;
  char tag[20];
  struct Alias *rec, *recfirst, *reclast;
};
extern struct AliasTags *AliasTagFirst, *AliasTagLast;

/* DATA ADDRESSPACKER ****************************************************
*/
struct addrp {
  struct addrp *next;
  ADDR addr;
  char archname[20];
  dword len;
  char attrs[256];
};

struct AddrPackerTags {
  struct AddrPackerTags *next;
  char tag[20];
  struct addrp *rec, *recfirst, *reclast;
};
extern struct AddrPackerTags *AddrPackerTagFirst, *AddrPackerTagLast;

/* DATA ADDRESSATTR ******************************************************
*/
struct AddrAttr {
  struct AddrAttr *next;
  ADDR addr;
  struct attrs *attr;
  struct attrs *attrfirst;
  struct attrs *attrlast;
};

struct AddrAttrTags {
  struct AddrAttrTags *next;
  struct AddrAttr  *rec;
  struct AddrAttr  *recfirst;
  struct AddrAttr  *reclast;
  char   tag[20];
};
extern struct AddrAttrTags *AddrAttrTagFirst, *AddrAttrTagLast;

/* DATA DATEADDRESS ******************************************************
*/
struct DateAddr {
  struct DateAddr *next;
  word day, month, year;
  word dow[7];
  char tpl_name[256];
  ADDR addr;     /* to addr */
  char name[36]; /* to whom message */
};

struct DateAddrTags {
  struct DateAddrTags *next;
  char tag[20];
  struct DateAddr *rec, *recfirst, *reclast;
};
extern struct DateAddrTags *DateAddrTagFirst, *DateAddrTagLast;

/* DATA SUBJECTADDRESS **************************************************/
struct SubjAddr {
  struct SubjAddr *next;
  ADDR addr;
  char str[256];
};

struct SubjAddrTags {
  struct SubjAddrTags *next;
  struct SubjAddr  *rec;
  struct SubjAddr  *recfirst;
  struct SubjAddr  *reclast;
  char   tag[20];
};
extern struct SubjAddrTags *SubjAddrTagFirst, *SubjAddrTagLast;


/* DATA KLUDGE **********************************************************/

struct kludge {
  struct kludge *next;
  char kl[128];
  BOOL set;
  regex_t *preg;
};
struct recKl {
  struct recKl *next;
  struct kludge *kl;
  struct kludge *klfirst;
  struct kludge *kllast;
};
struct KludgeTags {
  struct KludgeTags *next;
  char tag[20];
  struct recKl *rec;
  struct recKl *recfirst;
  struct recKl *reclast;
};
extern struct KludgeTags *KludgeTagFirst, *KludgeTagLast;

/* COMPRESS */
struct arc {
  char ext[4];
  signed long ioff, ilen;
  byte ident[256];
  char add[128], extract[128], view[128];
  int ratio;
};

struct Compress {
  struct Compress *next;
  char archname[20];
  struct arc arc;
};
extern struct Compress *CompressFirst, *CompressLast;

