/*
typedef unsigned long  dword;
typedef unsigned short word;
typedef signed short   sword;
typedef unsigned char  byte;
*/
#include "typedefs.h"
#include "compiler.h"

typedef int SQ_ERRNO;

#if defined (UNIX)
#define DELIM '/'
#define SEP "/"
/* #define ACCFILE S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH */
#define ACCFILE S_IRUSR|S_IWUSR
#else
#define DELIM '\\'
#define SEP "\\"
#define ACCFILE S_IWRITE|S_IREAD
#endif



/* #define CCHMAXPATHCOMP 2000 */

#define a_Private        0x0001
#define a_Crash          0x0002
#define a_Received       0x0004
#define a_Sent           0x0008
#define a_File           0x0010  /* FileAttached */
#define a_Intransit      0x0020
#define a_Orphan         0x0040
#define a_Killsent       0x0080
#define a_Local          0x0100
#define a_Hold           0x0200
#define a_Res1           0x0400
#define a_Request        0x0800  /* FileRequest */
#define a_Rrq            0x1000  /* ReturnReceiptRequest */
#define a_Isrr           0x2000  /* IsReturnReceipt */
#define a_Audit          0x4000  /* AuditRequest */
#define a_Update         0x8000  /* FileUpdateReq */

#define f_Dir            0x0001
#define f_Imm            0x0002
#define f_Xma            0x0004
#define f_Cfm            0x0008  /* Confirmation Request */
#define f_Zon            0x0010
#define f_Kfs            0x0020
#define f_Tfs            0x0040
#define f_Fpu            0x0080
#define f_Hub            0x0100
#define f_Ks             0x0200
#define f_It1            0x0400
#define f_It2            0x0800
#define f_It3            0x1000
#define f_Lok            0x2000
#define f_Npd            0x4000


#define flv_Normal       0x0001
#define flv_Dir          0x0002
#define flv_Crash        0x0004
#define flv_Imm          0x0008
#define flv_Hold         0x0010
#define flv_NEG          0x1000       /* negative mask */

#define i_Null           0x00000001
#define i_Loop           0x00000002
#define i_Loop2          0x00000004
#define i_Loop3          0x00000008
#define i_Seen           0x00000010
#define i_Lastvia        0x00000020
#define i_To2d           0x00000040
#define i_From2d         0x00000080
#define i_Checkedpath    0x00000100
#define i_Invalidvias    0x00000200
#define i_Invkludges     0x00000400
#define i_Echomail       0x00000800
#define i_Routedecho     0x00001000
#define i_User1          0x00002000
#define i_User2          0x00004000
#define i_User3          0x00008000
#define i_Intl           0x00010000
#define i_Interzone      0x00020000
#define i_Changed        0x00040000
#define i_Addlf          0x00080000
#define i_Normal         0x00100000
#define i_Dummyattach    0x00200000
#define i_Ignoreattach   0x00400000
#define i_Flag           0x00800000
#define i_Repeatscan     0x01000000
#define i_ZaLoop         0x02000000
#define i_NoMyVia	 0x08000000

#define MsgLogged        0x04000000


#define Yes 1 
#define No  0
#define YES 1 
#define NO  0
#define Fail 0
#define Ok 1
#define minus_one  0xFFFF
#define minus_one_long 0xFFFFFFFF
#define attrClear 0
#define attrSet 1
#define Wild_1 0xFFFF
#define Wild_2 0xFFFE

#define AddrCacheSize 100
#define NdlCacheSize 100

#define SECS_IN_DAY 86400
#define MINS_IN_DAY  1440

#define ProdName "itraxp"
/* #define VER VERH"."VERL */
extern char VER[];
#define VerMajor VERH
#define VerMinor VERL
#define ProdCode 0x41

#define DefLogName    "itraxp.log"
#define DefConfigName "itraxp.cfg"

#define EXPORT _export

#define DefCompessRatio 3.2

#define TZOFF ((dword)get_TZ() * 3600L)

#define MSGIDLENGTH 40

typedef struct Addr_ {
  unsigned short zone;
  unsigned short net;
  unsigned short node;
  unsigned short point;
  char  domain[64];
} ADDR;

typedef struct FLock_ {
    int handle;
    char FileName[256];
    long len;
} FLock;

#ifndef __OS2__
#define DosFreeMem(ptr) (GlobalFree(ptr))  
#endif



#if defined(__OS2__)
#define OSName "OS/2"
#define OS2SEM "\\sem32\\itrax.bsy"
#define COMPILER ""
#elif defined(__NT__) || defined(__WIN32__)
#define OSName "Win32"
#if defined(__BORLANDC__)
#define COMPILER "Borland C  5.0"
#elif defined(__WATCOMC__)
#define COMPILER "Watcom C  11.0"
#else
#define COMPILER ""
#endif
#elif defined(LINUX)
#define OSName "Linux"
#define COMPILER "gcc"
#else
#define OSName ""
#define COMPILER ""
#endif

#ifndef REXXVER
#define REXXVER ""
#endif

#ifdef BUILD
#define BUILD_STR "(build: "BUILD")"
#else
#define BUILD_STR ""
#endif
