
/* #if defined UNIX || defined __MINGW32__ */

#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>

#ifndef __MINGW32__

#define _A_NORMAL       0x00    /* Normal file - read/write permitted */
#define _A_RDONLY       0x01    /* Read-only file */
#define _A_HIDDEN       0x02    /* Hidden file */
#define _A_SYSTEM       0x04    /* System file */
#define _A_VOLID        0x08    /* Volume-ID entry */
#define _A_SUBDIR       0x10    /* Subdirectory */
#define _A_ARCH         0x20    /* Archive file */

#endif

struct find_t {
    char reserved[21];      /* reserved for use by DOS   */
    char attrib;             /* attribute byte for file   */
    unsigned short wr_time; /* time of last write to file*/
    unsigned short wr_date; /* date of last write to file*/
    unsigned long  size;    /* length of file in bytes   */
    char name[256];         /* null-terminated filename  */
    char attributes;
    char *searchname;
    char *path;
    DIR  *dir;
};

unsigned _dos_findfirst( const char *path, 
unsigned attributes, struct find_t *buffer );
unsigned _dos_findnext(  struct find_t *buffer );
unsigned _dos_findclose( struct find_t *buffer );

/* #endif */
