#include <EXTERN.h>
#include <perl.h>
#include <unistd.h>
#include <XSUB.h>

#ifndef sv_undef
#define sv_undef PL_sv_undef
#endif

#define PERLEXIT	"itraxp_exit"


/* 200.c */
void expand_str_200(char** s);
char *xstrcpy(char *i);
char *xstrcat(char *o, char *i);
void *xmalloc(size_t size);
void *xcalloc(size_t block, size_t sim);
void *xrealloc(void *s, size_t size);
int  get_macro_200 (char **p);

char *sp_s;

#define FromSP(i)	(char *)SvPV(ST(i), n_a); if (n_a == 0) sp_s  = ""
#define XCAL		(char *)xcalloc(n_a+1, sizeof(char))

/* init.c */
void init_globals (void);
void reset_globals(int old_type);
void free_pkt_cache (void);
/* scan.h */
static void read_tsfile(char *fn);
/* fido.c */
void  select_fido_area(char *areapath, FIDO_AREA *fido);
dword fetch_ts(char *areaname);
BOOL  read_fido_msg(char *fname, FIDO_MSG *msgHdr, TEXT **first);
void  msghdr_to_ftn(FIDO_MSG msgHdr, FTN *ftn);
void  ftn_to_msghdr(FTN ftn, FIDO_MSG *msgHdr);
int   create_fido_msg( char *areatag, FIDO_MSG Hdr, TEXT *Text );
BOOL  kill_fido_msg(void);
BOOL  write_fido_msg(char *fname, FIDO_MSG hdr, TEXT *txt);
void fido_pack(char *areatag);
/* squish.c */
BOOL select_squish_area(char *areaname, SQAREA *sqarea);
void sq_failure_reason(void);
BOOL read_squish_msg(SQAREA *squish, TEXT **first);
void xmsg_to_ftn( XMSG xmsg, FTN *ftn);
void sq_rewind(void);
BOOL open_squish_bases(char *areaname, int *sqd, int *sqi);
void ftn_to_xmsg(FTN ftn, XMSG *xmsg);
void text_to_sqbase(TEXT *txt, char **cbuf, char **tbuf);
int  add_squish_msg(int sqd, int sqi, XMSG xmsg, char *cbuf, char *tbuf);
BOOL kill_squish_msg(SQAREA *squish);
BOOL update_squish_msg(char *cbuf, char *tbuf);
BOOL sq_pack(char *areatag);
/* jam.c */
BOOL select_jam_area(char *areaname, JAM_AREA *);
BOOL read_jam_msg(JAM_AREA *, TEXT **);
void jam_to_ftn(JAM_AREA *jam, FTN *ftn);
BOOL open_jam_bases(char *areaname, JAM_AREA *jam);
void ftn_to_jam(FTN *ftn, JAM_AREA *jam);
int  add_jam_msg(JAM_AREA *jam, TEXT *txt);
BOOL kill_jam_msg(JAM_AREA *jam);
int  update_jam_msg(JAM_AREA *jam, TEXT *txt);
BOOL jam_pack(char *areatag);
/* pkt.h */
void   select_pkt_area(char *areapath, PKT_AREA *pkt);
BOOL   readpkt_wrapper(char *err);
BOOL   read_pkt(char *PKT_name, PKT_AREA *pkt);
void   rename_bad_pkt(char *fname);
BOOL   read_pkt_msg(PKT_AREA *pkt, TEXT **txt);
void   pktarea_to_ftn(struct pktarea pkt, FTN *ftn);
void   ftn_to_pktarea(FTN ftn, struct pktarea *pkt);
BOOL   write_pkt_msg(char *areatag, struct pktarea* pkt, TEXT *t, word flv);
void   update_old_pkt(char *fname, PKT_AREA pkt);
char  *get_fbox_path (int type, char* areatag, ADDR to, word flv);
static int open_read_pkt (char* PKT_name, PKT_AREA* pkt);
static void killpkt (void);
static int copypkt (char* areaname);
static BOOL make_new_pkt_name(char *areapath, char *fname);
dword  ReadPktHdr(int handle, PKT_HDR *pkt_hdr);
dword  WritePktHdr(int handle, PKT_HDR *pkt_hdr);
dword  WritePktMsgHdr(int handle, struct pkt_msg_hdr *pkt_msg_hdr);
static dword get_maxpktsz(ADDR to, char *areapath);
void   add_to_pktcache(ADDR to, ADDR from, char *areapath, char *fname, dword len);
static BOOL get_pkt_name(PKT_AREA* pkt, char *areapath, TEXT *t, char *fname);
static char * is_fbox(char *areatag, ADDR to, word flv);
static char *get_flv(word flv);
/* binkarea.c */
void    select_bink_area(char *areapath, PKT_AREA *);
void    bnk_to_bsy(char *s, char *bsy);
BOOL    read_FLO(char *areaname, char *FLO_name, PKT_AREA *pkt);
BOOL    read_FLO_msg(PKT_AREA *pkt, TEXT **t, FTN *ftn);
BOOL    write_binkout_OIP( char *areatag, FTN Ftn, TEXT *Text);
PKT_HDR make_pkt_header(FTN Ftn, ADDR aka, char *areatag);
void    chop_fname(char *s);
/* textarea.c */
BOOL add_text_msg(char *areatag, FTN *ftn, TEXT* newtext);
/* defarea.c */
void  set_ts(char *areaname, dword ts);
/* readmsg.h */
struct kl_str {
	char INTL[128], FMPT[128], TOPT[128], MSGID[128], REPLY[128];
};
BOOL   readmsg(char *err);
BOOL   isFLO(char *fname);
void   do_chat(void);
static void parse_msg(FTN *ftn, TEXT **txt, TEXT **Via, char *system);
BOOL   isZaloop(TEXT *v, ADDR to, char *system);
static dword parse_kludges(struct kl_str *kl, ADDR *from, ADDR *to);
static dword parse_via(TEXT *via, ADDR aka);
void   add_via(TEXT **text, ADDR fromAddr);
void del_my_via(TEXT **text, ADDR addr);
static void get_origin(TEXT *t, char *o);
static BOOL get_echo_from(char *o, ADDR *addr);
word   set_msg_flavor(word attr, word flag);
static BOOL get_via_address(char *str, ADDR *addr);
void   make_via_string(ADDR aka, char *str);
void   add_at_end(TEXT **txt, char *str);
/* dobnkout.h */
struct ATT {
	ADDR addr;
	char *fif_body;
};
typedef struct short_ADDR {
	word zone, net, node, point;
} sADDR;
BOOL   set_bsy( char *bsy);
void   kill_bsy( char *bsy);
static void dobinkout(char *areaname, int outtype, char *err);
int areaname_to_binktype(char *areatag);
static PKT_HDR *do_read_pkt( char *OIP_name );
static char get_flavor_letter( char *name );
char  *addr_to_binkoutbase(ADDR addr, struct BinkAreas *Bink);
char  *addr_to_brakeoutbase(ADDR to, struct BinkAreas *Bink);
char  *addr_to_amiga4doutbase(ADDR to, struct BinkAreas *Bink);
static char * brflavor(char cflav);
static BOOL do_binkOUT(char *fromName, char *toName);
static BOOL do_binkFLO(char *fif_body, char *toName);
static BOOL get_attach_info(char *FIF_name, struct ATT *att);
/* util.c */
word  str_to_flags( char *p );
void  fetch_systime(char *buf);
dword textlen(TEXT *t);
BOOL  is_zone_indep(ADDR addr);
BOOL  is_reg_indep(ADDR addr);
BOOL is_full_path(char *p);
/* msg.h */
BOOL   is_echoarea(int areatype, char *areatag);
static BOOL kill_msg(void);
static int get_new_msg_arg( int argc, char **argv, char *err, NewMsgArg *nma);
static FTN change_hdr(FTN ftn, NewMsgArg nma);
static TEXT * change_text(TEXT *text, NewMsgArg nma, ADDR from);
static void kill_netmail_kludges(TEXT **text);
int    add_msg(int areatype, char *areatag, FTN *new_ftn, TEXT *newtext, PKT_HDR* pkt_hdr);
static void clear_all_attr( AllAttr *aa);
TEXT  *make_msgtext_hdr(FTN *f, BOOL isEcho);
static TEXT *get_old_text(TEXT *text);
static FTN change_hdr (FTN ftn, NewMsgArg nma);
static BOOL get_block_name( char *str, char *name);
static BOOL get_block_addr( char *str, ADDR *addr);
static BOOL get_block_addrname( char *str, ADDR *addr, char *name);
static char *get_block_subj( char *subj, char *err);
static void set_hdr_attr( char *cattr, AllAttr *aa, BOOL direct, char *err);
TEXT  *get_array_string (char *str);
static void get_tpl(char *tpl_name, TEXT **t);
static void kill_flag_attr(char *s);
static void inv_tear_orig(TEXT *t);
/* setroute.h */
void set_route (char *tag, FTN *ftn);
/* getblist.c */
int getblocktype(char *token);
/* select.h */
BOOL   comp_addrs( ADDR addr, ADDR targ );
BOOL   comp_strings( char *str, char *substr, BOOL relaxed );
static BOOL do_select(char *tag, char *err_diag, BOOL fromTo );
static BOOL select_address( char *tag , BOOL fromTo , BOOL mode , BOOL relaxed );
static BOOL select_readdresslist(char *tag , BOOL fromTo , BOOL relaxed);
static BOOL select_system( char *tag , BOOL fromTo , BOOL relaxed );
static BOOL select_name( char *tag , BOOL fromTo , BOOL mode , BOOL relaxed );
static BOOL select_addrname( char *tag , BOOL fromTo , BOOL mode , BOOL relaxed );
static BOOL select_subject( char *tag , BOOL mode , BOOL relaxed );
static BOOL select_textstr( char *tag , BOOL mode , BOOL relaxed );
static BOOL select_nodelist( char *tag , BOOL fromTo );
static BOOL select_v9_nodelist( char *tag , BOOL fromTo );
static BOOL select_routing( char *tag , BOOL relaxed);
static BOOL select_attribute( char *tag , BOOL mode );
static BOOL select_files( char *tag , BOOL mode );
static BOOL select_msgage( char *tag , BOOL fromTo , BOOL mode);
static BOOL select_prage( char *tag , BOOL fromTo , BOOL mode);
static BOOL select_fage( char *tag , BOOL mode);
static BOOL select_passaddr( char *tag , BOOL fromTo , BOOL mode , BOOL relaxed );
static BOOL select_passname( char *tag , BOOL fromTo , BOOL mode , BOOL relaxed );
static BOOL select_msglen( char *tag , BOOL fromTo , BOOL mode , BOOL relaxed );
static BOOL select_date( char *tag , BOOL mode);
static BOOL select_dow( char *tag , BOOL mode);
static BOOL select_kludge( char *tag , BOOL mode , BOOL relaxed);
static BOOL select_ename( char *tag , BOOL mode , BOOL relaxed);
static BOOL check_all_attrs( char *str , AllAttr aa );
static BOOL fsearch(char *fname);
static BOOL rx_fsearch(char *fname, char *path, regex_t *preg);
static BOOL search_str(char *str, BOOL relaxed); 
static BOOL rx_search_str(const regex_t *preg);
static BOOL is_this_date(DD_MM_YY date, int dow[]);
static BOOL is_this_dow(int dow[]);
static BOOL is_kl_found(char *substr, regex_t *preg, BOOL relaxed);
/* ver9.c */
BOOL is_v9_listed(struct ndlTags *v9_ndlTag, ADDR addr, int *z, int *r, int *h);
BOOL v9_ndl_build(int nndl, char *ndlnames[], char *path, char *ext, word DefZone, word DefReg);
/* deffage.c */
dword get_age(char *cage);
/* time.c */
dword fdate_to_unix(word *ftime, word *fdate);
int   get_dows(char *str, int dow[]);
void  make_DateTime(char *s);
char *unix_to_ftscdate(time_t t, char *s);
dword ftscdate_to_unix(char *date);
dword seadog_to_unix(char *date);
/* defdate.c */
BOOL str_to_date(char *cdate, DD_MM_YY *date);
/* getname.h */
char * get_echo_name(void);
/* setattr.h */
void set_all_attrs( char *str , AllAttr *p_aa);
void inv_vias(TEXT *text);
void inv_kludges(TEXT *text, BOOL ALL);
/* chaddr.h */
void change_echo_kludges(FTN ftn, TEXT *t);
void change_address_kludges(FTN *ftn, TEXT **Text);
void set_Waddr(ADDR new_addr, ADDR *old_addr);
/* addline.h */
TEXT * line_to_txt (char *p);
/*delline.h */
static BOOL find_string( char *tag, char *string, char *err);
/* setpkt.h */
BOOL setpkthdr (char **parray, int array_len, char* err, PKT_HDR* hdr);
/* add_hdr.h */
TEXT *read_tpl( char *fname );
/* chaddr.h */
static void ChangeAddr(char *pptmp, ADDR *addr, char *err);
static void replace_origin_addr(char *o, ADDR new_addr);
/* chckpath.h */
static BOOL adjust_subj(char *old_subj, struct Path *pathFirst, char *New_subj[], int *nsubj);
/* substtxt.h */
static BOOL substr(char *s1, char *s2, BOOL relaxed, BOOL ALL);
static BOOL rx_substr(regex_t *preg, char *s2, BOOL ALL);
/* unpack.h */
BOOL   is_arcmail(char *fname);
static void ch_dir(char *path);
static int get_path (char *s, char *dir[], int max, char *err);
char* ufetch_arcer(char *a, char *f, char *exe, char* wdir, BOOL* dirset);
struct Compress * detect_arctype(char *a);
/* packpkt.h */
static BOOL get_pkt_to(char *fname, ADDR *to);
static void read_aptag(struct AddrPackerTags *tag, ADDR to, char *flags);
static char get_FLO_flavor(char *p);
static void read_compress_block(void);
static BOOL get_arcmail_name(char *arcpath, char *pkt,	char *flo, ADDR to, char *fname, int fbox);
static word set_kill_flavor(char *p, word flag);
static BOOL pupdate_FLO(char *fname, char *s);
static void get_callstr(char *a, char *f, char *exe, char *arg);
static BOOL is_pkt(char *fname);
static BOOL is_size_ok(char *s, char *pkt);
static BOOL get_last_arc_entry(int fbox, char *flo, char *pkt, char *arcpath, char *fname);
void   add_to_arccache(ADDR to, char *areapath, char *fname);
static BOOL make_new_arcname(ADDR to, char *arcpath, char *fname);
static BOOL is_curdate(char *fname);
static void get_todays_dow(char *dow);
static char get_last_char(char *arcpath, char *fname);
/* shell.c */
int shell(char *fname, char *arg);
/* crc32.c */
ULONG crc_str(register ULONG crc, char *str, register long len);
/* routeto.h */
static ADDR set_route_to (char *caddr, char *err);
/* getalist.h */
static void getalist(TEXT **list);
static void add_list(char *s, TEXT **list);
/* ndlrbld.h */
static void rebndl(struct Tags *t);
/* defndl.c */
int getndlnames(char *path, char *arg, char *ndllist[]);
BOOL ndl_build(int nndl, char **ndlnames, char *path, char *ext);
/* ndlscan.h */
static BOOL nodeLookUp(FILE *h_ndl, word host, word node, word* uplink);
/* getndl.h */
void get_ndl (struct ndlTags* ndlTag, char* block_name, char ***prenblock, int *count);
BOOL is_listed(struct ndlTags *ndlTag, ADDR addr, word* uplink, word* region);
/* config.c */
void config(char *path, char *cfg_name);
BOOL def_keyword(char *keyword, char *data, char *err);
/* defdata.h */
void define_block(char *blocktype, char *blockname, char **parray, int array_len, char *err);
/* gv.h */
char* get_global_var(char *var);
