
#define VERH 1
#define VERL 3

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#ifdef __FreeBSD__
#define _ANSI_SOURCE
#endif

#if defined OS2 && !defined __OS2__
#define __OS2__
#endif

#ifdef __OS2__
#define INCL_DOSFILEMGR
#define INCL_DOSPROCESS
#define INCL_DOSDEVICES
#define INCL_DOSSEMAPHORES
#define INCL_DOSSESMGR     
#define INCL_DOSQUEUES   
#define INCL_BASE
#define INCL_DOSEXCEPTIONS
#endif
#define INCL_REXXSAA
#define INCL_RXFUNC
#define INCL_RXSUBCOM
#define INCL_RXSHV

#if defined(__OS2__) || defined (__MINGW32__)
#include <process.h>
#include <dos.h>
#if defined (__OS2__)
#include <os2.h>
#undef ADDRESS
#elif defined(__MINGW32__)
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif
#endif

#if !defined(UNIX) && !defined(SASC)
#include <io.h>
#endif

#include <time.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <ctype.h>

#if !defined(UNIX) && !defined(SASC)
#include <share.h>
#endif
#if !(defined(_MSC_VER) && (_MSC_VER >= 1200))
#include <unistd.h>
#endif

#ifndef S_IRUSR
#define S_IRUSR S_IREAD
#endif
#ifndef S_IWUSR
#define S_IWUSR S_IWRITE
#endif

#include "defines.h"
#include "enum.h"
#include "squish.h"
#include "jam.h"
#include "ftn.h"
#include "data.h"
#include "findnix.h"
#include "recode.h"


#define get_dword(ptr)            \
   ((dword)((unsigned char)(ptr)[0]) |           \
    (((dword)((unsigned char)(ptr)[1])) << 8)  | \
    (((dword)((unsigned char)(ptr)[2])) << 16) | \
    (((dword)((unsigned char)(ptr)[3])) << 24))  \

/*
 *  get_word
 *
 *  Reads in a 2 byte word that is stored in little endian (Intel) notation
 *  and converts it to the local representation in an architecture-
 *  independent manner
 */

#define get_word(ptr)         \
    ((word)((unsigned char)(ptr)[0]) |         \
     (((word)((unsigned char)(ptr)[1])) << 8 ))


void put_dword(byte *ptr, dword value);
void put_word(byte *ptr, word value);



int _fast setfsize(int fd, long size);
char *strUpper(char *str);
char *strLower(char *str);
int _fast fexist(char *filename);
long _fast fsize(char *filename);
/* int sopen(const char *name, int oflag, int ishared, int mode); */
long filelength(int h);

#if defined (UNIX)
char *strrev(char *str);
#endif

#ifdef __MINGW32__
extern int dirNameLen;
#endif


/* util.c */
extern int    get_TZ(void);

extern FTN ftn, old_ftn;
extern struct CurMsg CurMsg;

typedef struct Text {
  struct Text *next;
  char str[256];
} TEXT;
extern TEXT *TextFirst, *ViaTextFirst;

struct Fnames {
	char fname[128];
  dword ts;
};

struct Pktnames {
  char fname[256];
  ADDR to;
};


struct nodeinc {
  char namelen;
  char name[12];
  ULONG crc32;
};

#define NODEINC_SIZE 17

struct nodeidx {
  char stat;
  word number;
  char listno;
  ULONG pos;
};

#define NODEIDX_SIZE 8

struct ATTRS {
  char s[50];
  word n;
};
extern struct ATTRS Attrs[];

struct FLAGS {
  char s[10];
  word n;
};
extern struct FLAGS Flags[];

struct KLUDGES {
  char s[50];
  word n;
  int  type; /* 0=upper, 1=lower */
};
extern struct KLUDGES Kludges[];

struct FLAVORS {
  char s[50];
  word n;
};
extern struct FLAVORS Flavors[];

struct STATS {
  char s[50];
  dword n;
};
extern struct STATS Stats[];

typedef struct {
  word attr;
  word flag;
  dword stat;
} AllAttr;

struct TAGDESC {
  char s[50];
  word n;
  void (*deffunc) (char *, char *, char *);
};
extern struct TAGDESC TagDesc[];

struct MACROS {
  char s[50];
  word n;
};
extern struct MACROS Macros[];

typedef struct {
  ADDR from;
  char fromName[36];
  ADDR to;
  char toName[36];
  char subj[72];
  AllAttr aa;
  char tame[256];
  TEXT *hText, *lText;
  int tlineNo;
  int llineNo;
  char *o, *r, *e;
	time_t d;
	char route[64]; /* ascii string of address to route to */
  PKT_HDR* pkt_hdr;
	
} NewMsgArg;

struct AREACACHE {
  char AreaTag[20];
  char AreaPath[256];
  int  AreaType;
  char system[20];
  BOOL isEcho;
};
extern struct AREACACHE AreaCache[];

/* cache for the addresses searched */
struct ADDRCACHE {
  ADDR addr;
  word reg, net;
  word uplink; /* -1 if not found */
};
extern struct ADDRCACHE AddrCache[];


struct MONTHS {
  char name[4];
  int n;
};
extern struct MONTHS Months[];

struct DOW {
  char dow[4];
  int n;
};
extern struct DOW Dow[];


/************************************************************************/
struct MaxMsgNos {
  struct MaxMsgNos *next;
  char area[20];
  int n;
};


extern struct MaxMsgNos *MaxMsgNoFirst, *MaxMsgNoLast;

typedef struct {
  char areaname[20];
  dword ts;
} TS;

/* timestamps (lastread) */
typedef struct tslist {
  struct tslist *next;
  TS ts;
} TSL;
extern TSL *TSlist;

struct _gv {
  struct _gv *next;
  char *var, *val;
};
extern struct _gv *GlobalVarList;

struct _db {
  dword HdrCRC;
  dword MsgidCRC;
  char Msgid[MSGIDLENGTH];
};

/*       dupes stuff   */
struct _dbcache {
  char areaname[256];
  char dupename[256];
  struct _db *dbrec;
  int nrec, nalloc;
};
extern struct _dbcache *DupeBase;
extern int DupesTotal, DupesMaxMsg, DupesMaxOpen;

/* end of dupes stuff */

extern ADDR MainAddress;
extern char *LogFile;
extern char ItraxPath[], TemplatePath[], FlagDir[], CompressFile[];
extern char *SeqDir;
extern unsigned long SeqOutRun;
extern char *TsPath, *DupeBasePath;
extern int  TsHandle;
extern char TZ[];
extern int Sharing;
extern int DebugLevel;

extern char *flavors[];
extern int nRead, nWritten;

/* extern jmp_buf jumper; */
extern time_t tStart;

extern unsigned long MsgId;

extern int writeY, writeX;
extern BOOL Chat_On, ChatOFF, LogOFF;

extern int sq_errno, jam_errno;

extern BOOL IgnoreBSY, TouchEchomail, UseRegExp, rxIcase;

extern BOOL IsInited;

extern char *FBox, OutFileName[];

struct filter {
  struct filter *next;
  char str[256];
  regex_t *preg;
};
extern struct filter *LogIncl, *LogInclLast;
extern struct filter *LogExcl, *LogExclLast;

extern BOOL BadAreaDefined;


int    __isnumber(char *);                         /* util.c */
int    parse(char *, char **, char **);            /* util.c */
int    splitf(char *, char **);                    /* util.c */
char * trim(char *);                               /* util.c */
char * strip(char *str);                           /* util.c */
char * get_next_word(char *str, char *w);          /* util.c */
BOOL   addr_cmp( ADDR , ADDR);                     /* util.c */
int    str_to_addr(char *address, ADDR *);         /* util.c */
int    str_to_Waddr(char *address, ADDR *);        /* util.c */
char * addr_to_str(ADDR, char *string);            /* util.c */
char * attr_to_str( const word attr, char *res );  /* util.c */
char * flag_to_str( const word flag, char *res );  /* util.c */
char * stat_to_str( const dword stat, char *res ); /* util.c */
word   str_to_attr( char *str);                    /* util.c */
word   str_to_flag( char *str);                    /* util.c */
dword  str_to_stat( char *str);                    /* util.c */
int    setpath(char *path);                        /* util.c */
BOOL   is_legal_tag(char *tag);                    /* util.c */
void   writeToLog(int level, char *str, ...);      /* util.c */
void   close_log(void);                            /* util.c */
int    fidoname_to_number(char *name);             /* util.c */
int    get_new_fido_fname(char *areatag);          /* util.c */
void   log_msg_hdr(void);                          /* util.c */
unsigned long get_MsgId(void);                     /* util.c */
unsigned long get_MsgId_original(void);            /* util.c */
void   fix_path( char *outdir);                    /* util.c */
void   add_text( TEXT **text, TEXT *subtxt, int lineno, BOOL mode); /* util.c */
BOOL   kill_text( TEXT **text , int lineno, BOOL mode); /* util.c */
void   free_text(TEXT *Text);                      /* util.c */
char * expand_str( char *buf);                     /* util.c */

BOOL   get_def_addr( char *system, const ADDR addrIn, ADDR *addrOut ); /* util.c */
void   set_flag_kludge(TEXT **, char *cflag);      /* uitl.c */
char * remove_quotes( char *str );                 /* util.c */
BOOL   is_TearLine( char *str);                    /* util.c */
BOOL   is_Origin( char *str);                      /* util.c */
BOOL   is_Via( char *str);                         /* util.c */
BOOL   is_kludge( char *str);                      /* util.c */
int    is_reserved_kludge( char *kl);              /* util.c */
BOOL   get_macro( char *str, char *macro);         /* util.c */
BOOL   from_hub(ADDR addr, ADDR hub);              /* util.c */
BOOL   get_ndl_info(ADDR addr, word* hub, word* region); /* util.c */
BOOL   isW(word c);                                /* util.c */
int    areaname_to_type(char *areatag);
BOOL   areaname_to_system(char *areatag, char *system);
BOOL   areaname_to_path(char *areatag, char *path);
BOOL   strncat_max(char *to_str, char *from_str, int max);
void   strip_CRLF(char *str);

void   get_attr(char *str);                        /* getattr.c */

BOOL   update_msg(int type);                       /* update.c */

void   init_catcher(void);                         /* catcher.c */
void   cleanup(void);                              /* catcher.c */
int    createLockFile();

ULONG  crc32(char *fname);                         /* crc32.c */
/* BOOL   is_listed(struct ndlTags *, ADDR addr, word* hub, word* region); */
void   addtag(int type, char *tag, char *err_diag);/* addtag.c */
/* char * RxSTRPTR(RXSTRING); */

void *xmalloc(size_t size);
void *xcalloc(size_t block, size_t sim);
void *xrealloc(void *s, size_t size);

	
