
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void  expand_str_200(char **s);
int get_macro_200 (char **p);

dword  textlen(TEXT *t);


void *xmalloc(size_t size)
{
  void *s;

  s = malloc(size);
  if (!s)
    abort();

  return s;    
}

void *xcalloc(size_t block, size_t sim)
{
    void *s;
    
    if (block == 0 || sim == 0) return NULL;

    s = (void*)malloc(block*sim);
    if (s == NULL) abort();
    
    memset(s, '\0', block*sim);
    
    return s;
}

void *xrealloc(void *s, size_t size)
{
  s = realloc(s, size);
  if (!s)
    abort();

  return s;    
}

char *xstrcpy(char *i)
{
	char* o;
	if (!i)
		return NULL;
		
	o = (char *)xmalloc((strlen(i)+1)*sizeof(char));
  return (char*)strcpy(o, i);
}

char *xstrcat(char *o, char *i)
{
  int l;

  if (!i)
    return NULL;
      
  l = (strlen(i)+1)*sizeof(char);
  
  if (o)
    o = (char *)xrealloc(o, l + strlen(o)*sizeof(char));
  else {
    o = (char *)xmalloc(l);
    *o = '\0';
  }

  return strcat(o, i);    
}

/*************************************************************************/
int get_env_200(char **p)
{
	char *env;

	if (p==NULL || *p==NULL)
		return Fail;

	env = getenv(*p);
	if (env) {
		free (*p);
		*p = xstrcpy (env);
	}

	return env ? Ok : Fail;
}

/**************************************************/
char * areaname_to_system_200(char *areatag)
{
  struct FidoAreas *FidoArea;
  struct BinkAreas *BinkArea;
  struct SquishAreas *SquishArea;
  struct JamAreas *JamArea;
  struct PktAreas  *PktArea;
  
  for( FidoArea = FidoAreaFirst; FidoArea; FidoArea = FidoArea->next )
    if ( !stricmp( FidoArea->name, areatag ) )
      return FidoArea->system;
  
  for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea->next )
    if ( !stricmp( BinkArea->name, areatag ) ) 
      return BinkArea->system;
  
  for( PktArea = PktAreaFirst; PktArea; PktArea = PktArea->next )
    if ( !stricmp( PktArea->name, areatag ) ) 
      return PktArea->system;
  
  for( SquishArea = SquishAreaFirst; SquishArea; SquishArea = SquishArea->next )
    if ( !stricmp( SquishArea->name, areatag ) ) 
      return SquishArea->system;
  
  for( JamArea = JamAreaFirst; JamArea; JamArea = JamArea->next )
    if ( !stricmp( JamArea->name, areatag ) ) 
      return JamArea->system;
  
  return NULL;
  
}

/********************************************************************/
char *addr_to_str_200(ADDR addr)
{
	char buf[32];
	char *s = NULL;

	free(s);
	s = NULL;
  
	if ( addr.zone == (word)-1 )
		s = xstrcpy("*");
	else {
/*		itoa(addr.zone, buf, 10); */
		sprintf(buf, "%u", addr.zone);
		s = xstrcpy(buf);
	}
	
  s = xstrcat(s, ":");
  
	if ( addr.net == (word)-1 )
		s = xstrcat(s, "*");
	else {
/*		itoa(addr.net, buf, 10); */
		sprintf(buf, "%u", addr.net);
		s = xstrcat(s, buf);
	}
  
  s = xstrcat(s, "/");
  
	if ( addr.node == (word)-1 )
		s = xstrcat(s, "*");
	else {
/*		itoa(addr.node, buf, 10); */
		sprintf(buf, "%u", addr.node);
		s = xstrcat(s, buf);
	}
  
  if ( addr.point ) {
    
    s = xstrcat(s, ".");
    
		if ( addr.point == (word)-1 )
			s = xstrcat(s, "*");
		else {
/*			itoa(addr.point, buf, 10); */
			sprintf(buf, "%u", addr.point);
			s = xstrcat(s, buf);
		}
		
  }
  
  return s;
}
char * fetch_systime_200(void)
{
  char ctz[5]={0};
  struct tm *tm;
  time_t t;
/* long tz = - ((_timezone/3600L) % 12L ); */
  int tz;
  int year;
	static char buf[256];

  
  t = time(NULL);
  tm = localtime(&t);
  year = 1900 + tm->tm_year;
  if (tm->tm_year < 70)
    year = 2000 + tm->tm_year;
  
  
  sprintf(buf, "@%d%02d%02d.%02d%02d%02d.UTC",
          year, tm->tm_mon+1, tm->tm_mday,
          tm->tm_hour, tm->tm_min, tm->tm_sec);

  if (0 != (tz = get_TZ())) {
    sprintf(ctz, "%+d", tz);
    strcat(buf, ctz);
  }
  
  return buf;
}

/*************************************************************************/
int get_macro_200 (char **p)
{
    time_t cur_time;
    struct tm *loc_time;
    struct Macro *tmpMacro;
    int i;
    char *system, w1[256], buf[256];
    ADDR addr, aka;
    char *macro = NULL;
    BOOL rc=Fail;

    if (p==NULL || *p==NULL) return Fail;

    for( i = 0; strlen( Macros[i].s ); ++i) {
	if ( !stricmp(Macros[i].s , *p) ) {
      
	    if (CurMsg.n == 0) {
		if (Macros[i].n != m_Program    &&
		    Macros[i].n != m_Systemtime &&
	            Macros[i].n != m_Localtime  &&
    		    Macros[i].n != m_Localdate  &&
	            Macros[i].n != m_TZ  &&
		    Macros[i].n != m_System  &&
		    Macros[i].n != m_pktTo  &&
		    Macros[i].n != m_pktFrom &&
		    Macros[i].n != m_Sysop) {
		    
		    writeToLog(4,"expanding macro: no active message in memory");
		    return Fail;
		}
	    }
	    switch( Macros[i].n ) {
        
		case m_Program:
		    macro = xstrcpy(ProdName);
		    macro = xstrcat(macro, " ");
		    macro = xstrcat(macro, VER);
		    break;

		    /*      case m_Nodelist: // ??? who the fuck ever needs this? */

		case m_Systemtime:

		    macro = xstrcpy(fetch_systime_200());
		    break;
        
		case m_Localtime:

		    macro = (char *)xmalloc(100);
		    cur_time = time(NULL);
		    loc_time = localtime(&cur_time);
		    sprintf(macro, "%02u:%02u:%02u",
		    loc_time->tm_hour, loc_time->tm_min,
		    loc_time->tm_sec);
		    break;

		case m_Localdate:
        
		    macro = (char *)xmalloc(100);
		    cur_time = time(NULL);
		    loc_time = localtime(&cur_time);
		    sprintf(macro, "%02u/%02u/%u",
		    loc_time->tm_mon+1, loc_time->tm_mday,
		    loc_time->tm_year+1900);
		    break;

		case m_TZ:
		    macro = (char *)xmalloc(100);
		    sprintf(macro, "%+d", get_TZ());
		    break;
				
		case m_System:
		    aka = MainAddress;
		    if (CurMsg.n && (system = areaname_to_system_200(CurMsg.areaname))) {
			addr = ftn.to;
			get_def_addr(system, addr, &aka);
		    }
		    macro = xstrcpy(addr_to_str_200(aka));
		    break;
        
		case m_fromName:
		    macro = xstrcpy(ftn.fromName);
		    break;
        
		case m_from:
		    macro = xstrcpy(addr_to_str_200(ftn.from));
		    break;

		case   m_toName:
		    macro = xstrcpy(ftn.toName);
		    break;
        
		case   m_to:
		    macro = xstrcpy(addr_to_str_200(ftn.to));
		    break;
        
		case   m_Time:
		    macro = xstrcpy(ftn.DateTime);
		    break;
        
		case m_Attributes: {
		    char cattr[256];
		    get_attr(cattr);
		    macro = xstrcpy(cattr);
		    break;
		}
        
		case m_Subject:
		    macro = xstrcpy(ftn.subject);
		    break;
        
		case m_lineCount:
		    macro = (char *)xmalloc(100);
		    sprintf(macro, "%u", ftn.lines);
		    break;
        
		case m_msgLength:
		    if (!ftn.msglen)
			ftn.msglen = textlen(TextFirst);

		    macro = (char *)xmalloc(100);
		    sprintf(macro, "%u", (unsigned)ftn.msglen);
		    break;
        
		case m_intlFrom:
		    strncpy(buf, ftn.intl, 99);
		    get_next_word(buf, w1);
		    macro = xstrcpy(buf);
		    break;
        
		case m_intlTo:
		    strncpy(buf, ftn.intl, 99);
		    macro = (char *)xmalloc(100);
		    macro[0] = '\0';
		    get_next_word(buf, macro);
		    break;

		case m_msgidFrom:
		    macro = xstrcpy(ftn.msgid);
		    break;

		case m_replyTo:
		    macro = xstrcpy(ftn.reply);
		    break;

		case m_routeTo:
		    macro = xstrcpy(addr_to_str_200(ftn.routeTo));
	            break;
        
		case m_toDomain:
	            if ((system = areaname_to_system_200(CurMsg.areaname))) {
                	addr = ftn.to;
			get_def_addr(system, addr, &aka);
		    } else {
			aka = MainAddress;
		    }
		    macro = xstrcpy(aka.domain);
        
		    break;
        
		case m_fromDomain:
		    if ((system = areaname_to_system_200(CurMsg.areaname))) {
			addr = ftn.from;
			get_def_addr(system, addr, &aka);
		    } else {
			aka = MainAddress;
		    }
		    macro = xstrcpy(aka.domain);

		    break;
        
		case m_old_fromName:
		    macro = xstrcpy(old_ftn.fromName);
		    break;
        
		case m_old_from:
		    macro = xstrcpy(addr_to_str_200(old_ftn.from));
		    break;

		case   m_old_toName:
		    macro = xstrcpy(old_ftn.toName);
		    break;

		case   m_old_to:
	            macro = xstrcpy(addr_to_str_200(old_ftn.to));
	            break;

	    	case   m_old_Time:
		    macro = xstrcpy(old_ftn.DateTime);
		    break;

		case m_old_Attributes: {
		    char cattr[256];
		    get_attr(cattr);
		    macro = xstrcpy(cattr);
		    break;
		}

		case m_old_Subject:
		    macro = xstrcpy(old_ftn.subject);
		    break;

		case m_old_lineCount:
		    macro = (char *)xmalloc(100);
		    sprintf(macro, "%u", old_ftn.lines);
		    break;

		case m_old_msgLength:

		    macro = (char *)xmalloc(100);
		    sprintf(macro, "%u", (unsigned)old_ftn.msglen);
		    break;

		case m_old_intlFrom:
		    strcpy(buf, old_ftn.intl);
		    get_next_word(buf, w1);
		    macro = xstrcpy(buf);
		    break;

		case m_old_intlTo:
		    strncpy(buf, old_ftn.intl, 99);
		    macro = (char *)xmalloc(100);
		    macro[0] = '\0';
		    get_next_word(buf, macro);
		    break;

		case m_old_msgidFrom:
		    macro = xstrcpy(old_ftn.msgid);
		    break;

		case m_old_replyTo:
		    macro = xstrcpy(old_ftn.reply);
		    break;

		case m_old_routeTo:
		    macro = xstrcpy(addr_to_str_200(old_ftn.routeTo));
		    break;

		case m_old_toDomain:
		    if ((system = areaname_to_system_200(CurMsg.areaname))) {
			addr = old_ftn.to;
			get_def_addr(system, addr, &aka);
		    } else {
			aka = MainAddress;
		    }
		    macro = xstrcpy(aka.domain);

		    break;

		case m_old_fromDomain:
		    if ((system = areaname_to_system_200(CurMsg.areaname))) {
			addr = old_ftn.from;
			get_def_addr(system, addr, &aka);
		    } else {
			aka = MainAddress;
		    }
		    macro = xstrcpy(aka.domain);

		    break;

		case m_pktFrom:
		    if (CurMsg.type == PKT && CurMsg.pkt.icur != -1)
			macro = xstrcpy(addr_to_str_200(CurMsg.pkt.from));
		    else if (CurMsg.type == BINK)
			macro = xstrcpy(addr_to_str_200(CurMsg.bink.from));
		    break;

		case m_pktTo:
		    if (CurMsg.type == PKT && CurMsg.pkt.icur != -1)
			macro = xstrcpy(addr_to_str_200(CurMsg.pkt.to));
		    else if (CurMsg.type == BINK)
			macro = xstrcpy(addr_to_str_200(CurMsg.bink.to));
		    break;

		default:
		    break;
	    }
	    if (macro) {
		free (*p);
		*p = macro;
		rc = Ok;
	    }
	    break;
	}
    }
    
    if (rc == Fail) {
	for (tmpMacro = MacroFirst; tmpMacro; tmpMacro = tmpMacro->next) {
	    if (!stricmp(tmpMacro->macrotag, *p)) {
	    	*p = (char*)xcalloc(strlen(tmpMacro->macroname)+1, sizeof(char));
	    	strcpy(*p, tmpMacro->macroname);
	    	rc = Ok;
		break;
	    }
	}
	if (rc == Fail) {
	    writeToLog(0, "macro not yet implemented: `%s'", *p );
	}
    }
	
    return rc;
}

/***************************************/
int get_global_var_200(char **p)
{
	struct _gv *gv;

	if (p==NULL || *p==NULL)
		return Fail;

	for (gv = GlobalVarList; gv; gv = gv->next)
	{
		if (gv->var && !stricmp(gv->var, *p)) {
			free (*p);
			*p = xstrcpy (gv->val);
			return Ok;
		}
	}
	return Fail;
}

int _expand_str(char *tpl, char** str)
{
	char *new_s=NULL;
	char *s, *pl, *pr, *macro=NULL;
	int rc = 0, rc0;

	if (str==NULL || *str == NULL)
		return 0;


	s = *str;
	
	while (*s)
	{
		if (NULL == (pl = strstr(s, tpl)))
			break;
		if (NULL == (pr = strstr(pl+strlen(tpl), tpl)))
			break;
		
		s[pl-s] = '\0';
		s[pr-s] = '\0';
		
		new_s = xstrcat (new_s, s);

		s = pl + strlen (tpl);
		
		macro = xstrcpy (s);
		
		if (!strcmp (tpl, "%"))
			rc0 = get_env_200 (&macro);
		else
			rc0 = 0;

		if (rc0 == 0)
			rc0 = get_macro_200 (&macro);

		if (rc0 == 0)
			rc0 = get_global_var_200 (&macro);

		if (rc0 == 0)
			new_s = xstrcat (new_s, tpl);
		
		new_s = xstrcat (new_s, macro);
		
		free (macro);
		
		if (rc0 == 0)
			new_s = xstrcat (new_s, tpl);

		if (rc0)
			rc = 1;
		
		s = pr + strlen (tpl);
	}
	
	new_s = xstrcat (new_s, s);
	
	free (*str);
	*str = new_s;
	return rc;
}

void expand_str_200(char** s)
{
	int cnt=0, rc;
/*	char* new_s; */
	
	if (s == NULL || *s == NULL)
		return;
	
	do {
		rc = _expand_str("%", s);
	} while (rc && cnt++ < 10);
	
	do {
		rc = _expand_str("%%", s);
	} while (rc && cnt++ < 10);
	
	return;
}
