
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/* used in msg.c */
BOOL write_binkout_OIP( char *areatag, FTN Ftn, TEXT *Text);
BOOL read_FLO(char *areaname, char *FLO_name, PKT_AREA *pkt);
BOOL read_FLO_msg(PKT_AREA *pkt, TEXT **t, FTN *ftn);
void update_FLO(char *fname, PKT_AREA pkt);

/* used in msg.c */
PKT_HDR make_pkt_header(FTN Ftn, ADDR aka, char *areatag);

void select_bink_area(char *areapath, PKT_AREA *);

void bnk_to_bsy(char *s, char *bsy);

word bname_to_flv(char *FLO_name);
void strip_path(char *s);

void chop_fname(char *s);

/* pkt.h */
dword WritePktHdr(int handle, PKT_HDR *pkt_hdr);
dword WritePktMsgHdr(int handle, struct pkt_msg_hdr *pkt_msg_hdr);


/* defined in time.c */
extern void    make_DateTime(char *msgtime);

extern void    add_via(TEXT **text, ADDR fromAddr);
extern TEXT *  make_msgtext_hdr(FTN *f, BOOL isEcho);


static char    get_flavor_OUT( word flavor );
static char    get_flavor_FLO( word flavor );
static void    fetch_password(FTN Ftn, char *areatag, char *password);
static void    addr_to_passw(struct PassAddrTags * tag, ADDR addr, char *password);
/* static void    name_to_passw(struct PassNameTags * tag, char *name, char *password); */
static BOOL    write_FIF(FTN *Ftn, char *toFile);
static BOOL    write_IR(FTN *Ftn, char *toFile);
static BOOL    binkarea_to_passwtag(char *areatag, char *passw_tag);
static BOOL    pktarea_to_passwtag(char *areatag, char *passw_tag);
static BOOL    get_oip_name(ADDR to, ADDR from, char flv, char mode,
														char *areapath, char *fname);
static void    add_to_oipcache(ADDR to, ADDR from, char flv, char mode,
															char *areapath, char *fname);
static BOOL    make_new_oip_name(char *areapath, char flv, char mode,
																char *fname);
static void    search_dir(char *patt, struct Pktnames **b, int *total);
static BOOL    is_valid_name(char *name);
static BOOL    is_valid_zdir(char *name);
static BOOL    is_valid_mzdir(char *s);
static BOOL    is_known_domain(char *d);
/* static BOOL    is_multidomain(char *areaname); */
static void    floname_to_addr(char *buf, ADDR *addr);
char *stristr(char *str1, char *str2);

typedef struct short_ADDR {
	word zone, net, node, point;
} sADDR;


static int BSOtype;

/*************************************************************************/
void select_bink_area(char *areapath, PKT_AREA *pkt)
{
    struct Pktnames *b = NULL;
    int done, total = 0;
    char z[256], s[256], f[256];
    struct find_t z_blk, pnt_blk;
    BOOL mdomain = No, nmz = No;
    struct BinkAreas *BinkArea;

    for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea ->next ) {
	if (!stricmp(areapath, BinkArea->path)) {
	    mdomain = BinkArea->multi_domain;
	    nmz = BinkArea->no_main_zone;
	    BSOtype = BinkArea->type;
	}
    }

    if (BSOtype == tBRAKE) {

        sprintf (s, "%s*.Mail", areapath);
        search_dir(s, &b, &total);
        sprintf (s, "%s*.List", areapath);
        search_dir(s, &b, &total);

    } else if (BSOtype == tAMIGA4D) {
    
	sprintf (s, "%s*.?ut", areapath);
	search_dir(s, &b, &total);
	sprintf (s, "%s*.?lo", areapath);
	search_dir(s, &b, &total);
	
    } else if (!mdomain) {

	areapath[strlen(areapath)-1] = '\0';
	if (areapath[strlen(areapath)-1] == '.') areapath[strlen(areapath)-1] = '\0';
	
	if (nmz) {
	    sprintf(z, "%s.*", areapath);
	} else {
	    sprintf(z, "%s", areapath);
	}
	    
	writeToLog(4, "select_bink: search for zonedir (nomultid): `%s'", z);
	done = _dos_findfirst(z, _A_SUBDIR, &z_blk);

	chop_fname(z);
	for( ; !done; done = _dos_findnext(&z_blk)) {
	    if (!(z_blk.attrib & _A_SUBDIR)) continue;
			
	    if (nmz && NULL == strrchr(z_blk.name, '.')) {
		writeToLog(4, "select_bink: not nmz-compliant zdir `%s'\n", z_blk.name);
		continue;
	    }
			
	    if (!is_valid_zdir(z_blk.name)) {
		writeToLog(4, "select_bink: not valid zdir `%s'\n", z_blk.name);
		continue;
	    }
			
	    writeToLog(4, "select_bink: valid zdir found `%s'\n", z_blk.name);
		
	    sprintf(s, "%s%s%c*.?ut", z, z_blk.name, DELIM);
	    search_dir(s, &b, &total);
	
	    sprintf(s, "%s%s%c*.?lo", z, z_blk.name, DELIM);
	    search_dir(s, &b, &total);

	    /* pnt level */
	    sprintf(s, "%s%s%c*.pnt", z, z_blk.name, DELIM);

	    done = _dos_findfirst(s, _A_SUBDIR, &pnt_blk);
	    chop_fname(s);
	    for (; !done; done = _dos_findnext(&pnt_blk)) {
		if (!(pnt_blk.attrib & _A_SUBDIR)) continue;
				
		sprintf(f, "%s%s%c*.?ut", s, pnt_blk.name, DELIM);
		search_dir(f, &b, &total);
			
		sprintf(f, "%s%s%c*.?lo", s, pnt_blk.name, DELIM);
		search_dir(f, &b, &total);
	    }
	    _dos_findclose(&pnt_blk);
	} /* loop */
	_dos_findclose(&z_blk);
    }   /* !multidomain */
	else {
		
	/* domain level */
	if (nmz) sprintf(z, "%s*.???", areapath);
	else sprintf(z, "%s*", areapath);

	writeToLog(4, "select_bink: search for zonedir (multid): `%s'\n", z);
	done = _dos_findfirst(z, _A_SUBDIR, &z_blk);
	chop_fname(z);
	for( ; !done; done = _dos_findnext(&z_blk)) {
	    if (!(z_blk.attrib & _A_SUBDIR)) continue;
			
	    if (!is_valid_mzdir(z_blk.name)) {
		writeToLog(4, "select_bink: multid, not valid mzdir `%s'\n", z_blk.name);
		continue;
	    } else {
		writeToLog(4, "select_bink: multid, valid mzdir found `%s'\n", z_blk.name);
	    }

	    sprintf(s, "%s%s%c*.?ut", z, z_blk.name, DELIM);
	    search_dir(s, &b, &total);
			
	    sprintf(s, "%s%s%c*.?lo", z, z_blk.name, DELIM);
	    search_dir(s, &b, &total);
			
	    sprintf(s, "%s%s%c*.pnt", z, z_blk.name, DELIM);
	    done = _dos_findfirst(s, _A_SUBDIR, &pnt_blk);
	    chop_fname(s);
	    for (; !done; done = _dos_findnext(&pnt_blk)) {

		if (!(pnt_blk.attrib & _A_SUBDIR)) continue;
				
		sprintf(f, "%s%s%c*.?ut", s, pnt_blk.name, DELIM);
		search_dir(f, &b, &total);
			
		sprintf(f, "%s%s%c*.?lo", s, pnt_blk.name, DELIM);
		search_dir(f, &b, &total);
	    }
	    _dos_findclose(&pnt_blk);
	}
	_dos_findclose(&z_blk);
    }   /* multidomain */
	
    pkt->fnames = b;
    pkt->total = total;
    pkt->icur = 0;
    
    return;
}
/****************************************************/
static void search_dir(char *patt, struct Pktnames **b, int *total)
{
    struct find_t ffblk;
    int done, n = *total;
    struct Pktnames *f = *b;

    writeToLog(4, "search_dir: search for filepattern `%s'\n", patt);
	
    done = _dos_findfirst(patt, 0, &ffblk);

    chop_fname(patt);

    for( ; !done; done = _dos_findnext(&ffblk)) {
	if (is_valid_name(ffblk.name) && ffblk.size ) {

	    writeToLog(5, "search_dir: found bink file `%s'\n", ffblk.name);
	    if (!f) f = (struct Pktnames *)malloc(sizeof(struct Pktnames));
	    else f = (struct Pktnames *)realloc(f, (n+1)*sizeof(struct Pktnames));

	    strcpy(f[n].fname, patt);
	    strcat(f[n++].fname, ffblk.name);
			
	}
    }

    *b = f;
    *total = n;
	
    return;
}

/****************************/
static BOOL is_valid_name(char *name)
{
	if (BSOtype == tBRAKE || BSOtype == tAMIGA4D) {
	}
	else {
		if (strlen(name) != 12) {
			return Fail;
		}
	
		while(*name && *name!='.')
			if (!isxdigit(*name++))
				return Fail;
	}

	return Ok;
	
}
/********************************/
static BOOL is_valid_zdir(char *s)
{
	char *p;
	
	if (NULL != (p = strrchr(s, '.'))) {
		++p;
		if (strlen(p) != 3)
			return Fail;
		return (isxdigit(p[0]) && isxdigit(p[1]) && isxdigit(p[2]));
	}
	
	return Ok;
}
/********************************/
static BOOL is_valid_mzdir(char *s)
{
	char *p;
	BOOL extOk = Yes, domainOk;
	char domain[128]={0};

	p = strrchr(s, '.');  

	if (p) {

		strncpy(domain, s, p-s);
		
		if (strlen(++p) != 3)
			return Fail;
		
		extOk = isxdigit(p[0]) && isxdigit(p[1]) && isxdigit(p[2]);
	}
	else
	strncpy(domain, s, 127);

	domainOk = is_known_domain(domain);
	return domainOk && extOk;
}

/**********************************/
static BOOL is_known_domain(char *d)
{
/*	char buf[256]; */

	struct SystemTags *SystemTag = NULL;
	struct System *sys = NULL;

	for( SystemTag = SystemTagFirst; SystemTag; SystemTag = SystemTag->next )
		for( sys = SystemTag->recfirst; sys; sys = sys->next )
			if (!stricmp(sys->domain, d)) {
				writeToLog(5, "is_known_domain: known domain `%s'\n", d);
				return Ok;
			}
	
	writeToLog(5, "is_known_domain: unknown domain `%s'\n", d);
	return Fail;
}


/******************************/
void chop_fname(char *s)
{
	char *p;
	if (NULL != (p = strrchr(s, DELIM)))
		s = p + 1;
	*s = '\0';
	return;
}
/*****************************************/
/*
static BOOL is_multidomain(char *areaname)
{
	struct BinkAreas *BinkArea = NULL;
	
	for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea ->next )
		if (!stricmp(areaname, BinkArea->name))
			return BinkArea->multi_domain;
	
	return No;
}
*/

/****************************************************************************/
BOOL write_binkout_OIP( char *areatag, FTN Ftn, TEXT *Text)
{
	int h; /* hdr */
	char buf[256], system[20], toPath[128], OIP_name[128], toFile[256];
	char outdir[128], c, s[256], flv;
	dword len;
	ADDR aka;
	PKT_HDR hdr;
	struct pkt_msg_hdr pkt;

	areaname_to_path(areatag, toPath);
	areaname_to_system(areatag, system);
	get_def_addr( system, Ftn.routeTo , &aka );
	
	
	strncpy( outdir , toPath , 123 ); outdir[123] = 0;
	if ( outdir[strlen(outdir)-1] == DELIM) {
		outdir[strlen(outdir)-1] = '\0';
	}
	strcat( outdir , ".itx" );
/*	strUpper( outdir ); */
	fix_path( outdir );
	
	
	/* process fileattach */
	if ( (Ftn.attr & a_File) && !(Ftn.stat & i_Ignoreattach) ) {

		char FIF_name[256];

		flv = get_flavor_FLO(Ftn.flavor);
		
		if (Fail == get_oip_name(Ftn.routeTo, aka, flv, 'f', outdir, FIF_name))
			return Fail;
		
		sprintf(toFile, "%s%c%s", outdir, DELIM, FIF_name);
		
		(void)write_FIF(&Ftn, toFile);

		strcpy (OutFileName, toFile);
		
	} /* fileattach */
	
	/* process FREQ */
	if (Ftn.attr & a_Request) {

		char IR_name[256];

		if (Fail == get_oip_name(Ftn.routeTo, aka, '\0', '\0', outdir, IR_name))
			return Fail;
		
		sprintf(toFile, "%s%c%s", outdir, DELIM, IR_name);
		
		(void)write_IR(&Ftn, toFile);
		
		strcpy (OutFileName, toFile);
		
	} /* FREQ */
	

	if ((Ftn.stat & i_Dummyattach))
		return Ok;
	

	flv = get_flavor_OUT(Ftn.flavor);

	if (Fail == get_oip_name(Ftn.routeTo, aka, flv, 'p', outdir, OIP_name))
		return Fail;

	sprintf(toFile, "%s%c%s", outdir, DELIM, OIP_name);
	
	if( -1 == (h = open(toFile, O_CREAT|O_APPEND|O_RDWR|O_BINARY, ACCFILE))) {
		perror(toFile);
		fprintf(stderr, "\7writeOIP: error opening pkt file: `%s'\n", toFile);
		writeToLog(0, "writeOIP: error opening pkt file: `%s'\n", toFile);
		return Fail;
	}
	
	hdr = make_pkt_header(Ftn, aka, areatag);
	
	if (0L == filelength(h)) {
		len = PKT_HDR_SIZE;
		if ( len != WritePktHdr( h , &hdr) ) { /* write PKT hdr */
			sprintf(buf, "writeOIP: error writing target file `%s'\n", toFile);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			close(h);
			return Fail;
		}
		addr_to_str( Ftn.routeTo , s );
		writeToLog(1, "   %s created for %s\n", OIP_name, s );
	}

	pkt.type = 0x2;
	pkt.cost = 0;
	pkt.attr = Ftn.attr;

	/* from whom message */
	pkt.fromNode = Ftn.from.node;
	pkt.fromNet  = Ftn.from.net;
	
	/* to whom message */
	pkt.toNode   = Ftn.to.node;
	pkt.toNet    = Ftn.to.net;

	strcpy(pkt.DateTime, Ftn.DateTime);
	
	len = PKT_MSG_HDR_SIZE;
	if ( len != WritePktMsgHdr( h , &pkt) ) {  /* write msg header */
		sprintf(buf, "writeOIP: error writing target file `%s'\n", toFile);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		close(h);
		return Fail;
	}
	
	strncpy( s , Ftn.toName , 35 ); s[35] = '\0';
	len = strlen(s) + 1;
	if ( len != write( h , s , len ) ) {
		writeToLog(0, "writeOIP: error writing target file `%s'\n", toFile);
		close(h);
		return Fail;
	}
	strncpy( s , Ftn.fromName , 35 ); s[35] = '\0';
	len = strlen(s) + 1;
	if ( len != write( h , s , len ) ) {
		writeToLog(0, "writeOIP: error writing target file `%s'\n", toFile);
		close(h);
		return Fail;
	}
	strncpy( s , Ftn.subject , 71 ); s[71] = '\0';
	len = strlen(s) + 1;
	if ( len != write( h , s , len ) ) {
		writeToLog(0, "writeOIP: error writing target file `%s'\n", toFile);
		close(h);
		return Fail;
	}
	
	/* write message text */
	for( ; Text; Text = Text->next)
	{
		len = strlen(Text->str);
		if ( len != write(h, Text->str, len) ) {
			writeToLog(0, "writeOIP: error writing target file `%s'\n", toFile);
			close(h);
			return Fail;
		}
	}
	c = '\0';
	write( h , &c , 1L ); /* end of pkt message (1 zero char) */

	/* TWO ENDING ZEROES ARE NOT ADDED HERE ! */

	close(h);
	
/*	writeToLog(1, "   written to Bundle %s\n", strUpper(areatag)); */
	writeToLog(1, "   written to Bundle %s\n", areatag);
	
	strcpy (OutFileName, toFile);
	
	return Ok;
}

/**********************************************************************/
static char get_flavor_OUT( word flavor )
{
	if (flavor & flv_Hold)
		return 'h';
	else if ( flavor & flv_Imm)
		return 'i';
	else if ( flavor & flv_Crash)
		return 'c';
	else if ( flavor & flv_Dir)
		return 'd';
	else
		return 'o';
}
/**********************************************************************/
static char get_flavor_FLO( word flavor )
{
	
	if (flavor & flv_Hold)
		return 'h';
	else if ( flavor & flv_Imm)
		return 'i';
	else if ( flavor & flv_Crash)
		return 'c';
	else if ( flavor & flv_Dir)
		return 'd';
	else
		return 'f';
}

/****************************************************/
PKT_HDR make_pkt_header(FTN Ftn, ADDR aka, char *areatag)
{
#ifdef DOS
	struct dosdate_t d;
	struct dostime_t t;
#else
	time_t t;
	struct tm *ttm;
#endif
	char password[9]={0}, passw_tag[20]={0};
	PKT_HDR hdr;
	
	memset(&hdr, 0, PKT_HDR_SIZE);
	
	if (Ok == binkarea_to_passwtag(areatag, passw_tag) ||
			Ok == pktarea_to_passwtag(areatag, passw_tag) )
		(void)fetch_password(Ftn, passw_tag, password);
	
	/* to whom packet */
	hdr.toZone   = (word) Ftn.routeTo.zone;
	hdr.toNet    = (word) Ftn.routeTo.net;
	hdr.toNode   = (word) Ftn.routeTo.node;
	hdr.toPoint  = (word) Ftn.routeTo.point;
	
	/* from whom packet */
	hdr.fromZone   = (word) aka.zone;
	
	if (aka.point == 0)
		hdr.fromNet  = (word) aka.net;
	else {
		hdr.fromNet  = 0xffff;
		hdr.AuxNet   = (word) aka.net;
	}
	
	hdr.fromNode   = (word) aka.node;
	hdr.fromPoint  = (word) aka.point;
#ifdef DOS
	_dos_getdate(&d);
	hdr.year   = (word) d.year;
	hdr.month  = (word) (d.month - 1);
	hdr.day    = (word) d.day;

	_dos_gettime(&t);
	hdr.hour   = (word) t.hour;
	hdr.minute = (word) t.minute;
	hdr.second = (word) t.second;
#else
	t = time(NULL);
	ttm = gmtime(&t);
	hdr.year   = (word) ttm->tm_year+1900;
	hdr.month  = (word) ttm->tm_mon;
	hdr.day    = (word) ttm->tm_mday;

	hdr.hour   = (word) ttm->tm_hour;
	hdr.minute = (word) ttm->tm_min;
	hdr.second = (word) ttm->tm_sec;
#endif
	hdr.baud    = (word) 0;
	hdr.pktType = (word) 0x2;

	/* password */
	memset(hdr.password, 0, 8);
	memcpy(hdr.password, password, strlen(password));
	
	hdr.QtoZone    = (word) hdr.toZone;
	hdr.QfromZone  = (word) hdr.fromZone;

	/* other stuff */
	hdr.prodCodeL = (char) ProdCode; /* (global var) */
	hdr.prodCodeH = (char) 0;
	hdr.verMajor  = (char) VerMajor; /* (global var) */
	hdr.verMinor  = (char) VerMinor; /* (global var) */
	hdr.CapWord   =  0x0001;         /* CW           */
	hdr.CapWordS  =  0x0100;         /* CW swapped   */
	hdr.prodData  = (dword) 0;
	
	return hdr;
}
/**********************************************************/
static void fetch_password(FTN Ftn, char *passw_tag, char *password)
{
	struct PassAddrTags *PassAddrTag = PassAddrTagFirst;
/*	char buf[256]; */
	
	memset(password, 8, 0);
	
	for( ; PassAddrTag; PassAddrTag = PassAddrTag->next )
	{
		writeToLog(4, "fetch_passw: passaddr tag search, compare `%s' and `%s'\n",
						passw_tag, PassAddrTag->tag);
		
		if (!stricmp(passw_tag, PassAddrTag->tag)) {
			writeToLog(4, "fetch_passw: PasswordAddress tag found: `%s'\n", passw_tag);
			(void)addr_to_passw(PassAddrTag, Ftn.routeTo, password);
			return;
		}
	}
	
/*
	PassNameTag = PassNameTagFirst;
	for( ; PassNameTag; PassNameTag = PassNameTag->next )
	{
		sprintf(buf, "fetch_passw: passname tag search, compare `%s' and `%s'\n",
						passw_tag, PassNameTag->tag);
		writeToLog(4, buf);
		if (!stricmp(passw_tag, PassNameTag->tag)) {
			sprintf(buf, "fetch_passw: PasswordName tag found: `%s'\n", passw_tag);
			writeToLog(4, buf);
			(void)name_to_passw(PassNameTag, Ftn.toName, password);
			return;
		}
	}
*/
	writeToLog(0, "fetch_password error: can`t find password data block `%s' for current binkarea\n",
					passw_tag);
	
	return;
	
}
/*****************************************************************************/
static void addr_to_passw(struct PassAddrTags * tag, ADDR addr, char *password)
{
	char caddr1[128], caddr2[128];
	
	
	for(tag->rec = tag->recfirst; tag->rec; tag->rec = tag->rec->next )
	{
		addr_to_str(addr, caddr1);
		addr_to_str(tag->rec->addr, caddr2);
		writeToLog(4, "addr->passw: compare `%s' and `%s'\n", caddr1, caddr2);
		
		if (addr_cmp(tag->rec->addr, addr)) {
			strcpy(password, tag->rec->password);
			writeToLog(4, "addr->passw: got password `%s' for addr `%s'\n", password, caddr1);
			return;
		}
	}
	return;
}
/*****************************************************************************/
/*
static void name_to_passw(struct PassNameTags * tag, char *name, char *password)
{
//	char buf[256];
	
	for(tag->rec = tag->recfirst; tag->rec; tag->rec = tag->rec->next )
	{
		writeToLog(4, "name->passw: compare `%s' and `%s'\n",
						name, tag->rec->name);
		if (!stricmp(tag->rec->name, name)) {
			strcpy(password, tag->rec->password);
			writeToLog(4, "name->passw: got password `%s' for name `%s'\n", password, name);
			return;
		}
	}
	return;
}
*/
/************************************************/
static BOOL write_FIF(FTN *Ftn, char *toFile)
{
	int h;
	char buf[256], s[256];
	char fspec[256], new_subj[72]={0};
	char kill_flavor[2]={0};
	dword len;
	
	if ( Ftn->flag & f_Kfs )
		strcpy(kill_flavor, "^");
	else if ( Ftn->flag & f_Tfs )
		strcpy(kill_flavor, "#");


	if( -1 == (h = open(toFile, O_CREAT|O_APPEND|O_RDWR|O_BINARY, ACCFILE))) {
		sprintf(buf, "write_FIF: error opening file: `%s'\n", toFile);
		perror(toFile);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		return Fail;
	}
	
	if (0L == filelength(h)) {

		len = sizeof(sADDR);
		if ( len != write(h, &Ftn->routeTo, len) ) {
			writeToLog(0, "write_FIF: error writing target file `%s'\n", toFile);
			close(h);
			return Fail;
		}
		
		addr_to_str( Ftn->routeTo , s );
		writeToLog(1, "   %s created for %s\n", toFile, s );
		
	}
	
	
	strcpy(buf, Ftn->subject);
	while(get_next_word(buf, s))
	{
		writeToLog(1, "   FIF : %s%s\n", kill_flavor, s );
		sprintf(fspec, "%s%s\r\n", kill_flavor, s);
		len = strlen(fspec);
		if ( len != write(h, fspec, len) ) {
			writeToLog(0, "write_FIF: error writing target file `%s'\n", toFile);
			close(h);
			return Fail;
		}
		if (strlen(new_subj))
			strcat(new_subj, " ");
		(void)strip_path(s);
		strcat(new_subj, s);
	}
	close(h);
	
	strcpy(Ftn->subject, new_subj);
	return Ok;
}
/************************************************/
static BOOL write_IR(FTN *Ftn, char *toFile)
{
	int h;
	char s[256], buf[256];
	char fspec[256];
/*	char new_subj[72]={0}; */
	dword len;
	
	
	if( -1 == (h = open(toFile, O_CREAT|O_APPEND|O_RDWR|O_BINARY, ACCFILE))) {
		sprintf(buf, "write_IR: error opening file: `%s'\n", toFile);
		perror(toFile);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		return Fail;
	}
	
	if (0L == filelength(h)) {

		len = sizeof(sADDR);
		if ( len != write(h, &Ftn->routeTo, len) ) {
			writeToLog(0, "write_IR: error writing target file `%s'\n", toFile);
			close(h);
			return Fail;
		}
		
		addr_to_str( Ftn->routeTo , s );
		writeToLog(1, "   %s created for %s\n", toFile, s );
		
	}
	
	
	strcpy(buf, Ftn->subject);
	while(get_next_word(buf, s))
	{
		writeToLog(1, "   IR : %s\n", s );
		sprintf(fspec, "%s\r\n", s);
		len = strlen(fspec);
		if ( len != write(h, fspec, len) ) {
			writeToLog(0, "write_IR: error writing target file `%s'\n", toFile);
			close(h);
			return Fail;
		}
/*
		if (strlen(new_subj))
			strcat(new_subj, " ");
		(void)strip_path(s);
		strcat(new_subj, s);
*/
	}
	close(h);
	
/*  strcpy(Ftn->subject, new_subj); */
	return Ok;
}
/***************************************************************/
static BOOL binkarea_to_passwtag(char *areatag, char *passw_tag)
{
	struct BinkAreas *BinkArea;
/*	char buf[256]; */
	for( BinkArea = BinkAreaFirst; BinkArea; BinkArea = BinkArea->next )
	{
		if ( !stricmp( BinkArea->name, areatag ) ) {
			strcpy(passw_tag , BinkArea->passw_tag);
			break;
		}
	}
	if (strlen(passw_tag)) {
		writeToLog(4, "binkarea_to_passwtag: password block `%s' found for binkarea `%s'\n",
						passw_tag, areatag);
		return Ok;

	}
	else {
		writeToLog(4, "binkarea_to_passwtag: no password block defined for binkarea `%s'\n", areatag);
		return Fail;
	}
}

/***************************************************************/
static BOOL pktarea_to_passwtag(char *areatag, char *passw_tag)
{
	struct PktAreas *PktArea;
/*	char buf[256]; */
	for( PktArea = PktAreaFirst; PktArea; PktArea = PktArea->next )
	{
		if ( !stricmp( PktArea->name, areatag ) ) {
			strcpy(passw_tag , PktArea->passw_tag);
			break;
		}
	}
	if (strlen(passw_tag)) {
		writeToLog(4, "pktarea_to_passwtag: password block `%s' found for binkarea `%s'\n",
						passw_tag, areatag);
		return Ok;

	}
	else {
		writeToLog(4, "pktarea_to_passwtag: no password block defined for binkarea `%s'\n", areatag);
		return Fail;
	}
}


/******************************/
void strip_path(char *s)
{
    char *p, *q = s;
	
    while(NULL != (p = strchr(q, DELIM))) q = p+1;
	
    if (*q) {
	memmove(s, q, strlen(q));
	s[strlen(q)] = '\0';
    } else {	
	*s = '\0';
    }
	
}
/********************************************************************/
static BOOL get_oip_name(ADDR to, ADDR from, char flv, char mode,
												char *areapath, char *fname)
{
	struct pktcache *cache = OipCache;
/*	char buf[256]; */

	if (mode != 'f' && mode != 'p' && mode != '\0') {
		fprintf(stderr, "get_oip_name: internal error #5534 (mode is not `P' or `F' or zero)\n");
		abort();
	}
	
	
	for( ; cache; cache = cache->next )
	{
		if (addr_cmp(cache->to, to) && 
				addr_cmp(cache->from, from) &&
				!stricmp(cache->areapath, areapath) &&
				cache->flavor == flv &&
				cache->mode == mode)
		{
			strcpy(fname, cache->fname);
			writeToLog(4, "get_oip_name: get name from cache, `%s'\n",
							fname);
			return Ok;
		}
	}
	
	if (Fail == make_new_oip_name(areapath, flv, mode, fname)) {
		writeToLog(4, "get_oip_name: fail to get a new name\n");
		return Fail;
	}
	

	writeToLog(4, "get_oip_name: add new name to cache, `%s'\n",
					fname);
	
	add_to_oipcache(to, from, flv, mode, areapath, fname);
	return Ok;
}

/****************************************************************/
static void add_to_oipcache(ADDR to, ADDR from, char flv, char mode,
														char *areapath, char *fname)
{
	struct pktcache *cache = OipCache;
	
	cache = (struct pktcache *)calloc(1, sizeof(struct pktcache));
	if (cache) {
		cache->next = NULL;
		/*******************/
		cache->to = to;
		cache->from = from;
		cache->flavor = flv;
		cache->mode = mode;     /* 'P' , 'F' , or zero */
		strcpy(cache->areapath, areapath);
		strcpy(cache->fname, fname);
		/*******************/
		if (OipCacheLast) {
			OipCacheLast->next = cache;
		}
		else {
			OipCache = cache;
		}
		OipCacheLast = cache;
	}
	
	return;
}

/******************************************************************/
static BOOL make_new_oip_name(char *areapath, char flv, char mode, char *fname)
{
	struct stat st;
	char fullname[256], ext[4];
	int i;
	
	if (mode)
		sprintf(ext, "%ci%c", flv, mode);
	else
		strcpy(ext, "ir");

	for(i = 0 ; i < 100; ++i)
	{
		
		sprintf(fname , "%08x.%s", (unsigned)get_MsgId(), ext );
		sprintf(fullname, "%s%s", areapath, fname);
		if (0 != stat(fullname, &st))
			return Ok;
	}
	
	writeToLog(6, "make_new_oip_name: get new name from %dth attempt\n", i);
	
	return Fail;
}

/************************************/
void bnk_to_bsy(char *s, char *bsy)
{
	char *p;
	
	strcpy(bsy, s);
	p = strrchr(bsy, '.');
	if (p) bsy[p-bsy] = '\0';
	
	strcat(bsy, ".bsy");

	return;
}

/************************************
void bnk_to_bsy(char *s, char *bsy)
{
	char *p;
	
	strcpy(bsy, s);
	p = strrchr(bsy, '.');
	if (p) bsy[p-bsy] = '\0';
		
	p = strrchr(bsy, '.');
	if (p) {
		if (stricmp (&p[1], "lo") && strcmp (&p[1], "ut"))
			bsy[p-bsy] = '\0';
	}

	strcat(bsy, ".bsy");

	return;
}*/

/****************************************/
BOOL read_FLO(char *areaname, char *FLO_name, PKT_AREA *pkt)
{
	int h;
	char buf[256], caddrTo[128], caddrFrom[128], system[20];
	dword len;
	
	strcpy(buf, FLO_name);
	floname_to_addr(buf, &pkt->to);

	(void)areaname_to_system(areaname, system);
	get_def_addr(system, pkt->to , &pkt->from);
	
	if( (h = open(FLO_name, O_RDONLY|O_BINARY)) == -1 ) {
		writeToLog(0, "read_FLO: error opening  file: `%s'\n", FLO_name);
		return  Fail;
	}

	len = filelength(h);

	if (pkt->text == NULL)
		pkt->text = (char *)malloc(len+1);
	else
		pkt->text = (char *)realloc(pkt->text, len+1);

	if (pkt->text == NULL) {
		writeToLog(0, "read_FLO: low_memo\n");
		close(h);
		return Fail;
	}
	
	if ( len != read( h, pkt->text, len ) ){
		writeToLog(0, "read_FLO: error reading FLO file: `%s'\n", FLO_name);
		close(h);
		return Fail;
	}
	
	pkt->text[len] = '\0';
	close(h);

	addr_to_str(pkt->from, caddrFrom);
	addr_to_str(pkt->to, caddrTo);
	
	writeToLog(1, "Opening ?LO `%s'  from %s to %s", FLO_name, caddrFrom, caddrTo);

	pkt->off  = 0L;
	pkt->off0 = 0L;
	pkt->new_off = 0L;
	pkt->len = len;
	
	return Ok;
}

/***************************************************/
BOOL read_FLO_msg(PKT_AREA *pkt, TEXT **t, FTN *ftn)
{
	char *p, *p0, *q, subj[72]={0};
	dword off = pkt->off;

	ftn->to = pkt->to;
	ftn->from = pkt->from;

	make_DateTime(ftn->DateTime);
	sprintf(ftn->fromName, "%s %s", ProdName, VER);
	strcpy(ftn->toName, "Sysop");
	ftn->attr = a_Private | a_Local | a_File;
	ftn->flag = 0;
	ftn->stat = i_Dummyattach;
	ftn->utime = time(NULL);
	ftn->routeTo = ftn->to;
	

	/* set flavor */
	ftn->flavor = bname_to_flv(pkt->fname);
	

	p = &pkt->text[off];
	p0 = p;

	q = subj;
	while(*p && *p!='\r' && *p!='\n')
	{
		*q++ = *p++;
		if ((q - subj) > 71)
			break;
	}
	
	q = subj;
	if (*q == '^') {
		ftn->flag |= f_Kfs;
		q++;
	}
	else if (*q == '#') {
		ftn->flag |= f_Tfs;
		q++;
	}

	strcpy(ftn->subject, q);

	if (*p=='\r' || *p=='\n')
		++p;
	if (*p=='\r' || *p=='\n')
		++p;
	
	off += p - p0;
	
	pkt->off0 = pkt->off;
	pkt->off = off;

	(*t) = make_msgtext_hdr(ftn, 0);
	(void) add_via(t, ftn->from);
	
	
	return Ok;
}

/*****************************************/
void update_FLO(char *fname, PKT_AREA pkt)
{
	int h;
/*	char buf[256]; */
	dword len;

	if( -1 == (h = open(fname, O_RDWR|O_BINARY, ACCFILE))) {
		perror(fname);
		writeToLog(0, "error opening ?LO file for updating (%s)\n", fname);
		return;
	}

	lseek(h, 0L ,SEEK_SET);
	setfsize(h, 0L);
	lseek(h, 0L ,SEEK_SET);
	
	if (pkt.off != (dword)-1L) {
		
		len = pkt.len - pkt.off;
		if ( len != write( h , &pkt.text[pkt.off], len ) ) { 
			writeToLog(0, "update_FLO, error writing file `%s'\n", fname);
		}
	}
	
	close(h);
	
	return;
}

/******************************************/
static void floname_to_addr(char *buf, ADDR *addr)
{
	char *p, *q;
	dword zone = -1, net = -1, node = -1, pnt = 0;
	dword defzone = (dword) MainAddress.zone;
	int i, n, pos;

/*	p = strchr (buf, DELIM);
	if (p)
		buf = p+1;
*/
	memset (addr, sizeof(ADDR), 0);

	if (BSOtype == tBRAKE) {
		if (NULL == (p = strrchr(buf, DELIM))) return;
		if (NULL == (p = strchr (buf, '.')))   return;
		sscanf (++p, "%lu.%lu.%lu.%lu", &zone, &net, &node, &pnt);
	}
	else if (BSOtype == tAMIGA4D) {
		if (NULL == (p = strrchr(buf, DELIM))) return;
		sscanf (++p, "%lu.%lu.%lu.%lu", &zone, &net, &node, &pnt);
	} else {

	
	    q = stristr(buf, ".pnt");

	    if (q) {
		while(*q != DELIM && q > buf) q--;
		if (*q == DELIM) buf = q;
	    } else {
		p = strrchr (buf, DELIM);
		if (p) buf = p;
	    }
	    
		for(i=0, p = strtok(buf, SEP); p; p = strtok(NULL, SEP), ++i)
		{
			if (i == 0) {
				q = strchr (p, '.');
				if (q == NULL) {
					zone = defzone;
					continue;
				}
				else if (zone == (dword)-1) {
					n = sscanf(++q, "%3lx%n", &zone, &pos);
					if (n==1 && pos==3) {
						continue;
					}
					else
						zone = (dword)-1;
				}
			}

			if (net == (dword)-1) {
				sscanf (p, "%4lx%4lx", &net, &node);
			}
			else {
				sscanf (p, "%8lx", &pnt);
			}
		}

	} /*tBINK*/
	
	if (zone == (dword)-1)
		zone = defzone;

	addr->zone = (word)zone;
	addr->net = (word)net;
	addr->node = (word)node;
	addr->point = (word)pnt;

	return;
}
/**********************************/
word bname_to_flv(char *FLO_name)
{
	word flavor = 0;
	char *p =  strrchr(FLO_name, '.');
	
	if (p) {
		
		int i = p - FLO_name + 1;

		if (FLO_name[i] == 'H' || FLO_name[i] == 'h')
			flavor = flv_Hold;
		else if (FLO_name[i] == 'C' || FLO_name[i] == 'c')
			flavor = flv_Crash;
		else if (FLO_name[i] == 'I' || FLO_name[i] == 'i')
			flavor = flv_Imm;
		else if (FLO_name[i] == 'D' || FLO_name[i] == 'd')
			flavor = flv_Dir;
	}

	return flavor;
	
}
