
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

BOOL parse_compress(char *fname);

static BOOL get_ident(char *buf, byte *ident, long *ioff, long *ilen);

static char err_diag[256];
static char *search_path(char *fname);


BOOL parse_compress(char *fname)
{
	FILE *h;
	char *p, s[256], buf[256], w[256], *path;
	char save_str[256];
	char ext[4]={0}, add[128]={0}, extract[128]={0}, view[128]={0};
	char archname[20], exe_name[128];
	struct Compress *Compress = NULL, *Last = NULL;
	long ioff = 0L, ilen = 0L;
	int ratio = 0;
	byte ident[256];
	BOOL in_arc = No;
	int kwolines = 0;

	h = fopen(fname, "r");
	if (h  == NULL) {
		sprintf(s, "can`t open compress config `%s'\n", fname);
		writeToLog(3, s);
		return Fail;
	}
	
	
	while (NULL != fgets(buf, 255, h))
	{
		++kwolines;
		strip_CRLF(buf);

		if (!strlen(buf)) continue;  /* empty line */

		
		p = strchr(buf, ';');        /* strip comments */
		if (p) {
			buf[p-buf] = '\0';
		}

		strip(buf);

		if (!strlen(buf)) {
			continue;            /* only comments */
		}
		
		strcpy(save_str, buf);       /* save original line */
		
		sprintf(err_diag, "%s -- line #%d,",  fname, kwolines);
		
/*    printf("\nnext string: `%s'\n", buf); */

		get_next_word(buf, w);
		if (!stricmp(w, "DOS")) {
#if !defined (__DOS__)
		    continue;
#endif
		    get_next_word(buf, w);
		}
				
		if (!stricmp(w, "OS2")) {
#if !defined (__OS2__)
		    continue;
#endif
		    get_next_word(buf, w);
		}

		if (!stricmp(w, "UNIX")) {
#if !defined (UNIX)
		    continue;
#endif
		    get_next_word(buf, w);
		}

		if (!strlen(buf)) {
			sprintf(s, "%s syntax error (empty argument): `%s'\n", err_diag, save_str);
			fprintf(stderr, "\7%s\n", s);
			writeToLog(0, s);
			fclose(h);
			abort();
		}
		
		/* STORE CURRENT PACKER */
		if (!stricmp(w, "End")) {

			
			if (!in_arc) {
				sprintf(s, "%s unexpected `End Archiver' found\n", err_diag);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
			
			
			Compress = (struct Compress *)calloc(1, sizeof(struct Compress));
			Compress->next  = NULL;
			/************************/
			strcpy(Compress->archname, archname);
			/************************/
			if (Last)
				Last->next = Compress;
			else
				CompressFirst = Compress;
			Last = Compress;

			if (strlen(ext))
				strcpy(Compress->arc.ext, ext);
			else {
				sprintf(s, "%s no `Extention' defined for `%s'\n", err_diag, archname);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}

			/* STORE ADD */
			if (strlen(add)) {
				strcpy(Compress->arc.add, add);
			}
			else {
				sprintf(s, "%s no `Add' defined for `%s'\n", err_diag, archname);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
			
			/* STORE EXTRACT */
			if (strlen(extract)) {
				strcpy(Compress->arc.extract, extract);
			}
			else {
				sprintf(s, "%s no `Extract' defined for `%s'\n", err_diag, archname);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
			
			/* STORE RATIO */
			Compress->arc.ratio = ratio;
			
#if 0
			/* STORE VIEW */
			if (strlen(view))
				strcpy(Compress->arc.view, view);
			else {
				sprintf(s, "%s no `View' defined for `%s'\n", err_diag, archname);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
#endif
			/* STORE IDENT */
			Compress->arc.ioff = ioff;
			Compress->arc.ilen = ilen;
			if (ilen)
				memcpy(Compress->arc.ident, ident, ilen);
			else {
				sprintf(s, "%s no `Ident' defined for `%s'\n", err_diag, archname);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
			in_arc = No;
		}
		/* START NEW ARCHIVER */
		else if (!stricmp(w, "Archiver")) {
			if (in_arc) {
				sprintf(s, "%s no `End Archiver' found for `%s'\n",
								err_diag, archname);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
/*			strset(ext, 0);
			strset((char *)ident, 0);
			strset(add, 0);
			strset(extract, 0);
			strset(view, 0);
			strset(archname, 0);
*/			ilen = 0L;
			ioff = 0L;
			ratio = 0;
			strncpy(archname, buf, 19); archname[19] = '\0';
			in_arc = Yes;
		}
		/* EXTENTION */
		else if (!stricmp(w, "extension")) {
			strncpy(ext, buf, 3);
			ext[3] = '\0';
		}
		/* IDENT */
		else if (!stricmp(w, "ident")) {
			if (!get_ident(buf, ident, &ioff, &ilen)) {
				sprintf(s, "%s Ident syntax: `%s'\n", err_diag, save_str);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
		}
		/* ADD */
		else if (!stricmp(w, "add")) {
			
			strncpy(add, buf, 127);
			add[127] = '\0';
			get_next_word(add, exe_name);
			path = search_path(exe_name);
			if (!path) {
				sprintf(s, "%s archiver not found in curdir or PATH: `%s'\n",
								err_diag, exe_name);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
			
			strcpy(s, add);
			sprintf(add, "%s %s", path, s);
				
			if (!strstr(add, "%a") || !strstr(add, "%f")) {
				sprintf(s, "%s %%a or %%f missing for `Add'\n", err_diag);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
		}
		/* EXTRACT */
		else if (!stricmp(w, "extract")) {
			strncpy(extract, buf, 127);
			extract[127] = '\0';
			get_next_word(extract, exe_name);
			path = search_path(exe_name);
			if (!path) {
				sprintf(s, "%s archiver not found in curdir or PATH: `%s'\n",
								err_diag, exe_name);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
			
			strcpy(s, extract);
			sprintf(extract, "%s %s", path, s);
				
			if (!strstr(extract, "%a") || !strstr(extract, "%f")) {
				sprintf(s, "%s %%a or %%f missing for `Extract'\n", err_diag);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
		}
		/* RATIO */
		else if (!stricmp(w, "ratio")) {
			float r;
			if (1 != sscanf(buf, "%f", &r)) {
				sprintf(s, "%s incorrect ratio `%s'\n", err_diag, buf);
				fprintf(stderr, "\7%s\n", s);
				writeToLog(0, s);
				fclose(h);
				abort();
			}
			ratio = (int)(r*10.0);
		}
		/* VIEW  -- not really used */
		else if (!stricmp(w, "view")) {
			strncpy(view, buf, 127);
			view[127] = '\0';
		}
		/* OTHER */
		else {
			sprintf(s, "%s unknown keyword: `%s'\n", err_diag, w);
			fprintf(stderr, "\7%s\n", s);
			writeToLog(0, s);
			fclose(h);
			abort();
		}
		
	}   /* file walk */

	if (in_arc) {
		sprintf(s, "%s unexpected end of file\n", err_diag);
		fprintf(stderr, "\7%s\n", s);
		writeToLog(0, s);
		fclose(h);
		abort();
	}
	
	fclose(h);
	

	for(Compress = CompressFirst; Compress; Compress = Compress->next)
	{
		int i;
		char a[3];
		sprintf(buf, "Archiver: %s\n", Compress->archname);
		writeToLog(5, buf);
		sprintf(buf, "                Ext:     %s\n", Compress->arc.ext);
		writeToLog(5, buf);
		sprintf(buf, "                Add:     %s\n", Compress->arc.add);
		writeToLog(5, buf);
		sprintf(buf, "                Extract: %s\n", Compress->arc.extract);
		writeToLog(5, buf);
		sprintf(buf, "                View:    %s\n", Compress->arc.view);
		writeToLog(5, buf);
		sprintf(buf, "                Ratio:   %d\n", Compress->arc.ratio);
		writeToLog(5, buf);
		sprintf(buf, "                Ident:   off=%d  ", (signed)Compress->arc.ioff);

		p = buf + strlen(buf);
		
		for(i = 0; i < Compress->arc.ilen; ++i)
		{
/*			itoa(Compress->arc.ident[i], a, 16); */
			sprintf(a, "%x", Compress->arc.ident[i]);
			strcat(buf, a);
			strcat(buf, " ");
		}
		strcat(buf, "\n");
		writeToLog(5, buf);

	}

	return Ok;
}

/************************************************************/
static BOOL get_ident(char *buf, byte *ident, long *ioff, long *ilen)
{
	char s[256]={0}, *p;
	int i = 0, b;
	long io;
	
	if (2 != sscanf(buf, "%ld,%s", &io, s))
		return Fail;

	p = s;
	while(*p) {
		sscanf(p, "%2x", &b);
		ident[i++] = (byte) b;
		++p;
		if (*p)
			++p;
	}

	*ilen = i;
	*ioff = io;

	return Ok;
}

/************************************/
static char *search_path(char *fname)
{
	char *p;
/*	struct find_t ffblk; */
#if !defined UNIX
	static char buf[256];
#endif

	if (NULL  == (p = strrchr(fname, DELIM)))
		p = fname;

#ifndef UNIX	
	if (!strchr(p, '.'))
		strcat(fname, ".exe");

#endif

	if (!access(fname, 0)) {

#if defined __MINGW32__
		return _fullpath(buf, fname, 255);
#elif defined EMX
		_fullpath(buf, fname, 255);
		return (char*)buf;
#endif
	    return fname;
	}
	
#ifdef __BORLANDC__
	return searchpath(fname);
#else  
/*	_searchenv(fname, "PATH", buf);
	return strlen(buf) ? buf : NULL;
*/	return NULL;
#endif

}
