
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void config(char *path, char *cfg_name);
BOOL def_keyword(char *keyword, char *data, char *err);

extern BOOL is_full_path(char *p);
extern BOOL parse_compress(char *fname);
extern void open_log(void);
int def_echoarea (char *s, int isbad, char *err);

extern void defFidoArea(char *str, char *err_diag);
extern void defBinkArea(char *str, char *err);
extern void defSquishArea(char *str, char *err_diag);
extern void defTextArea(char *str, char *err_diag);
extern void defPktArea(char *str, char *err_diag);
extern void defJamArea(char *str, char *err_diag);


static BOOL parse_keyword(int kto, char *buf, char *err);
/* static int check_data_type(char *type); */
static BOOL is_unique_tag(char *tag);

static void add_to_loginclude(char *s, char *err);
static void add_to_logexclude(char *s, char *err);

enum { MAIN_ADDRESS = 0,
	DATA,
	END_DATA,
	LOGFILE,
	TEMPLATEPATH,
	TIMEZONE,
	SHARING,
	DEBUG,
	FIDOAREA,
	BINKAREA,
	SQUISHAREA,
	TEXTAREA,
	PKTAREA,
	JAMAREA,
	CHAT,
	IGNOREBSY,
	FLAGDIR,
	TOUCHECHOMAIL,
	USEREGEXP,
	COMPRESSFILE,
	LOGINCLUDE,
	LOGEXCLUDE,
	RXIGNORECASE,
	TIMESTAMPPATH,
	DUPEBASEPATH,
	DUPESMAXOPEN,
	DUPESMAXMSG,
	ECHOAREA,
	BADAREA,
	LOCKFILE,
	INTAB,
	OUTTAB,
	SEQDIR,
	SEQOUTRUN
};

/* defines are in enum.h */
char *key[] = {
		"MAINADDRESS" ,
		"DATA" ,
		"#END#" ,
		"LOGFILE" ,
		"TEMPLATEPATH" ,
		"TIMEZONE" ,
		"SHARING" ,
		"DEBUG" ,
		"FIDOAREA" ,
		"BINKAREA" ,
		"SQUISHAREA" ,
		"TEXTAREA" ,
		"PKTAREA",
		"JAMAREA",
		"CHAT",
		"IGNOREBSY",
		"FLAGDIR",
		"TOUCHECHOMAIL",
		"USEREGEXP",
		"COMPRESSFILE",
		"LOGINCLUDE",
		"LOGEXCLUDE",
		"RXIGNORECASE",
		"TIMESTAMPPATH",
		"DUPEBASEPATH",
		"DUPESMAXOPEN",
		"DUPESMAXMSG",
		"ECHOAREA",
		"BADAREA",
		"LOCKFILE",
		"INTAB",
		"OUTTAB",
		"SEQDIR",
		"SEQOUTRUN",
		"" };


char err_diag[256];
char buf[256], buf2[256], savestr[256], ctype[256];
char tag[20], arg1[128];


/*************************************************************************/
void config(char *path, char *cfg_name)
{

	FILE *h;  /* our config */

	char *c = NULL, *full_cfg_name;
	int i, kto = -1, kwolines;
	static BOOL data_defined = No, indata = No;
	static int cnt, blocktype, rec_lev;
	dword off;

	++rec_lev;
	
	if (++cnt == 300) {
		strcpy(buf2, "Stack overflow\n");
		writeToLog(0, buf2);
		printf("\n\7%s", buf2);
		abort();
	}
	
	full_cfg_name = (char *)malloc(256);
		
	sprintf(full_cfg_name, "%s%s", path, cfg_name);
	
	h = fopen(full_cfg_name, "rb");
	
	if (h  == NULL) {
		strcpy(full_cfg_name, cfg_name);
		h = fopen(full_cfg_name, "rb");
	}
	
	if (h  == NULL) {
		sprintf(buf2, "config file `%s' not found, rely on defaults\n",
			cfg_name);
		writeToLog(1, buf2);
		return;
	}

	
	if( Chat_On )
		printf("reading configuration file `%s'\n", cfg_name);
	
	
	
	kwolines = 0;

	while (!feof(h))
	{
		memset(&buf, 0, 256);
		fgets(buf, 255, h);
		++kwolines;
		
		if (strlen(buf) < 3) continue; /* too short to parse */
		
		strip_CRLF(buf);
		

		if (!strlen(buf)) continue;  /* empty line */

/*    strcpy(savestr, buf);  // save original line */
		
		c = strchr(buf, ';'); /* strip comments */
		while(c && c>buf)
		{
			if (*(c-1) != '\\')
				break;
			c = strchr(++c, ';');
		}

		if (c)
			buf[c-buf] = '\0';


		if (!strlen(buf)) {
			continue; /* only comments */
		}
		
		/*    trim(buf); // replace tabs and strip spaces */
		
		sprintf(err_diag, "%s -- line #%d,",  full_cfg_name, kwolines);

		/* expand envs & macros *************/
		expand_str(buf);
		strip(buf);
		strcpy(savestr, buf);  /* save original line */
		
		if (!strlen(buf)) {
			continue; 
		}

		/************************************/
		if (!strnicmp("$include", buf, 8)) {
			get_next_word(buf, arg1);
			sprintf(buf2, "including cfg file `%s'\n", buf);
			writeToLog(5, buf2);
			
			
			off = ftell(h);
			fclose(h);

			config(path, buf);
			
			h = fopen(full_cfg_name, "rb");
			
			if (h  == NULL) {
				printf("\7");
				perror(full_cfg_name);
				abort();
			}
			
			if (0 != fseek(h, off, SEEK_SET)) {
				strcpy(buf2, "config file seek error\n");
				printf("\n\7%s", buf2);
				writeToLog(0, buf2);
				abort();
			}
			
			continue;
			
			
		} /* include */
		
		if (indata == No) {
			
			get_next_word( buf , arg1 );
			sprintf( buf2 , "parse config, 1st arg:`%s' tail:`%s'\n",
							arg1, buf);
			writeToLog(5, buf2);
			
			if (!strlen(buf)) {
				fprintf(stderr, "\7%s syntax: `%s'\n", err_diag, savestr);
				abort();
			}
			/*************************************************/
			kto = -1;
			for( i = 0; strlen( key[i] ); ++i )
			{
				if ( !stricmp(key[i], arg1) ) {
					kto = i;
					break;
				}
			}


			if (kto == DATA) {



				indata = Yes;
				data_defined = No;

				get_next_word( buf , ctype );   /* 2nd word = DATA TYPE */
				ctype[63] = 0;
				memset(tag, '\0', 20);
				get_next_word( buf , tag );  /* 3d word = TAG */
				tag[19] = 0;

				if ( !strlen(tag) ) {
					fprintf(stderr, "\7%s syntax: `%s'\n", err_diag, savestr);
					abort();
				}

				if (!is_unique_tag(tag)) {
					fprintf(stderr, "\7%s %s, tag already defined: `%s'\n",
									err_diag, savestr, tag);
					abort();
				}

				sprintf(buf2, "parse config, data type:`%s' tag:`%s'\n",
								ctype, tag );
				writeToLog(5, buf2);


			} /* DATA */
			else if (kto == END_DATA) {
				fprintf(stderr, "\7%s not expected : `%s'\n", err_diag, arg1);
				abort();
			}
			else if (!parse_keyword(kto, buf, err_diag)) {
				fprintf(stderr, "\7%s unknown keyword: `%s'\n", err_diag, savestr);
				abort();
			}
			
		} /* not in data block */
		else
		{ /*********** IN DATA *************/
			if (!strlen(buf)) {
				fprintf(stderr, "\7%s syntax: `%s'\n", err_diag, savestr);
				abort();
			}
			strcpy(buf2, buf);
			get_next_word( buf2 , arg1 );
			
			if (!stricmp(arg1, "#END#")) { /* end of block */
				if (!data_defined) {
					fprintf(stderr, "\7%s empty Data Block: `%s'\n", err_diag, savestr);
					abort();
				}
				writeToLog(5, "parse config, got #End# for Data block\n");
				
				indata = No;
				data_defined = No;
			}
			else {
				int i;
				void (*f) (char *, char *, char *) = NULL;
				sprintf(buf2, "parse config, got data in datablock: `%s'\n", buf);
				writeToLog(5, buf2);
				data_defined = Yes;
				/*\\//\\//\\//\\//\\//\\//\\//\\//\\*/
				for( i = 0; strlen(TagDesc[i].s); ++i)
				{
					if ( !stricmp(TagDesc[i].s, ctype) ) {
						f = (void (*)(char *, char *, char *))TagDesc[i].deffunc;
						break;
					}
				}
				if (!strlen(TagDesc[i].s)) {
					sprintf(buf2, "%s unknown data type: `%s'\n", err_diag, ctype);
					fprintf(stderr, "\7%s\n", buf2);
					writeToLog(0, buf2);
					abort();
				}
				if (f == NULL) {
					sprintf(buf2, "config error: DATA %s not yet implemented, ignored\n",
									TagDesc[i].s);
					writeToLog(0, buf2);
				}
				else {
					f(tag, buf, err_diag);
				}
				/*\\//\\//\\//\\//\\//\\//\\//\\//\\*/
			}
		}   /* in data */
	}     /* feof */
	
	fclose(h);
	
	
	free(full_cfg_name);

	--rec_lev;
	

	if (indata == Yes && rec_lev == 0) {
		fprintf(stderr, "\7%s expected `#END#', got: `%s'\n", err_diag, savestr);
		abort();
	}

	if (rec_lev == 0) {
		data_defined = No;
		indata = No;
		cnt = 0;
		blocktype = 0;
	}
	
#if 0
	if (rec_lev == 0) {
		struct EchoAreas *tmp;
		struct Address *tmpaddr;
		char t;
		for (tmp = EchoAreas; tmp; tmp = tmp->next)
		{
			if (tmp->type == E_FIDO)
				t = 'F';
			else if (tmp->type == E_SQUISH)
				t = '$';
			else if (tmp->type == E_JAM)
				t = 'J';
			else if (tmp->type == E_PASS)
				t = '0';
			else
				t = '?';
			
			printf ("%s, t: %c, l:   ", tmp->name, t);
			for (tmpaddr = tmp->links; tmpaddr; tmpaddr=tmpaddr->next)
				printf ("%hu:%hu/%hu.%hu ", tmpaddr->addr.zone, tmpaddr->addr.net,
								tmpaddr->addr.node, tmpaddr->addr.point);
			printf ("%s\n", tmp->BadArea ? "(BAD)":"");
		}
	}
#endif
	return;
}

/****************************************************/
BOOL parse_keyword(int kto, char *buf, char *err)
{
	int i;
	char buf2[256], caddr[128];
#ifdef MSGIDSEQ
	char *p;
#endif

	switch (kto) {

	case MAIN_ADDRESS:

			get_next_word( buf , buf2 );
			strncpy(caddr, buf2, 63); caddr[63] = 0;
			if ( !strlen(caddr) ) {
				fprintf(stderr, "\7%s syntax: `%s'\n", err, buf);
				abort();
			}

/*			strset(buf2, 0); */
			if (get_next_word( buf , buf2 )) {
				buf2[62] = 0;
				strcat(caddr, "@");
				strncat(caddr, buf2, 63);
			}

			sprintf(buf2, "parse config, got MainAddress: `%s'\n", caddr );
			writeToLog(4, buf2);

			if ( !str_to_addr(caddr, &MainAddress) ) {
				fprintf(stderr, "\7%s syntax: `%s'\n", err, buf);
				abort();
			}
			if (!strlen(MainAddress.domain)) {
				fprintf(stderr, "\7you MUST specify domain for MainAddress\n");
				abort();
			}


			break;

	case FIDOAREA:
	case BINKAREA:
	case SQUISHAREA:
	case TEXTAREA:
	case PKTAREA:
	case JAMAREA:
			{

				if (!strlen(buf))  {
					fprintf(stderr, "\7%s syntax: `%s'\n", err, buf);
					abort();
				}

				if (kto == FIDOAREA)
					(void)defFidoArea(buf, err);
				else if (kto == BINKAREA)
					(void)defBinkArea(buf, err);
				else if (kto == SQUISHAREA)
					(void)defSquishArea(buf, err);
				else if (kto == TEXTAREA)
					(void)defTextArea(buf, err);
				else if (kto == PKTAREA)
					(void)defPktArea(buf , err);
				else if (kto == JAMAREA)
					(void)defJamArea(buf, err);

				break;
			}

	case LOGFILE:
		if (LogFile) {
			close_log();
		}
		
		if (is_full_path(buf)) {
			LogFile = (char *) malloc (strlen(buf)+1);
			strcpy(LogFile, buf);
		}
		else {
			LogFile = (char *) malloc (strlen(buf)+strlen(ItraxPath)+1);
			sprintf (LogFile, "%s%s", ItraxPath, buf);
		}
		
/*		open_log(); */
		
		break;

	case COMPRESSFILE:
			{
/*				struct find_t ffblk; */

				sprintf(CompressFile, "%s%s", ItraxPath, buf);
				if ( access(CompressFile, 0) ) {

					strcpy(CompressFile, buf);

					if ( access(CompressFile, 0) ) {
						perror(CompressFile);
						fprintf(stderr, "\7%s can't find compress file : `%s'\n",
										err, CompressFile);
						abort();
					}
				}

	if (!parse_compress(CompressFile)) {
		fprintf(stderr, "\7%s error processing compress file : `%s'\n",
									err, CompressFile);
					abort();
				}

			}

			break;

	case TEMPLATEPATH:

			sprintf(TemplatePath, "%.63s%.63s", ItraxPath, buf);

			if (!setpath(TemplatePath)) {

				strncpy(TemplatePath, buf, 127); TemplatePath[127] = 0;
				if (!setpath(TemplatePath)) {
					fprintf(stderr, "\7%s template path not found : `%s'\n",
									err, TemplatePath);
					abort();
				}
			}

			sprintf(buf2, "parse config, got template path: `%s'\n",
				TemplatePath);
			writeToLog(5, buf2);

			break;

	case TIMESTAMPPATH:

			{
				static char tsp[256];
			
				sprintf(tsp, "%.63s%.63s", ItraxPath, buf);

				if (!setpath(tsp)) {

					strncpy(tsp, buf, 127); tsp[127] = 0;
					if (!setpath(tsp)) {
						fprintf(stderr, "\7%s timestamp path not found : `%s'\n",
										err, tsp);
						abort();
					}
				}
				if (TsPath)
					free (TsPath);
				TsPath = strdup(tsp);
			}

			break;

	case FLAGDIR:

			sprintf(FlagDir, "%.63s%.63s", ItraxPath, buf);

			if (!setpath(FlagDir)) {

				strncpy(FlagDir, buf, 127); FlagDir[127] = 0;
				if (!setpath(FlagDir)) {
					fprintf(stderr, "\7%s template path not found : `%s'\n",
			err, FlagDir);
					abort();
				}
			}

			sprintf(buf2, "parse config, got flag dir: `%s'\n", FlagDir);
			writeToLog(5, buf2);

			break;

	case SHARING:

			if ( !stricmp(buf, "YES") )
				Sharing = Yes;
			else if ( !stricmp(buf, "NO") )
				Sharing = No;
			else {
				fprintf(stderr, "\7%s syntax: `%s'\n", err, buf);
				abort();
			}
			sprintf(buf2, "parse config, got sharing: `%s'\n", buf);
			writeToLog(5, buf2);

			break;

	case CHAT:

			if ( !stricmp(buf, "ON") )
				Chat_On = Yes;
			else if ( !stricmp(buf, "OFF") )
				Chat_On = No;
			else {
				fprintf(stderr, "\7%s syntax: `%s'\n", err, buf);
				abort();
			}
			sprintf(buf2, "parse config, got chat: `%s'\n", buf);
			writeToLog(5, buf2);

			break;

	case IGNOREBSY:

			if ( !stricmp(buf, "ON") )
				IgnoreBSY = Yes;
			else if ( !stricmp(buf, "OFF") )
				IgnoreBSY = No;
			else {
				fprintf(stderr, "\7%s syntax: `%s' (On/Off required)\n", err, buf);
	abort();
			}
			sprintf(buf2, "parse config, got ignoreBSY: `%s'\n", buf);
			writeToLog(5, buf2);

			break;

	case RXIGNORECASE:

		if ( !stricmp(buf, "ON") ) {
			rxIcase = REG_ICASE;
		}
			else if ( !stricmp(buf, "OFF") )
	rxIcase = 0;
			else {
				fprintf(stderr, "\7%s syntax: `%s' (On/Off required)\n", err, buf);
				abort();
			}
			sprintf(buf2, "parse config, got rxIgnoreCase: `%s'\n", buf);
			writeToLog(5, buf2);

			break;

	case TOUCHECHOMAIL:

			if ( !stricmp(buf, "YES") )
				TouchEchomail = Yes;
			else if ( !stricmp(buf, "NO") )
				TouchEchomail = No;
			else {
				fprintf(stderr, "\7%s syntax: `%s' (Yes/No required)\n", err, buf);
				abort();
			}
			sprintf(buf2, "parse config, got TouchEchomail: `%s'\n", buf);
			writeToLog(5, buf2);

			break;

	case USEREGEXP:

			if ( !stricmp(buf, "YES") )
				UseRegExp = Yes;
			else if ( !stricmp(buf, "NO") )
				UseRegExp = No;
			else {
				fprintf(stderr, "\7%s syntax: `%s' (Yes/No required)\n", err, buf);
				abort();
			}
			sprintf(buf2, "parse config, got UseRegExp: `%s'\n", buf);
			writeToLog(5, buf2);

			break;

	case DEBUG:

			DebugLevel = atoi( buf);
			sprintf(buf2, "parse config, got debuglevel: `%s'\n", buf);
			writeToLog(5, buf2);

			break;

	case LOGINCLUDE:

			add_to_loginclude(buf, err);

			break;

	case LOGEXCLUDE:

			add_to_logexclude(buf, err);

			break;


	case DUPEBASEPATH:

			{
				static char dbp[256];

				sprintf(dbp, "%.63s%.63s", ItraxPath, buf);

				if (!setpath(dbp)) {

					strncpy(dbp, buf, 127); dbp[127] = 0;
					if (!setpath(dbp)) {
						fprintf(stderr, "\7%s path not found : `%s'\n",
										err, dbp);
						abort();
					}
				}

				DupeBasePath = dbp;
			}

			break;

	case DUPESMAXOPEN:

			i = atoi(buf);
			if (i)
	DupesMaxOpen = i;
			break;

	case DUPESMAXMSG:

			i = atoi(buf);
			if (i)
				DupesMaxMsg = i;
			break;

	case ECHOAREA:
	case BADAREA:
		{
			int isbad = 0;
			if (kto == BADAREA)
				isbad = 1;

			if (!def_echoarea (buf, isbad, err)) {
				fprintf(stderr, "\7%s error defining echoarea\n",	err);
				abort();
			}
		}
		
		break;
	
	case LOCKFILE:
	
    		sprintf(lockFile.FileName, buf);
		
		break;
		
	case INTAB:
	
		intabName = (char*)xcalloc(strlen(buf)+strlen(ItraxPath)+1, sizeof(buf));
		sprintf(intabName, "%s%s", ItraxPath, buf);
		    if ( access(intabName, 0) ) {

			strcpy(intabName, buf);

			if ( access(intabName, 0) ) {
				perror(intabName);
				fprintf(stderr, "\7%s can't find intab file : `%s'\n",
						err, intabName);
				abort();
			}
		    }

		break;
		
	case OUTTAB:

		outtabName = (char*)xcalloc(strlen(buf)+strlen(ItraxPath)+1, sizeof(buf));
		sprintf(outtabName, "%s%s", ItraxPath, buf);
		    if ( access(outtabName, 0) ) {

			strcpy(outtabName, buf);

			if ( access(outtabName, 0) ) {
				perror(outtabName);
				fprintf(stderr, "\7%s can't find outtab file : `%s'\n",
						err, outtabName);
				abort();
			}
		    }

		break;

	case SEQDIR:
#ifdef MSGIDSEQ
		if (SeqDir)
		  free(SeqDir);

/* All checks in GenMsgId() */
		SeqDir = (char *)malloc(strlen(buf)+1);
		strcpy(SeqDir, buf);
		writeToLog(5, "parse config, got SeqDir: `%s'\n", buf);
#else
		fprintf(stderr, "warning: itraxp compiled without MSGIDSEQ, SeqDir ignored\n");
#endif
	        break;

	case SEQOUTRUN:
#ifdef MSGIDSEQ
		if (!isdigit(*buf))
		{
		  fprintf(stderr, "Bad SeqOutrun value '%s'\n", buf);
		  abort();
		}
		SeqOutRun = (unsigned long)atol(buf);

		p = buf;
		while (isdigit(*p)) p++;
		if (*p != '\0')
		{
		  if (p[1])
		  {
		    fprintf(stderr, "Bad SeqOutrun value '%s'\n", buf);
		    abort();
		  }
		  switch (tolower(*p))
		  {
		    case 'y':	SeqOutRun *= 365;
		    case 'd':	SeqOutRun *= 24;
		    case 'h':	SeqOutRun *= 60*60;
		    		break;
		    case 'w':	SeqOutRun *= 7l*24*60*60;
		    		break;
		    case 'm':	SeqOutRun *= 31l*24*60*60;
		    		break;
		    default:	fprintf(stderr, "Bad SeqOutrun value '%s'\n", buf);
		    		abort();
		  }
		}
		writeToLog(5, "parse config, got SeqOutRun: `%s'\n", buf);
#else
fprintf(stderr, "warning: itraxp compiled without MSGIDSEQ, SeqDirOutrun ignored\n");
#endif
    break;

	default:

			return Fail;

	} /* switch */
	
	return Ok;
}


/*********************************/
/*
static int check_data_type(char *type)
{
	int  i;
	for( i = 0; strlen(TagDesc[i].s); ++i )
		if ( !stricmp(TagDesc[i].s, type) )
			return i;
	return -1;
}
*/

/***********************************/
static BOOL is_unique_tag(char *tag)
{
	struct Tags *Tag = NULL;
	
	for(Tag = TagFirst; Tag; Tag = Tag->next)
	{
		if (!stricmp(Tag->tag, tag))
			return Fail;
		
	}
	
	return Ok;
	
}

/************************************************/
static void add_to_loginclude(char *s, char *err)
{
	struct filter *f = LogIncl;
	regex_t *preg = NULL;
	char buf[256], regbuf[100];
	int rc;
	
	remove_quotes(s);
	
	if (UseRegExp) {
		preg = (regex_t *)calloc(1, sizeof(regex_t));
		if (0 != (rc = regcomp (preg, s, REG_EXTENDED|rxIcase))) {
			regerror (rc, preg, regbuf, 100);
			sprintf(buf, "%s regular expression syntax : `%s' (%s)", err, s, regbuf);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}

	f = (struct filter *)calloc(1, sizeof(struct filter));
	f->next  = NULL;
	/************************/
	strcpy(f->str, s);
	f->preg = preg;
	/************************/
	if (LogInclLast)
		LogInclLast->next = f;
	else
		LogIncl = f;
	LogInclLast = f;


	return;
}
/************************************************/
static void add_to_logexclude(char *s, char *err)
{
	struct filter *f = LogExcl;
	regex_t *preg = NULL;
	char buf[256], regbuf[100];
	int rc;
	
	remove_quotes(s);

	if (UseRegExp) {
		preg = (regex_t *)calloc(1, sizeof(regex_t));
		if (0 != (rc = regcomp (preg, s, REG_EXTENDED))) {
			regerror (rc, preg, regbuf, 100);
			sprintf(buf, "%s regular expression syntax : `%s' (%s)", err, s, regbuf);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}

	f = (struct filter *)calloc(1, sizeof(struct filter));
	f->next  = NULL;
	/************************/
	strcpy(f->str, s);
	f->preg = preg;
	/************************/
	if (LogExclLast)
		LogExclLast->next = f;
	else
		LogExcl = f;
	LogExclLast = f;


	return;
}

/*****************************************/
BOOL def_keyword(char *keyword, char *data, char *err)
{
	int i;
	for( i = 0; strlen( key[i] ); ++i )
		if ( !stricmp(key[i], keyword) )
			return parse_keyword(i, data, err);
			
	return Fail;
}
