
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"
#include "crc.h"

static int crc32tab[256]={0};

void  crc32init(ULONG poly);
ULONG crc_str(register ULONG crc, char *str, register long len);

/* ------------------------------------------------------------------------- */
ULONG
crc32(char *fname)
{
	FILE *h;
	ULONG l, sum = 0L;
	register ULONG crc = CRC32INIT, len = 0L;
	char *buf=NULL;
	char s[256];


	if ( NULL == (h = fopen(fname, "rb")))
	{
		perror(fname);
		sprintf(s , "crc32 error: can`t open file `%s'\n", fname);
		writeToLog(0, s);
		return 0;
	}

	fseek(h, 0L, SEEK_END);
	len = ftell(h);
	fseek(h, 0L, SEEK_SET);

	buf = (char *)malloc(BLOCK_SIZE);

	l = (len > BLOCK_SIZE) ? BLOCK_SIZE : len;

	setvbuf (h, NULL, _IOFBF, BLOCK_SIZE);

	while (l && fread(buf, l, 1, h))
	{
		crc = crc_str(crc, buf, l);
		sum += l;
		if (len - sum < l)
			l = len - sum;
	}

	free(buf);

	fclose(h);

	return ~crc;

}

/* ------------------------------------------------------------------------- */
ULONG crc_str(register ULONG crc, char *str, register long len)
{
	static BOOL init_once = Yes;

	if (init_once) {
		crc32init(CRC32POLY);
		init_once = No;
	}
	
	while(len--)
		crc = crc32tab[( (int)(crc) ^ (*str++) ) & 0xff] ^ (crc >> 8);
		
	return crc;
}

/* ------------------------------------------------------------------------- */
void 
crc32init (ULONG poly)
{
	register int i, j;
	register ULONG crc;

	for (i=0;i<256;i++)
	{
		crc = i;
		for (j = 8; j > 0; j--)
		{
			if (crc & 1)
				crc = (crc >> 1) ^ poly;
			else
				crc >>= 1;
		}
		crc32tab[i] = crc;
	}
}								/*crc32init()*/

