
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

extern BOOL is_valid_attr(char *p);

extern void defAddrPack(char *tag, char *str, char *err_diag);

void defAddrPack(char *tag, char *str, char *err_diag)
{
	/* <addr_mask> , <packer_ID>|- , <len>|- , [<flags> ...] */
	struct AddrPackerTags *AddrPackerTag = NULL, *mark = NULL;
	struct Compress *Compress = NULL;
	char buf[256], archname[128], caddr[128], save_attr[256]={0}, cattr[128];
	char clen[128];
	ADDR addr;
	dword len = 0L, mult = 1L;

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) ADDRESSPACKER, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	
	/* Address mask */
	get_next_word(str, caddr);
	if ( !str_to_Waddr(caddr, &addr) ) {
		sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

	/* archiver name */
	get_next_word(str, archname);
	if (!strcmp(archname, "-"));
/*		strset(archname, 0); */
	else {
		for(Compress = CompressFirst; Compress; Compress = Compress->next)
			if (!stricmp(Compress->archname, archname))
				break;

		if (!Compress) {
			sprintf(buf, "%s packer undefined : `%s'\n", err_diag, archname);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}

	/* length */
	get_next_word(str, clen);

	if (!strcmp(clen, "-"))
		len = 0L;
	else {
		strLower(clen);

		if (clen[strlen(clen)-1] == 'k') {
			clen[strlen(clen)-1] = '\0';
			mult = 1024L;
		}
		else  if (clen[strlen(clen)-1] == 'm') {
			clen[strlen(clen)-1] = '\0';
			mult = 1024L * 1024L;
		}

		if (!__isnumber(clen)) {
			sprintf(buf, "%s syntax (length): `%s'\n", err_diag, clen);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}

		len = atol(clen) * mult;

	}
	/* flags */
	if (strlen(str)) {
		strcpy(save_attr, str);
		while(get_next_word(str, cattr))
			if (!is_valid_attr(cattr)) {
				sprintf(buf, "%s incorrect attribute : `%s'\n", err_diag, cattr);
				fprintf(stderr, "\7%s", buf);
				writeToLog(0, buf);
				abort();
			}
	}

/*//////////////////////////////////////////////////////////////////////////*/
	AddrPackerTag = AddrPackerTagFirst;
	for( ; AddrPackerTag; AddrPackerTag = AddrPackerTag->next )
	{
		if (!stricmp(tag, AddrPackerTag->tag)) {
			mark = AddrPackerTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		AddrPackerTag = mark;
	}
	else {   /* create new tag */
		AddrPackerTag = (struct AddrPackerTags *)calloc(1, sizeof(struct AddrPackerTags));
		AddrPackerTag->next  = NULL;
		/*//////////////////////*/
		strcpy(AddrPackerTag->tag, tag);
		/*//////////////////////*/
		AddrPackerTag->rec = AddrPackerTag->recfirst = AddrPackerTag->reclast  = NULL;
		
		if (AddrPackerTagLast) {
			AddrPackerTagLast->next = AddrPackerTag;
		}
		else {
			AddrPackerTagFirst = AddrPackerTag;
		}
		
		AddrPackerTagLast = AddrPackerTag;
	}
	
	AddrPackerTag->rec = (struct addrp *)calloc(1, sizeof(struct addrp));
	AddrPackerTag->rec->next = NULL;
	/*////////////////////////////*/
	AddrPackerTag->rec->addr = addr;
	strcpy(AddrPackerTag->rec->archname, archname);
	AddrPackerTag->rec->len = len;
	if (strlen(save_attr))
		strcpy(AddrPackerTag->rec->attrs, save_attr);
	/*////////////////////////////*/
	
	if (AddrPackerTag->reclast) {
		AddrPackerTag->reclast->next = AddrPackerTag->rec;
	}
	else {
		AddrPackerTag->recfirst = AddrPackerTag->rec;
	}
	
	AddrPackerTag->reclast = AddrPackerTag->rec;
	
	return;
}
