
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/************************************************************************/
void  defAddrName(char *tag, char *str, char *err_diag)
{
	struct AddrNameTags *AddrNameTag = NULL, *mark = NULL;
	char name[256], caddr[128];
	char buf[256], regbuf[100];
	regex_t *preg = NULL;
	int rc;
	ADDR addr;

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag( (int) ADDRESSNAME, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	
	get_next_word(str, caddr);
	
	if ( !str_to_Waddr(caddr, &addr) ) {
		sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	strcpy(name, str);

	if (UseRegExp) {
		preg = (regex_t *)calloc(1, sizeof(regex_t));
		if (0 != (rc = regcomp (preg, name, REG_EXTENDED|rxIcase))) {
			regerror (rc, preg, regbuf, 100);
			sprintf(buf, "%s regular expression syntax : `%s' (%s)",
							err_diag, name, regbuf);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}

	
/*//////////////////////////////////////////////////////////////////////////*/

	for( AddrNameTag = AddrNameTagFirst; AddrNameTag; AddrNameTag = AddrNameTag->next )
	{
		if (!stricmp(tag, AddrNameTag->tag)) {
			mark = AddrNameTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		AddrNameTag = mark;
	}
	else {    /* create new tag */
		AddrNameTag = (struct AddrNameTags *)calloc(1, sizeof(struct AddrNameTags));
		AddrNameTag->next  = NULL;
		/*//////////////////////*/
		strcpy(AddrNameTag->tag, tag);
		/*//////////////////////*/
		AddrNameTag->rec = AddrNameTag->recfirst = AddrNameTag->reclast  = NULL;
		
		if (AddrNameTagLast) {
			AddrNameTagLast->next = AddrNameTag;
		}
		else {
			AddrNameTagFirst = AddrNameTag;
		}
		
		AddrNameTagLast = AddrNameTag;
	}
	
	AddrNameTag->rec = (struct AddrName *)calloc(1, sizeof(struct AddrName));
	AddrNameTag->rec->next = NULL;
	/*//////////////////////*/
	AddrNameTag->rec->addr = addr;
	name[35] = '\0';
	strcpy(AddrNameTag->rec->name, name);
	AddrNameTag->rec->preg = preg;
	/*//////////////////////*/
	
	if (AddrNameTag->reclast) {
		AddrNameTag->reclast->next = AddrNameTag->rec;
	}
	else {
		AddrNameTag->recfirst = AddrNameTag->rec;
	}
	
	AddrNameTag->reclast = AddrNameTag->rec;

	
	return;
}
