
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

BOOL is_valid_attr(char *p);

/* DATA ATTRIBUTE
               1       2       [3]
   call: ( "Tag" , "Attr1" , ["Attr2"] , ...)
*/

/***********************************************************************/
void defAttribute(char *tag, char *str, char *err_diag)
{
	
	struct AttrTags *AttrTag = NULL, *mark = NULL;
	char s[256], cattr[20], w[256];
	
	strUpper(tag);
	tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(s, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", s);
		writeToLog(0, s);
		abort();
	}
	
	/*///////////////////*/
	addtag(ATTRIBUTE, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	
	for( AttrTag = AttrTagFirst; AttrTag; AttrTag = AttrTag->next )
	{
		if (!stricmp(tag, AttrTag->tag)) {
			mark = AttrTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		AttrTag = mark;
	}
	else {    /* create new tag */
		AttrTag = (struct AttrTags *)calloc(1, sizeof(struct AttrTags));
		AttrTag->next = NULL;
		AttrTag->rec = NULL;
		AttrTag->recfirst = NULL;
		AttrTag->reclast = NULL;
		/*//////////////////////*/
		strcpy(AttrTag->tag, tag);
		/*//////////////////////*/
		
		if (AttrTagLast) {
			AttrTagLast->next = AttrTag;
		}
		else {
			AttrTagFirst = AttrTag;
		}
		
		AttrTagLast = AttrTag;
	}
	
	AttrTag->rec = (struct recAttr *)calloc(1, sizeof(struct recAttr));
	AttrTag->rec->next = NULL;
	AttrTag->rec->attr = NULL;
	AttrTag->rec->attrfirst = NULL;
	AttrTag->rec->attrlast = NULL;
		
	if (AttrTag->reclast) {
		AttrTag->reclast->next = AttrTag->rec;
	}
	else {
		AttrTag->recfirst = AttrTag->rec;
	}
	
	AttrTag->reclast = AttrTag->rec;

	while(get_next_word(str, w))
	{
		strncpy(cattr, (const char*)(strUpper(w)), 19); cattr[19] = 0;
		
		if (!is_valid_attr(cattr)) {
			sprintf(s, "%s incorrect attribute : `%s'\n", err_diag, cattr);
			fprintf(stderr, "\7%s", s);
			writeToLog(0, s);
			abort();
		}
		
		AttrTag->rec->attr = (struct attrs *)calloc(1, sizeof(struct attrs));
		AttrTag->rec->attr->next = NULL;
		/*////////////////////////////*/
		strcpy(AttrTag->rec->attr->cattr, cattr);
		/*////////////////////////////*/
		
		if (AttrTag->rec->attrlast) {
			AttrTag->rec->attrlast->next = AttrTag->rec->attr;
		}
		else {
			AttrTag->rec->attrfirst = AttrTag->rec->attr;
		}
		AttrTag->rec->attrlast = AttrTag->rec->attr;
		
	} /* argc loop */
	
	return;
}

/*************************************/
BOOL is_valid_attr(char *p)
{
	int j;

	if ( *p == '!' )
		p++;

	for( j = 0; strlen( Attrs[j].s ); ++j)
		if ( !stricmp(Attrs[j].s, p) )
			return Ok;

	for( j = 0; strlen( Flags[j].s ); ++j)
		if ( !stricmp(Flags[j].s, p) )
			return Ok;

	for( j = 0; strlen( Stats[j].s ); ++j)
		if ( !stricmp(Stats[j].s, p) )
			return Ok;

	return Fail;
}
