
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

BOOL str_to_date(char *cdate, DD_MM_YY *date);
int  get_dows(char *str, int dow[]);


extern void defDate(char *tag, char *str, char *err_diag);

void defDate(char *tag, char *str, char *err_diag)
{
	struct DateTags *DateTag = NULL, *mark = NULL;
	char buf[256], cdate[256];
	DD_MM_YY date;
	int i, dow[7]={0}, ndow = 0;

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) DATE_, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	
	/* Date */
	get_next_word(str, cdate);
	

	if ( strlen(cdate) > 8 || !str_to_date(cdate, &date)) {

		sprintf(buf, "%s incorrect date: `%s'", err_diag, cdate);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
		
	}

	/* dows */
	if (strlen(str)) {
		if (0 == (ndow = get_dows(str, dow))) {
			sprintf(buf, "%s incorrect day of week: `%s'", err_diag, str);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}

/*//////////////////////////////////////////////////////////////////////////*/

	for( DateTag = DateTagFirst; DateTag; DateTag = DateTag->next )
	{
		if (!stricmp(tag, DateTag->tag)) {
			mark = DateTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		DateTag = mark;
	}
	else {    /* create new tag */
		DateTag = (struct DateTags *)calloc(1, sizeof(struct DateTags));
		DateTag->next  = NULL;
		/*//////////////////////*/
		strcpy(DateTag->tag, tag);
		/*//////////////////////*/
		DateTag->rec = DateTag->recfirst = DateTag->reclast  = NULL;
		
		if (DateTagLast) {
			DateTagLast->next = DateTag;
		}
		else {
			DateTagFirst = DateTag;
		}
		
		DateTagLast = DateTag;
	}
	
	DateTag->rec = (struct Date *)calloc(1, sizeof(struct Date));
	DateTag->rec->next = NULL;
	/*/////////////////////////////*/
	DateTag->rec->date = date;
	for( i = 0; i < ndow; ++i )
		DateTag->rec->dow[i] = dow[i];
	/*/////////////////////////////*/
	
	if (DateTag->reclast) {
		DateTag->reclast->next = DateTag->rec;
	}
	else {
		DateTag->recfirst = DateTag->rec;
	}
	
	DateTag->reclast = DateTag->rec;
	
	return;
}

/***********************************/
BOOL str_to_date(char *cdate, DD_MM_YY *date)
{
	int d, m, y;
	char cd[9]={0}, cm[9]={0}, cy[9]={0};
	char *p = NULL;
	
	if (NULL == (p = strchr(cdate, '.'))) {
		return Fail;
	}
	strncpy(cd, cdate, p-cdate);
	cdate = p + 1;
	
	if (NULL == (p = strchr(cdate, '.'))) {
		return Fail;
	}
	
	strncpy(cm, cdate, p-cdate);
	cdate = p + 1;

	strcpy(cy, cdate);

	/* DAY */
	if (!__isnumber(cd)) {
		if (!strcmp(cd, "*"))
			d = (int)Wild_1;
		else
			return Fail;
	}
	else {
		d = atoi(cd);
		if (d == 0 || d > 31)
			return Fail;
	}

	/* MONTH */
	if (!__isnumber(cm)) {
		if (!strcmp(cm, "*"))
			m = (int)Wild_1;
		else
			return Fail;
	}
	else {
		m = atoi(cm);
		if (m == 0 || m > 12)
			return Fail;
		--m;
	}

	/* YEAR */
	if (!__isnumber(cy)) {
		if (!strcmp(cy, "*"))
			y = (int)Wild_1;
		else
			return Fail;
	}
	else {
		y = atoi(cy);
		if (y > 1900)
			y = y - 1900;
	}

	date->day = d;
	date->month = m;
	date->year = y;
	
	return Ok;
}

/**********************************/
int get_dows(char *str, int dow[])
{
	int i, ndow = 0, cur_ndow;
	char cdow[20], buf[256];

	strcpy(buf, str);
	
	while (get_next_word(buf, cdow))
	{
		cdow[19] = '\0';
		for( i = 0, cur_ndow = -1; i < 7; ++i)
		{
			if (!stricmp(Dow[i].dow, cdow)) {
				cur_ndow = i;
				break;
			}
		}

		if (cur_ndow == -1)
			return 0;

		dow[ndow++] = Dow[cur_ndow].n + 1;

		if (ndow == 7)
			break;

	}

	return ndow;
}
