
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

extern int  get_dows(char *str, int dow[]);

void defDow(char *tag, char *str, char *err_diag)
{
	struct DowTags *DowTag = NULL, *mark = NULL;
	char buf[256];
	int i, dow[7]={0}, ndow = 0;

	/* TAG */
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag( (int) DAYOFWEEK, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	/* DOW */
	if (0 == (ndow = get_dows(str, dow))) {
		sprintf(buf, "%s incorrect day of week: `%s'", err_diag, str);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

/*//////////////////////////////////////////////////////////////////////////*/

	for( DowTag = DowTagFirst; DowTag; DowTag = DowTag->next )
	{
		if (!stricmp(tag, DowTag->tag)) {
			mark = DowTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		DowTag = mark;
	}
	else {    /* create new tag */
		DowTag = (struct DowTags *)calloc(1, sizeof(struct DowTags));
		DowTag->next  = NULL;
		/*//////////////////////*/
		strcpy(DowTag->tag, tag);
		/*//////////////////////*/
		DowTag->rec = DowTag->recfirst = DowTag->reclast  = NULL;
		
		if (DowTagLast) {
			DowTagLast->next = DowTag;
		}
		else {
			DowTagFirst = DowTag;
		}
		
		DowTagLast = DowTag;
	}
	
	DowTag->rec = (struct Dow *)calloc(1, sizeof(struct Dow));
	DowTag->rec->next = NULL;
	/*/////////////////////////////*/
	for( i = 0; i < ndow; ++i )
		DowTag->rec->dow[i] = dow[i];
	/*/////////////////////////////*/
	
	if (DowTag->reclast) {
		DowTag->reclast->next = DowTag->rec;
	}
	else {
		DowTag->recfirst = DowTag->rec;
	}
	
	DowTag->reclast = DowTag->rec;
	
	return;
}
