
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/************************************************************************/
void defEchoName(char *tag, char *name, char *err_diag)
{
	struct EchoNameTags *EchoNameTag = NULL, *mark = NULL;
	char buf[256], regbuf[100];
	regex_t *preg = NULL;
	int rc;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) ECHONAME, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	remove_quotes( name );

	if (UseRegExp) {
		preg = (regex_t *)calloc(1, sizeof(regex_t));
		if (0 != (rc = regcomp (preg, name, REG_EXTENDED|rxIcase))) {
			regerror (rc, preg, regbuf, 100);
			sprintf(buf, "%s regular expression syntax : `%s' (%s)",
							err_diag, name, regbuf);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( EchoNameTag = EchoNameTagFirst; EchoNameTag; EchoNameTag = EchoNameTag->next )
	{
		if (!stricmp(tag, EchoNameTag->tag)) {
			mark = EchoNameTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		EchoNameTag = mark;
	}
	else {    /* create new tag */
		EchoNameTag = (struct EchoNameTags *)calloc(1, sizeof(struct EchoNameTags));
		EchoNameTag->next  = NULL;
		/*//////////////////////*/
		strcpy(EchoNameTag->tag, tag);
		/*//////////////////////*/
		EchoNameTag->rec = EchoNameTag->recfirst = EchoNameTag->reclast  = NULL;
		
		if (EchoNameTagLast) {
			EchoNameTagLast->next = EchoNameTag;
		}
		else {
			EchoNameTagFirst = EchoNameTag;
		}
		
		EchoNameTagLast = EchoNameTag;
	}
	
	EchoNameTag->rec = (struct Echo *)calloc(1, sizeof(struct Echo));
	EchoNameTag->rec->next = NULL;
	/*/////////////////////////////*/
	name[19] = '\0';
	strcpy(EchoNameTag->rec->name, name);
	EchoNameTag->rec->preg = preg;
	/*/////////////////////////////*/
	
	if (EchoNameTag->reclast) {
		EchoNameTag->reclast->next = EchoNameTag->rec;
	}
	else {
		EchoNameTag->recfirst = EchoNameTag->rec;
	}
	
	EchoNameTag->reclast = EchoNameTag->rec;
	
	return;
}
