
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/* also used in defmage.c, select.c */
dword get_age(char *cage);

void defFileAge(char *tag, char *str, char *err_diag)
{
/* call: (" DAYS[:MINS] , [#], fname1, fname2, ...) */
	
	struct FileAgeTags *FileAgeTag = NULL, *mark = NULL;
	char buf[256], fname[256], tmp_name[256]={0}, cage[10], fdir[256];
	dword secs;
	BOOL fDir = No;

	/* TAG */
	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/* AGE as DAYS[:MINS] */
	get_next_word(str, cage);
	cage[9] = 0;

	if ((dword)-1L == (secs = get_age(cage))) {
		sprintf(buf, "%s syntax in age : `%s' -- should be days:mins",
						err_diag, cage);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

	get_next_word(str, tmp_name);
	if (*tmp_name == '#') {
		fDir = Yes;
		if (strlen(tmp_name) > 1) {
			strcpy(fdir, &tmp_name[1]);
			if (!setpath(fdir)) {
				sprintf(buf, "%s path doesn't exist : `%s'", err_diag, fdir);
				fprintf(stderr, "\7%s", buf);
				writeToLog(0, buf);
				abort();
			}
		}
		else
			strcpy(fdir, FlagDir);
/*		strset(tmp_name, 0); */
		get_next_word(str, tmp_name);
	}
	
	if (!strlen(tmp_name)) {
		sprintf(buf, "%s no filename defined", err_diag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag(FILEAGE, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	
	for( FileAgeTag = FileAgeTagFirst; FileAgeTag; FileAgeTag = FileAgeTag->next )
	{
		if (!stricmp(tag, FileAgeTag->tag)) {
			mark = FileAgeTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		FileAgeTag = mark;
	}
	else {    /* create new tag */
		FileAgeTag = (struct FileAgeTags *)calloc(1, sizeof(struct FileAgeTags));
		FileAgeTag->next = NULL;
		FileAgeTag->rec = NULL;
		FileAgeTag->recfirst = NULL;
		FileAgeTag->reclast = NULL;
		/*////////////////////////*/
		strcpy(FileAgeTag->tag, tag);
		/*////////////////////////*/
		
		if (FileAgeTagLast) {
			FileAgeTagLast->next = FileAgeTag;
		}
		else {
			FileAgeTagFirst = FileAgeTag;
		}
		
		FileAgeTagLast = FileAgeTag;
	}
	
	FileAgeTag->rec = (struct FileAge *)calloc(1, sizeof(struct FileAge));
	FileAgeTag->rec->next = NULL;
	FileAgeTag->rec->file = NULL;
	FileAgeTag->rec->filefirst = NULL;
	FileAgeTag->rec->filelast = NULL;
	FileAgeTag->rec->secs = secs;
		
	if (FileAgeTag->reclast) {
		FileAgeTag->reclast->next = FileAgeTag->rec;
	}
	else {
		FileAgeTag->recfirst = FileAgeTag->rec;
	}
	
	FileAgeTag->reclast = FileAgeTag->rec;
	

	do {
		
		if (fDir == Yes)
			sprintf(fname, "%s%s", fdir, tmp_name);
		else
			strcpy(fname, tmp_name);
		
		FileAgeTag->rec->file = (struct files *)calloc(1, sizeof(struct files));
		FileAgeTag->rec->file->next = NULL;
		/*////////////////////////////*/
		strcpy(FileAgeTag->rec->file->fname, fname);
		/*////////////////////////////*/
		
		if (FileAgeTag->rec->filelast) {
			FileAgeTag->rec->filelast->next = FileAgeTag->rec->file;
		}
		else {
			FileAgeTag->rec->filefirst = FileAgeTag->rec->file;
		}
		FileAgeTag->rec->filelast = FileAgeTag->rec->file;
		
	} while (get_next_word(str, tmp_name));
	
	return;
}

/**********************************************/
dword get_age(char *cage)
/* returns age in SECS */
{
	char *p, cdays[10]={0}, cmins[10]={0};
	dword days = 0L, mins = 0L;
	
	if (NULL == (p = strchr(cage, ':'))) {
		if (__isnumber(cage))
			days = atol(cage);
		else
			return (dword)-1L;
	}
	else {
		strncpy(cdays, cage, p-cage);
		strcpy(cmins, &cage[p-cage+1]);
		if (strlen(cdays)) {
			if (__isnumber(cdays))
				days = atol(cdays);
			else
				return (dword)-1L;
		}
		if (strlen(cmins)) {
			if (__isnumber(cmins))
				mins = atol(cmins);
			else
				return (dword)-1L;
		}
	}
	
	return days * (dword)SECS_IN_DAY + mins * 60;
				
}
