
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void defFiles(char *tag, char *str, char *err_diag)
{
	struct FilesTags *FilesTag = NULL, *mark = NULL;
	char buf[256], fname[256], tmp_name[256]={0}, fdir[128];
	char path[256]={0};
	BOOL fDir = No;
/*	struct find_t ffblk; */
	regex_t *preg = NULL;
	
	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag(FILES, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	
	for( FilesTag = FilesTagFirst; FilesTag; FilesTag = FilesTag->next )
	{
		if (!stricmp(tag, FilesTag->tag)) {
			mark = FilesTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		FilesTag = mark;
	}
	else {    /* create new tag */
		FilesTag = (struct FilesTags *)calloc(1, sizeof(struct FilesTags));
		FilesTag->next = NULL;
		FilesTag->rec = NULL;
		FilesTag->recfirst = NULL;
		FilesTag->reclast = NULL;
		/*////////////////////////*/
		strcpy(FilesTag->tag, tag);
		/*////////////////////////*/
		
		if (FilesTagLast) {
			FilesTagLast->next = FilesTag;
		}
		else {
			FilesTagFirst = FilesTag;
		}
		
		FilesTagLast = FilesTag;
	}
	
	FilesTag->rec = (struct recFiles *)calloc(1, sizeof(struct recFiles));
	FilesTag->rec->next = NULL;
	FilesTag->rec->file = NULL;
	FilesTag->rec->filefirst = NULL;
	FilesTag->rec->filelast = NULL;
		
	if (FilesTag->reclast) {
		FilesTag->reclast->next = FilesTag->rec;
	}
	else {
		FilesTag->recfirst = FilesTag->rec;
	}
	
	FilesTag->reclast = FilesTag->rec;

	get_next_word(str, tmp_name);
	if (*tmp_name == '#') {
		fDir = Yes;
		if (strlen(tmp_name) > 1) {
			strcpy(fdir, &tmp_name[1]);
			if (!setpath(fdir)) {
				sprintf(buf, "%s path doesn't exist : `%s'\n", err_diag, fdir);
				fprintf(stderr, "\7%s", buf);
				writeToLog(0, buf);
				abort();
			}
		}
		else
			strcpy(fdir, FlagDir);
		
/*		strset(tmp_name, 0); */
		get_next_word(str, tmp_name);
	}
	
	if (!strlen(tmp_name)) {
		sprintf(buf, "%s no filename defined\n", err_diag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

	do  {

		if (fDir == Yes) {

			char *pfname, neg[2]={0};

			pfname = tmp_name;
			if (*pfname == '!') {
				++pfname;
				strcpy(neg, "!");
			}
			else
/*				strset(neg, 0); */
			
			sprintf(fname, "%s%s%s", neg, fdir, pfname);
			
			if (UseRegExp) {
				char regbuf[100];
				int rc;

				preg = (regex_t *)calloc(1, sizeof(regex_t));
				if (0 != (rc = regcomp (preg, pfname, REG_EXTENDED|rxIcase))) {
					regerror (rc, preg, regbuf, 100);
					sprintf(buf, "%s regular expression syntax : `%s' (%s)\n",
									err_diag, pfname, regbuf);
					fprintf(stderr, "\7%s", buf);
					writeToLog(0, buf);
					abort();
				}
				strcpy(path, fdir);
			}
		} /* fDir */
		else
			strcpy(fname, tmp_name);

		if (*fname != '!' && !preg) {
			if ( access(fname, 0) ) {
				sprintf(buf, "warning! DATA FILES: file `%s' doesn't exist\n", fname);
				writeToLog(4, buf);
			}
		}
		
		FilesTag->rec->file = (struct files *)calloc(1, sizeof(struct files));
		FilesTag->rec->file->next = NULL;
		/*////////////////////////////*/
		strcpy(FilesTag->rec->file->fname, fname);
		strcpy(FilesTag->rec->file->path, path);
		FilesTag->rec->file->preg = preg;
		/*////////////////////////////*/
		
		if (FilesTag->rec->filelast) {
			FilesTag->rec->filelast->next = FilesTag->rec->file;
		}
		else {
			FilesTag->rec->filefirst = FilesTag->rec->file;
		}
		FilesTag->rec->filelast = FilesTag->rec->file;
		
	} while (get_next_word(str, tmp_name));
	
	return;
}
