
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void defKludge(char *tag, char *str, char *err_diag)
{
/* DATA KLUDGE
             1       2       [3]        
   call: ( "Tag" , "kl1" , ["kl2"] , ...)
*/
/***********************************************************************/
	
	struct KludgeTags *KludgeTag = NULL, *mark = NULL;
	char s[256], ckl[256], *p;
	BOOL set;
	regex_t *preg = NULL;
	
	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(s, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", s);
		writeToLog(0, s);
		abort();
	}
	
	/*///////////////////*/
	addtag(KLUDGE, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	
	for( KludgeTag = KludgeTagFirst; KludgeTag; KludgeTag = KludgeTag->next )
	{
		if (!stricmp(tag, KludgeTag->tag)) {
			mark = KludgeTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		KludgeTag = mark;
	}
	else {    /* create new tag */
		KludgeTag = (struct KludgeTags *)calloc(1, sizeof(struct KludgeTags));
		KludgeTag->next = NULL;
		KludgeTag->rec = NULL;
		KludgeTag->recfirst = NULL;
		KludgeTag->reclast = NULL;
		/*////////////////////////*/
		strcpy(KludgeTag->tag, tag);
		/*////////////////////////*/
		
		if (KludgeTagLast) {
			KludgeTagLast->next = KludgeTag;
		}
		else {
			KludgeTagFirst = KludgeTag;
		}
		
		KludgeTagLast = KludgeTag;
	}
	
	KludgeTag->rec = (struct recKl *)calloc(1, sizeof(struct recKl));
	KludgeTag->rec->next = NULL;
	KludgeTag->rec->kl = NULL;
	KludgeTag->rec->klfirst = NULL;
	KludgeTag->rec->kllast = NULL;
		
	if (KludgeTag->reclast) {
		KludgeTag->reclast->next = KludgeTag->rec;
	}
	else {
		KludgeTag->recfirst = KludgeTag->rec;
	}
	
	KludgeTag->reclast = KludgeTag->rec;

	while(get_next_word(str, s))
	{
		s[126] = 0;
		
		p = s;
		if ( *p == '!' ) {
			p++;
			set = No;
		}
		else
			set = Yes;

		sprintf(ckl, "\1%s", p);

		
		if (UseRegExp) {
			
			char regbuf[100];
			int rc;
			
			preg = (regex_t *)calloc(1, sizeof(regex_t));
			if (0 != (rc = regcomp (preg, ckl, REG_EXTENDED|rxIcase))) {
				regerror (rc, preg, regbuf, 100);
				sprintf(s, "%s regular expression syntax : `%s' (%s)",
								err_diag, ckl, regbuf);
				fprintf(stderr, "\7%s", s);
				writeToLog(0, s);
				abort();
			}
		}
		
		KludgeTag->rec->kl = (struct kludge *)calloc(1, sizeof(struct kludge));
		KludgeTag->rec->kl->next = NULL;
		/*////////////////////////////*/
		ckl[127] = '\0';
		strcpy(KludgeTag->rec->kl->kl, ckl);
		KludgeTag->rec->kl->set = set;
		KludgeTag->rec->kl->preg = preg;
		/*////////////////////////////*/
		
		if (KludgeTag->rec->kllast) {
			KludgeTag->rec->kllast->next = KludgeTag->rec->kl;
		}
		else {
			KludgeTag->rec->klfirst = KludgeTag->rec->kl;
		}
		KludgeTag->rec->kllast = KludgeTag->rec->kl;
		
	} /* argc loop */
	
	return;
}
