
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void defLengthAddr(char *tag, char *str, char *err_diag);

void defLengthAddr(char *tag, char *str, char *err_diag)
{
	struct LengthAddrTags *LengthAddrTag = NULL, *mark = NULL;
	char buf[256], clen[256];
	dword len, mult = 1L;
	ADDR addr;

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag( (int) LENGTHADDRESS, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	get_next_word(str, clen);
	strLower(clen);
	
	if (clen[strlen(clen)-1] == 'k') {
		clen[strlen(clen)-1] = '\0';
		mult = 1024L;
	}
	else  if (clen[strlen(clen)-1] == 'm') {
		clen[strlen(clen)-1] = '\0';
		mult = 1024L * 1024L;
	}

	if (!__isnumber(clen)) {
		sprintf(buf, "%s incorrect length (%s) for tagname %s",
						err_diag, clen, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	len = atol(clen) * mult;
	
	if ( !str_to_Waddr(str, &addr) ) {
		sprintf(buf, "%s incorrect address `%s' for tagname: `%s'\n",
						err_diag, str, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( LengthAddrTag = LengthAddrTagFirst; LengthAddrTag; LengthAddrTag = LengthAddrTag->next )
	{
		if (!stricmp(tag, LengthAddrTag->tag)) {
			mark = LengthAddrTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		LengthAddrTag = mark;
	}
	else {    /* create new tag */
		LengthAddrTag = (struct LengthAddrTags *)calloc(1, sizeof(struct LengthAddrTags));
		LengthAddrTag->next  = NULL;
		/*//////////////////////*/
		strcpy(LengthAddrTag->tag, tag);
		/*//////////////////////*/
		LengthAddrTag->rec = LengthAddrTag->recfirst = LengthAddrTag->reclast  = NULL;
		
		if (LengthAddrTagLast) {
			LengthAddrTagLast->next = LengthAddrTag;
		}
		else {
			LengthAddrTagFirst = LengthAddrTag;
		}
		
		LengthAddrTagLast = LengthAddrTag;
	}
	
	LengthAddrTag->rec = (struct LengthAddr *)calloc(1, sizeof(struct LengthAddr));
	LengthAddrTag->rec->next = NULL;
	/*/////////////////////////////*/
	LengthAddrTag->rec->len = len;
	LengthAddrTag->rec->addr = addr;
	/*/////////////////////////////*/
	
	if (LengthAddrTag->reclast) {
		LengthAddrTag->reclast->next = LengthAddrTag->rec;
	}
	else {
		LengthAddrTag->recfirst = LengthAddrTag->rec;
	}
	
	LengthAddrTag->reclast = LengthAddrTag->rec;
	
	return;
}
