
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

extern void defMsgLen(char *tag, char *str, char *err_diag);

void defMsgLen(char *tag, char *str, char *err_diag)
{
	struct MsgLenTags *MsgLenTag = NULL, *mark = NULL;
	char buf[256], clen[256];
	dword len, mult = 1L;
	ADDR addr;

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag( (int) MESSAGELENGTH, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	get_next_word(str, clen);
	strLower(clen);
	
	if (clen[strlen(clen)-1] == 'k') {
		clen[strlen(clen)-1] = '\0';
		mult = 1024L;
	}
	else  if (clen[strlen(clen)-1] == 'm') {
		clen[strlen(clen)-1] = '\0';
		mult = 1024L * 1024L;
	}
	

	if (!__isnumber(clen)) {
		sprintf(buf, "%s incorrect length (%s) for tagname %s",
						err_diag, clen, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	len = atol(clen) * mult;

	addr.zone = addr.net = addr.node = addr.point = Wild_1;
	
	if (strlen(str)) {
		if ( !str_to_Waddr(str, &addr) ) {
			sprintf(buf, "%s incorrect address `%s' for tagname: `%s'\n",
							err_diag, str, tag);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( MsgLenTag = MsgLenTagFirst; MsgLenTag; MsgLenTag = MsgLenTag->next )
	{
		if (!stricmp(tag, MsgLenTag->tag)) {
			mark = MsgLenTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		MsgLenTag = mark;
	}
	else {    /* create new tag */
		MsgLenTag = (struct MsgLenTags *)calloc(1, sizeof(struct MsgLenTags));
		MsgLenTag->next  = NULL;
		/*//////////////////////*/
		strcpy(MsgLenTag->tag, tag);
		/*//////////////////////*/
		MsgLenTag->rec = MsgLenTag->recfirst = MsgLenTag->reclast  = NULL;
		
		if (MsgLenTagLast) {
			MsgLenTagLast->next = MsgLenTag;
		}
		else {
			MsgLenTagFirst = MsgLenTag;
		}
		
		MsgLenTagLast = MsgLenTag;
	}
	
	MsgLenTag->rec = (struct MsgLen *)calloc(1, sizeof(struct MsgLen));
	MsgLenTag->rec->next = NULL;
	/*/////////////////////////////*/
	MsgLenTag->rec->len = len;
	MsgLenTag->rec->addr = addr;
	/*/////////////////////////////*/
	
	if (MsgLenTag->reclast) {
		MsgLenTag->reclast->next = MsgLenTag->rec;
	}
	else {
		MsgLenTag->recfirst = MsgLenTag->rec;
	}
	
	MsgLenTag->reclast = MsgLenTag->rec;
	
	return;
}
