
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/************************************************************************/
void defName(char *tag, char *name, char *err_diag)
{
	struct NameTags *NameTag = NULL, *mark = NULL;
	char buf[256], regbuf[100];
	regex_t *preg = NULL;
	int rc;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) NAME, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	remove_quotes( name );

	if (UseRegExp) {
		preg = (regex_t *)calloc(1, sizeof(regex_t));
		if (0 != (rc = regcomp (preg, name, REG_EXTENDED|rxIcase))) {
			regerror (rc, preg, regbuf, 100);
			sprintf(buf, "%s regular expression syntax : `%s' (%s)",
							err_diag, name, regbuf);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( NameTag = NameTagFirst; NameTag; NameTag = NameTag->next )
	{
		if (!stricmp(tag, NameTag->tag)) {
			mark = NameTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		NameTag = mark;
	}
	else {    /* create new tag */
		NameTag = (struct NameTags *)calloc(1, sizeof(struct NameTags));
		NameTag->next  = NULL;
		/*//////////////////////*/
		strcpy(NameTag->tag, tag);
		/*//////////////////////*/
		NameTag->rec = NameTag->recfirst = NameTag->reclast  = NULL;
		
		if (NameTagLast) {
			NameTagLast->next = NameTag;
		}
		else {
			NameTagFirst = NameTag;
		}
		
		NameTagLast = NameTag;
	}
	
	NameTag->rec = (struct Name *)calloc(1, sizeof(struct Name));
	NameTag->rec->next = NULL;
	/*/////////////////////////////*/
	name[35] = '\0';
	strcpy(NameTag->rec->name, name);
	NameTag->rec->preg = preg;
	/*/////////////////////////////*/
	
	if (NameTag->reclast) {
		NameTag->reclast->next = NameTag->rec;
	}
	else {
		NameTag->recfirst = NameTag->rec;
	}
	
	NameTag->reclast = NameTag->rec;
	
	return;
}
