
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

#define MAXNDL 10

BOOL v9_ndl_build(int nndl, char *ndlnames[],
char *path, char *ext, word DefZone, word DefReg);

extern int getndlnames(char *path, char *arg, char *ndllist[]);

/***********************************************************************/
void defNodelist_v9(char *tag, char *arg, char *err_diag)
{
/* DATA VERSION9
             1       2      [  3       4  ]    [ 5 ]   [6]     [...]
   call: ( "Tag" , "Ext" ,  "zone" , "reg" , "Path" , "Ndl1" , ["Ndl2"] , ...)
	
   char exc_[3]={"Abort", "Ignore", "Disable", ""};
*/	
	struct ndlTags *v9_ndlTag = NULL, *mark = NULL;
	char ext[128], path[128], s[256], str[256], w[256];
	char *ndlnames[MAXNDL], ndlname[13];
	char allnames[256];
	int i, nndl, nread;
	BOOL rebuild = No;
/*	struct find_t ffblk; */
	int h_inc;
	struct nodeinc nodeinc;
	char n_inc_buf[NODEINC_SIZE], *pbuf;
	word DefZone = Wild_1, DefReg = Wild_1;
	long size;

	/* 1- TAG */
	/* TAG */
	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(s, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", s);
		writeToLog(0, s);
		abort();
	}

	/*///////////////////*/
	addtag(VERSION9, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	/* EXT */
	get_next_word(arg, ext);
	ext[127] = 0;

	/* OPTIONAL 3,4 - ZONE, REG */
	get_next_word(arg, w);
	if (__isnumber(w)) {
		
		DefZone = (word) atoi(w);
		
		get_next_word(arg, w);
		if (__isnumber(w))
			DefReg = (word) atoi(w);
		else {
			sprintf(s, "%s default region incorrect or missing  : `%s'",
							err_diag, w);
			fprintf(stderr, "\7%s", s);
			writeToLog(0, s);
			abort();
		}
		get_next_word(arg, w);
	}
	

	/* PATH */
	strncpy(path, w, 127);  path[127] = 0;
	
	if ( !setpath(path) ) {
		sprintf(s, "%s path not found : `%s'\n", err_diag, path);
		fprintf(stderr, "\7%s", s);
		writeToLog(0, s);
		abort();
	}
	
	/* NODELIST NAMES */
	
	strcpy(allnames, arg);

	nndl = getndlnames(path, arg, ndlnames);
	if (!nndl) {
		sprintf(str, "%s nodelist file(s) template not found: `%s'\n",
						err_diag, allnames);
		fprintf(stderr, "\7%s", str);
		writeToLog(0, str);
		abort();
	}
	

	/* see if we need to rebuild indexes */
	rebuild = No;
	while (1)
	{
		sprintf(s, "%sver9idx.%s", path, ext);
		sprintf(str, "trying to find index file `%s'... ", s);
		if (access(s, 0)) {
			strcat(str, "not found.\n");
			writeToLog(3, str);
			rebuild = Yes;
			break;
		}
		else {
			strcat(str, "ok\n");
			writeToLog(3, str);
		}
		
		sprintf(s, "%sver9inc.%s", path, ext);
		sprintf(str, "trying to open index file `%s'... ", s);
		if ( (h_inc = open(s, O_RDONLY|O_BINARY)) == -1 ) {
			strcat(str, "failed.\n");
			writeToLog(3, str);
			rebuild = Yes;
			break;
		}
		else {
			strcat(str, "ok\n");
			writeToLog(3, str);
		}
		
		if (Chat_On)
			printf("checking v9 nodelist indexes...  ");
		
		i = 0;
		size = filelength(h_inc);
		while( size > tell( h_inc ) )
		{
			
			nread = NODEINC_SIZE;
			if (nread != (read(h_inc, &n_inc_buf, nread))) {
				writeToLog(3, "v9: nodeinc record is of incorrect size\n");
				rebuild = Yes;
				break;
			}
			
			pbuf = n_inc_buf;
			nodeinc.namelen = *pbuf;
			pbuf++;
			memmove(&(nodeinc.name), pbuf, 12);
			pbuf += 12;
			nodeinc.crc32 = get_dword(pbuf);
			
			
			memset(ndlname, 0, 13);
			strncpy(ndlname, nodeinc.name, 12);
			ndlname[12] = 0;
			
			++i; /* the number of records read */
			
			if (i > nndl) {
				writeToLog(3, "v9: the number of nodelist files in config and indexfile don`t match\n");
				rebuild = Yes;
				break;
			}
			
			if (0 != stricmp(ndlnames[i-1], ndlname)) {
				sprintf(str, "v9: nodelist names changed: old:`%s' new:`%s'\n",
								ndlname, ndlnames[i-1]);
				writeToLog(2, str);
				rebuild = Yes;
				break;
			}
			
			sprintf(s, "%s%s", path, ndlname);
			
			if (access(s, 0)) {
				sprintf(str, "v9: incorrect filename stored in nodeinc : `%s'\n", s);
				writeToLog(3, str);
				rebuild = Yes;
				break;
			}
			if ( crc32(s) != nodeinc.crc32 ) {
				sprintf(str, "v9: CRC don`t match (%s)\n", s);
				writeToLog(3, str);
				rebuild = Yes;
				break;
			}
		}
		if (Chat_On)
			printf("done\n");
		
		close(h_inc);
		
		if (rebuild == Yes)
			break;
		
		if (i != nndl) {
			writeToLog(3, "v9: the number of nodelist files in config and indexfile don`t match\n");
			rebuild = Yes;
			break;
		}

		rebuild = No;
		break;  /* no need to rebuild */
	}
	
	if (rebuild == Yes) {
		BOOL rc;
		writeToLog(1, "rebuilding v9 nodelist indexes\n");
		
		rc = v9_ndl_build(nndl, ndlnames, path, ext, DefZone, DefReg);
		
		if (rc == Fail) {
			sprintf(str, "v9 error: nodelist rebuild failed\n");
			fprintf(stderr, "\7%s", str);
			writeToLog(0, str);
			abort();
		}
		
	}
	else {
		writeToLog(3, "v9: index files are ok and up-to-date\n");
	}

	for( i = 0; i < nndl; i++ )
		free( ndlnames[i] );


	printf("end of argument parsing\n");

/* end of argument parsing */
/*/////////////////////////////////////////////////////////////////*/
	
	for( v9_ndlTag = v9_ndlTagFirst; v9_ndlTag; v9_ndlTag = v9_ndlTag->next )
	{
		if (!stricmp(tag, v9_ndlTag->tag)) {
			mark = v9_ndlTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		v9_ndlTag = mark;
	}
	else {    /* create new tag */
		v9_ndlTag = (struct ndlTags *)calloc(1, sizeof(struct ndlTags));
		v9_ndlTag->next = NULL;
		/*////////////////////*/
		strcpy(v9_ndlTag->tag, tag);
		v9_ndlTag->active = Yes;
		/*////////////////////*/
		v9_ndlTag->rec = v9_ndlTag->recfirst = v9_ndlTag->reclast = NULL;
		
		if (v9_ndlTagLast) {
			v9_ndlTagLast->next = v9_ndlTag;
		}
		else {
			v9_ndlTagFirst = v9_ndlTag;
		}
		
		v9_ndlTagLast = v9_ndlTag;
	}

	v9_ndlTag->rec = (struct nodelist *)calloc(1, sizeof(struct nodelist));
	v9_ndlTag->rec->next = NULL;
	
	strcpy(v9_ndlTag->rec->ext,  ext);
	strcpy(v9_ndlTag->rec->path, path);
	v9_ndlTag->rec->zone = DefZone;
	v9_ndlTag->rec->reg = DefReg;
	strcpy(v9_ndlTag->rec->allnames, allnames);
	
	if (v9_ndlTag->reclast) {
		v9_ndlTag->reclast->next = v9_ndlTag->rec;
	}
	else {
		v9_ndlTag->recfirst = v9_ndlTag->rec;
	}
	v9_ndlTag->reclast = v9_ndlTag->rec;
	
	
	return;
}

	

