
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void  defPassAddr(char *tag, char *str, char *err_diag);
void  defPassName(char *tag, char *str, char *err_diag);

/************************************************************************/
void defPassAddr(char *tag, char *str, char *err_diag)
{
	struct PassAddrTags *PassAddrTag = NULL, *mark = NULL;
	ADDR addr;
	char password[9], caddr[64], buf[256];

	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) PASSWORDADDRESS, tag, err_diag); /* add tag to the global taglist */
	/*///////////////////*/

	get_next_word(str, password);
	password[8] = 0;
	
	get_next_word(str, caddr);
	caddr[63] = 0;
	
	if ( !str_to_addr(caddr, &addr) ) {
		sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( PassAddrTag = PassAddrTagFirst; PassAddrTag; PassAddrTag = PassAddrTag->next )
	{
		if (!stricmp(tag, PassAddrTag->tag)) {
			mark = PassAddrTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		PassAddrTag = mark;
	}
	else {    /* create new tag */
		PassAddrTag = (struct PassAddrTags *)calloc(1, sizeof(struct PassAddrTags));
		PassAddrTag->next  = NULL;
		/*//////////////////////*/
		strcpy(PassAddrTag->tag, tag);
		/*//////////////////////*/
		PassAddrTag->rec = PassAddrTag->recfirst = PassAddrTag->reclast  = NULL;
		
		if (PassAddrTagLast) {
			PassAddrTagLast->next = PassAddrTag;
		}
		else {
			PassAddrTagFirst = PassAddrTag;
		}
		
		PassAddrTagLast = PassAddrTag;
	}
	
	PassAddrTag->rec = (struct PassAddr *)calloc(1, sizeof(struct PassAddr));
	PassAddrTag->rec->next = NULL;
	/*//////////////////////*/
	strcpy(PassAddrTag->rec->password, password);
	PassAddrTag->rec->addr = addr;
	/*//////////////////////*/
	
	if (PassAddrTag->reclast) {
		PassAddrTag->reclast->next = PassAddrTag->rec;
	}
	else {
		PassAddrTag->recfirst = PassAddrTag->rec;
	}
	
	PassAddrTag->reclast = PassAddrTag->rec;

	
	return;
}

/************************************************************************/
void defPassName(char *tag, char *str, char *err_diag)
{
	struct PassNameTags *PassNameTag = NULL, *mark = NULL;
	char name[36], arg[256];
	char password[9], buf[256], save[256];

	strcpy(save, str);
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag( (int) PASSWORDNAME, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	get_next_word(str, arg);
	strncpy(password, arg, 8);
	password[8] = 0;
	
	remove_quotes(str);
	strncpy(name, str, 35);
	name[35] = 0;
	
	if (!strlen(password) || !strlen(name)) {
		sprintf(buf, "%s syntax:`%s'", err_diag, save);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*//////////////////////////////////////////////////////////////////////////*/

	for( PassNameTag = PassNameTagFirst; PassNameTag; PassNameTag = PassNameTag->next )
	{
		if (!stricmp(tag, PassNameTag->tag)) {
			mark = PassNameTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		PassNameTag = mark;
	}
	else {    /* create new tag */
		PassNameTag = (struct PassNameTags *)calloc(1, sizeof(struct PassNameTags));
		PassNameTag->next  = NULL;
		/*//////////////////////*/
		strcpy(PassNameTag->tag, tag);
		/*//////////////////////*/
		PassNameTag->rec = PassNameTag->recfirst = PassNameTag->reclast  = NULL;
		
		if (PassNameTagLast) {
			PassNameTagLast->next = PassNameTag;
		}
		else {
			PassNameTagFirst = PassNameTag;
		}
		
		PassNameTagLast = PassNameTag;
	}
	
	PassNameTag->rec = (struct PassName *)calloc(1, sizeof(struct PassName));
	PassNameTag->rec->next = NULL;
	/*//////////////////////*/
	strcpy(PassNameTag->rec->password, password);
	strcpy(PassNameTag->rec->name, name);
	/*//////////////////////*/
	
	if (PassNameTag->reclast) {
		PassNameTag->reclast->next = PassNameTag->rec;
	}
	else {
		PassNameTag->recfirst = PassNameTag->rec;
	}
	
	PassNameTag->reclast = PassNameTag->rec;

	
	return;
}
