
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

extern void defPath(char *tag, char *str, char *err_diag);

void defPath(char *tag, char *path, char *err_diag)
{
	struct PathTags *PathTag = NULL, *mark = NULL;
	char buf[256];

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) PATH, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	if (strlen(path) > 127)
		path[127] = '\0';
	
	remove_quotes(path);
	
	if (!setpath(path)) {
		
		sprintf(buf, "%s Warning! path doesn't exist : `%s'", err_diag, path);
		writeToLog(0, buf);
		
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( PathTag = PathTagFirst; PathTag; PathTag = PathTag->next )
	{
		if (!stricmp(tag, PathTag->tag)) {
			mark = PathTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		PathTag = mark;
	}
	else {    /* create new tag */
		PathTag = (struct PathTags *)calloc(1, sizeof(struct PathTags));
		PathTag->next  = NULL;
		/*//////////////////////*/
		strcpy(PathTag->tag, tag);
		/*//////////////////////*/
		PathTag->rec = PathTag->recfirst = PathTag->reclast  = NULL;
		
		if (PathTagLast) {
			PathTagLast->next = PathTag;
		}
		else {
			PathTagFirst = PathTag;
		}
		
		PathTagLast = PathTag;
	}
	
	PathTag->rec = (struct Path *)calloc(1, sizeof(struct Path));
	PathTag->rec->next = NULL;
	/*/////////////////////////////*/
	strcpy(PathTag->rec->path, path);
	/*/////////////////////////////*/
	
	if (PathTag->reclast) {
		PathTag->reclast->next = PathTag->rec;
	}
	else {
		PathTag->recfirst = PathTag->rec;
	}
	
	PathTag->reclast = PathTag->rec;
	
	return;
}
