
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void defPlenAddr(char *tag, char *str, char *err_diag);

void defPlenAddr(char *tag, char *str, char *err_diag)
{
	struct LengthAddrTags *PktLenAddrTag = NULL, *mark = NULL;
	char buf[256], clen[256];
	dword len, mult = 1L;
	ADDR addr;

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag( (int) PKTLENGTH, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	get_next_word(str, clen);
	strLower(clen);
	
	if (clen[strlen(clen)-1] == 'k') {
		clen[strlen(clen)-1] = '\0';
		mult = 1024L;
	}
	else  if (clen[strlen(clen)-1] == 'm') {
		clen[strlen(clen)-1] = '\0';
		mult = 1024L * 1024L;
	}
	

	if (!__isnumber(clen)) {
		sprintf(buf, "%s incorrect length (%s) for tagname %s",
						err_diag, clen, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	len = atol(clen) * mult;
	
	if ( !str_to_Waddr(str, &addr) ) {
		sprintf(buf, "%s incorrect address `%s' for tagname: `%s'\n",
						err_diag, str, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( PktLenAddrTag = PktLenAddrTagFirst; PktLenAddrTag; PktLenAddrTag = PktLenAddrTag->next )
	{
		if (!stricmp(tag, PktLenAddrTag->tag)) {
			mark = PktLenAddrTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		PktLenAddrTag = mark;
	}
	else {    /* create new tag */
		PktLenAddrTag = (struct LengthAddrTags *)calloc(1, sizeof(struct LengthAddrTags));
		PktLenAddrTag->next  = NULL;
		/*//////////////////////*/
		strcpy(PktLenAddrTag->tag, tag);
		/*//////////////////////*/
		PktLenAddrTag->rec = PktLenAddrTag->recfirst = PktLenAddrTag->reclast  = NULL;
		
		if (PktLenAddrTagLast) {
			PktLenAddrTagLast->next = PktLenAddrTag;
		}
		else {
			PktLenAddrTagFirst = PktLenAddrTag;
		}
		
		PktLenAddrTagLast = PktLenAddrTag;
	}
	
	PktLenAddrTag->rec = (struct LengthAddr *)calloc(1, sizeof(struct LengthAddr));
	PktLenAddrTag->rec->next = NULL;
	/*/////////////////////////////*/
	PktLenAddrTag->rec->len = len;
	PktLenAddrTag->rec->addr = addr;
	/*/////////////////////////////*/
	
	if (PktLenAddrTag->reclast) {
		PktLenAddrTag->reclast->next = PktLenAddrTag->rec;
	}
	else {
		PktLenAddrTag->recfirst = PktLenAddrTag->rec;
	}
	
	PktLenAddrTag->reclast = PktLenAddrTag->rec;
	
	return;
}
