
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/* defined in deffage.c*/
dword get_age(char *cage);

void defProcAge(char *tag, char *str, char *err_diag)
{
/* call: (" DAYS[:MINS] , [addr]) */
	
	struct ProcAgeTags *ProcAgeTag = NULL, *mark = NULL;
	char buf[256], cage[10], caddr[128];
	ADDR addr;
	dword secs = 0L;

	/* TAG */
	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	addr.zone = addr.net = addr.node = addr.point = Wild_1;
	
	/* AGE as DAYS[:MINS] */
	get_next_word(str, cage);
	cage[9] = 0;

	if ((dword)-1L == (secs = get_age(cage))) {
		sprintf(buf, "%s syntax in age : `%s' -- should be days:mins",
						err_diag, cage);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////*/
	addtag( (int) PROCESSAGE, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	

	/* ADDR */
	if (get_next_word(str, caddr)) {
		
		caddr[127] = 0;

		if ( !str_to_Waddr(caddr, &addr) ) {
			sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( ProcAgeTag = ProcAgeTagFirst; ProcAgeTag; ProcAgeTag = ProcAgeTag->next )
	{
		if (!stricmp(tag, ProcAgeTag->tag)) {
			mark = ProcAgeTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		ProcAgeTag = mark;
	}
	else {    /* create new tag */
		ProcAgeTag = (struct ProcAgeTags *)calloc(1, sizeof(struct ProcAgeTags));
		ProcAgeTag->next  = NULL;
		/*//////////////////////*/
		strcpy(ProcAgeTag->tag, tag);
		/*//////////////////////*/
		ProcAgeTag->rec = ProcAgeTag->recfirst = ProcAgeTag->reclast  = NULL;
		
		if (ProcAgeTagLast) {
			ProcAgeTagLast->next = ProcAgeTag;
		}
		else {
			ProcAgeTagFirst = ProcAgeTag;
		}
		
		ProcAgeTagLast = ProcAgeTag;
	}
	
	ProcAgeTag->rec = (struct MsgAge *)calloc(1, sizeof(struct MsgAge));
	ProcAgeTag->rec->next = NULL;
	/*//////////////////////*/
	ProcAgeTag->rec->secs = secs;
	ProcAgeTag->rec->addr = addr;
	/*//////////////////////*/
	
	if (ProcAgeTag->reclast) {
		ProcAgeTag->reclast->next = ProcAgeTag->rec;
	}
	else {
		ProcAgeTag->recfirst = ProcAgeTag->rec;
	}
	
	ProcAgeTag->reclast = ProcAgeTag->rec;

	
	return;
}
