
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/*                              1            2                    3
   call: FtnDefReAddressList( "Tag" , "Address_String1" , "Address_String2" )
*/
/************************************************************************/
void defReAddressList(char *tag, char *str, char *err_diag)
{
	
	char caddr[64], buf[256];
	struct ReAddrTags *ReAddrTag = NULL, *mark = NULL;
	ADDR addr1, addr2;
	
	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

	/* ADDR1 */
	get_next_word(str, caddr);
	caddr[63] = 0;
	if ( !str_to_Waddr(caddr, &addr1) ) {
		sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

	/* ADDR2 */
	get_next_word(str, caddr);
	caddr[63] = 0;
	if ( !str_to_Waddr(caddr, &addr2) ) {
		sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag(READDRESSLIST, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	
/*///////////////////////////////////////////////////////////////////////*/
	
	if (ReAddrTagFirst) {
		ReAddrTag = ReAddrTagFirst;
		do {
			if (!stricmp(tag, ReAddrTag->tag)) {
				mark = ReAddrTag;
				break;
			}
			ReAddrTag = ReAddrTag->next;
		} while (ReAddrTag);
	}

	if (mark) { /* tag already defined */
		ReAddrTag = mark;
	}
	else {    /* create new tag */
		ReAddrTag = (struct ReAddrTags *)calloc(1, sizeof(struct ReAddrTags));
		ReAddrTag->next  = NULL;
		/*////////////////////////*/
		strcpy(ReAddrTag->tag, tag);
		/*////////////////////////*/
		ReAddrTag->rec  = NULL;
		ReAddrTag->recfirst = NULL;
		ReAddrTag->reclast  = NULL;
		
		if (ReAddrTagLast) {
			ReAddrTagLast->next = ReAddrTag;
		}
		else {
			ReAddrTagFirst = ReAddrTag;
		}
		
		ReAddrTagLast = ReAddrTag;
	}
	
	ReAddrTag->rec = (struct ReAddressList *)calloc(1, sizeof(struct ReAddressList));
	ReAddrTag->rec->next = NULL;
	/*//////////////////////////*/
	ReAddrTag->rec->addr1 = addr1;
	ReAddrTag->rec->addr2 = addr2;
	/*//////////////////////////*/
	if (ReAddrTag->reclast) {
		ReAddrTag->reclast->next = ReAddrTag->rec;
	}
	else {
		ReAddrTag->recfirst = ReAddrTag->rec;
	}
	
	ReAddrTag->reclast = ReAddrTag->rec;
	
}
