
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/* DATA ROUTING
   call: ( "tag" , "flavor1", "flavor2", ...,  "Dest", "Targ1" , "Targ2" , ...)
	
   argc = 3 or more
*/
/***************************************************************************/
void defRouting(char *tag, char *str, char *err_diag)
{
	int i;
	char s[256], *pflav = NULL;
	char w[256];
	struct RoutingTags *RoutingTag = NULL, *mark=NULL;
	ADDR dest_addr, targ_addr;
	word flavor, nflav = 0;
	BOOL found = No, Neg = No;
	
	strUpper(tag); tag[19] = 0;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(s, "%s incorrect data block name : `%s'\n", err_diag, tag);
		fprintf(stderr, "\7%s", s);
		writeToLog(0, s);
		abort();
	}

	/*///////////////////*/
	addtag(ROUTING, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	

	if (RoutingTagFirst) {
		RoutingTag = RoutingTagFirst;
		do {
			if ( !stricmp(tag, RoutingTag->tag) ) {
				mark = RoutingTag;
				break;
			}
			RoutingTag = RoutingTag->next;
		} while (RoutingTag);
	}

	if (mark) /* tag already defined */
		RoutingTag = mark;
	else {    /* create new tag */
		RoutingTag = (struct RoutingTags *)calloc(1, sizeof(struct RoutingTags));
		RoutingTag->next  = NULL;
		/*////////////////////////*/
		strcpy(RoutingTag->tag,tag);
		/*////////////////////////*/
		RoutingTag->rec  = NULL;
		RoutingTag->recfirst = NULL;
		RoutingTag->reclast  = NULL;
		
		if (RoutingTagLast) {
			RoutingTagLast->next = RoutingTag;
		}
		else {
			RoutingTagFirst = RoutingTag;
		}
		
		RoutingTagLast = RoutingTag;
	}

	RoutingTag->rec = (struct Routing *)calloc(1, sizeof(struct Routing));
	RoutingTag->rec->next = NULL;
	

	/* FLAVORS */
	nflav = 0;
	while(get_next_word(str, w))
	{
		Neg = No;
		pflav = w;
		if (*pflav == '!') {
			++pflav;
			Neg = Yes;
		}
		
		for( i = 0, found = No; strlen( Flavors[i].s ); ++i)
		{
			if ( !stricmp(Flavors[i].s, pflav) ) {
				flavor = Flavors[i].n;
				if (Neg == Yes)
					flavor |= flv_NEG;
				if (nflav < 10)
					RoutingTag->rec->flavor[nflav++] = flavor;
				
				found = Yes;
				break;
			}
		}
		
		if (found == No)
			break;
		
	} /* flavor loop */
	
	if (!strlen(str)) {
		sprintf(s, "%s incorrect argument count\n", err_diag);
		fprintf(stderr, "\7%s", s);
		writeToLog(0, s);
		abort();
	}


	/* DEST */
	if ( !str_to_Waddr(w, &dest_addr) ) {
		sprintf(s, "%s incorrect <dest> : `%s'\n", err_diag, w);
		fprintf(stderr, "\7%s", s);
		writeToLog(0, s);
		abort();
	}

	RoutingTag->rec->dest  = dest_addr;

	RoutingTag->rec->targlist  = NULL;
	RoutingTag->rec->targfirst = NULL;
	RoutingTag->rec->targlast  = NULL;
	

	if (!strlen(str)) {
		sprintf(s, "%s incorrect argument count\n", err_diag);
		fprintf(stderr, "\7%s", s);
		writeToLog(0, s);
		abort();
	}


	/* TARGETS */
	while(get_next_word(str, w))
	{
		RoutingTag->rec->targlist = (struct targets *)calloc(1, sizeof(struct targets));
		RoutingTag->rec->targlist->next  = NULL;
		
		if (!str_to_Waddr(w, &targ_addr)) {
			sprintf(s, "%s incorrect <target> : `%s'\n", err_diag, w);
			fprintf(stderr, "\7%s", s);
			writeToLog(0, s);
			abort();
		}
		
		RoutingTag->rec->targlist->targ  = targ_addr;
	
		if (RoutingTag->rec->targlast) {
			RoutingTag->rec->targlast->next = RoutingTag->rec->targlist;
		}
		else {
			RoutingTag->rec->targfirst = RoutingTag->rec->targlist;
		}
		
		RoutingTag->rec->targlast = RoutingTag->rec->targlist;
	}
	
	if (RoutingTag->reclast)
		RoutingTag->reclast->next = RoutingTag->rec;
	else
		RoutingTag->recfirst = RoutingTag->rec;
	
	RoutingTag->reclast = RoutingTag->rec;

	
	return;
}

