
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/************************************************************************/
void defSubject(char *tag, char *subject, char *err_diag)
{
	struct SubjectTags *SubjectTag = NULL, *mark = NULL;
	char buf[256], regbuf[100];
	regex_t *preg = NULL;
	int rc;

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) SUBJECT, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	
	remove_quotes( subject );

	if (UseRegExp) {
		preg = (regex_t *)calloc(1, sizeof(regex_t));
		if (0 != (rc = regcomp (preg, subject, REG_EXTENDED|rxIcase))) {
			regerror (rc, preg, regbuf, 100);
			sprintf(buf, "%s regular expression syntax : `%s' (%s)",
							err_diag, subject, regbuf);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}
/*//////////////////////////////////////////////////////////////////////////*/

	for( SubjectTag = SubjectTagFirst; SubjectTag; SubjectTag = SubjectTag->next )
	{
		if (!stricmp(tag, SubjectTag->tag)) {
			mark = SubjectTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		SubjectTag = mark;
	}
	else {    /* create new tag */
		SubjectTag = (struct SubjectTags *)calloc(1, sizeof(struct SubjectTags));
		SubjectTag->next  = NULL;
		/*//////////////////////*/
		strcpy(SubjectTag->tag, tag);
		/*//////////////////////*/
		SubjectTag->rec = SubjectTag->recfirst = SubjectTag->reclast  = NULL;
		
		if (SubjectTagLast) {
			SubjectTagLast->next = SubjectTag;
		}
		else {
			SubjectTagFirst = SubjectTag;
		}
		
		SubjectTagLast = SubjectTag;
	}
	
	SubjectTag->rec = (struct Subject *)calloc(1, sizeof(struct Subject));
	SubjectTag->rec->next = NULL;
	/*/////////////////////////////*/
	subject[71] = '\0';
	strcpy(SubjectTag->rec->subject, subject);
	SubjectTag->rec->preg = preg;
	/*/////////////////////////////*/
	
	if (SubjectTag->reclast) {
		SubjectTag->reclast->next = SubjectTag->rec;
	}
	else {
		SubjectTag->recfirst = SubjectTag->rec;
	}
	
	SubjectTag->reclast = SubjectTag->rec;
	
	return;
}
