
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/*               1            2              3        4      5
   DefSystem( "Tag" , "Address_String" , "Domain" , zone1 , zone2....)
*/
void defSystem(char *tag, char *str, char *err_diag)
{
	struct SystemTags *SystemTag = NULL, *mark = NULL;
	ADDR addr;
	char  caddr[64], domain[64], buf[256], w[256];
	int i;
	word z;

	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(3, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) SYSTEM, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/

	/* ADDRESS */
	get_next_word(str, caddr);
	caddr[63] = 0;
	
	if ( !str_to_addr(caddr, &addr) ) {
		sprintf(buf, "%s incorrect address : `%s'\n", err_diag, caddr);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

	/* DOMAIN */
	get_next_word(str, domain);
	domain[63] = 0;
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( SystemTag = SystemTagFirst; SystemTag; SystemTag = SystemTag->next )
	{
		if (!stricmp(tag, SystemTag->tag)) {
			mark = SystemTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		SystemTag = mark;
	}
	else {    /* create new tag */
		SystemTag = (struct SystemTags *)calloc(1, sizeof(struct SystemTags));
		SystemTag->next  = NULL;
		/*//////////////////////*/
		strcpy(SystemTag->tag, tag);
		/*//////////////////////*/
		SystemTag->rec = SystemTag->recfirst = SystemTag->reclast  = NULL;
		
		if (SystemTagLast) {
			SystemTagLast->next = SystemTag;
		}
		else {
			SystemTagFirst = SystemTag;
		}
		
		SystemTagLast = SystemTag;
	}
	
	SystemTag->rec = (struct System *)calloc(1, sizeof(struct System));
	SystemTag->rec->next = NULL;
	/*//////////////////////*/
	SystemTag->rec->addr = addr;
	strcpy( SystemTag->rec->domain, domain );
	/*///////////////////////////////////////////////////////////*/

	/* ZONES */
	for( i = 0 ; i < 20 ; ++i )
		SystemTag->rec->zones[i] = 0;

	i = 0;
	while(get_next_word(str, w))
	{
		if (0 == (z = (word)atoi(w))) {
			sprintf(buf, "%s incorrect zone : `%s'\n", err_diag, w);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
		SystemTag->rec->zones[i] = z;
		if (++i == 20)
			break;
	}
	if (!i) {
		sprintf(buf, "%s no zones defined\n", err_diag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	
	/*///////////////////////////////////////////////////////////*/
	
	if (SystemTag->reclast) {
		SystemTag->reclast->next = SystemTag->rec;
	}
	else {
		SystemTag->recfirst = SystemTag->rec;
	}
	
	SystemTag->reclast = SystemTag->rec;
	
	return;
}
