
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"


/************************************************************************/
void defTextString(char *tag, char *tstr, char *err_diag)
{
	struct TextStrTags *TextStrTag = NULL, *mark = NULL;
	char buf[256], regbuf[100];
	regex_t *preg = NULL;
	int rc;
	
	if ( !is_legal_tag(tag) ) {
		sprintf(buf, "%s incorrect data block name : `%s'", err_diag, tag);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	/*///////////////////*/
	addtag( (int) TEXTSTRING, tag, err_diag);  /* add tag to the global taglist */
	/*///////////////////*/
	remove_quotes( tstr );
	
	if (UseRegExp) {
		preg = (regex_t *)calloc(1, sizeof(regex_t));
		if (0 != (rc = regcomp (preg, tstr, REG_EXTENDED|rxIcase))) {
			regerror (rc, preg, regbuf, 100);
			sprintf(buf, "%s regular expression syntax : `%s' (%s)",
							err_diag, tstr, regbuf);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}
	
/*//////////////////////////////////////////////////////////////////////////*/

	for( TextStrTag = TextStrTagFirst; TextStrTag; TextStrTag = TextStrTag->next )
	{
		if (!stricmp(tag, TextStrTag->tag)) {
			mark = TextStrTag;
			break;
		}
	}

	if (mark) { /* tag already defined */
		TextStrTag = mark;
	}
	else {    /* create new tag */
		TextStrTag = (struct TextStrTags *)calloc(1, sizeof(struct TextStrTags));
		TextStrTag->next  = NULL;
		/*//////////////////////*/
		strcpy(TextStrTag->tag, tag);
		/*//////////////////////*/
		TextStrTag->rec = TextStrTag->recfirst = TextStrTag->reclast  = NULL;
		
		if (TextStrTagLast) {
			TextStrTagLast->next = TextStrTag;
		}
		else {
			TextStrTagFirst = TextStrTag;
		}
		
		TextStrTagLast = TextStrTag;
	}
	
	TextStrTag->rec = (struct TextStr *)calloc(1, sizeof(struct TextStr));
	TextStrTag->rec->next = NULL;
	/*/////////////////////////////*/
	strcpy(TextStrTag->rec->str, tstr);
	TextStrTag->rec->preg = preg;
	/*/////////////////////////////*/
	
	if (TextStrTag->reclast) {
		TextStrTag->reclast->next = TextStrTag->rec;
	}
	else {
		TextStrTag->recfirst = TextStrTag->rec;
	}
	
	TextStrTag->reclast = TextStrTag->rec;
	
	return;
}
