
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"
#ifdef __WATCOMC__
#include <direct.h>
#else
#include <dirent.h>
#endif


dword fetch_ts(char *areaname);
dword seadog_to_unix(char *date);
char * unix_to_ftscdate(time_t t, char *s);
dword fdate_to_unix(word *ftime, word *fdate);
void adjust_lastread (const char* lr, int type);

/* called from scan.h */
void    select_fido_area(char *areapath, FIDO_AREA *fido);

/* readmsg.h*/
BOOL read_fido_msg(char *fname, FIDO_MSG *msgHdr, TEXT **first);


/* init.c */
dword get_lastread(char *areaname);

TEXT * str_to_text(char *buf);  

/* called from msg.c */
int     create_fido_msg( char *areatag, FIDO_MSG Hdr, TEXT *Text);
BOOL    write_fido_msg(char *fname, FIDO_MSG hdr, TEXT *txt);
BOOL    kill_fido_msg(void);
void    msghdr_to_ftn(FIDO_MSG msgHdr, FTN *ftn);
void    ftn_to_msghdr(FTN ftn, FIDO_MSG *msgHdr);
int     get_highest_fname(char *areatag, char *areapath, char *ext);

/* called from renumber.c */
void fido_pack(char *areatag);


/* defined in time.c */
extern dword ftscdate_to_unix(char *date);


static int  get_max_msg(char *areapath, char *ext);
/* static void set_highest_fname(char *areatag, int n); */

static int fido_cmp(struct Fnames *s1, struct Fnames *s2)
{
	register int i1, i2;
	
	i1 = atoi(s1->fname);
	i2 = atoi(s2->fname);
	
	return (i1 < i2)? -1 : (i1 > i2);
}

BOOL is_fido_msg(char *q, char *ext)
{
	while(*q && isdigit(*q))
		++q;

	if (*(q++) == '.')
	    return (stricmp(q, ext) == 0);
	return 0;
}

/*************************************************************************/
void select_fido_area(char *areapath, FIDO_AREA *fido)
{
	char s[256], buf[256];
#ifdef __OS2__  
	HDIR          fh = 1;
	FILEFINDBUF3  fb;
	ULONG         rc, fc = 10L;
#else
	DIR *dir;
	struct dirent *d;
#endif  

#if !defined UNIX && !defined __MINGW32__
	char *p, *q;
	int i;
#endif
	register int  total = 0;
	struct Fnames *f = NULL;

	if (TsHandle != -1)
		fido->ts = fetch_ts(CurMsg.areaname);
	else
		fido->ts = 0L;
	
	CurMsg.maxts = fido->ts;
	
	

#ifdef __OS2__
	sprintf(s, "%s*.msg", areapath);

	sprintf(buf, "select_fido_area: search for pattern `%s'\n", s);
	writeToLog(4, buf);
	rc = DosFindFirst(s, &fh, 0, &fb, sizeof(fb), &fc, FIL_STANDARD);

	while (!rc) {
		
		for( p = (char *)&fb, i = 0; i < fc;
				p += ((FILEFINDBUF3 *)p)->oNextEntryOffset, ++i)
		{
			dword ts = 0L;

			q = ((FILEFINDBUF3 *)p)->achName;
			while(*q && isdigit(*q))
				++q;
			
			if (*q != '.')
				continue;
			
			
			ts = fdate_to_unix((word *)&((FILEFINDBUF3 *)p)->ftimeLastWrite,
												(word *)&((FILEFINDBUF3 *)p)->fdateLastWrite);

			ts += TZOFF; /* local -> UTC */

			if (ts > fido->ts) {
							
				if (!f)
					f = (struct Fnames *)malloc(sizeof(struct Fnames));
				else
					f = (struct Fnames *)realloc(f, (total+1)*sizeof(struct Fnames));

				strcpy(f[total].fname, ((FILEFINDBUF3 *)p)->achName);
				f[total++].ts = ts;

				if (!((FILEFINDBUF3 *)p)->oNextEntryOffset)
					break;
				
			}  /* timestamp ok */
		}
		rc = DosFindNext(fh, &fb, sizeof(fb), &fc);
	}

	DosFindClose(fh);
#else

#ifdef __MINGW32__
	dirNameLen = strlen(areapath)-1;
	areapath[dirNameLen] = 0;
#endif

	dir = opendir(areapath);

#ifdef __MINGW32__
	areapath[dirNameLen] = '\\';
#endif
	if (dir) {
		while ((d = readdir(dir))) {
	
			dword ts = 0L;
			struct stat st;

			if (!is_fido_msg(d->d_name, "msg"))
				continue;

			sprintf(s, "%s%s", areapath, d->d_name);
			if (stat(s, &st)) {
		perror("stat");
					abort();
			}

			ts = st.st_mtime;
			sprintf(buf, "select_fido: found `%s' with mtime=%ld\n", s, (long)st.st_mtime);
			writeToLog(5, buf);
			
			ts += TZOFF; /* local -> UTC */

			if (ts > fido->ts) {
				if (!f)
					f = (struct Fnames *)malloc(sizeof(struct Fnames));
				else
					f = (struct Fnames *)realloc(f, (total+1)*sizeof(struct Fnames));

				strcpy(f[total].fname, d->d_name);
				f[total++].ts = ts;
			}
		}
		closedir(dir);
	}
#endif

	qsort (f, total, sizeof (*f), (int (*)(const void*, const void*)) fido_cmp);
	
	fido->fnames = f;
	fido->total = total;
	fido->n = 0;

/*  set_highest_fname(CurMsg.areaname, total); */
	
	return;
}

/*******************************************************************/
int create_fido_msg( char *areatag, FIDO_MSG Hdr, TEXT *Text )
{
	int n;
	char buf[256], fname[128], areapath[128], full_new_name[256];

	/* get new filename in target area */
	if (!areaname_to_path(areatag, areapath)) {
		sprintf(buf, "create_fido_msg: error getting path for fidoarea `%s'\n", areatag);
		writeToLog(4, buf);
		return Fail;
	}
	
	n = get_highest_fname(areatag , areapath, "msg");
	sprintf( fname , "%d.msg", n);
	sprintf( full_new_name , "%s%s", areapath, fname );

	sprintf( buf , "create_fido_msg: add mail to fido area `%s' : `%s'\n",
					areatag , full_new_name );
	writeToLog(4, buf);

	if (!write_fido_msg(full_new_name, Hdr, Text)) {
		return Fail;
	}
	
	strcpy (OutFileName, full_new_name);
	return n;
	
}

/***************************************************************/
BOOL read_fido_msg(char *fname, FIDO_MSG *msgHdr, TEXT **first)
{
	int h; 
	
/*	word rawdate, rawtime; */
	char *buf=NULL;
	char s[256];
	char buf_msg[OMSG_SIZE], *pbuf_msg = buf_msg;
	unsigned long len;
	time_t ut;
	
	if( -1 == (h = sopen(fname, O_RDWR|O_BINARY, SH_DENYNO, ACCFILE)) ) {
		perror(fname);
		return  Fail;
	}

	lseek(h ,0 ,SEEK_SET);
	
	
	/* read msg header */

	if (OMSG_SIZE != read(h, &buf_msg, OMSG_SIZE)) {
		close(h);
		return Fail;
	}
	
	memmove(&(msgHdr->fromName), pbuf_msg, 36);
	pbuf_msg += 36;
	msgHdr->fromName[35] = '\0';

	memmove(&(msgHdr->toName), pbuf_msg, 36);
	pbuf_msg += 36;
	msgHdr->toName[35]   = '\0';
	
	memmove(&(msgHdr->subject), pbuf_msg, 72);
	pbuf_msg += 72;
	msgHdr->subject[71]  = '\0';

	memmove(&(msgHdr->DateTime), pbuf_msg, 20);
	pbuf_msg += 20;
	msgHdr->DateTime[19] = '\0';
	
	msgHdr->TimesRead = get_word(pbuf_msg);
	pbuf_msg += 2;

	msgHdr->toNode = get_word(pbuf_msg);
	pbuf_msg += 2;

	msgHdr->fromNode = get_word(pbuf_msg);
	pbuf_msg += 2;
	
	msgHdr->cost = get_word(pbuf_msg);
	pbuf_msg += 2;
	
	msgHdr->fromNet = get_word(pbuf_msg);
	pbuf_msg += 2;
	
	msgHdr->toNet = get_word(pbuf_msg);
	pbuf_msg += 2;
	
	msgHdr->toZone = get_word(pbuf_msg);
	pbuf_msg += 2;
	
	msgHdr->fromZone = get_word(pbuf_msg);
	pbuf_msg += 2;

	msgHdr->toPoint = get_word(pbuf_msg);
	pbuf_msg += 2;

	msgHdr->fromPoint = get_word(pbuf_msg);
	pbuf_msg += 2;

	msgHdr->replyTo = get_word(pbuf_msg);
	pbuf_msg += 2;

	msgHdr->attr = get_word(pbuf_msg);
	pbuf_msg += 2;

	msgHdr->nextReply = get_word(pbuf_msg);
	pbuf_msg += 2;

	if (Fail == (ut = ftscdate_to_unix(msgHdr->DateTime)) &&
			Fail == (ut = seadog_to_unix(msgHdr->DateTime)) ) {
		sprintf(s, "read_fido_msg error: invalid date `%s'\n", msgHdr->DateTime);
		writeToLog(1, s);
		ut = time(NULL);
/*    return Fail; */
	}
	
	unix_to_ftscdate(ut, msgHdr->DateTime);
	
	len = filelength(h) - OMSG_SIZE;
	if (NULL == (buf = (char *)calloc(len+1, sizeof(char)))) {
		close(h);
		writeToLog(4, "read_fido_msg error: low memo reading msg\n");
		return Fail;
	}
	
	if (len != read(h, buf,len )) {
		close(h);
		free(buf);
		return Fail;
	}
	
	
	(*first) = str_to_text(buf);

	free(buf);

	/* store timestamp */

	close(h);
	
	return Ok;
}

/**************************************************************/
BOOL write_fido_msg(char *fname, FIDO_MSG hdr, TEXT *txt)
{
	int h;
/*	unsigned long len; */
	char buf[256];
	char buf_msg[OMSG_SIZE], *pbuf_msg = buf_msg;
	
	if (-1 == (h = sopen(fname, O_RDWR|O_BINARY|O_CREAT|O_EXCL, SH_DENYNO, ACCFILE))) {
		sprintf(buf, "write_fido_msg: can`t create file: `%s'\n", fname);
		perror(fname);
		writeToLog(0, buf);
		return Fail;
	}
	
	lseek( h, 0L, SEEK_SET);
	
/*	len = sizeof( FIDO_MSG ); */

	memmove(pbuf_msg, &(hdr.fromName), 36);
	pbuf_msg += 36;
	memmove(pbuf_msg, &(hdr.toName), 36);
	pbuf_msg += 36;
	memmove(pbuf_msg, &(hdr.subject), 72);
	pbuf_msg += 72;
	memmove(pbuf_msg, &(hdr.DateTime), 20);
	pbuf_msg += 20;
	put_word(pbuf_msg, hdr.TimesRead);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.toNode);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.fromNode);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.cost);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.fromNet);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.toNet);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.toZone);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.fromZone);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.toPoint);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.fromPoint);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.replyTo);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.attr);
	pbuf_msg += 2;
	put_word(pbuf_msg, hdr.nextReply);
	pbuf_msg += 2;

	/* write msg hdr */
	if ( OMSG_SIZE != write(h, &buf_msg, OMSG_SIZE) ) {
		sprintf(buf, "write_fido_msg: error writing file: `%s'\n", fname);
		writeToLog(0, buf);
		close(h);
		return Fail;
	}

	/* write msg text */
	{
		char *str = NULL;
		dword len = 0L, l0 = 0L, l;
		for( ; txt; txt = txt->next)
		{
			l = strlen(txt->str);
			len += l;
			if (!str)
				str = (char *)malloc((len+1)*sizeof(char));
			else
				str = (char *)realloc(str, (len+1));
			memcpy(&str[l0], txt->str, l);
			l0 = len;
		}
		
		if ( len != write(h, str, len) ) {
			sprintf(buf, "write_fido_msg: error writing file `%s'\n", fname);
			writeToLog(0, buf);
			free(str);
			close(h);
			return Fail;
		}
		free(str);
	}

	strcpy(buf, "\0");
	write(h, buf, 1L);

	close(h);
	return Ok;
}
/****************************************************************************/
BOOL kill_fido_msg(void)
{
	char fname[256], buf[256], lr[256];
/*	struct stat st; */
	
	sprintf(fname , "%s%s", CurMsg.areapath,
						CurMsg.fido.fnames[CurMsg.fido.n-1].fname);

	if ( remove(fname) ) {
		sprintf(buf, "kill_fido_msg: error deleting msg file: `%s'\n", fname);
		writeToLog(4, buf);
		return Fail;
	}
	
  
	sprintf (lr, "%sLASTREAD", CurMsg.areapath);
	adjust_lastread (lr, LR_FIDO);
	
	return Ok;
}

/**********************************************/
void msghdr_to_ftn(FIDO_MSG msgHdr, FTN *ftn)
{
	ftn->to.net    = msgHdr.toNet;
	ftn->to.node   = msgHdr.toNode;
	ftn->from.net  = msgHdr.fromNet;
	ftn->from.node = msgHdr.fromNode;
	strcpy(ftn->fromName, msgHdr.fromName);
	strcpy(ftn->toName, msgHdr.toName);
	strcpy(ftn->subject, msgHdr.subject);
	strcpy(ftn->DateTime, msgHdr.DateTime);
	ftn->attr = msgHdr.attr;
	
	ftn->to.zone = ftn->from.zone = 0;
	
	ftn->utime = ftscdate_to_unix(ftn->DateTime);
	
	
	return;
}
/*********************************************/
void ftn_to_msghdr(FTN ftn, FIDO_MSG *msgHdr)
{
	msgHdr->toNet = ftn.to.net;
	msgHdr->toNode = ftn.to.node;
	msgHdr->fromNet = ftn.from.net;
	msgHdr->fromNode = ftn.from.node;
	memset(msgHdr->fromName, 0, 36);
	strcpy(msgHdr->fromName, ftn.fromName);
	memset(msgHdr->toName, 0, 36);
	strcpy(msgHdr->toName, ftn.toName);
	memset(msgHdr->subject, 0, 72);
	strcpy(msgHdr->subject, ftn.subject);
	strcpy(msgHdr->DateTime, ftn.DateTime);
	msgHdr->attr = ftn.attr;
	
	return;
}

/**************************************************/
/*
static void set_highest_fname(char *areatag, int n)
{
	char buf[256];
	struct MaxMsgNos *MaxMsgNo;
	
	for( MaxMsgNo = MaxMsgNoFirst; MaxMsgNo; MaxMsgNo = MaxMsgNo->next )
		if (!stricmp( MaxMsgNo->area, areatag))
				break;
	
	if (!MaxMsgNo) {
		MaxMsgNo = (struct MaxMsgNos *)calloc(1, sizeof(struct MaxMsgNos));
		MaxMsgNo->next  = NULL;
		if (MaxMsgNoLast) {
			MaxMsgNoLast->next = MaxMsgNo;
		}
		else {
			MaxMsgNoFirst = MaxMsgNo;
		}
		
		MaxMsgNoLast = MaxMsgNo;
	}
	
	strcpy(MaxMsgNo->area, areatag);
	MaxMsgNo->n = n+1;

	sprintf(buf, "set_highwater: area:%s, set max msg no=%d\n",
					areatag, n+1);
	writeToLog(4, buf);
	

	return;
	
}
*/

/**********************************************************************/
int get_highest_fname(char *areatag, char *areapath, char *ext)
{
	int n = 0;
	struct MaxMsgNos *MaxMsgNo = NULL;
	char buf[256];

	
	/*//////////////////////////////////////////////////////*/
	for( MaxMsgNo = MaxMsgNoFirst; MaxMsgNo; MaxMsgNo = MaxMsgNo->next )
		if (!stricmp( MaxMsgNo->area, areatag))
				break;
	
	if (MaxMsgNo) {
/*		struct find_t ffblk; */
		char fname[256];
		
		n = MaxMsgNo->n++;
		sprintf(fname, "%s%d.%s", areapath, n, ext);
		sprintf(buf, "get_highwater, got %d from cache, check `%s'\n",
						n, fname);
		writeToLog(4, buf);
		if (!access(fname, 0)) {
			writeToLog(4, "get_highwater, file got from cache exists, re-read\n");
			n = get_max_msg(areapath, ext);
			MaxMsgNo->n = n + 1;
		}
		
	}
	else {
		n = get_max_msg(areapath, ext);
		sprintf(buf, "get_highwater: fetch max msg no directly (%d)\n", n);
		writeToLog(4, buf);


		MaxMsgNo = (struct MaxMsgNos *)calloc(1, sizeof(struct MaxMsgNos));
		MaxMsgNo->next  = NULL;
		/*//////////////////////*/
		strcpy(MaxMsgNo->area, areatag);
		MaxMsgNo->n = n+1;
		/*//////////////////////*/
		if (MaxMsgNoLast) {
			MaxMsgNoLast->next = MaxMsgNo;
		}
		else {
			MaxMsgNoFirst = MaxMsgNo;
		}

		MaxMsgNoLast = MaxMsgNo;
	}

	return n;
}
/***********************************************/
static int get_max_msg(char *areapath, char *ext)
{
	char s[256], buf[256];
#if !defined UNIX && !defined __MINGW32__
	char *p;
	int i;
#endif
	int n, tot = 0;
#ifdef __OS2__
	HDIR          fh = 1;
	FILEFINDBUF3  fb;
	ULONG         rc, fc = 10L;
#else
	DIR *dir;
	struct dirent *de;
#endif
	
	sprintf(s, "%s*.%s", areapath, ext);

	sprintf(buf, "get_max_msg: search for pattern `%s'\n", s);
	writeToLog(4, buf);

#ifdef __OS2__
	rc = DosFindFirst(s, &fh, 0, &fb, sizeof(fb), &fc, FIL_STANDARD);

	while (!rc) {
		
		for( p = (char *)&fb, i = 0; i < fc;
				p += ((FILEFINDBUF3 *)p)->oNextEntryOffset, ++i)
		{

			n = atoi( ((FILEFINDBUF3 *)p)->achName );
			if (n > tot)
				tot = n;

			if (!((FILEFINDBUF3 *)p)->oNextEntryOffset)
				break;
				
		}
		rc = DosFindNext(fh, &fb, sizeof(fb), &fc);
	}

	DosFindClose(fh);
#else

#ifdef __MINGW32__
	dirNameLen = strlen(areapath)-1;
	areapath[dirNameLen] = 0;
#endif

	dir = opendir(areapath);

#ifdef __MINGW32__
	areapath[dirNameLen] = '\\';
#endif

	while (dir && (de = readdir(dir)))
	{
					if (is_fido_msg(de->d_name, ext)) {
		n = atoi(de->d_name);
		if (n > tot)
			tot = n;
		}
	}
	closedir(dir);
#endif
	
	return tot+1;
}

/******************************/
void fido_pack(char *areatag)
{
	FIDO_AREA fido;
	char areapath[128];
	char o[256], n[256], fname[128], buf[256];
	int i, total, delta = 0, cnt = 0;

	
	(void) areaname_to_path(areatag, areapath);
	
	select_fido_area(areapath, &fido);

	total = fido.total;

	if (!total)
		return;

	if( Chat_On ) {
		strUpper(areatag);
		sprintf(buf, "Renumbering *.MSG base (%s) ", areatag);
		printf("%s", buf);
		delta = total / (66 - strlen(buf));
		if (delta == 0)
			delta = 1;
	}
	
	
	for(i = 0; i < total; ++i)
	{

		if (Chat_On) {
			if (++cnt == delta) {
				printf("3");
/*				putch(''); */
				cnt = 0;
			}
		}
		
		sprintf(o, "%s%s", areapath, fido.fnames[i].fname);
		sprintf(fname, "%d.msg", i+1);
		sprintf(n, "%s%s", areapath, fname);
		rename(o, n);
		
	}

	if (Chat_On)   {
		printf(" done.\n");
	}

	sprintf(buf, "Fido area: %s.  %d messages renumbered\n",
					areatag, total);
	writeToLog(1, buf);

	free(fido.fnames);

	return;
}
