
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

/* #if defined UNIX || defined __MINGW32__ */
#include "patmat.h"

void unix_to_fdate(word *ftime, word *fdate, time_t utime);


long filelength(int h)
{
    long pos, size;
    pos = tell(h);
    lseek(h, 0L, SEEK_END);
    size = tell(h);
    lseek(h, pos, SEEK_SET);
    return size;
}

unsigned check_find_dir(struct find_t *buffer)
{
    struct dirent *sd;
    struct stat filestat;
    char *filename;
    
    while ((sd = readdir(buffer->dir)) != NULL) {
	filename = (char*)xcalloc(strlen(buffer->path)+strlen(sd->d_name)+2, sizeof(char));
	sprintf(filename, "%s%c%s", buffer->path, DELIM, sd->d_name);
#ifndef UNIX
	if (patmat(strUpper(filename), strUpper(buffer->searchname))) {
#else
	if (patmat(filename, buffer->searchname)) {
#endif
	    stat(filename, &filestat);
	    if (buffer->attributes & _A_SUBDIR) {
		if (S_ISDIR(filestat.st_mode)) buffer->attrib = _A_SUBDIR;
/*		else buffer->attrib = 0; */
		buffer->size = filestat.st_size;
		strcpy(buffer->name, sd->d_name);
		unix_to_fdate((word*)&(buffer->wr_time),
			  (word*)&(buffer->wr_date),
			  filestat.st_mtime);
		free(filename);
		return 0;
	    } else {
		if (!S_ISDIR(filestat.st_mode)) {
		    buffer->size = filestat.st_size;
		    strcpy(buffer->name, sd->d_name);
		    unix_to_fdate((word*)&(buffer->wr_time),
				  (word*)&(buffer->wr_date),
				  filestat.st_mtime);
		    free(filename);
		    return 0;
		}
	    }
	}
	free(filename);
    }
    
    return 1;
}

unsigned _dos_findfirst( const char *path, 
unsigned attributes, struct find_t *buffer)
{
    char *tpath, *ptr, *searchname;
    unsigned rc = 1;
    
    memset(buffer, '\0', sizeof(struct find_t));
    
    if (path == NULL) return rc;
    
    tpath = (char*)xcalloc(strlen(path)+1, sizeof(char));
    searchname = (char*)xcalloc(strlen(path)+1, sizeof(char));
    strcpy(tpath, path);
    strcpy(searchname, path);
    
    ptr = strrchr(tpath, DELIM);
    
    if (ptr) *ptr = '\0';
    
    if ((buffer->dir = opendir(tpath)) == NULL) {
	return rc;
    }

    buffer->path = tpath;
    buffer->searchname = searchname;
    buffer->attributes = attributes;

    rc = check_find_dir(buffer);
    
    if (rc) {
	free(buffer->path);
	free(buffer->searchname);
	closedir(buffer->dir);
	memset(buffer, '\0', sizeof(struct find_t));
    }
    
    return rc;
}

unsigned _dos_findnext(  struct find_t *buffer)
{
    buffer->attrib = 0;
    buffer->wr_time = 0;
    buffer->wr_date = 0;
    buffer->size = 0;
    memset(&(buffer->name), '\0', sizeof(buffer->name));
    return check_find_dir(buffer);
}

unsigned _dos_findclose( struct find_t *buffer)
{
    if (!buffer) return 1;
    if (buffer->path) free(buffer->path);
    if (buffer->searchname) free(buffer->searchname);
    if (buffer->dir) closedir(buffer->dir);
    return 0;
}


/* #endif */

