
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

int getblocktype(char *token);


/* static TEXT *list = NULL; */

/* static void getblist(int type); */

/* static void add_list(char *s); */

#if 0

typedef struct RxStemData {
		SHVBLOCK shvb;                     /* Request block for RxVar    */
		CHAR ibuf[256];                    /* Input buffer               */
		CHAR varname[128];                 /* Buffer for the variable    */
																			/* name                       */
		ULONG stemlen;                     /* Length of stem.            */
		ULONG varlen;                      /* Length of variable value   */
		ULONG count;                       /* Number of elements         */
																			/* processed                  */
} RXSTEMDATA;


LONG   EXPENTRY EXPORT 
GetBlockList(PSZ name, LONG argc, PRXSTRING argv, PSZ queue, PRXSTRING  retstr )
{
	char buf[256], err[128];
	ULONG len;
	TEXT *tmp;
	int type = -1;
	RXSTEMDATA  ldp;                     /* stem data                  */
	
	queue = queue;
	argv = argv;
	
	sprintf(err, "REXX (%s),", name);
	if (argc < 1) {
		sprintf(buf, "%s argument count\n", err);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}
	else if (argc == 2) {
		type = getblocktype(RxSTRPTR(argv[1]));
		if (type == -1) {
			sprintf(buf, "%s incorrect block type `%s'\n", err, RxSTRPTR(argv[1]));
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}
	}
	
/*///////////////////////////////////////////////////////////////////////*/
																			/* Initialize data area       */
	ldp.count = 0;
	strcpy(ldp.varname, argv[0].strptr);
	ldp.stemlen = argv[0].strlength;
	strupr(ldp.varname);                 /* uppercase the name         */
	
	if (ldp.varname[ldp.stemlen-1] != '.') { /* if no trailing dot, add it */
		ldp.varname[ldp.stemlen++] = '.';
	}
	
	for((void)getblist(type); list; list = tmp )
	{
		len = strlen(list->str);
		memcpy(ldp.ibuf, list->str, len);
		ldp.varlen = len;
		ldp.count++;
		sprintf(ldp.varname+ldp.stemlen, "%d", ldp.count);

		ldp.shvb.shvnext = NULL;
		ldp.shvb.shvname.strptr = ldp.varname;
		ldp.shvb.shvname.strlength = strlen(ldp.varname);
		ldp.shvb.shvnamelen = ldp.shvb.shvname.strlength;
		ldp.shvb.shvvalue.strptr = ldp.ibuf;
		ldp.shvb.shvvalue.strlength = ldp.varlen;
		ldp.shvb.shvvaluelen = ldp.varlen;
		ldp.shvb.shvcode = RXSHV_SET;
		ldp.shvb.shvret = 0;
		
		if (RexxVariablePool(&ldp.shvb) == RXSHV_BADN) {
			return 1;      /* error on non-zero          */
		}

		tmp = list->next;
		free(list);
		
	} /* text loop */
	
																		/* set stem.0 to lines read   */
	sprintf(ldp.ibuf, "%d", ldp.count);
	ldp.varname[ldp.stemlen] = '0';
	ldp.varname[ldp.stemlen+1] = 0;
	ldp.shvb.shvnext = NULL;
	ldp.shvb.shvname.strptr = ldp.varname;
	ldp.shvb.shvname.strlength = ldp.stemlen+1;
	ldp.shvb.shvnamelen = ldp.stemlen+1;
	ldp.shvb.shvvalue.strptr = ldp.ibuf;
	ldp.shvb.shvvalue.strlength = strlen(ldp.ibuf);
	ldp.shvb.shvvaluelen = ldp.shvb.shvvalue.strlength;
	ldp.shvb.shvcode = RXSHV_SET;
	ldp.shvb.shvret = 0;
	
	if (RexxVariablePool(&ldp.shvb) == RXSHV_BADN) {
		return 1;            /* error on non-zero          */
	}
	
	return 0;                        
}

#endif
/**********************************/
/*
static void getblist(int type)
{
	struct Tags *Tag;
	
	for(Tag = TagFirst; Tag; Tag = Tag->next)
		if (Tag->i == type || type == -1) 
			add_list(Tag->tag);      

	return;
}
*/

/******************************/
#if 1
/*
static void add_list(char *s)
{
	static TEXT *tmp;

	tmp = (TEXT *) calloc(1, sizeof(TEXT) );
	strcpy(tmp->str, s);
	tmp->next = list;

	list = tmp;

	return;
}
*/
#else
/*
static void add_list(char *s)
{
	static TEXT **t, **t2 = NULL;

	for(t = &list; *t; *t = (*t)->next);
	*t = (TEXT *) calloc(1, sizeof(TEXT) );
	strcpy((*t)->str, s);
	(*t)->next = NULL;
	if (t2)
		t2->next = *t;

	return;
}
*/
#endif
int getblocktype(char *token)
{
		int i, type;
		for( i = 0, type = -1; strlen(TagDesc[i].s); ++i )
		{
			if ( !stricmp(TagDesc[i].s, token) ) {
				type = i;
				break;
			}
		}
		return type;
}
