
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"
#include "getopt.h"
#include "date.h"


void banner(void);
void perlver(void);

/*extern BOOL   RegisterRexxFunc(int type);         // rexxcall.c */
/*extern BOOL   CallRexx(char *progname, char *arg);     // rexxcall.c */

extern BOOL   is_full_path(char *);
extern FILE * open_log(char *);

/* defined in init.c */
extern void init(char *cfg, char *arg0);
extern void final_cleanup (void);


static void usage(void);

int CallPerl(char *progname, char *arg);

char VER[20];
#ifdef __MINGW32__
int dirNameLen;
#endif


int main(int argc, char **argv)
{

	char buf[256];
	char script[256];
	char *cfgname = NULL , /**tossarea = NULL,*/ *s;
	char *a[9]={NULL};
	struct stat st;
	int debug = -1, regex = 0, icase = 0, nobsy = 0, chatoff = 0, echo = 0;
	int c, i;
/*	int digit_optind = 0; */

#ifdef __linux__
	sprintf(VER, "%d.%02d/lnx %s", VERH, VERL, itraxp_date);
#elif defined(__FreeBSD__) || defined(__NetBSD__)
	sprintf(VER, "%d.%02d/bsd %s", VERH, VERL, itraxp_date);
#elif defined(__OS2__) || defined(OS2)
	sprintf(VER, "%d.%02d/os2 %s", VERH, VERL, itraxp_date);
#elif defined(__NT__)
	sprintf(VER, "%d.%02d/w32 %s", VERH, VERL, itraxp_date);
#elif defined(__sun__)
	sprintf(VER, "%d.%02d/sun %s", VERH, VERL, itraxp_date);
#elif defined(MSDOS)
	sprintf(VER, "%d.%02d/dos %s", VERH, VERL, itraxp_date);
#elif defined(__BEOS__)
	sprintf(VER, "%d.%02d/beos %s", VERH, VERL, itraxp_date);
#else
	sprintf(VER, "%d.%02d", VERH, VERL, itraxp_date);
#endif

	if (argc < 2) {
		banner();
		usage();  
		/* NOT REACHED */
	}

	/* parse command line arguments */
	while (1)
	{
/*		int this_option_optind = optind ? optind : 1; */
		int option_index = 0;
		char *options="?1:2:3:4:5:6:7:8:9:bCc:d:ehil:rvp";

		static struct option long_options[] =
		{
			{"ignore-bsy", 0, 0, 'b'},
			{"chat-off", 0, 0, 'C'},
			{"config", 1, 0, 'c'},
			{"debug", 1, 0, 'd'},
			{"help", 0, 0, 'h'},
			{"icase", 0, 0, 'i'},
			{"logfile", 0, 0, 'l'},
			{"regex", 0, 0, 'r'},
			{"touch-echomail", 0, 0, 'e'},
			{"version", 0, 0, 'v'},
			{"perl", 0, 0, 'p'},
/*			{"toss", 1, 0, "t"}, */
			{0, 0, 0, 0}
		};

		c = getopt_long (argc, argv, options, long_options, &option_index);
		if (c == EOF)
			break;

		switch (c)
		{
		case 0:
			/*
			printf ("option %s", long_options[option_index].name);
			if (optarg)
			printf (" with arg %s", optarg);
			printf ("\n");
			*/
			break;

		case 'b':
			nobsy = 1;
			break;

		case 'C':
			chatoff = 1;
			break;

		case 'c':
			cfgname = optarg;
			break;

		case 'd':
			debug = atoi(optarg);
			if (!debug)
				debug = -1;
			break;

		case 'e':
			echo = 1;
			break;

		case 'h':
		case '?':
			usage();
			/* NOT REACHED */
			break;

		case 'i':
			icase = 1;
			break;

		case 'l':

			if  (LogFile == NULL) {
				LogFile = strdup (optarg);
				open_log (LogFile);
			}
			break;

		case 'r':
			regex = 1;
			break;

			/*
			case 't':
			tossarea = optarg;
			break;
			*/
		case 'v':
			banner();
			exit(0);
		case 'p':
			perlver();
			exit(0);
		default:
			if (isdigit(c)) {
				a[c-'1'] = optarg;
			}
			else
				printf ("?? getopt returned character code 0%o ??\n", c);
		}
	}

	if (!cfgname)
		cfgname = DefConfigName;

	sprintf(lockFile.FileName, "itraxp.bsy");
	lockFile.handle = -1;
	
	init(cfgname, argv[0]);
	
	if (debug != -1)
		DebugLevel = debug;

	if (regex)
		UseRegExp = Yes;

	if (icase)
		rxIcase = REG_ICASE;

	if (nobsy)
		IgnoreBSY = Yes;

	if (echo)
		TouchEchomail = Yes;

	if (chatoff)
		Chat_On = No;


	/******************************************************/
/*	if (Fail == RegisterRexxFunc(0)) // EXE
		abort();
*/
/*
	if (tossarea)
		toss(tossarea);    
*/

	if (optind >= argc) {
		fprintf(stderr, "nothing to do\n");
	}

	for (i = 0; optind < argc; ++i, optind++)
	{
		s = argv[optind];
		if (is_full_path(s))
			strcpy(script, s);
		else
			sprintf(script, "%s%s", ItraxPath, s);

		if (!strchr(script, '.'))
			strcat(script, ".pl");
		
		if (stat(script, &st)) {
			writeToLog(0, "script not found: %s\n", script);
			fprintf(stderr, "\7script not found: %s\n", script);
			continue;
		}
			
		sprintf(buf, "Executing script: %s\n", script);
		writeToLog(0, buf);

		if( Chat_On ) {
			printf("\n\n%s", buf);
		}

		if (Fail == CallPerl(script, a[i])) {
		    printf("script execution failed: `%s'\n", script);
		}

/*		if (Fail == CallRexx(script, a[i]))
			printf("script execution failed: `%s'\n", script);
*/		
	}

	final_cleanup();
	
	printf("\n");


	return 0;
}

/**********************/
void banner(void)
{
	printf("\n%s %s %s\n\n\
(c) 2004    by Andrey Slusar, 2:467/126\n\
(c) 2002-05 by Alexander Reznikov, 2:4600/220\n\
(c) 2000-04 by Fedor Lizunkov, 2:5020/960\n\
(c) 1996-99 by Igor  Shvyrkov, 2:5020/410\n\n",
				ProdName, VER, BUILD_STR);
	return;
}

void perlver(void)
{
    printf("\nCompilation with Perl - %s\n\n", perl_ver);
}


static void usage(void)
{
	/*  -t, --toss  [area]    toss echomail in area [area]\n\ */
	
	printf("Usage: itraxp [OPTION]... [SCRIPT]...\n \
\n\
	-b, --ignore-bsy      ignore .bsy semaphore\n\
	-C, --chat-off        suppress all output to screen\n\
	-c, --config [name]   set alternate config name [name]\n\
	-d, --debug  [level]  set debug level [level]\n\
	-e, --touch-echomail  always add via to all unseen messages\n\
	-h, --help            show this help\n\
	-i, --icase           ignore case in regex search\n\
	-l, --logfile         set log file name\n\
	-r, --regex           turn regex support on\n\
	-v, --version         program version\n\
	-p, --perl            compilation perl version\n\
\n\
	-[n] [arg1,arg2,...]  n=1...9\n\
        comma-separated list of arguments to n-th script\n\
\n");
				
	exit(0);
}
