
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include <sys/types.h>
#include <locale.h>
#ifdef UNIX
#include <sys/wait.h>
#endif

#ifdef __GNUC__
#define Perl___notused Perl___notused __attribute__ ((unused))
#endif

#include "itrax.h"

#include "iperl.h"

static PerlInterpreter *perl = NULL;
static int  do_perl=1;

#include "log.h"
#include "scan.h"
#include "readmsg.h"
#include "dobnkout.h"
#include "setroute.h"
#include "setflav.h"
#include "creatfil.h"
#include "killfile.h"
#include "select.h"
#include "rewind.h"
#include "gettext.h"
#include "getkl.h"
#include "getvias.h"
#include "getsubj.h"
#include "getto.h"
#include "getfrom.h"
#include "gettime.h"
#include "gethdr.h"
#include "getattr.h"
#include "getroute.h"
#include "setattr.h"
#include "msg.h"
#include "chaddr.h"
#include "delline.h"
#include "addline.h"
#include "add_hdr.h"
#include "addintl.h"
#include "setdate.h"
#include "chckpath.h"
#include "killkl.h"
#include "substtxt.h"
#include "unpack.h"
#include "packpkt.h"
#include "writestr.h"
#include "getuplnk.h"
#include "getcrc.h"
#include "isbusy.h"
#include "no_bsy.h"
#include "routeto.h"
#include "actndl.h"
#include "expmacro.h"
#include "renumber.h"
#include "grep.h"
#include "getename.h"
#include "getalist.h"
#include "ndlrbld.h"
#include "ndlscan.h"
#include "fbox.h"
#include "getndl.h"
#include "getmsg.h"
#include "zap.h"
#include "pkt.h"
#include "getpkt.h"
#include "setpkt.h"
#include "defkey.h"
#include "defdata.h"
#include "rrconf.h"
#include "gv.h"
#include "translat.h"


#if defined(__NT__)
EXTERN_C void boot_DynaLoader (pTHXo_ CV* cv);
#else
void boot_DynaLoader(CV *cv);
#endif

#if defined(OS2)
void boot_DB_File(CV *cv);
void boot_Fcntl(CV *cv);
void boot_POSIX(CV *cv);
void boot_SDBM_File(CV *cv);
void boot_IO(CV *cv);
void boot_OS2__Process(CV *cv);
void boot_OS2__ExtAttr(CV *cv);
void boot_OS2__REXX(CV *cv);
#endif

#if defined(__NT__)
EXTERN_C void xs_init (pTHXo)
#else
static void xs_init(void)
#endif
{
  static char *file = __FILE__;
#if defined(OS2)
  newXS("DB_File::bootstrap", boot_DB_File, file);
  newXS("Fcntl::bootstrap", boot_Fcntl, file);
  newXS("POSIX::bootstrap", boot_POSIX, file);
  newXS("SDBM_File::bootstrap", boot_SDBM_File, file);
  newXS("IO::bootstrap", boot_IO, file);
  newXS("OS2::Process::bootstrap", boot_OS2__Process, file);
  newXS("OS2::ExtAttr::bootstrap", boot_OS2__ExtAttr, file);
  newXS("OS2::REXX::bootstrap", boot_OS2__REXX, file);
#else
  dXSUB_SYS;
#endif
  newXS("DynaLoader::boot_DynaLoader", boot_DynaLoader, file);
  newXS("Scan", perl_Scan, file);
  newXS("DoBinkOutbound", perl_DoBinkOutbound, file);
  newXS("DoBrakeOutbound", perl_DoBrakeOutbound, file);
  newXS("DoAmiga4DOutbound", perl_DoAmiga4DOutbound, file);
  newXS("DoOutbound", perl_DoOutbound, file);
  newXS("SetRouting", perl_SetRouting, file);
  newXS("SetFlavor", perl_SetFlavor, file);
  newXS("CreateFile", perl_CreateFile, file);
  newXS("KillFile", perl_KillFile, file);
  newXS("SelectFrom", perl_SelectFrom, file);
  newXS("SelectTo", perl_SelectTo, file);
  newXS("Select", perl_Select, file);
  newXS("ReadMsg", perl_ReadMsg, file);
  newXS("Rewind", perl_Rewind, file);
  newXS("GetText", perl_GetText, file);
  newXS("GetKludges", perl_GetKludges, file);
  newXS("GetVias", perl_GetVias, file);
  newXS("GetHdr", perl_GetHdr, file);
  newXS("GetTo", perl_GetTo, file);
  newXS("GetFrom", perl_GetFrom, file);
  newXS("GetSubject", perl_GetSubject, file);
  newXS("GetTime", perl_GetTime, file);
  newXS("GetRouting", perl_GetRouting, file);
  newXS("GetAttribute", perl_GetAttribute, file);
  newXS("SetAttribute", perl_SetAttribute, file);
  newXS("Move", perl_Move, file);
  newXS("Kill", perl_Kill, file);
  newXS("CopyArea", perl_CopyArea, file);
  newXS("Bounce", perl_Bounce, file);
  newXS("CreateMail", perl_CreateMail, file);
  newXS("ChangeMail", perl_ChangeMail, file);
  newXS("ChangeFrom", perl_ChangeFrom, file);
  newXS("ChangeTo", perl_ChangeTo, file);
  newXS("DeleteLine", perl_DeleteLine, file);
  newXS("AddLine", perl_AddLine, file);
  newXS("AddHeader", perl_AddHeader, file);
  newXS("AddIntl", perl_AddIntl, file);
  newXS("SetMessageTime", perl_SetMessageTime, file);
  newXS("CheckPath", perl_CheckPath, file);
  newXS("KillKludge", perl_KillKludge, file);
  newXS("SubstText", perl_SubstText, file);
  newXS("Unpack", perl_Unpack, file);
  newXS("PackPkt", perl_PackPkt, file);
  newXS("Log", perl_Log, file);
  newXS("WriteString", perl_WriteString, file);
  newXS("GetUplink", perl_GetUplink, file);
  newXS("GetCRC", perl_GetCRC, file);
  newXS("isBusy", perl_isBusy, file);
  newXS("IgnoreBsy", perl_IgnoreBsy, file);
  newXS("RouteTo", perl_RouteTo, file);
  newXS("ActiveNodelist", perl_ActiveNodelist, file);
  newXS("ExpandMacro", perl_ExpandMacro, file);
  newXS("Renumber", perl_Renumber, file);
  newXS("rxSearch", perl_rxSearch, file);
  newXS("GetEchoName", perl_GetEchoName, file);
  newXS("GetAreaList", perl_GetAreaList, file);
  newXS("NdlReBuild", perl_NdlReBuild, file);
  newXS("SetFboxPath", perl_SetFboxPath, file);
  newXS("SetGlobalVar", perl_SetGlobalVar, file);
  newXS("UnSetGlobalVar", perl_UnSetGlobalVar, file);
  newXS("GetGlobalVar", perl_GetGlobalVar, file);
  newXS("GetNodelistRecord", perl_GetNodelistRecord, file);
  newXS("ReReadConfig", perl_ReReadConfig, file);
  newXS("GetNodelistBlock", perl_GetNodelistBlock, file);
  newXS("GetMsg", perl_GetMsg, file);
  newXS("GetRawMsg", perl_GetRawMsg, file);
  newXS("ZapText", perl_ZapText, file);
  newXS("ReadPkt", perl_ReadPkt, file);
  newXS("CopyPkt", perl_CopyPkt, file);
  newXS("MovePkt", perl_MovePkt, file);
  newXS("KillPkt", perl_KillPkt, file);
  newXS("GetPktHdr", perl_GetPktHdr, file);
  newXS("SetPktHdr", perl_SetPktHdr, file);
  newXS("DefKeyWord", perl_DefKeyWord, file);
  newXS("DefDataBlock", perl_DefDataBlock, file);
  newXS("InvalideTearOrig", perl_InvalideTearOrig, file);
  newXS("RecodeIn", perl_RecodeIn, file);
  newXS("RecodeOut", perl_RecodeOut, file);
/*  newXS("", perl_, file); */
}

static void exitperl(void)
{
  if (perl)
  { dSP;
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    PUTBACK;
    perl_call_pv(PERLEXIT, G_EVAL|G_SCALAR);
    SPAGAIN;
    PUTBACK;
    FREETMPS;
    LEAVE;
    perl_destruct(perl);
    perl_free(perl);
    perl=NULL;
  }
}

#if defined(OS2)
static void perlthread(ULONG arg)
{
  FILE *f;
  char str[256], *p;
  if ((f=fdopen((int)arg, "r")) == NULL)
    return;
  while (fgets(str, sizeof(str), f))
  { if ((p = strchr(str, '\n')) != NULL)
      *p = '\0';
    writeToLog(0, "PERL: %s", str);
  }
  fclose(f);
}
#endif

static int handleperlerr(int *saveerr)
{
   int perlpipe[2], pid;

#if defined(UNIX)
   pipe(perlpipe);
perl_fork:
   if ((pid=fork())>0)
   {
     *saveerr=dup(fileno(stderr));
     dup2(perlpipe[1], fileno(stderr));
     close(perlpipe[0]);
     close(perlpipe[1]);
   }
   else if (pid==0)
   { FILE *f;
     char str[256];
     close(perlpipe[1]);
     f=fdopen(perlpipe[0], "r");
     while (fgets(str, sizeof(str), f))
     { char *p = strchr(str, '\n');
       if (p) *p = '\0';
       writeToLog(0, "PERL: %s", str);
     }
     fclose(f);
     fflush(stdout);
     _exit(0);
   }
   else
   { if (errno==EINTR)
       goto perl_fork;
     writeToLog(2, "Can't fork(): %s!", strerror(errno));
     close(perlpipe[1]);
     close(perlpipe[0]);
     return 0;
   }
#elif defined(OS2)
   pipe(perlpipe);
   *saveerr=dup(fileno(stderr));
   dup2(perlpipe[1], fileno(stderr));
   close(perlpipe[1]);
   DosCreateThread((PTID)&pid, perlthread, perlpipe[0], 0, 65536);
#else
   *saveerr=dup(fileno(stderr));
   perlpipe[0]=open("/dev/null", O_WRONLY);
   if (perlpipe[0]!=-1)
   { dup2(perlpipe[0], fileno(stderr));
     close(perlpipe[0]);
   }
   pid=0;
#endif
   return pid;
}

static void restoreperlerr(int saveerr, int pid)
{
   dup2(saveerr, fileno(stderr));
   close(saveerr);
   if (pid == 0)
     return;
#if defined(UNIX)
   waitpid(pid, &pid, 0);
#elif defined(OS2)
   DosWaitThread((PTID)&pid, DCWW_WAIT);
#endif
}

static int PerlStart(char *fname)
{
   int rc;
   char *perlargs[]={"", fname, NULL};
   int saveerr, pid;

   if (access(fname, R_OK))
   { writeToLog(0, "Can't read %s: %s, perl filtering disabled",
                   fname, strerror(errno));
     do_perl=0;
     return 1;
   }
   perl = perl_alloc();
   perl_construct(perl);
   pid=handleperlerr(&saveerr);
   rc=perl_parse(perl, xs_init, 2, perlargs, NULL);
   restoreperlerr(saveerr, pid);
   if (!rc)
   {
     pid=handleperlerr(&saveerr);
     rc=perl_run(perl);
     restoreperlerr(saveerr, pid);
     if (rc)
       writeToLog(0, "Error executing %s, perl filtering disabled", fname);
   }
   else
     writeToLog(0, "Can't parse %s, perl filtering disabled", fname);

   if (rc)
   {
     perl_destruct(perl);
     perl_free(perl);
     perl=NULL;
     do_perl=0;
     return 1;
   }

   atexit(exitperl);
   return 0;
}

int CallPerl(char *progname, char *arg)
{
   int pid, saveerr;
   char *subname, *prc, *token;
   static char **argv;
   int c, argc;
   static int do_perlfilter=1;
   STRLEN n_a;

   prc = strrchr(progname, DELIM);
   if (!prc) {
       prc = progname;
   } else {
       prc++;
   }
   subname = (char*)calloc(strlen(prc)+1, sizeof(char));
   strcpy(subname, prc);
   c = strlen(subname)-3;
   if (subname[c] == '.') subname[c] = '\0';

     if (do_perl && perl==NULL)
	if (PerlStart(progname))
	    return 0;
    if (!perl || !do_perlfilter)
	return 0;

    setlocale(LC_TIME, "C");

    pid = handleperlerr(&saveerr);


    if (arg) {
	for (token = strtok(arg, ","), argc=0; token != NULL; token = strtok(NULL, ","), argc++) {
	    if (argc) {
		argv = (char**)xrealloc(argv, (argc+1)*sizeof(char*));
	    } else {
		argv = (char**)malloc(sizeof(char*));
	    }

	    argv[argc] = token;
	}

    } else argc = 0;

/*    if (argc) {
        argv = (char**)xrealloc(argv, (argc+1)*sizeof(char*));
    } else {
	argv = (char**)malloc(sizeof(char*));
    }

    argv[argc++] = NULL;
*/
    {
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK(SP);
	for (c = 0; c < argc; c++) {
	    XPUSHs(sv_2mortal(newSVpv(argv[c], strlen(argv[c]))));
	}
	PUTBACK;

	perl_call_pv(subname, G_EVAL|G_SCALAR);

	SPAGAIN;
	PUTBACK;
	FREETMPS;
	LEAVE;
	restoreperlerr(saveerr, pid);
	if (SvTRUE(ERRSV)) {
	    writeToLog(0, "Perl filter eval error: %s\n", SvPV(ERRSV, n_a));
	    do_perlfilter = 0;
	    return 0;

	}

	exitperl();

/*	perl_call_argv(subname, G_EVAL, argv);
	restoreperlerr(saveerr, pid);
*/
    }
    return 1;
}
