
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include <direct.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "mem.h"
#define Ok 1
#define Fail 0

enum { ZONE = 0, NODE, POINT_ };

typedef struct _list {
	struct _list *next;
	char *fname;
} LIST;

typedef int BOOL;

int nmz = 0;

void add_to_list(char *s, LIST **L)
{
	LIST *l;
	l = (LIST *)xmalloc(sizeof(LIST));
	l->next = *L;
	l->fname = xstrcpy(s);
	*L = l;
	
}

static int is_valid_zdir(char *s)
{
	char *p;
	BOOL rc = Ok;
	
	p = strrchr(s, '.');
	
	if (p = strrchr(s, '.')) {
		++p;
		if (strlen(p) != 3)
			rc = Fail;
		else
			rc = (isxdigit(p[0]) && isxdigit(p[1]) && isxdigit(p[2]));
	}
	else if (nmz)
		rc = Fail;
	
	return rc;	
}
static int is_valid_pzdir(char *s)
{
	BOOL rc = Ok;
	int i;

	if (strlen(s) != 12)
		return Fail;
		
	if (0 != strnicmp(&s[8], ".PNT", 4))
		return Fail;

	for(i = 0; i < 8; ++i)
		if (!isxdigit(s[i]))
			return Fail;
			
	return Ok;
}
void scandir(char *path, char *suff, int type, LIST **l)
{

#if defined (UNIX)

#define UILO "/*.ilo"
#define UCLO "/*.clo"
#define UDLO "/*.dlo"
#define UHLO "/*.hlo"
#define UFLO "/*.flo"
#define UPNT "/*.pnt"

#else

#define UILO "\\*.ILO"
#define	UCLO "\\*.CLO"
#define	UDLO "\\*.DLO"
#define	UHLO "\\*.HLO"
#define	UFLO "\\*.FLO"
#define	UPNT "\\*.PNT"

#endif



	DIR *d;
	struct dirent *de;
	char *fullpath, *p, *nextpath;

	fullpath = xstrcpy(path);
	fullpath = xstrcat(fullpath, suff);

	d = opendir(fullpath);

	if (!d) {
		return;
	}

	while (de = readdir(d))
	{
		if (type == NODE) {
			add_to_list(de->d_name, l);
		}
		else if (de->d_attr & _A_SUBDIR) {
				
			nextpath = xstrcpy(path);
			
			if (type == ZONE) {
					
				if (!is_valid_zdir(de->d_name))
					continue;
					
				if (p = strrchr(nextpath, DELIM)) {
					nextpath[p-nextpath] = '\0';
				}
				else {
					free(nextpath);
					nextpath = NULL;
				}
			}
			else if (type == POINT_ && !is_valid_pzdir(de->d_name))
				continue;

			if (nextpath)
				nextpath = xstrcat(nextpath, SEP);
			nextpath = xstrcat(nextpath, de->d_name);			

			scandir(nextpath, UILO, NODE, l);
			scandir(nextpath, UCLO, NODE, l);
			scandir(nextpath, UDLO, NODE, l);
			scandir(nextpath, UHLO, NODE, l);
			scandir(nextpath, UFLO, NODE, l);


			if (type == ZONE) {
				scandir(nextpath, UPNT, POINT_, l);
			}
			free(nextpath);
		}
	}
	
	free(fullpath);
	
	return;
}

void main(int argc, char **argv)
{
	char *patt;
	LIST *list = NULL;

	patt = xstrcpy(argv[1]);
	scandir(patt, ".*",  ZONE, &list);
	
	for(; list; list=list->next)
	{
		printf("`%s'\n", list->fname);
	}
}
