
#ifdef __MSDOS__
#include <dos.h>
#endif
/* #include "prog.h" */
#include "compiler.h"

#ifdef __MINGW32__
#include <io.h>
#endif

#if defined(__MSDOS__)

  #include <stdio.h>
  #include <stdlib.h>
  #include <io.h>
  #include <fcntl.h>

  int _fast setfsize(int fd, long size)
  {
    union REGS r;
    long pos=tell(fd);

    lseek(fd, size, SEEK_SET);

  #ifdef __386__
    r.h.ah=0x40;
    r.x.ebx=fd;
    r.x.ecx=0;
    r.x.edx=0;

    int386(0x21, &r, &r);
  #else
    r.h.ah=0x40;
    r.x.bx=fd;
    r.x.cx=0;
    r.x.dx=0;

    int86(0x21, &r, &r);
  #endif

    lseek(fd, pos, SEEK_SET);

    return 0;
  }
#elif defined(OS2)

  #define INCL_DOSFILEMGR
  #include <os2.h>

  int _fast setfsize(int fd, long size)
  {
    return ((int)DosSetFileSize((HFILE)fd, (ULONG)size));
  }

#elif defined(__NT__) || defined(NT)

  int _fast setfsize(int fd, long size)
  {
      return chsize(fd, size);
  }
#elif defined(UNIX)

  #include <unistd.h>

  int _fast setfsize(int fd, long size)
  {
    return ftruncate(fd, size);
  }
/*
#elif defined(__NT__)
  #define WIN32_LEAN_AND_MEAN
  #include <windows.h>
  #include <winbase.h>
  int _fast setfsize(int fd, long size)
  {
    SetFilePointer((HANDLE)fd, size, NULL, FILE_BEGIN);
    return (!SetEndOfFile((HANDLE)fd));
  }
*/
#else
  #error Unknown OS
#endif

