
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

#ifdef __OS2__

#define INCL_DOSPROCESS

#define QUE_NAME "\\QUEUES\\itrax.QUE"
int start_session(char *name, char *arg);
int exec_pgm(char *fname, char *arg);
ULONG type = 0L;
#endif

int start_session(char *name, char *arg);
int exec_pgm(char *fname, char *arg);

int shell(char *fname, char *arg)
{
	char buf[256];
#ifdef __OS2__
	char *p;
#elif UNIX
	char *sys;
#endif
	int rc;
/*	struct find_t ffblk; */

	if ( access(fname, 0) ) {
		sprintf(buf, "shell errror: packer not found `%s'\n", fname);
		writeToLog(0, buf);
		return -1;
	}

#if defined __OS2__
	if (p = strrchr(fname, '.')) {
		if (!stricmp(p, ".cmd"))
			return spawnlp(P_WAIT, fname, fname, arg, NULL);
	}

	DosQueryAppType(fname, &type);
	
	if (type & FAPPTYP_DOS) {
		sprintf(buf, "%s is of type DOS\n", fname);
		writeToLog(4, buf);
		rc = start_session(fname, arg);
	}
	else if (type & FAPPTYP_WINDOWCOMPAT) {
		sprintf(buf, "%s is of type OS/2\n", fname);
		writeToLog(4, buf);
		rc = exec_pgm(fname, arg);
	}
	else {
		sprintf(buf, "%s: is unknown application type (%04x)\n", fname, type);
		writeToLog(0, buf);
		rc = -1;
	}
#elif defined UNIX
	sys = (char*)calloc(strlen(fname)+strlen(arg)+20, sizeof(char));
	sprintf(sys, "/bin/sh -c \"%s %s\"", fname, arg);
	rc = system(sys);
	free(sys);
#elif defined __MINGW32__
	rc = _spawnlp(P_WAIT, fname, fname, arg, NULL);
#else
	rc = spawnlp(P_WAIT, fname, fname, arg, NULL);
#endif
	return rc;
}

#ifdef __OS2__
int start_session(char *name, char *arg)
{
		
	HQUEUE        QueueHandle;   /* Queue handle */
	REQUESTDATA   Request;       /* Request-identification data */
	ULONG         DataLength;    /* Length of element received */
	PVOID         DataAddress;   /* Address of element received */
	ULONG         ElementCode;   /* Request a particular element */
	BOOL          NoWait;        /* No wait if queue is empty */
	BYTE          ElemPriority;  /* Priority of element received */
	HEV           SemHandle;     /* Semaphore handle */

	STARTDATA   StartData;    /* Start session data structure */
	ULONG       SessID;       /* Session ID (returned) */
	PID         PID;          /* Process ID (returned) */
	char        ObjBuf[100];  /* Object buffer */
	APIRET      rc;           /* Return code */
	char    *p;
	int i;
	

	rc = DosCreateQueue(&QueueHandle,     /* Queue handle */
											QUE_FIFO |        /* Ordering for elements */
											QUE_NOCONVERT_ADDRESS, /* 16-bit address conversion */
											QUE_NAME);           /* Queue name string  */

	if (rc)
		return -1;
	

/************************************************************************/
	StartData.Length = sizeof(STARTDATA);  /* Length of STARTDATA structure */
	StartData.Related = SSF_RELATED_CHILD; /* Child session */
	StartData.FgBg = SSF_FGBG_FORE;
	StartData.TraceOpt = SSF_TRACEOPT_NONE;  /* Don't trace session */
	StartData.PgmTitle = "Archiver Session";
	StartData.PgmName = name;
	StartData.PgmInputs = (PBYTE)arg;
	StartData.TermQ = (PBYTE)QUE_NAME;
	StartData.Environment = 0;
	StartData.InheritOpt = SSF_INHERTOPT_PARENT;
	StartData.SessionType = SSF_TYPE_VDM;  
	StartData.IconFile = 0;/* Assume no specific icon file  is provided      */
	StartData.PgmHandle = 0; /* Do not use the installation file */

	StartData.PgmControl = SSF_CONTROL_VISIBLE | SSF_CONTROL_MAXIMIZE;
	StartData.InitXPos = 30;
	StartData.InitYPos = 40;
	StartData.InitXSize = 200;    /* Initial window coordinates */
	StartData.InitYSize = 140;    /*   and size                 */

	StartData.Reserved = 0;       /* Reserved, must be zero */

	StartData.ObjectBuffer = ObjBuf;  /* Object buffer to hold DosExecPgm */
																		/*   failure causes                 */

	StartData.ObjectBuffLen = 100;  /* Size of object buffer */
	rc = DosStartSession(&StartData, &SessID, &PID);

	if (rc)
		return -1;

	/*************************************************************************/
	ElementCode = 0;
	NoWait = 0;
	SemHandle = 0;            /* Unused since this is a call   */
	
	rc = DosReadQueue(QueueHandle, &Request, &DataLength,
										&DataAddress, ElementCode, NoWait,
										&ElemPriority, SemHandle);

	if (rc)
		return -1;
	

	p = (char *)DataAddress;
	i = (int)p[2];
	
	rc = DosCloseQueue(QueueHandle);      /* Queue handle */
	
	DosFreeMem(DataAddress);

	return i;
}


/************************************/
int exec_pgm(char *fname, char *arg)
{
	CHAR        LoadError[100];
	RESULTCODES ReturnCodes;
	APIRET      rc;                        /* Return code */
	char args[256];

	sprintf(args, "%s%c%s%c%c\n", fname, '\0', arg, '\0', '\0');

	rc = DosExecPgm(LoadError,           /* Object name buffer */
									sizeof(LoadError),   /* Length of object name buffer */
									EXEC_SYNC,           /* Asynchronous/Trace flags */
									args,                /* Argument string */
									NULL,                /* Environment string */
									&ReturnCodes,        /* Termination codes */
									fname);      /* Program file name */


	if (rc)
		printf("DosExecPgm failed (%s) with rc=%d\n", LoadError, rc);

	return rc ? -1 : ReturnCodes.codeResult;

}
#endif /* __OS2__ */  
	
