
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"


int   get_highest_fname(char *areatag, char *areapath, char *ext);
char* get_textarea_name (char *areatag, FTN *new_ftn);
BOOL  add_text_msg(char *areatag, FTN *ftn, TEXT* newtext);


/*****************************************************/
BOOL add_text_msg(char *areatag, FTN *ftn, TEXT* newtext)
{
	FILE *th;
	char *text_area_fname, buf[256];
	
	text_area_fname = get_textarea_name (areatag, ftn);

	if (text_area_fname == NULL || NULL == (th = fopen(text_area_fname, "a+b")))
	{
		sprintf(buf, "add_msg: error opening textarea file : `%s'\n", text_area_fname);
		perror(text_area_fname);
		writeToLog(0, buf);
		return Fail;
	}

	for( ; newtext; newtext = newtext->next )
	{
		if (!is_kludge(newtext->str)) {
			fprintf (th, "%s", newtext->str);
			if (newtext->str[strlen(newtext->str)-1] == '\r')
				fprintf (th, "\n");
		}
	}

	fclose(th);

	sprintf(buf, "   written to file: `%s'  in Area : %s\n",
					text_area_fname, areatag);
	writeToLog(1, buf);

	strcpy (OutFileName, text_area_fname);
	return Ok;

}


/*****************************************************/
char* get_textarea_name (char *areatag, FTN *new_ftn)
{
	DIR *dir;
	FILE *th;
	char txt_path[128]={0}, txt_base[128]={0}, txt_fname[128]={0};
	char txt_ext[128]={0};
	char *p, cnet[10]={0}, cnode[10]={0}, cpnt[10]={0};
	static char text_area_fname[256];
	
	if (areaname_to_type(areatag) != TXT ||
			Fail == areaname_to_path (areatag, text_area_fname)) {
		return NULL;
	}

	p = strrchr(text_area_fname, DELIM);
	if (p == NULL)
		strcpy(txt_fname, text_area_fname);
	else {
		strncpy(txt_path, text_area_fname, p-text_area_fname+1);
		strcpy(txt_fname, ++p);
	}

	p = strrchr(txt_fname, '.');
	if (p == NULL)
		strcpy(txt_base, txt_fname);
	else {
		strncpy(txt_base, txt_fname, p-txt_fname);
		strcpy(txt_ext, ++p);
	}

	if (!strcmp(txt_base, "#")) {
		sprintf(text_area_fname, "%s%d.%s",
						txt_path, get_highest_fname(areatag, txt_path, txt_ext),
						txt_ext);
	}
	else if (!strcmp(txt_base, ">")) {

/*		itoa(new_ftn->to.net, cnet, 10); */
		sprintf(cnet, "%u", new_ftn->to.net);
/*		itoa(new_ftn->to.node, cnode,10); */
		sprintf(cnode, "%u", new_ftn->to.node);
/*		itoa(new_ftn->to.point, cpnt,10); */
		sprintf(cpnt, "%u", new_ftn->to.point);

		sprintf(text_area_fname, "%s%s_%s.%s", txt_path, cnet, cnode, cpnt);

	}
	else if (!strcmp(txt_base, "<")) {

/*		itoa(new_ftn->from.net, cnet, 10); */
		sprintf(cnet, "%u", new_ftn->from.net);
/*		itoa(new_ftn->from.node, cnode,10); */
		sprintf(cnode, "%u", new_ftn->from.node);
/*		itoa(new_ftn->from.point, cpnt,10); */
		sprintf(cpnt, "%u", new_ftn->from.point);

		sprintf(text_area_fname, "%s%s_%s.%s", txt_path, cnet, cnode, cpnt);

	}
	
 	dir = opendir(text_area_fname);
 	if (dir != NULL) {
 		writeToLog(0, "add_msg: file - \'%s\' is directory!\n", text_area_fname);
 		closedir(dir);
 		return NULL;
 	}


	th = fopen(text_area_fname, "a+b");

	if (th == NULL && (strlen(cnet))) {

		cpnt[3] = '\0';
		sprintf(text_area_fname, "%s%s%s.%s", txt_path, cnet, cnode, cpnt);

		th = fopen(text_area_fname, "a+b");
		if (th == NULL)
			return NULL;
	}
	fclose(th);
	return text_area_fname;
}
