
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"

void  make_DateTime(char *s);
char * unix_to_ftscdate(time_t t, char *s);
dword ftscdate_to_unix(char *date);
dword sqdate_to_unix(struct _stamp st);
dword ftscdate_to_unix(char *date);
dword seadog_to_unix(char *date);
dword fdate_to_unix(word *ftime, word *fdate);
void  unix_to_sqdate(time_t t, struct _stamp *st);
void unix_to_fdate(word *ftime, word *fdate, time_t utime);

static BOOL is_valid_dow(char *s);
static short get_month_no(char *cmon);  /* 0 - 11 */

struct dos_d
{
	word da : 5;
	word mo : 4;
	word yr : 7;
};

struct dos_t
{
	word ss : 5;
	word mm : 6;
	word hh : 5;
};

/****************************************************************************/
void make_DateTime(char *s)
{
	time_t t;
	
	t = time(NULL);
	(void) unix_to_ftscdate(t, s);
	return;
}

/****************************/
char * unix_to_ftscdate(time_t t, char *s)
{
	struct tm *tm;
	

	tm = localtime(&t);
	
	if (!tm) {
		time_t t = time(NULL);
		tm = localtime(&t);
	}
	
	sprintf(s, "%02u %s %02u  %02u:%02u:%02u", tm->tm_mday, Months[tm->tm_mon].name, tm->tm_year%100, tm->tm_hour, tm->tm_min, tm->tm_sec);
	
	return s;
}

/****************************************/
dword ftscdate_to_unix(char *date)
{
	short day, mon, y, h, min, sec;
	dword i;
	char cmon[256];
	struct tm tm;
	
	i = sscanf(date, "%hd %s %hd %hd:%hd:%hd", &day, cmon, &y, &h, &min, &sec);

	if (i != 6)
		return Fail;
		
	if (-1 == (mon = get_month_no(cmon)))
		return Fail;

	tm.tm_sec  = sec;
	tm.tm_min  = min;
	tm.tm_hour = h;
	tm.tm_mday = day;
	tm.tm_mon  = mon;

	if (y < 70)
		y += 100;
	tm.tm_year = y;
	tm.tm_isdst = -1;

	return mktime(&tm);
	
}
/****************************************/
dword seadog_to_unix(char *date)
{
	short day, mon, y, h, min;
	dword i;
	char cmon[256], dow[256];
	struct tm tm;
	
	i = sscanf(date, "%s %hd %s %hd %hd:%hd", dow, &day, cmon, &y, &h, &min);
	if (i != 6)
		return Fail;

	if (!is_valid_dow(dow))
		return Fail;
	
		
	if (-1 == (mon = get_month_no(cmon)))
		return Fail;

	tm.tm_sec  = 0;
	tm.tm_min  = min;
	tm.tm_hour = h;
	tm.tm_mday = day;
	tm.tm_mon  = mon;

	if (y < 70)
		y += 100;
	tm.tm_year = y;
	tm.tm_isdst = -1;

	return mktime(&tm);
	
}

/******************************/
static short get_month_no(char *cmon)
/* returns month number from 0 or -1 if failed */
{
	short i;
	for( i = 0; i < 12; ++i)
	{
		if (!stricmp(cmon, Months[i].name))
			return (short) (i);
	}
	return -1;
}

/*********************************/
dword sqdate_to_unix(struct _stamp st)
{
	struct tm tm;
	
	if (st.time.ss == 0 && st.time.mm == 0 && st.time.hh == 0 &&
			st.date.da == 0 && st.date.mo == 0 && st.date.yr == 0)
	{
		return 0;
	}
	
	
	tm.tm_sec  = st.time.ss * 2;
	tm.tm_min  = st.time.mm;
	tm.tm_hour = st.time.hh;
	tm.tm_mday = st.date.da;
	tm.tm_mon  = st.date.mo - 1;
	tm.tm_year = st.date.yr + 80;
	tm.tm_isdst = -1;

	return mktime(&tm);
	
}
/**********************************************/
void unix_to_sqdate(time_t t, struct _stamp *st)
{
	struct tm *tm = localtime(&t);

	if (!tm) {
		time_t t = time(NULL);
		tm = localtime(&t);
		writeToLog(4, "unix_to_sqate failed, set current time\n");
	}
		
	st->time.ss = tm->tm_sec/2;
	st->time.mm = tm->tm_min;
	st->time.hh = tm->tm_hour;
	st->date.da = tm->tm_mday;
	st->date.mo = tm->tm_mon + 1;
	st->date.yr = tm->tm_year - 80;

	return;
}

/******************************************/
dword fdate_to_unix(word *ftime, word *fdate)
{
	struct tm tm;

	tm.tm_sec  = ((struct dos_t *)ftime)->ss * 2;
	tm.tm_min  = ((struct dos_t *)ftime)->mm;
	tm.tm_hour = ((struct dos_t *)ftime)->hh;
	tm.tm_mday = ((struct dos_d *)fdate)->da;
	tm.tm_mon  = ((struct dos_d *)fdate)->mo - 1;
	tm.tm_year = ((struct dos_d *)fdate)->yr + 80;
	tm.tm_isdst = -1;

	return mktime(&tm);
	
}

void unix_to_fdate(word *ftime, word *fdate, time_t utime)
{
    struct tm *stm;
    
    stm = localtime(&utime);
    
    ((struct dos_d *)fdate)->da = stm->tm_mday;
    ((struct dos_d *)fdate)->mo = stm->tm_mon + 1;
    ((struct dos_d *)fdate)->yr = stm->tm_year - 80;

    ((struct dos_t *)ftime)->hh = stm->tm_hour;
    ((struct dos_t *)ftime)->mm = stm->tm_min;
    ((struct dos_t *)ftime)->ss = stm->tm_sec >> 1;
    
    return;
    
}

/*******************************/
static BOOL is_valid_dow(char *s)
{
	int i;
	for( i = 0 ; strlen(Dow[i].dow); ++i)
		if (!stricmp(Dow[i].dow, s))
			return Ok;
	return Fail;
}
