
/************************************************************************
 *	itraxp - netmail tracker
 *      by Fedor Lizunkov 2:5020/960@Fidonet
 *
 *	itraxp - clone from itraX 
 *	by Igor Shvyrkov 2:5020/410@Fidonet
 ************************************************************************/

#include "itrax.h"
#include "crc.h"
#define DUPEEXT ".dup"


void defFidoArea(char *str, char *err_diag);
/* void defBinkArea(char *str, char *err); */
void defSquishArea(char *str, char *err);
/* void defTextArea(char *str, char *err); */
/* void defPktArea(char *str, char *err); */
void defJamArea(char *str, char *err);

void reset_globals(int old_type);

extern void select_pkt_area(char *areapath, PKT_AREA *pkt);
extern BOOL readpkt_wrapper(char *err);
extern BOOL is_echoarea(int areatype, char *areatag);
/* extern static dword is_dupe(char *areaname, dword HdrCRC, dword MsgidCRC, char *msgid); */
extern ULONG crc_str(register ULONG crc, char *str, register long len);
extern char * get_echo_name(void);
extern void pktarea_to_ftn(struct pktarea pkt, FTN *ftn);
extern void do_chat(void);
extern int add_msg(int areatype, char *areatag, FTN *new_ftn, TEXT *newtext);
extern BOOL set_shvar (char *base_name, int idx, char *val);

static void get_dupe_info (dword *, dword *);
static char *get_msgid(TEXT *t);

extern ULONG crc_str(register ULONG crc, char *str, register long len);


void flush_dupes(void);

char * get_echo_name(void);

static dword is_dupe(char *areaname, dword HdrCRC, dword MsgidCRC, char *msgid);
static void flush_this_base(struct _dbcache db);

#if 0
LONG   EXPENTRY EXPORT  
IsDupe(PSZ name, LONG argc, PRXSTRING argv, PSZ queue, PRXSTRING  retstr )
{
	char res[256] = {0};
	char err[128], buf[256], *ename;
	dword MsgidCRC, HdrCRC;
	BOOL rc = No;

	queue = queue;
	argv = argv;

	sprintf(err, "REXX (%s),", name);

	if (argc) {
		sprintf(buf, "%s argument count\n", err);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

	if ( CurMsg.n && (ename = get_echo_name()) ) {
		get_dupe_info(&HdrCRC, &MsgidCRC);
		rc = is_dupe(ename, HdrCRC, MsgidCRC, ftn.msgid);
	}

	itoa(rc, res, 10);

	strcpy(RXSTRPTR(*retstr), res);

	retstr->strlength = strlen(res);

	return 0;                        
}

LONG   EXPENTRY EXPORT  
GetEchoLinks(PSZ name, LONG argc, PRXSTRING argv, PSZ queue, PRXSTRING  retstr )
{
	char err[128], buf[256], ename[20], *strlinks;
	char stem_name[128];
	struct EchoAreas* tmp;
	struct Address* links = NULL;
	int i;
	
	queue = queue;
	argv = argv;

	sprintf(err, "REXX (%s),", name);

	if (argc != 1 && argc != 2) {
		sprintf(buf, "%s argument count\n", err);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
		abort();
	}

	strncpy (ename, RxSTRPTR(argv[0]), 19);
	ename[19] = '\0';
	
	for (tmp = EchoAreas; tmp; tmp = tmp->next)
	{
		if (!stricmp (ename, tmp->name)) {
			links = tmp->links;
			break;
		}
	}
	
	if (argc == 2) {
		strncpy(stem_name, RxSTRPTR(argv[1]), 120); stem_name[120] = 0;
		strip(stem_name);
		expand_str(stem_name);

		if (stem_name[strlen(stem_name)-1] != '.')
			strcat (stem_name, ".");
		strupr (stem_name);
	}
	
  strlinks = NULL;
	for (i = 0; links; links = links->next)
	{
		addr_to_str (links->addr, buf);
		if (argc == 1) {
			if (strlinks)
				strlinks = xstrcat (strlinks, " ");
			strlinks = xstrcat (strlinks, buf);
		}
		else {
			if (Fail == set_shvar (stem_name, ++i, buf))
				abort();
		}
	}

	if (argc == 2) {
		itoa (i, buf, 10);
		if (Fail == set_shvar (stem_name, 0, buf)) {
			abort();
		}
	}

	if (argc == 1 && strlinks) {
		retstr->strptr = strlinks;
		retstr->strlength = strlen(strlinks);
	}
	else {
		retstr->strlength = 0;
	}

	return 0;                        
}
#endif
static dword is_dupe(char *areaname, dword HdrCRC, dword MsgidCRC, char *msgid)
{
	int i;
	struct _db *dbrec = NULL;
	int nrec = 0, nalloc = 0, delta = 20, narea = 0;

	BOOL isDupe = No;

	for (i = 0; i < DupesTotal; ++i)
	{
		if (!stricmp(areaname, DupeBase[i].areaname)) {
			nrec = DupeBase[i].nrec;
			nalloc = DupeBase[i].nalloc;
			dbrec = DupeBase[i].dbrec;
			narea = i;
			break;
		}
	}

	/* new area */
	if (!dbrec) {
		int fd, l;
		char dupename[256], buf[256];

		sprintf(dupename, "%s%s%s",
			DupeBasePath ? DupeBasePath : "", areaname, DUPEEXT);


		if( -1 == (fd = open(dupename, O_CREAT|O_RDWR|O_BINARY, ACCFILE))) {
			sprintf(buf, "is_dupe: error opening dupebase file : `%s'\n", dupename);
			perror(dupename);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
			abort();
		}

		nrec = filelength(fd) / sizeof (struct _db);
		nalloc = nrec;

		if (nrec) {
			
			l = nrec * sizeof (struct _db);
			dbrec = (struct _db *)malloc(l);
			
			if (read(fd, dbrec, l) != l) {
				sprintf(buf, "is_dupe: error reading dupebase file : `%s'\n", dupename);
				perror(dupename);
				fprintf(stderr, "\7%s", buf);
	writeToLog(0, buf);
	abort();
			}
		}

		close(fd);

		if (DupesTotal < DupesMaxOpen) {

			if (!DupeBase) {
				DupeBase = (struct _dbcache *)malloc(1 * sizeof (struct _dbcache));
			}
			else {
				DupeBase = (struct _dbcache *)
					realloc(DupeBase, (DupesTotal+1) * sizeof (struct _dbcache));
			}

			if (!DupeBase) {
				strcpy(buf, "low memo handling dupebase\n");
				fprintf(stderr, "\7%s", buf);
				writeToLog(0, buf);
				abort();
			}

			++DupesTotal;
			
		}
		else {

			flush_this_base(DupeBase[0]);
			free(DupeBase[0].dbrec);
			
			for (i = 0; i < DupesTotal-1; ++i)
				DupeBase[i] = DupeBase[i+1];
			
		} /* memory limit exceeded, shifting all elements */

		strcpy(DupeBase[DupesTotal-1].areaname, areaname);
		strcpy(DupeBase[DupesTotal-1].dupename, dupename);
		DupeBase[DupesTotal-1].dbrec = NULL;
		DupeBase[DupesTotal-1].nrec = nrec;
		DupeBase[DupesTotal-1].nalloc = nrec;

		narea = DupesTotal-1;
			

	}  /* new area */

	for (i = 0; i < nrec; ++i)
	{
		if ( dbrec[i].HdrCRC == HdrCRC &&
				dbrec[i].MsgidCRC == MsgidCRC &&
				!strncmp(dbrec[i].Msgid, msgid, MSGIDLENGTH-1) )
		{
			isDupe = Yes;
			break;
		} /* dupe found */
	}


	if (!isDupe) {
			
		if (nrec < DupesMaxMsg) {
			if (nrec == nalloc) {
			
	nalloc += delta;
			
				if (!dbrec)
					dbrec = (struct _db *) malloc(nalloc * sizeof(struct _db));
				else
		dbrec = (struct _db *) realloc(dbrec, nalloc * sizeof(struct _db));

			}
			++nrec;
		}
		else {
			for (i = 0; i < nrec-1; ++i)
	dbrec[i] = dbrec[i+1];
		}
		
		dbrec[nrec-1].HdrCRC = HdrCRC;
		dbrec[nrec-1].MsgidCRC = MsgidCRC;
		strncpy(dbrec[nrec-1].Msgid, msgid, MSGIDLENGTH-1);
		dbrec[nrec-1].Msgid[MSGIDLENGTH-1] = 0;
		DupeBase[narea].nrec = nrec;
		DupeBase[narea].nalloc = nalloc;
		
	} /* add record */

	DupeBase[narea].dbrec = dbrec;

	return isDupe;
}

void flush_dupes(void)
{
	int i;

	for (i = 0; i < DupesTotal; ++i)
	{
		flush_this_base(DupeBase[i]);
		free(DupeBase[i].dbrec);
	}
	
	free(DupeBase);
	DupeBase = NULL;
	
	return;
}

static void flush_this_base(struct _dbcache db)
{
	dword n, l = sizeof(struct _db);
	char buf[256];
	int fd;

	if( (fd = sopen(db.dupename, O_RDWR|O_BINARY, SH_DENYNO, ACCFILE))) {
		n = db.nrec;
		n *= l;
		if (n != write(fd, db.dbrec, n)) {
			sprintf(buf, "flush_db: error writing dupebase file : `%s'\n",
							db.dupename);
			perror(db.dupename);
			fprintf(stderr, "\7%s", buf);
			writeToLog(0, buf);
		}
		close(fd);
	}
	else {
		sprintf(buf, "flush_db: error opening dupebase file : `%s'\n", db.dupename);
		perror(db.dupename);
		fprintf(stderr, "\7%s", buf);
		writeToLog(0, buf);
	}
	return;
}



void toss(char *pktareaname)
{
	char s[256], areapath[128], *echotag, *p;
	char *err = "toss";
	dword MsgidCRC, HdrCRC;
	ADDR addr;

	if (areaname_to_type(pktareaname) != PKT) {
		sprintf(s, "toss, invalid pkt areaname: `%s'\n", pktareaname);
		fprintf(stderr, "\7%s\n", s);
		writeToLog(0, s);
		abort();
	}

	(void)reset_globals(0);

	areaname_to_path(pktareaname, areapath);
	CurMsg.type = PKT;
	strcpy(CurMsg.areapath, areapath);
	strcpy(CurMsg.areaname, pktareaname);

	select_pkt_area(areapath, &CurMsg.pkt);
	CurMsg.pkt.off = 0L;

	while (readpkt_wrapper(err))
	{
		++nRead;
		if ((echotag = get_echo_name())) {
			pktarea_to_ftn(CurMsg.pkt, &ftn);
			if ((p = get_msgid(TextFirst))) {
				strcpy(ftn.msgid, p);
	p = ftn.msgid;
	p[strlen(p)-1] = '\0';
				strcpy(s, p);
	if ((p = strchr(s, ' '))) {
		s[p-s] = '\0';
		if (str_to_addr(s, &addr)) {
			ftn.from.zone = addr.zone;
			ftn.to.zone = addr.zone;
			ftn.from.point = addr.point;
		}
	}
			}
			get_dupe_info(&HdrCRC, &MsgidCRC);
			is_dupe(echotag, HdrCRC, MsgidCRC, ftn.msgid);
			add_msg(JAM, "jam_test", &ftn, TextFirst);
		}

		if( Chat_On )
			do_chat();    

		update_msg(PKT);

		free_text(TextFirst);  
		TextFirst = NULL;    
	}

	return;    
}

static void get_dupe_info (dword *HdrCRC, dword *MsgidCRC)
{
	char buf[128];
	dword m, h;

	m = crc_str(CRC32INIT, ftn.msgid, strlen(ftn.msgid));
	addr_to_str(ftn.to, buf);
	h = crc_str(CRC32INIT, buf, strlen(buf));
	addr_to_str(ftn.from, buf);
	h = crc_str(h, buf, strlen(buf));
	h = crc_str(h, ftn.fromName, strlen(ftn.fromName));
	h = crc_str(h, ftn.toName, strlen(ftn.toName));
	h = crc_str(h, ftn.DateTime, strlen(ftn.DateTime));
	h = crc_str(h, ftn.subject, strlen(ftn.subject));

	*MsgidCRC = m;
	*HdrCRC = h;

	return;
}

/* stupid but fast */
static char *get_msgid(TEXT *t)
{
	static char *p = NULL;

	for ( ; t ; t = t->next)
	{
		if (t->str[0] == '\1') {
			p = t->str + 1;
			if (!strncmp(p, "MSGID", 5)) {
				p += 5;
				while (*p && (*p==':' || *p==' '))
					++p;
				break;
			}
		}
	}
	return p;
}

int def_echoarea (char *s, int isbad, char *err)
{
	char buf[256], w[256], areatag[256], areapath[256];
	int type = 0;
	BOOL link_defined = No;
	ADDR addr;
	struct Address *links = NULL, *tmplist;
	struct EchoAreas *tmp;


	if (BadAreaDefined) {
		fprintf (stderr, "bad area already defined\n");
		return Fail;
	}


	if (isbad) {
		writeToLog(4, "define badarea\n");
		BadAreaDefined = Yes;
	}

	if (NULL == get_next_word (s, areatag))
		return Fail;
	
	sprintf (buf, "def_echo: got atag: `%s'\n", areatag);
	writeToLog(4, buf);
	
	if (NULL == get_next_word (s, w))
		return Fail;

	if (w[0] == '-') {
		if (w[1] == '0') {
			writeToLog(4, "type is pass\n");
			type = E_PASS;
		}
		else
			return Fail;
	}
	else {
		strcpy (areapath, w);
		sprintf (buf, "def_echo: got apath: `%s'\n", areapath);
		writeToLog(4, buf);
	}

	while (get_next_word (s, w))
	{
		if (w[0] == '-') {
			if (type)
				continue;
			else if (w[1] == '$') {
				type = E_SQUISH;
				writeToLog(4, "type is squish\n");
			}
			else if (w[1] == 'j' || w[1] == 'J') {
				type = E_JAM;
				writeToLog(4, "type is jam\n");
			}
			else if (w[1] == 'f' || w[1] == 'F') {
				type = E_FIDO;
				writeToLog(4, "type is msg\n");
			}
			else if (w[1] == '0') {
				type = E_PASS;
				writeToLog(4, "type is pass\n");
			}
			else {
				sprintf (buf, "unknown flag -%c, ignored\n", w[1]);
				writeToLog(4, buf);
			}
		}
		else {
			if (!str_to_addr(w, &addr)) {
				fprintf (stderr, "incorrect addr: `%s'\n", w);
				return Fail;
			}
			sprintf (buf, "got link: `%s'\n", w);
			writeToLog(4, buf);
			tmplist = (struct Address *) malloc (sizeof (struct Address));
			if (tmplist == NULL) {
				fprintf (stderr, "tmplist: low memo\n");
        return Fail;
			}
			
			tmplist->next = links;
			tmplist->addr = addr;
      links = tmplist;
			
			link_defined = Yes;
		}
	}

	if (link_defined == No)
		return Fail;

	if (type == 0) {
		type = E_FIDO;
		writeToLog(4, "type is msg\n");
	}

	sprintf (buf, "%s %s echomail", areapath, areatag);

	if (type == E_FIDO)
		(void)defFidoArea(buf, err);
	else if (type == E_SQUISH)
		(void)defSquishArea(buf, err);
	else if (type == E_JAM)
		(void)defJamArea(buf, err);

	tmp = (struct EchoAreas *) malloc (sizeof (struct EchoAreas));
	tmp->next = EchoAreas;
	strncpy (tmp->name, areatag, 19);
	tmp->name[19] = '\0';
	tmp->links = links;
	tmp->BadArea = isbad;
	tmp->type = type;
	EchoAreas = tmp;

	return Ok;
	
}
